local SDC = SimpleDailyCraft

local function IsTwo(Table)
  if Table == nil then return true end
  if #Table == 2 then return false end
  return true
end

--"|H0:item:44812:308:50:0:0:0:0:0:0:0:0:0:0:0:0:36:0:0:0:0:131072|h|h"
local function GetEncode(String)
  local NumString = ""
  for word in string.gmatch(String, "%d+|") do
    NumString = string.gsub(word, "|", "",1)
  end
  return tonumber(NumString)
end

local function ToLink(Id)
  if not Id then return "" end
  return "|H0:item:"..Id..":30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
end

local function GetCost(Table)
  local Cost = 0
  for i = 1, #Table do
    Cost = Cost + TamrielTradeCentrePrice:GetPriceInfo(ToLink(Table[i])).Avg
  end
  return Cost
end
--/script SimpleDailyCraft.AlchmyEnumerate()
function SDC.AlchmyEnumerate()  --To get all ways of making alchmy (need all traits unlock and all materials in bag when run) 
  SDC.SV.Alchmy = {}
  for a = 1, 34 do
    for b = a + 1 ,34 do
      local Link = GetAlchemyResultingItemLink(5, 75365, 5, SDC.Alchemy["Reagents"][a], 5, SDC.Alchemy["Reagents"][b])
      if Link ~= "" then
        local Id = GetItemLinkItemId(Link)
        if SDC.SV.Alchmy[Id] == nil then SDC.SV.Alchmy[Id] = {} end
        local Tep = {SDC.Alchemy["Reagents"][a], SDC.Alchemy["Reagents"][b]}
        Tep["Pre"] = GetCost(Tep)
        table.insert(SDC.SV.Alchmy[Id], Tep)
      end
    end
  end
  for a = 1, 34 do
    for b = a + 1 ,34 do
      local Link = GetAlchemyResultingItemLink(5, 64501, 5, SDC.Alchemy["Reagents"][a], 5, SDC.Alchemy["Reagents"][b])
      if Link ~= "" then
        local Id = GetItemLinkItemId(Link)
        if SDC.SV.Alchmy[Id] == nil then SDC.SV.Alchmy[Id] = {} end
        local Tep = {SDC.Alchemy["Reagents"][a], SDC.Alchemy["Reagents"][b]}
        Tep["Pre"] = GetCost(Tep)
        table.insert(SDC.SV.Alchmy[Id], Tep)
      end
    end
  end
  for a = 1, 34 do
    for b = a + 1 , 34 do
      for c = b + 1 , 34 do
        local Link = GetAlchemyResultingItemLink(5, 75365, 5, SDC.Alchemy["Reagents"][a], 5, SDC.Alchemy["Reagents"][b], 5, SDC.Alchemy["Reagents"][c])
        if Link ~= "" then
          local Id = GetItemLinkItemId(Link)
          if SDC.SV.Alchmy[Id] == nil then SDC.SV.Alchmy[Id] = {} end
          if IsTwo(SDC.SV.Alchmy[Id][1]) then
            local Tep = {SDC.Alchemy["Reagents"][a], SDC.Alchemy["Reagents"][b], SDC.Alchemy["Reagents"][c]}
            Tep["Pre"] = GetCost(Tep)
            table.insert(SDC.SV.Alchmy[Id], Tep)
          end
        end
      end
    end
  end
  for a = 1, 34 do
    for b = a + 1 , 34 do
      for c = b + 1 , 34 do
        local Link = GetAlchemyResultingItemLink(5, 64501, 5, SDC.Alchemy["Reagents"][a], 5, SDC.Alchemy["Reagents"][b], 5, SDC.Alchemy["Reagents"][c])
        if Link ~= "" then
          local Id = GetItemLinkItemId(Link)
          if SDC.SV.Alchmy[Id] == nil then SDC.SV.Alchmy[Id] = {} end
          if IsTwo(SDC.SV.Alchmy[Id][1]) then
            local Tep = {SDC.Alchemy["Reagents"][a], SDC.Alchemy["Reagents"][b], SDC.Alchemy["Reagents"][c]}
            Tep["Pre"] = GetCost(Tep)
            table.insert(SDC.SV.Alchmy[Id], Tep)
          end
        end
      end
    end
  end
  for Id, _ in pairs(SDC.SV.Alchmy) do
    table.sort(SDC.SV.Alchmy[Id], function(a, b)
      return a.Pre < b.Pre
    end)
  end
end
--/script SimpleDailyCraft.MasterEnumerate()
function SDC.MasterEnumerate() 
  SDC.SV.Master = {}
  for a = 1, 34 do
    for b = a + 1 , 34 do
      for c = b + 1 , 34 do
        local Link = GetAlchemyResultingItemLink(5, 75365, 5, SDC.Alchemy["Reagents"][a], 5, SDC.Alchemy["Reagents"][b], 5, SDC.Alchemy["Reagents"][c])
        if Link ~= "" then
          local Encode = GetEncode(Link)
          if SDC.SV.Master[Encode] == nil then SDC.SV.Master[Encode] = {} end
          local Tep = {SDC.Alchemy["Reagents"][a], SDC.Alchemy["Reagents"][b], SDC.Alchemy["Reagents"][c]}
          Tep["Pre"] = GetCost(Tep)
          table.insert(SDC.SV.Master[Encode], Tep)
        end
      end
    end
  end
  for Id, _ in pairs(SDC.SV.Master) do
    table.sort(SDC.SV.Master[Id], function(a, b)
      return a.Pre < b.Pre
    end)
  end
end
--The combo of reagents for daily craft
SDC.Alchmy2Craft = 
                {
                    [54336] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            ["Pre"] = 195.9500000000,
                        },
                    },
                    [54337] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            ["Pre"] = 196.6700000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 77581,
                            ["Pre"] = 790.0800000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 77581,
                            ["Pre"] = 804.9900000000,
                        },
                        [4] = 
                        {
                            [1] = 30165,
                            [2] = 150671,
                            ["Pre"] = 7468.6700000000,
                        },
                        [5] = 
                        {
                            [1] = 30156,
                            [2] = 150671,
                            ["Pre"] = 7483.5800000000,
                        },
                        [6] = 
                        {
                            [1] = 77581,
                            [2] = 150671,
                            ["Pre"] = 8076.9900000000,
                        },
                    },
                    [30146] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            ["Pre"] = 168.2700000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            ["Pre"] = 176.7200000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            ["Pre"] = 190.0500000000,
                        },
                    },
                    [54339] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            ["Pre"] = 165.9600000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            ["Pre"] = 178.2500000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            ["Pre"] = 184.0700000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            ["Pre"] = 186.2100000000,
                        },
                        [5] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            ["Pre"] = 192.0300000000,
                        },
                        [6] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            ["Pre"] = 204.3200000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            ["Pre"] = 353.5600000000,
                        },
                        [8] = 
                        {
                            [1] = 30166,
                            [2] = 30163,
                            ["Pre"] = 373.8100000000,
                        },
                        [9] = 
                        {
                            [1] = 77585,
                            [2] = 30163,
                            ["Pre"] = 379.6300000000,
                        },
                        [10] = 
                        {
                            [1] = 30155,
                            [2] = 30160,
                            ["Pre"] = 423.0300000000,
                        },
                        [11] = 
                        {
                            [1] = 30166,
                            [2] = 30160,
                            ["Pre"] = 435.3200000000,
                        },
                        [12] = 
                        {
                            [1] = 77585,
                            [2] = 30160,
                            ["Pre"] = 441.1400000000,
                        },
                        [13] = 
                        {
                            [1] = 30148,
                            [2] = 150672,
                            ["Pre"] = 491.2000000000,
                        },
                        [14] = 
                        {
                            [1] = 30155,
                            [2] = 150672,
                            ["Pre"] = 499.1600000000,
                        },
                        [15] = 
                        {
                            [1] = 77585,
                            [2] = 150672,
                            ["Pre"] = 517.2700000000,
                        },
                        [16] = 
                        {
                            [1] = 30163,
                            [2] = 30160,
                            ["Pre"] = 610.6300000000,
                        },
                        [17] = 
                        {
                            [1] = 30163,
                            [2] = 150672,
                            ["Pre"] = 686.7600000000,
                        },
                        [18] = 
                        {
                            [1] = 30160,
                            [2] = 150672,
                            ["Pre"] = 748.2700000000,
                        },
                        [19] = 
                        {
                            [1] = 30148,
                            [2] = 30164,
                            ["Pre"] = 2124.1500000000,
                        },
                        [20] = 
                        {
                            [1] = 30155,
                            [2] = 30164,
                            ["Pre"] = 2132.1100000000,
                        },
                        [21] = 
                        {
                            [1] = 30166,
                            [2] = 30164,
                            ["Pre"] = 2144.4000000000,
                        },
                        [22] = 
                        {
                            [1] = 77585,
                            [2] = 30164,
                            ["Pre"] = 2150.2200000000,
                        },
                        [23] = 
                        {
                            [1] = 30163,
                            [2] = 30164,
                            ["Pre"] = 2319.7100000000,
                        },
                        [24] = 
                        {
                            [1] = 30160,
                            [2] = 30164,
                            ["Pre"] = 2381.2200000000,
                        },
                        [25] = 
                        {
                            [1] = 150672,
                            [2] = 30164,
                            ["Pre"] = 2457.3500000000,
                        },
                    },
                    [54340] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30160,
                            ["Pre"] = 439.4300000000,
                        },
                        [2] = 
                        {
                            [1] = 30161,
                            [2] = 30160,
                            ["Pre"] = 498.7500000000,
                        },
                        [3] = 
                        {
                            [1] = 30158,
                            [2] = 150670,
                            ["Pre"] = 563.8700000000,
                        },
                        [4] = 
                        {
                            [1] = 30160,
                            [2] = 150670,
                            ["Pre"] = 796.5800000000,
                        },
                        [5] = 
                        {
                            [1] = 30158,
                            [2] = 30164,
                            ["Pre"] = 2148.5100000000,
                        },
                        [6] = 
                        {
                            [1] = 30161,
                            [2] = 30164,
                            ["Pre"] = 2207.8300000000,
                        },
                        [7] = 
                        {
                            [1] = 150670,
                            [2] = 30164,
                            ["Pre"] = 2505.6600000000,
                        },
                        [8] = 
                        {
                            [1] = 30158,
                            [2] = 150671,
                            ["Pre"] = 7481.1500000000,
                        },
                        [9] = 
                        {
                            [1] = 30161,
                            [2] = 150671,
                            ["Pre"] = 7540.4700000000,
                        },
                        [10] = 
                        {
                            [1] = 30160,
                            [2] = 150671,
                            ["Pre"] = 7713.8600000000,
                        },
                        [11] = 
                        {
                            [1] = 150670,
                            [2] = 150671,
                            ["Pre"] = 7838.3000000000,
                        },
                        [12] = 
                        {
                            [1] = 30164,
                            [2] = 150671,
                            ["Pre"] = 9422.9400000000,
                        },
                    },
                    [54341] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            ["Pre"] = 352.0300000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            ["Pre"] = 370.4400000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 150669,
                            ["Pre"] = 698.3400000000,
                        },
                        [4] = 
                        {
                            [1] = 30157,
                            [2] = 150669,
                            ["Pre"] = 716.7500000000,
                        },
                        [5] = 
                        {
                            [1] = 30163,
                            [2] = 150669,
                            ["Pre"] = 895.4300000000,
                        },
                        [6] = 
                        {
                            [1] = 30162,
                            [2] = 30164,
                            ["Pre"] = 2122.6200000000,
                        },
                        [7] = 
                        {
                            [1] = 30157,
                            [2] = 30164,
                            ["Pre"] = 2141.0300000000,
                        },
                        [8] = 
                        {
                            [1] = 150669,
                            [2] = 30164,
                            ["Pre"] = 2666.0200000000,
                        },
                        [9] = 
                        {
                            [1] = 30162,
                            [2] = 150731,
                            ["Pre"] = 3541.5000000000,
                        },
                        [10] = 
                        {
                            [1] = 30157,
                            [2] = 150731,
                            ["Pre"] = 3559.9100000000,
                        },
                        [11] = 
                        {
                            [1] = 30163,
                            [2] = 150731,
                            ["Pre"] = 3738.5900000000,
                        },
                        [12] = 
                        {
                            [1] = 150669,
                            [2] = 150731,
                            ["Pre"] = 4084.9000000000,
                        },
                        [13] = 
                        {
                            [1] = 30164,
                            [2] = 150731,
                            ["Pre"] = 5509.1800000000,
                        },
                    },
                    [158308] = 
                    {
                        [1] = 
                        {
                            [1] = 150672,
                            [2] = 150670,
                            ["Pre"] = 872.7100000000,
                        },
                        [2] = 
                        {
                            [1] = 150672,
                            [2] = 150669,
                            ["Pre"] = 1033.0700000000,
                        },
                        [3] = 
                        {
                            [1] = 150670,
                            [2] = 150669,
                            ["Pre"] = 1081.3800000000,
                        },
                    },
                    [77596] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            ["Pre"] = 340.4900000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 150670,
                            ["Pre"] = 670.9700000000,
                        },
                        [3] = 
                        {
                            [1] = 77590,
                            [2] = 77591,
                            ["Pre"] = 772.1600000000,
                        },
                        [4] = 
                        {
                            [1] = 150670,
                            [2] = 77591,
                            ["Pre"] = 1102.6400000000,
                        },
                        [5] = 
                        {
                            [1] = 77590,
                            [2] = 139019,
                            ["Pre"] = 1872.7200000000,
                        },
                        [6] = 
                        {
                            [1] = 77583,
                            [2] = 139019,
                            ["Pre"] = 1953.1500000000,
                        },
                        [7] = 
                        {
                            [1] = 150670,
                            [2] = 139019,
                            ["Pre"] = 2203.2000000000,
                        },
                        [8] = 
                        {
                            [1] = 77591,
                            [2] = 139019,
                            ["Pre"] = 2384.8200000000,
                        },
                    },
                    [151969] = 
                    {
                        [1] = 
                        {
                            [1] = 150789,
                            [2] = 150731,
                            ["Pre"] = 3636.3400000000,
                        },
                        [2] = 
                        {
                            [1] = 150789,
                            [2] = 150671,
                            ["Pre"] = 7550.1000000000,
                        },
                        [3] = 
                        {
                            [1] = 150731,
                            [2] = 150671,
                            ["Pre"] = 10841.8200000000,
                        },
                    },
                    [44809] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            ["Pre"] = 168.7200000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            ["Pre"] = 187.5500000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            ["Pre"] = 192.2600000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            ["Pre"] = 192.7500000000,
                        },
                        [5] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            ["Pre"] = 197.4600000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            ["Pre"] = 203.9800000000,
                        },
                        [7] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            ["Pre"] = 209.1800000000,
                        },
                        [8] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            ["Pre"] = 216.2900000000,
                        },
                        [9] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            ["Pre"] = 228.0100000000,
                        },
                    },
                    [44810] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            ["Pre"] = 361.5200000000,
                        },
                        [2] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            ["Pre"] = 380.3500000000,
                        },
                    },
                    [27042] = 
                    {
                        [1] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            ["Pre"] = 316.2500000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            ["Pre"] = 485.0200000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 77591,
                            ["Pre"] = 747.9200000000,
                        },
                        [4] = 
                        {
                            [1] = 77583,
                            [2] = 77591,
                            ["Pre"] = 852.5900000000,
                        },
                        [5] = 
                        {
                            [1] = 30163,
                            [2] = 77591,
                            ["Pre"] = 916.6900000000,
                        },
                    },
                    [44812] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            ["Pre"] = 186.7600000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            ["Pre"] = 201.3800000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            ["Pre"] = 206.3800000000,
                        },
                        [4] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            ["Pre"] = 213.1000000000,
                        },
                        [5] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            ["Pre"] = 218.1000000000,
                        },
                        [6] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            ["Pre"] = 220.9100000000,
                        },
                        [7] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            ["Pre"] = 225.9100000000,
                        },
                        [8] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            ["Pre"] = 232.7200000000,
                        },
                        [9] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            ["Pre"] = 240.5300000000,
                        },
                        [10] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            ["Pre"] = 252.2500000000,
                        },
                        [11] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            ["Pre"] = 253.5600000000,
                        },
                        [12] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            ["Pre"] = 258.5600000000,
                        },
                        [13] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            ["Pre"] = 273.1800000000,
                        },
                        [14] = 
                        {
                            [1] = 30151,
                            [2] = 30161,
                            ["Pre"] = 284.9000000000,
                        },
                        [15] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            ["Pre"] = 292.7100000000,
                        },
                        [16] = 
                        {
                            [1] = 30165,
                            [2] = 150670,
                            ["Pre"] = 551.3900000000,
                        },
                        [17] = 
                        {
                            [1] = 30157,
                            [2] = 150670,
                            ["Pre"] = 556.3900000000,
                        },
                        [18] = 
                        {
                            [1] = 30149,
                            [2] = 150670,
                            ["Pre"] = 571.0100000000,
                        },
                        [19] = 
                        {
                            [1] = 30151,
                            [2] = 150670,
                            ["Pre"] = 582.7300000000,
                        },
                        [20] = 
                        {
                            [1] = 77590,
                            [2] = 150670,
                            ["Pre"] = 590.5400000000,
                        },
                        [21] = 
                        {
                            [1] = 30161,
                            [2] = 150670,
                            ["Pre"] = 623.1900000000,
                        },
                        [22] = 
                        {
                            [1] = 30165,
                            [2] = 30152,
                            ["Pre"] = 1054.2500000000,
                        },
                        [23] = 
                        {
                            [1] = 30157,
                            [2] = 30152,
                            ["Pre"] = 1059.2500000000,
                        },
                        [24] = 
                        {
                            [1] = 30149,
                            [2] = 30152,
                            ["Pre"] = 1073.8700000000,
                        },
                        [25] = 
                        {
                            [1] = 30151,
                            [2] = 30152,
                            ["Pre"] = 1085.5900000000,
                        },
                        [26] = 
                        {
                            [1] = 77590,
                            [2] = 30152,
                            ["Pre"] = 1093.4000000000,
                        },
                        [27] = 
                        {
                            [1] = 30161,
                            [2] = 30152,
                            ["Pre"] = 1126.0500000000,
                        },
                        [28] = 
                        {
                            [1] = 150670,
                            [2] = 30152,
                            ["Pre"] = 1423.8800000000,
                        },
                    },
                    [44813] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30160,
                            ["Pre"] = 415.0700000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30160,
                            ["Pre"] = 415.2900000000,
                        },
                    },
                    [44814] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 77591,
                            ["Pre"] = 721.3500000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 139020,
                            ["Pre"] = 793.6300000000,
                        },
                        [3] = 
                        {
                            [1] = 30160,
                            [2] = 77591,
                            ["Pre"] = 978.2000000000,
                        },
                        [4] = 
                        {
                            [1] = 30160,
                            [2] = 139020,
                            ["Pre"] = 1050.4800000000,
                        },
                        [5] = 
                        {
                            [1] = 77591,
                            [2] = 139020,
                            ["Pre"] = 1356.5400000000,
                        },
                    },
                    [44815] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            ["Pre"] = 158.2200000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            ["Pre"] = 201.2200000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            ["Pre"] = 201.4400000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 77589,
                            ["Pre"] = 503.9200000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 77589,
                            ["Pre"] = 504.1400000000,
                        },
                        [6] = 
                        {
                            [1] = 30151,
                            [2] = 77589,
                            ["Pre"] = 547.1400000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 150669,
                            ["Pre"] = 699.8700000000,
                        },
                        [8] = 
                        {
                            [1] = 30154,
                            [2] = 150669,
                            ["Pre"] = 700.0900000000,
                        },
                        [9] = 
                        {
                            [1] = 30151,
                            [2] = 150669,
                            ["Pre"] = 743.0900000000,
                        },
                        [10] = 
                        {
                            [1] = 30148,
                            [2] = 30152,
                            ["Pre"] = 1042.3700000000,
                        },
                        [11] = 
                        {
                            [1] = 30154,
                            [2] = 30152,
                            ["Pre"] = 1042.5900000000,
                        },
                        [12] = 
                        {
                            [1] = 77589,
                            [2] = 150669,
                            ["Pre"] = 1045.7900000000,
                        },
                        [13] = 
                        {
                            [1] = 77589,
                            [2] = 30152,
                            ["Pre"] = 1388.2900000000,
                        },
                        [14] = 
                        {
                            [1] = 150669,
                            [2] = 30152,
                            ["Pre"] = 1584.2400000000,
                        },
                    },
                    [77602] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            ["Pre"] = 220.1000000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 77591,
                            ["Pre"] = 732.2000000000,
                        },
                        [3] = 
                        {
                            [1] = 77590,
                            [2] = 139020,
                            ["Pre"] = 844.4400000000,
                        },
                        [4] = 
                        {
                            [1] = 77590,
                            [2] = 150731,
                            ["Pre"] = 3594.0600000000,
                        },
                        [5] = 
                        {
                            [1] = 77591,
                            [2] = 150731,
                            ["Pre"] = 4106.1600000000,
                        },
                        [6] = 
                        {
                            [1] = 139020,
                            [2] = 150731,
                            ["Pre"] = 4178.4400000000,
                        },
                    },
                    [30145] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            ["Pre"] = 266.0400000000,
                        },
                        [2] = 
                        {
                            [1] = 30158,
                            [2] = 30152,
                            ["Pre"] = 1066.7300000000,
                        },
                    },
                    [27041] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            ["Pre"] = 186.6400000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 77589,
                            ["Pre"] = 515.6800000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 77589,
                            ["Pre"] = 520.8000000000,
                        },
                        [4] = 
                        {
                            [1] = 30153,
                            [2] = 139019,
                            ["Pre"] = 1833.4500000000,
                        },
                        [5] = 
                        {
                            [1] = 30157,
                            [2] = 139019,
                            ["Pre"] = 1838.5700000000,
                        },
                        [6] = 
                        {
                            [1] = 77589,
                            [2] = 139019,
                            ["Pre"] = 2167.6100000000,
                        },
                        [7] = 
                        {
                            [1] = 30153,
                            [2] = 150671,
                            ["Pre"] = 7468.5500000000,
                        },
                        [8] = 
                        {
                            [1] = 30157,
                            [2] = 150671,
                            ["Pre"] = 7473.6700000000,
                        },
                        [9] = 
                        {
                            [1] = 77589,
                            [2] = 150671,
                            ["Pre"] = 7802.7100000000,
                        },
                        [10] = 
                        {
                            [1] = 139019,
                            [2] = 150671,
                            ["Pre"] = 9120.4800000000,
                        },
                    },
                    [54333] = 
                    {
                        [1] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            ["Pre"] = 221.4700000000,
                        },
                    },
                    [77597] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            ["Pre"] = 340.4900000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 150670,
                            ["Pre"] = 670.9700000000,
                        },
                        [3] = 
                        {
                            [1] = 77590,
                            [2] = 77591,
                            ["Pre"] = 772.1600000000,
                        },
                        [4] = 
                        {
                            [1] = 150670,
                            [2] = 77591,
                            ["Pre"] = 1102.6400000000,
                        },
                        [5] = 
                        {
                            [1] = 77590,
                            [2] = 139019,
                            ["Pre"] = 1872.7200000000,
                        },
                        [6] = 
                        {
                            [1] = 77583,
                            [2] = 139019,
                            ["Pre"] = 1953.1500000000,
                        },
                        [7] = 
                        {
                            [1] = 150670,
                            [2] = 139019,
                            ["Pre"] = 2203.2000000000,
                        },
                        [8] = 
                        {
                            [1] = 77591,
                            [2] = 139019,
                            ["Pre"] = 2384.8200000000,
                        },
                    },
                    [44821] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            ["Pre"] = 313.8200000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 30152,
                            ["Pre"] = 1173.8300000000,
                        },
                    },
                    [27039] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            ["Pre"] = 181.5600000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 30164,
                            ["Pre"] = 2135.9100000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 30164,
                            ["Pre"] = 2135.9500000000,
                        },
                    },
                    [152151] = 
                    {
                        [1] = 
                        {
                            [1] = 150789,
                            [2] = 150731,
                            ["Pre"] = 3636.3400000000,
                        },
                        [2] = 
                        {
                            [1] = 150789,
                            [2] = 150671,
                            ["Pre"] = 7550.1000000000,
                        },
                        [3] = 
                        {
                            [1] = 150731,
                            [2] = 150671,
                            ["Pre"] = 10841.8200000000,
                        },
                    },
                    [77592] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            ["Pre"] = 195.1400000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 77589,
                            ["Pre"] = 514.9900000000,
                        },
                        [3] = 
                        {
                            [1] = 77585,
                            [2] = 77589,
                            ["Pre"] = 529.9900000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 139019,
                            ["Pre"] = 1832.7600000000,
                        },
                        [5] = 
                        {
                            [1] = 77585,
                            [2] = 139019,
                            ["Pre"] = 1847.7600000000,
                        },
                        [6] = 
                        {
                            [1] = 77584,
                            [2] = 150731,
                            ["Pre"] = 3554.1000000000,
                        },
                        [7] = 
                        {
                            [1] = 77585,
                            [2] = 150731,
                            ["Pre"] = 3569.1000000000,
                        },
                        [8] = 
                        {
                            [1] = 77589,
                            [2] = 150731,
                            ["Pre"] = 3888.9500000000,
                        },
                        [9] = 
                        {
                            [1] = 139019,
                            [2] = 150731,
                            ["Pre"] = 5206.7200000000,
                        },
                    },
                    [77593] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            ["Pre"] = 195.1400000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 77589,
                            ["Pre"] = 514.9900000000,
                        },
                        [3] = 
                        {
                            [1] = 77585,
                            [2] = 77589,
                            ["Pre"] = 529.9900000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 139019,
                            ["Pre"] = 1832.7600000000,
                        },
                        [5] = 
                        {
                            [1] = 77585,
                            [2] = 139019,
                            ["Pre"] = 1847.7600000000,
                        },
                        [6] = 
                        {
                            [1] = 77584,
                            [2] = 150731,
                            ["Pre"] = 3554.1000000000,
                        },
                        [7] = 
                        {
                            [1] = 77585,
                            [2] = 150731,
                            ["Pre"] = 3569.1000000000,
                        },
                        [8] = 
                        {
                            [1] = 77589,
                            [2] = 150731,
                            ["Pre"] = 3888.9500000000,
                        },
                        [9] = 
                        {
                            [1] = 139019,
                            [2] = 150731,
                            ["Pre"] = 5206.7200000000,
                        },
                    },
                    [76826] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            ["Pre"] = 165.9600000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            ["Pre"] = 178.2500000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            ["Pre"] = 184.0700000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            ["Pre"] = 186.2100000000,
                        },
                        [5] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            ["Pre"] = 192.0300000000,
                        },
                        [6] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            ["Pre"] = 204.3200000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            ["Pre"] = 353.5600000000,
                        },
                        [8] = 
                        {
                            [1] = 30166,
                            [2] = 30163,
                            ["Pre"] = 373.8100000000,
                        },
                        [9] = 
                        {
                            [1] = 77585,
                            [2] = 30163,
                            ["Pre"] = 379.6300000000,
                        },
                        [10] = 
                        {
                            [1] = 30155,
                            [2] = 30160,
                            ["Pre"] = 423.0300000000,
                        },
                        [11] = 
                        {
                            [1] = 30166,
                            [2] = 30160,
                            ["Pre"] = 435.3200000000,
                        },
                        [12] = 
                        {
                            [1] = 77585,
                            [2] = 30160,
                            ["Pre"] = 441.1400000000,
                        },
                        [13] = 
                        {
                            [1] = 30148,
                            [2] = 150672,
                            ["Pre"] = 491.2000000000,
                        },
                        [14] = 
                        {
                            [1] = 30155,
                            [2] = 150672,
                            ["Pre"] = 499.1600000000,
                        },
                        [15] = 
                        {
                            [1] = 77585,
                            [2] = 150672,
                            ["Pre"] = 517.2700000000,
                        },
                        [16] = 
                        {
                            [1] = 30163,
                            [2] = 30160,
                            ["Pre"] = 610.6300000000,
                        },
                        [17] = 
                        {
                            [1] = 30163,
                            [2] = 150672,
                            ["Pre"] = 686.7600000000,
                        },
                        [18] = 
                        {
                            [1] = 30160,
                            [2] = 150672,
                            ["Pre"] = 748.2700000000,
                        },
                        [19] = 
                        {
                            [1] = 30148,
                            [2] = 30164,
                            ["Pre"] = 2124.1500000000,
                        },
                        [20] = 
                        {
                            [1] = 30155,
                            [2] = 30164,
                            ["Pre"] = 2132.1100000000,
                        },
                        [21] = 
                        {
                            [1] = 30166,
                            [2] = 30164,
                            ["Pre"] = 2144.4000000000,
                        },
                        [22] = 
                        {
                            [1] = 77585,
                            [2] = 30164,
                            ["Pre"] = 2150.2200000000,
                        },
                        [23] = 
                        {
                            [1] = 30163,
                            [2] = 30164,
                            ["Pre"] = 2319.7100000000,
                        },
                        [24] = 
                        {
                            [1] = 30160,
                            [2] = 30164,
                            ["Pre"] = 2381.2200000000,
                        },
                        [25] = 
                        {
                            [1] = 150672,
                            [2] = 30164,
                            ["Pre"] = 2457.3500000000,
                        },
                    },
                    [77595] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            ["Pre"] = 211.7900000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 150672,
                            ["Pre"] = 493.9600000000,
                        },
                        [3] = 
                        {
                            [1] = 77590,
                            [2] = 150672,
                            ["Pre"] = 542.2300000000,
                        },
                    },
                    [76828] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30160,
                            ["Pre"] = 439.4300000000,
                        },
                        [2] = 
                        {
                            [1] = 30161,
                            [2] = 30160,
                            ["Pre"] = 498.7500000000,
                        },
                        [3] = 
                        {
                            [1] = 30158,
                            [2] = 150670,
                            ["Pre"] = 563.8700000000,
                        },
                        [4] = 
                        {
                            [1] = 30160,
                            [2] = 150670,
                            ["Pre"] = 796.5800000000,
                        },
                        [5] = 
                        {
                            [1] = 30158,
                            [2] = 30164,
                            ["Pre"] = 2148.5100000000,
                        },
                        [6] = 
                        {
                            [1] = 30161,
                            [2] = 30164,
                            ["Pre"] = 2207.8300000000,
                        },
                        [7] = 
                        {
                            [1] = 150670,
                            [2] = 30164,
                            ["Pre"] = 2505.6600000000,
                        },
                        [8] = 
                        {
                            [1] = 30158,
                            [2] = 150671,
                            ["Pre"] = 7481.1500000000,
                        },
                        [9] = 
                        {
                            [1] = 30161,
                            [2] = 150671,
                            ["Pre"] = 7540.4700000000,
                        },
                        [10] = 
                        {
                            [1] = 30160,
                            [2] = 150671,
                            ["Pre"] = 7713.8600000000,
                        },
                        [11] = 
                        {
                            [1] = 150670,
                            [2] = 150671,
                            ["Pre"] = 7838.3000000000,
                        },
                        [12] = 
                        {
                            [1] = 30164,
                            [2] = 150671,
                            ["Pre"] = 9422.9400000000,
                        },
                    },
                    [76829] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            ["Pre"] = 158.2200000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            ["Pre"] = 201.2200000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            ["Pre"] = 201.4400000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 77589,
                            ["Pre"] = 503.9200000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 77589,
                            ["Pre"] = 504.1400000000,
                        },
                        [6] = 
                        {
                            [1] = 30151,
                            [2] = 77589,
                            ["Pre"] = 547.1400000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 150669,
                            ["Pre"] = 699.8700000000,
                        },
                        [8] = 
                        {
                            [1] = 30154,
                            [2] = 150669,
                            ["Pre"] = 700.0900000000,
                        },
                        [9] = 
                        {
                            [1] = 30151,
                            [2] = 150669,
                            ["Pre"] = 743.0900000000,
                        },
                        [10] = 
                        {
                            [1] = 30148,
                            [2] = 30152,
                            ["Pre"] = 1042.3700000000,
                        },
                        [11] = 
                        {
                            [1] = 30154,
                            [2] = 30152,
                            ["Pre"] = 1042.5900000000,
                        },
                        [12] = 
                        {
                            [1] = 77589,
                            [2] = 150669,
                            ["Pre"] = 1045.7900000000,
                        },
                        [13] = 
                        {
                            [1] = 77589,
                            [2] = 30152,
                            ["Pre"] = 1388.2900000000,
                        },
                        [14] = 
                        {
                            [1] = 150669,
                            [2] = 30152,
                            ["Pre"] = 1584.2400000000,
                        },
                    },
                    [76830] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            ["Pre"] = 352.0300000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            ["Pre"] = 370.4400000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 150669,
                            ["Pre"] = 698.3400000000,
                        },
                        [4] = 
                        {
                            [1] = 30157,
                            [2] = 150669,
                            ["Pre"] = 716.7500000000,
                        },
                        [5] = 
                        {
                            [1] = 30163,
                            [2] = 150669,
                            ["Pre"] = 895.4300000000,
                        },
                        [6] = 
                        {
                            [1] = 30162,
                            [2] = 30164,
                            ["Pre"] = 2122.6200000000,
                        },
                        [7] = 
                        {
                            [1] = 30157,
                            [2] = 30164,
                            ["Pre"] = 2141.0300000000,
                        },
                        [8] = 
                        {
                            [1] = 150669,
                            [2] = 30164,
                            ["Pre"] = 2666.0200000000,
                        },
                        [9] = 
                        {
                            [1] = 30162,
                            [2] = 150731,
                            ["Pre"] = 3541.5000000000,
                        },
                        [10] = 
                        {
                            [1] = 30157,
                            [2] = 150731,
                            ["Pre"] = 3559.9100000000,
                        },
                        [11] = 
                        {
                            [1] = 30163,
                            [2] = 150731,
                            ["Pre"] = 3738.5900000000,
                        },
                        [12] = 
                        {
                            [1] = 150669,
                            [2] = 150731,
                            ["Pre"] = 4084.9000000000,
                        },
                        [13] = 
                        {
                            [1] = 30164,
                            [2] = 150731,
                            ["Pre"] = 5509.1800000000,
                        },
                    },
                    [76831] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            ["Pre"] = 168.7200000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            ["Pre"] = 187.5500000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            ["Pre"] = 192.2600000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            ["Pre"] = 192.7500000000,
                        },
                        [5] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            ["Pre"] = 197.4600000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            ["Pre"] = 203.9800000000,
                        },
                        [7] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            ["Pre"] = 209.1800000000,
                        },
                        [8] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            ["Pre"] = 216.2900000000,
                        },
                        [9] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            ["Pre"] = 228.0100000000,
                        },
                    },
                    [76832] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 77591,
                            ["Pre"] = 721.3500000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 139020,
                            ["Pre"] = 793.6300000000,
                        },
                        [3] = 
                        {
                            [1] = 30160,
                            [2] = 77591,
                            ["Pre"] = 978.2000000000,
                        },
                        [4] = 
                        {
                            [1] = 30160,
                            [2] = 139020,
                            ["Pre"] = 1050.4800000000,
                        },
                        [5] = 
                        {
                            [1] = 77591,
                            [2] = 139020,
                            ["Pre"] = 1356.5400000000,
                        },
                    },
                    [76833] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            ["Pre"] = 313.8200000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 30152,
                            ["Pre"] = 1173.8300000000,
                        },
                    },
                    [76834] = 
                    {
                        [1] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            ["Pre"] = 316.2500000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            ["Pre"] = 485.0200000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 77591,
                            ["Pre"] = 747.9200000000,
                        },
                        [4] = 
                        {
                            [1] = 77583,
                            [2] = 77591,
                            ["Pre"] = 852.5900000000,
                        },
                        [5] = 
                        {
                            [1] = 30163,
                            [2] = 77591,
                            ["Pre"] = 916.6900000000,
                        },
                    },
                    [77603] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            ["Pre"] = 220.1000000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 77591,
                            ["Pre"] = 732.2000000000,
                        },
                        [3] = 
                        {
                            [1] = 77590,
                            [2] = 139020,
                            ["Pre"] = 844.4400000000,
                        },
                        [4] = 
                        {
                            [1] = 77590,
                            [2] = 150731,
                            ["Pre"] = 3594.0600000000,
                        },
                        [5] = 
                        {
                            [1] = 77591,
                            [2] = 150731,
                            ["Pre"] = 4106.1600000000,
                        },
                        [6] = 
                        {
                            [1] = 139020,
                            [2] = 150731,
                            ["Pre"] = 4178.4400000000,
                        },
                    },
                    [76836] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            ["Pre"] = 266.0400000000,
                        },
                        [2] = 
                        {
                            [1] = 30158,
                            [2] = 30152,
                            ["Pre"] = 1066.7300000000,
                        },
                    },
                    [158309] = 
                    {
                        [1] = 
                        {
                            [1] = 150672,
                            [2] = 150670,
                            ["Pre"] = 872.7100000000,
                        },
                        [2] = 
                        {
                            [1] = 150672,
                            [2] = 150669,
                            ["Pre"] = 1033.0700000000,
                        },
                        [3] = 
                        {
                            [1] = 150670,
                            [2] = 150669,
                            ["Pre"] = 1081.3800000000,
                        },
                    },
                    [76838] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            ["Pre"] = 173.3500000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            ["Pre"] = 187.9700000000,
                        },
                    },
                    [76839] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            ["Pre"] = 361.5200000000,
                        },
                        [2] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            ["Pre"] = 380.3500000000,
                        },
                    },
                    [76840] = 
                    {
                        [1] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            ["Pre"] = 190.0100000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            ["Pre"] = 194.1200000000,
                        },
                        [3] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            ["Pre"] = 202.6100000000,
                        },
                        [4] = 
                        {
                            [1] = 30153,
                            [2] = 150672,
                            ["Pre"] = 502.9600000000,
                        },
                        [5] = 
                        {
                            [1] = 30166,
                            [2] = 150672,
                            ["Pre"] = 511.4500000000,
                        },
                        [6] = 
                        {
                            [1] = 30158,
                            [2] = 150672,
                            ["Pre"] = 515.5600000000,
                        },
                    },
                    [76841] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            ["Pre"] = 195.9500000000,
                        },
                    },
                    [76842] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            ["Pre"] = 168.2700000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            ["Pre"] = 176.7200000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            ["Pre"] = 190.0500000000,
                        },
                    },
                    [76843] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            ["Pre"] = 196.6700000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 77581,
                            ["Pre"] = 790.0800000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 77581,
                            ["Pre"] = 804.9900000000,
                        },
                        [4] = 
                        {
                            [1] = 30165,
                            [2] = 150671,
                            ["Pre"] = 7468.6700000000,
                        },
                        [5] = 
                        {
                            [1] = 30156,
                            [2] = 150671,
                            ["Pre"] = 7483.5800000000,
                        },
                        [6] = 
                        {
                            [1] = 77581,
                            [2] = 150671,
                            ["Pre"] = 8076.9900000000,
                        },
                    },
                    [76844] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            ["Pre"] = 181.5600000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 30164,
                            ["Pre"] = 2135.9100000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 30164,
                            ["Pre"] = 2135.9500000000,
                        },
                    },
                    [76845] = 
                    {
                        [1] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            ["Pre"] = 221.4700000000,
                        },
                    },
                    [76846] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            ["Pre"] = 170.0200000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            ["Pre"] = 241.9000000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            ["Pre"] = 253.4800000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 150669,
                            ["Pre"] = 711.6700000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 77581,
                            ["Pre"] = 778.4200000000,
                        },
                        [6] = 
                        {
                            [1] = 30161,
                            [2] = 150669,
                            ["Pre"] = 783.5500000000,
                        },
                        [7] = 
                        {
                            [1] = 30159,
                            [2] = 77581,
                            ["Pre"] = 790,
                        },
                        [8] = 
                        {
                            [1] = 30161,
                            [2] = 77581,
                            ["Pre"] = 861.8800000000,
                        },
                        [9] = 
                        {
                            [1] = 77581,
                            [2] = 150669,
                            ["Pre"] = 1320.0700000000,
                        },
                    },
                    [76847] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            ["Pre"] = 169.0700000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            ["Pre"] = 169.7600000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            ["Pre"] = 169.8800000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            ["Pre"] = 180.8300000000,
                        },
                        [5] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            ["Pre"] = 180.9500000000,
                        },
                        [6] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            ["Pre"] = 181.6400000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            ["Pre"] = 251.3100000000,
                        },
                        [8] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            ["Pre"] = 262.3800000000,
                        },
                        [9] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            ["Pre"] = 263.0700000000,
                        },
                        [10] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            ["Pre"] = 263.1900000000,
                        },
                    },
                    [76848] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            ["Pre"] = 186.6400000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 77589,
                            ["Pre"] = 515.6800000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 77589,
                            ["Pre"] = 520.8000000000,
                        },
                        [4] = 
                        {
                            [1] = 30153,
                            [2] = 139019,
                            ["Pre"] = 1833.4500000000,
                        },
                        [5] = 
                        {
                            [1] = 30157,
                            [2] = 139019,
                            ["Pre"] = 1838.5700000000,
                        },
                        [6] = 
                        {
                            [1] = 77589,
                            [2] = 139019,
                            ["Pre"] = 2167.6100000000,
                        },
                        [7] = 
                        {
                            [1] = 30153,
                            [2] = 150671,
                            ["Pre"] = 7468.5500000000,
                        },
                        [8] = 
                        {
                            [1] = 30157,
                            [2] = 150671,
                            ["Pre"] = 7473.6700000000,
                        },
                        [9] = 
                        {
                            [1] = 77589,
                            [2] = 150671,
                            ["Pre"] = 7802.7100000000,
                        },
                        [10] = 
                        {
                            [1] = 139019,
                            [2] = 150671,
                            ["Pre"] = 9120.4800000000,
                        },
                    },
                    [76849] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            ["Pre"] = 177.0300000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            ["Pre"] = 177.7600000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            ["Pre"] = 180.8700000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 139020,
                            ["Pre"] = 801.3700000000,
                        },
                        [5] = 
                        {
                            [1] = 77584,
                            [2] = 139020,
                            ["Pre"] = 804.4800000000,
                        },
                        [6] = 
                        {
                            [1] = 30159,
                            [2] = 139020,
                            ["Pre"] = 805.2100000000,
                        },
                    },
                    [77599] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            ["Pre"] = 254.0700000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 77589,
                            ["Pre"] = 506.6800000000,
                        },
                        [3] = 
                        {
                            [1] = 150789,
                            [2] = 77589,
                            ["Pre"] = 597.2300000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 139020,
                            ["Pre"] = 796.1700000000,
                        },
                        [5] = 
                        {
                            [1] = 150789,
                            [2] = 139020,
                            ["Pre"] = 886.7200000000,
                        },
                        [6] = 
                        {
                            [1] = 77589,
                            [2] = 139020,
                            ["Pre"] = 1139.3300000000,
                        },
                    },
                    [76827] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            ["Pre"] = 186.7600000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            ["Pre"] = 201.3800000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            ["Pre"] = 206.3800000000,
                        },
                        [4] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            ["Pre"] = 213.1000000000,
                        },
                        [5] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            ["Pre"] = 218.1000000000,
                        },
                        [6] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            ["Pre"] = 220.9100000000,
                        },
                        [7] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            ["Pre"] = 225.9100000000,
                        },
                        [8] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            ["Pre"] = 232.7200000000,
                        },
                        [9] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            ["Pre"] = 240.5300000000,
                        },
                        [10] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            ["Pre"] = 252.2500000000,
                        },
                        [11] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            ["Pre"] = 253.5600000000,
                        },
                        [12] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            ["Pre"] = 258.5600000000,
                        },
                        [13] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            ["Pre"] = 273.1800000000,
                        },
                        [14] = 
                        {
                            [1] = 30151,
                            [2] = 30161,
                            ["Pre"] = 284.9000000000,
                        },
                        [15] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            ["Pre"] = 292.7100000000,
                        },
                        [16] = 
                        {
                            [1] = 30165,
                            [2] = 150670,
                            ["Pre"] = 551.3900000000,
                        },
                        [17] = 
                        {
                            [1] = 30157,
                            [2] = 150670,
                            ["Pre"] = 556.3900000000,
                        },
                        [18] = 
                        {
                            [1] = 30149,
                            [2] = 150670,
                            ["Pre"] = 571.0100000000,
                        },
                        [19] = 
                        {
                            [1] = 30151,
                            [2] = 150670,
                            ["Pre"] = 582.7300000000,
                        },
                        [20] = 
                        {
                            [1] = 77590,
                            [2] = 150670,
                            ["Pre"] = 590.5400000000,
                        },
                        [21] = 
                        {
                            [1] = 30161,
                            [2] = 150670,
                            ["Pre"] = 623.1900000000,
                        },
                        [22] = 
                        {
                            [1] = 30165,
                            [2] = 30152,
                            ["Pre"] = 1054.2500000000,
                        },
                        [23] = 
                        {
                            [1] = 30157,
                            [2] = 30152,
                            ["Pre"] = 1059.2500000000,
                        },
                        [24] = 
                        {
                            [1] = 30149,
                            [2] = 30152,
                            ["Pre"] = 1073.8700000000,
                        },
                        [25] = 
                        {
                            [1] = 30151,
                            [2] = 30152,
                            ["Pre"] = 1085.5900000000,
                        },
                        [26] = 
                        {
                            [1] = 77590,
                            [2] = 30152,
                            ["Pre"] = 1093.4000000000,
                        },
                        [27] = 
                        {
                            [1] = 30161,
                            [2] = 30152,
                            ["Pre"] = 1126.0500000000,
                        },
                        [28] = 
                        {
                            [1] = 150670,
                            [2] = 30152,
                            ["Pre"] = 1423.8800000000,
                        },
                    },
                    [27040] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 77581,
                            ["Pre"] = 776.6700000000,
                        },
                        [2] = 
                        {
                            [1] = 30149,
                            [2] = 77581,
                            ["Pre"] = 809.7000000000,
                        },
                    },
                    [44714] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            ["Pre"] = 173.3500000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            ["Pre"] = 187.9700000000,
                        },
                    },
                    [44715] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            ["Pre"] = 169.0700000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            ["Pre"] = 169.7600000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            ["Pre"] = 169.8800000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            ["Pre"] = 180.8300000000,
                        },
                        [5] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            ["Pre"] = 180.9500000000,
                        },
                        [6] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            ["Pre"] = 181.6400000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            ["Pre"] = 251.3100000000,
                        },
                        [8] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            ["Pre"] = 262.3800000000,
                        },
                        [9] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            ["Pre"] = 263.0700000000,
                        },
                        [10] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            ["Pre"] = 263.1900000000,
                        },
                    },
                    [77594] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            ["Pre"] = 211.7900000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 150672,
                            ["Pre"] = 493.9600000000,
                        },
                        [3] = 
                        {
                            [1] = 77590,
                            [2] = 150672,
                            ["Pre"] = 542.2300000000,
                        },
                    },
                    [77598] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            ["Pre"] = 254.0700000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 77589,
                            ["Pre"] = 506.6800000000,
                        },
                        [3] = 
                        {
                            [1] = 150789,
                            [2] = 77589,
                            ["Pre"] = 597.2300000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 139020,
                            ["Pre"] = 796.1700000000,
                        },
                        [5] = 
                        {
                            [1] = 150789,
                            [2] = 139020,
                            ["Pre"] = 886.7200000000,
                        },
                        [6] = 
                        {
                            [1] = 77589,
                            [2] = 139020,
                            ["Pre"] = 1139.3300000000,
                        },
                    },
                    [77600] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            ["Pre"] = 186.8300000000,
                        },
                        [2] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            ["Pre"] = 277.3800000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            ["Pre"] = 292.2200000000,
                        },
                        [4] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            ["Pre"] = 315.5300000000,
                        },
                        [5] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            ["Pre"] = 382.7700000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 77581,
                            ["Pre"] = 780.9600000000,
                        },
                        [7] = 
                        {
                            [1] = 77585,
                            [2] = 77581,
                            ["Pre"] = 804.2700000000,
                        },
                        [8] = 
                        {
                            [1] = 150789,
                            [2] = 77581,
                            ["Pre"] = 871.5100000000,
                        },
                        [9] = 
                        {
                            [1] = 77583,
                            [2] = 77581,
                            ["Pre"] = 909.6600000000,
                        },
                        [10] = 
                        {
                            [1] = 77587,
                            [2] = 139019,
                            ["Pre"] = 1824.4500000000,
                        },
                        [11] = 
                        {
                            [1] = 150789,
                            [2] = 139019,
                            ["Pre"] = 1915,
                        },
                        [12] = 
                        {
                            [1] = 77581,
                            [2] = 139019,
                            ["Pre"] = 2441.8900000000,
                        },
                    },
                    [77601] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            ["Pre"] = 186.8300000000,
                        },
                        [2] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            ["Pre"] = 277.3800000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            ["Pre"] = 292.2200000000,
                        },
                        [4] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            ["Pre"] = 315.5300000000,
                        },
                        [5] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            ["Pre"] = 382.7700000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 77581,
                            ["Pre"] = 780.9600000000,
                        },
                        [7] = 
                        {
                            [1] = 77585,
                            [2] = 77581,
                            ["Pre"] = 804.2700000000,
                        },
                        [8] = 
                        {
                            [1] = 150789,
                            [2] = 77581,
                            ["Pre"] = 871.5100000000,
                        },
                        [9] = 
                        {
                            [1] = 77583,
                            [2] = 77581,
                            ["Pre"] = 909.6600000000,
                        },
                        [10] = 
                        {
                            [1] = 77587,
                            [2] = 139019,
                            ["Pre"] = 1824.4500000000,
                        },
                        [11] = 
                        {
                            [1] = 150789,
                            [2] = 139019,
                            ["Pre"] = 1915,
                        },
                        [12] = 
                        {
                            [1] = 77581,
                            [2] = 139019,
                            ["Pre"] = 2441.8900000000,
                        },
                    },
                    [76835] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 77581,
                            ["Pre"] = 776.6700000000,
                        },
                        [2] = 
                        {
                            [1] = 30149,
                            [2] = 77581,
                            ["Pre"] = 809.7000000000,
                        },
                    },
                    [76837] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30160,
                            ["Pre"] = 415.0700000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30160,
                            ["Pre"] = 415.2900000000,
                        },
                    },
                    [30141] = 
                    {
                        [1] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            ["Pre"] = 190.0100000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            ["Pre"] = 194.1200000000,
                        },
                        [3] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            ["Pre"] = 202.6100000000,
                        },
                        [4] = 
                        {
                            [1] = 30153,
                            [2] = 150672,
                            ["Pre"] = 502.9600000000,
                        },
                        [5] = 
                        {
                            [1] = 30166,
                            [2] = 150672,
                            ["Pre"] = 511.4500000000,
                        },
                        [6] = 
                        {
                            [1] = 30158,
                            [2] = 150672,
                            ["Pre"] = 515.5600000000,
                        },
                    },
                    [30142] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            ["Pre"] = 170.0200000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            ["Pre"] = 241.9000000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            ["Pre"] = 253.4800000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 150669,
                            ["Pre"] = 711.6700000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 77581,
                            ["Pre"] = 778.4200000000,
                        },
                        [6] = 
                        {
                            [1] = 30161,
                            [2] = 150669,
                            ["Pre"] = 783.5500000000,
                        },
                        [7] = 
                        {
                            [1] = 30159,
                            [2] = 77581,
                            ["Pre"] = 790,
                        },
                        [8] = 
                        {
                            [1] = 30161,
                            [2] = 77581,
                            ["Pre"] = 861.8800000000,
                        },
                        [9] = 
                        {
                            [1] = 77581,
                            [2] = 150669,
                            ["Pre"] = 1320.0700000000,
                        },
                    },
                    [54335] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            ["Pre"] = 177.0300000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            ["Pre"] = 177.7600000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            ["Pre"] = 180.8700000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 139020,
                            ["Pre"] = 801.3700000000,
                        },
                        [5] = 
                        {
                            [1] = 77584,
                            [2] = 139020,
                            ["Pre"] = 804.4800000000,
                        },
                        [6] = 
                        {
                            [1] = 30159,
                            [2] = 139020,
                            ["Pre"] = 805.2100000000,
                        },
                    },
                }
--The combo of reagents for master craft
SDC.Master2Craft = 
                {
                    [1835008] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30162,
                            [3] = 77590,
                            ["Pre"] = 289.2600000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 77590,
                            ["Pre"] = 290.7900000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 77590,
                            ["Pre"] = 291.0100000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 77590,
                            ["Pre"] = 302.5500000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 77590,
                            ["Pre"] = 302.5900000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 77590,
                            ["Pre"] = 311.0400000000,
                        },
                        [7] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 77590,
                            ["Pre"] = 315.1500000000,
                        },
                        [8] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 77590,
                            ["Pre"] = 384.1000000000,
                        },
                        [9] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 422.2500000000,
                        },
                        [10] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 30163,
                            ["Pre"] = 486.3500000000,
                        },
                        [11] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 30160,
                            ["Pre"] = 547.8600000000,
                        },
                        [12] = 
                        {
                            [1] = 77587,
                            [2] = 30162,
                            [3] = 150672,
                            ["Pre"] = 571.4300000000,
                        },
                        [13] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 150672,
                            ["Pre"] = 573.1800000000,
                        },
                        [14] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 150672,
                            ["Pre"] = 584.7600000000,
                        },
                        [15] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 150672,
                            ["Pre"] = 584.8400000000,
                        },
                        [16] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 150672,
                            ["Pre"] = 589.8400000000,
                        },
                        [17] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 619.7000000000,
                        },
                        [18] = 
                        {
                            [1] = 30148,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 621.2300000000,
                        },
                        [19] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 621.4500000000,
                        },
                        [20] = 
                        {
                            [1] = 30155,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 629.1900000000,
                        },
                        [21] = 
                        {
                            [1] = 30159,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 633.0300000000,
                        },
                        [22] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 633.1100000000,
                        },
                        [23] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 638.1100000000,
                        },
                        [24] = 
                        {
                            [1] = 30156,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 648.0200000000,
                        },
                        [25] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 652.7300000000,
                        },
                        [26] = 
                        {
                            [1] = 77587,
                            [2] = 30161,
                            [3] = 150672,
                            ["Pre"] = 656.6400000000,
                        },
                        [27] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            [3] = 150672,
                            ["Pre"] = 664.4500000000,
                        },
                        [28] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 150672,
                            ["Pre"] = 704.9100000000,
                        },
                        [29] = 
                        {
                            [1] = 150789,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 714.5400000000,
                        },
                        [30] = 
                        {
                            [1] = 77590,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 816.7900000000,
                        },
                        [31] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 150669,
                            ["Pre"] = 832.6600000000,
                        },
                        [32] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 853.9200000000,
                        },
                        [33] = 
                        {
                            [1] = 77590,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 878.3000000000,
                        },
                        [34] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 77581,
                            ["Pre"] = 910.9900000000,
                        },
                        [35] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 926.2000000000,
                        },
                        [36] = 
                        {
                            [1] = 77587,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1136.0900000000,
                        },
                        [37] = 
                        {
                            [1] = 77590,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1241.4300000000,
                        },
                        [38] = 
                        {
                            [1] = 77587,
                            [2] = 150672,
                            [3] = 30152,
                            ["Pre"] = 1457.3300000000,
                        },
                        [39] = 
                        {
                            [1] = 77590,
                            [2] = 150672,
                            [3] = 30152,
                            ["Pre"] = 1505.6000000000,
                        },
                        [40] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 30164,
                            ["Pre"] = 2256.9400000000,
                        },
                        [41] = 
                        {
                            [1] = 77590,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2587.3800000000,
                        },
                        [42] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 150671,
                            ["Pre"] = 7589.5800000000,
                        },
                        [43] = 
                        {
                            [1] = 77587,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 7871.7500000000,
                        },
                        [44] = 
                        {
                            [1] = 77590,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 7920.0200000000,
                        },
                    },
                    [1444865] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 30160,
                            ["Pre"] = 505.1400000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 30160,
                            ["Pre"] = 505.8300000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 30160,
                            ["Pre"] = 587.3800000000,
                        },
                    },
                    [132101] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1680.1200000000,
                        },
                    },
                    [132102] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30149,
                            [3] = 30151,
                            ["Pre"] = 311.9400000000,
                        },
                        [2] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 657.6400000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1167.3500000000,
                        },
                        [4] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1191.3800000000,
                        },
                    },
                    [1379335] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 30160,
                            ["Pre"] = 506.0900000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30160,
                            [3] = 150669,
                            ["Pre"] = 1036.1600000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1114.4900000000,
                        },
                    },
                    [132104] = 
                    {
                        [1] = 
                        {
                            [1] = 30151,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1296.0500000000,
                        },
                    },
                    [396809] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 77583,
                            ["Pre"] = 403.2100000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 77591,
                            ["Pre"] = 834.8800000000,
                        },
                    },
                    [132618] = 
                    {
                        [1] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 931.9200000000,
                        },
                    },
                    [399374] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 30156,
                            ["Pre"] = 282.8200000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 30156,
                            ["Pre"] = 283.5500000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 139020,
                            ["Pre"] = 907.1600000000,
                        },
                    },
                    [396818] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 30165,
                            [3] = 30156,
                            ["Pre"] = 283.6300000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 77581,
                            ["Pre"] = 891.9500000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 150671,
                            ["Pre"] = 7570.5400000000,
                        },
                    },
                    [267799] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 77589,
                            ["Pre"] = 594.6800000000,
                        },
                    },
                    [198681] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 774.3300000000,
                        },
                    },
                    [399386] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 139020,
                            ["Pre"] = 883.1300000000,
                        },
                    },
                    [267803] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 77589,
                            ["Pre"] = 593.9900000000,
                        },
                    },
                    [132636] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 77590,
                            ["Pre"] = 322.2900000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 334.0100000000,
                        },
                    },
                    [1448477] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 150789,
                            ["Pre"] = 333.0700000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 150789,
                            ["Pre"] = 344.8300000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 150789,
                            ["Pre"] = 344.9500000000,
                        },
                    },
                    [1578526] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 139020,
                            ["Pre"] = 883.4800000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 139020,
                            ["Pre"] = 895.3600000000,
                        },
                    },
                    [1777183] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10931.8900000000,
                        },
                    },
                    [197919] = 
                    {
                        [1] = 
                        {
                            [1] = 30164,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 12886.9700000000,
                        },
                    },
                    [1511965] = 
                    {
                        [1] = 
                        {
                            [1] = 77581,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9819.6800000000,
                        },
                    },
                    [1508121] = 
                    {
                        [1] = 
                        {
                            [1] = 150670,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9580.9900000000,
                        },
                    },
                    [10485760] = 
                    {
                        [1] = 
                        {
                            [1] = 150672,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1493.5800000000,
                        },
                    },
                    [1514271] = 
                    {
                        [1] = 
                        {
                            [1] = 77589,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 11266.7400000000,
                        },
                        [2] = 
                        {
                            [1] = 139019,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 12584.5100000000,
                        },
                    },
                    [1547008] = 
                    {
                        [1] = 
                        {
                            [1] = 77589,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5631.6400000000,
                        },
                    },
                    [263451] = 
                    {
                        [1] = 
                        {
                            [1] = 77589,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4509.8200000000,
                        },
                    },
                    [66311] = 
                    {
                        [1] = 
                        {
                            [1] = 30160,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 3023.3500000000,
                        },
                        [2] = 
                        {
                            [1] = 30160,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 3095.6300000000,
                        },
                    },
                    [198425] = 
                    {
                        [1] = 
                        {
                            [1] = 30160,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1438.7100000000,
                        },
                    },
                    [330014] = 
                    {
                        [1] = 
                        {
                            [1] = 30163,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4380.7200000000,
                        },
                    },
                    [66848] = 
                    {
                        [1] = 
                        {
                            [1] = 30163,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1307.6300000000,
                        },
                        [2] = 
                        {
                            [1] = 150672,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 3078.2200000000,
                        },
                    },
                    [8454917] = 
                    {
                        [1] = 
                        {
                            [1] = 30163,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2655.7800000000,
                        },
                    },
                    [67337] = 
                    {
                        [1] = 
                        {
                            [1] = 30163,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1252.7600000000,
                        },
                    },
                    [1678592] = 
                    {
                        [1] = 
                        {
                            [1] = 77583,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2652.3500000000,
                        },
                    },
                    [10034432] = 
                    {
                        [1] = 
                        {
                            [1] = 77583,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2413.6600000000,
                        },
                    },
                    [1646592] = 
                    {
                        [1] = 
                        {
                            [1] = 77583,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 1083.1700000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1291.8400000000,
                        },
                        [3] = 
                        {
                            [1] = 150672,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1514.8400000000,
                        },
                        [4] = 
                        {
                            [1] = 150670,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1723.5100000000,
                        },
                        [5] = 
                        {
                            [1] = 150672,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2615.4000000000,
                        },
                        [6] = 
                        {
                            [1] = 150670,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2824.0700000000,
                        },
                    },
                    [66825] = 
                    {
                        [1] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2530.1700000000,
                        },
                        [2] = 
                        {
                            [1] = 30163,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2961.8400000000,
                        },
                    },
                    [1377042] = 
                    {
                        [1] = 
                        {
                            [1] = 30161,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8239.6700000000,
                        },
                    },
                    [164608] = 
                    {
                        [1] = 
                        {
                            [1] = 30161,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 8000.9800000000,
                        },
                    },
                    [136480] = 
                    {
                        [1] = 
                        {
                            [1] = 30161,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1244.0600000000,
                        },
                    },
                    [204800] = 
                    {
                        [1] = 
                        {
                            [1] = 30161,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 1035.3900000000,
                        },
                        [2] = 
                        {
                            [1] = 30160,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 1208.7800000000,
                        },
                        [3] = 
                        {
                            [1] = 150672,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2917.8600000000,
                        },
                    },
                    [198400] = 
                    {
                        [1] = 
                        {
                            [1] = 30161,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1140.8800000000,
                        },
                        [2] = 
                        {
                            [1] = 30161,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1213.1600000000,
                        },
                        [3] = 
                        {
                            [1] = 30160,
                            [2] = 150670,
                            [3] = 139020,
                            ["Pre"] = 1510.9900000000,
                        },
                        [4] = 
                        {
                            [1] = 30160,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8355.9900000000,
                        },
                        [5] = 
                        {
                            [1] = 30160,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8428.2700000000,
                        },
                    },
                    [270336] = 
                    {
                        [1] = 
                        {
                            [1] = 30151,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1155.2900000000,
                        },
                        [2] = 
                        {
                            [1] = 77589,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1457.9900000000,
                        },
                        [3] = 
                        {
                            [1] = 150672,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1996.4400000000,
                        },
                    },
                    [1974016] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10971.8500000000,
                        },
                        [2] = 
                        {
                            [1] = 77591,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 11483.9500000000,
                        },
                        [3] = 
                        {
                            [1] = 139020,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 11556.2300000000,
                        },
                    },
                    [499200] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1486.5700000000,
                        },
                        [2] = 
                        {
                            [1] = 77591,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4820.5700000000,
                        },
                    },
                    [137504] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1211.4100000000,
                        },
                    },
                    [170270] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1232.6700000000,
                        },
                    },
                    [1842688] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1256.6400000000,
                        },
                    },
                    [1841438] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1184.3600000000,
                        },
                    },
                    [1841440] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 1002.7400000000,
                        },
                    },
                    [10027008] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2083.1800000000,
                        },
                        [2] = 
                        {
                            [1] = 77590,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2514.8500000000,
                        },
                        [3] = 
                        {
                            [1] = 150670,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2845.3300000000,
                        },
                    },
                    [133145] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1303.8600000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1634.3400000000,
                        },
                    },
                    [628992] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 982.6200000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1313.1000000000,
                        },
                        [3] = 
                        {
                            [1] = 77583,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2595.2800000000,
                        },
                    },
                    [170240] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 801,
                        },
                        [2] = 
                        {
                            [1] = 77590,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2333.2300000000,
                        },
                    },
                    [1841408] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            [3] = 150672,
                            ["Pre"] = 752.6900000000,
                        },
                    },
                    [8520473] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 753.2200000000,
                        },
                    },
                    [10420224] = 
                    {
                        [1] = 
                        {
                            [1] = 150789,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 11014.1300000000,
                        },
                    },
                    [1514783] = 
                    {
                        [1] = 
                        {
                            [1] = 150789,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9292.7900000000,
                        },
                    },
                    [1187103] = 
                    {
                        [1] = 
                        {
                            [1] = 150789,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8249.3000000000,
                        },
                    },
                    [1514015] = 
                    {
                        [1] = 
                        {
                            [1] = 150789,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7975.0200000000,
                        },
                    },
                    [1776159] = 
                    {
                        [1] = 
                        {
                            [1] = 150789,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 4061.2600000000,
                        },
                    },
                    [461086] = 
                    {
                        [1] = 
                        {
                            [1] = 30156,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1462.3300000000,
                        },
                        [2] = 
                        {
                            [1] = 30163,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1631.1000000000,
                        },
                    },
                    [922112] = 
                    {
                        [1] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1079.5500000000,
                        },
                    },
                    [596253] = 
                    {
                        [1] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2058.9400000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            [3] = 139019,
                            ["Pre"] = 2227.7100000000,
                        },
                    },
                    [8984832] = 
                    {
                        [1] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 958.3800000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1127.1500000000,
                        },
                    },
                    [952576] = 
                    {
                        [1] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 590.8100000000,
                        },
                        [2] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1022.4800000000,
                        },
                    },
                    [596254] = 
                    {
                        [1] = 
                        {
                            [1] = 30156,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 877.9500000000,
                        },
                        [2] = 
                        {
                            [1] = 77590,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1046.7200000000,
                        },
                    },
                    [659968] = 
                    {
                        [1] = 
                        {
                            [1] = 30149,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8187.4900000000,
                        },
                    },
                    [136458] = 
                    {
                        [1] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 972.3800000000,
                        },
                    },
                    [8520710] = 
                    {
                        [1] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1196.0900000000,
                        },
                    },
                    [133632] = 
                    {
                        [1] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 77581,
                            ["Pre"] = 939.7300000000,
                        },
                        [2] = 
                        {
                            [1] = 30149,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1270.2100000000,
                        },
                        [3] = 
                        {
                            [1] = 30149,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1773.0700000000,
                        },
                    },
                    [1775901] = 
                    {
                        [1] = 
                        {
                            [1] = 77585,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2308.2700000000,
                        },
                    },
                    [1547037] = 
                    {
                        [1] = 
                        {
                            [1] = 77585,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2272.6800000000,
                        },
                    },
                    [1776128] = 
                    {
                        [1] = 
                        {
                            [1] = 77585,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1244.4000000000,
                        },
                    },
                    [66843] = 
                    {
                        [1] = 
                        {
                            [1] = 77585,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3843.6600000000,
                        },
                        [2] = 
                        {
                            [1] = 77585,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5614.2500000000,
                        },
                    },
                    [1444864] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 30160,
                            ["Pre"] = 505.9500000000,
                        },
                    },
                    [67869] = 
                    {
                        [1] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 590.0900000000,
                        },
                    },
                    [1908480] = 
                    {
                        [1] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7655.1700000000,
                        },
                        [2] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            [3] = 150671,
                            ["Pre"] = 7760.5600000000,
                        },
                    },
                    [1777408] = 
                    {
                        [1] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3741.4100000000,
                        },
                        [2] = 
                        {
                            [1] = 150789,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5379.0300000000,
                        },
                        [3] = 
                        {
                            [1] = 77585,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10946.8900000000,
                        },
                    },
                    [1809664] = 
                    {
                        [1] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 2020.0700000000,
                        },
                        [2] = 
                        {
                            [1] = 77585,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2546.9600000000,
                        },
                    },
                    [1776157] = 
                    {
                        [1] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 702.3000000000,
                        },
                    },
                    [203008] = 
                    {
                        [1] = 
                        {
                            [1] = 77590,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 926.6100000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 1007.0400000000,
                        },
                        [3] = 
                        {
                            [1] = 30158,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1206,
                        },
                        [4] = 
                        {
                            [1] = 30158,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2306.5600000000,
                        },
                        [5] = 
                        {
                            [1] = 30160,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2539.2700000000,
                        },
                        [6] = 
                        {
                            [1] = 77590,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2635.6900000000,
                        },
                        [7] = 
                        {
                            [1] = 77583,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2716.1200000000,
                        },
                        [8] = 
                        {
                            [1] = 150670,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 3147.7900000000,
                        },
                        [9] = 
                        {
                            [1] = 150670,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 4248.3500000000,
                        },
                        [10] = 
                        {
                            [1] = 77583,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 8048.7600000000,
                        },
                        [11] = 
                        {
                            [1] = 150670,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8480.4300000000,
                        },
                    },
                    [983840] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 976.0700000000,
                        },
                    },
                    [99072] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2484.5800000000,
                        },
                        [2] = 
                        {
                            [1] = 30160,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9759.0100000000,
                        },
                    },
                    [530717] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2056.5100000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2916.5200000000,
                        },
                    },
                    [198656] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2358.9700000000,
                        },
                        [2] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            [3] = 150671,
                            ["Pre"] = 7691.6100000000,
                        },
                    },
                    [755712] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1277.1900000000,
                        },
                    },
                    [754432] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2311.1900000000,
                        },
                        [2] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7643.8300000000,
                        },
                    },
                    [166664] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1229.4100000000,
                        },
                    },
                    [1379072] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 886.9100000000,
                        },
                    },
                    [466432] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 77584,
                            [3] = 77591,
                            ["Pre"] = 811.4200000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 923.6600000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1068.2700000000,
                        },
                        [4] = 
                        {
                            [1] = 77590,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1180.5100000000,
                        },
                        [5] = 
                        {
                            [1] = 30162,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1434.0100000000,
                        },
                        [6] = 
                        {
                            [1] = 30148,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1435.5400000000,
                        },
                        [7] = 
                        {
                            [1] = 30153,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1447.3000000000,
                        },
                        [8] = 
                        {
                            [1] = 30165,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1447.4200000000,
                        },
                        [9] = 
                        {
                            [1] = 30157,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1452.4200000000,
                        },
                        [10] = 
                        {
                            [1] = 30166,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1455.7900000000,
                        },
                        [11] = 
                        {
                            [1] = 30149,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1467.0400000000,
                        },
                        [12] = 
                        {
                            [1] = 30151,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1478.7600000000,
                        },
                        [13] = 
                        {
                            [1] = 30161,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1519.2200000000,
                        },
                        [14] = 
                        {
                            [1] = 150672,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1768.7400000000,
                        },
                        [15] = 
                        {
                            [1] = 77589,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1781.4600000000,
                        },
                        [16] = 
                        {
                            [1] = 150670,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1817.0500000000,
                        },
                        [17] = 
                        {
                            [1] = 77591,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1977.4100000000,
                        },
                        [18] = 
                        {
                            [1] = 77591,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 3401.6900000000,
                        },
                        [19] = 
                        {
                            [1] = 30154,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4185.3800000000,
                        },
                        [20] = 
                        {
                            [1] = 30154,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4257.6600000000,
                        },
                        [21] = 
                        {
                            [1] = 30160,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4442.2300000000,
                        },
                        [22] = 
                        {
                            [1] = 30160,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4514.5100000000,
                        },
                        [23] = 
                        {
                            [1] = 77591,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8734.3300000000,
                        },
                    },
                    [8585216] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 602.1100000000,
                        },
                        [2] = 
                        {
                            [1] = 30158,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 899.9400000000,
                        },
                        [3] = 
                        {
                            [1] = 30161,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 959.2600000000,
                        },
                        [4] = 
                        {
                            [1] = 30161,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2543.9000000000,
                        },
                        [5] = 
                        {
                            [1] = 30158,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2609.0200000000,
                        },
                        [6] = 
                        {
                            [1] = 30161,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2668.3400000000,
                        },
                        [7] = 
                        {
                            [1] = 30160,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2841.7300000000,
                        },
                        [8] = 
                        {
                            [1] = 30158,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7817.2200000000,
                        },
                        [9] = 
                        {
                            [1] = 30161,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7876.5400000000,
                        },
                        [10] = 
                        {
                            [1] = 30158,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7941.6600000000,
                        },
                        [11] = 
                        {
                            [1] = 30160,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 8174.3700000000,
                        },
                        [12] = 
                        {
                            [1] = 30158,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9526.3000000000,
                        },
                        [13] = 
                        {
                            [1] = 30161,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9585.6200000000,
                        },
                        [14] = 
                        {
                            [1] = 150670,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9883.4500000000,
                        },
                    },
                    [721672] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 77583,
                            ["Pre"] = 476.5000000000,
                        },
                    },
                    [131865] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 693.9000000000,
                        },
                        [2] = 
                        {
                            [1] = 30161,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 833.6500000000,
                        },
                        [3] = 
                        {
                            [1] = 30161,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1265.3200000000,
                        },
                        [4] = 
                        {
                            [1] = 30161,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2365.8800000000,
                        },
                        [5] = 
                        {
                            [1] = 77590,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7968.3300000000,
                        },
                    },
                    [530688] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 443.8500000000,
                        },
                    },
                    [204544] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7653.4600000000,
                        },
                        [2] = 
                        {
                            [1] = 150789,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7712.7800000000,
                        },
                        [3] = 
                        {
                            [1] = 150789,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7886.1700000000,
                        },
                        [4] = 
                        {
                            [1] = 150789,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9595.2500000000,
                        },
                        [5] = 
                        {
                            [1] = 30158,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10945.1800000000,
                        },
                        [6] = 
                        {
                            [1] = 30161,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 11004.5000000000,
                        },
                        [7] = 
                        {
                            [1] = 30160,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 11177.8900000000,
                        },
                    },
                    [591872] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30156,
                            [3] = 77583,
                            ["Pre"] = 419.6100000000,
                        },
                        [2] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 588.3800000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1279.6200000000,
                        },
                        [4] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            [3] = 30152,
                            ["Pre"] = 1448.3900000000,
                        },
                    },
                    [1251075] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9513.7000000000,
                        },
                    },
                    [1249025] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2548.1100000000,
                        },
                    },
                    [1251072] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 77589,
                            [3] = 30164,
                            ["Pre"] = 2560.8300000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3878.6000000000,
                        },
                    },
                    [1447711] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7640.8600000000,
                        },
                    },
                    [1447709] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 2005.7600000000,
                        },
                    },
                    [1447706] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 687.9900000000,
                        },
                    },
                    [1511171] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 150671,
                            ["Pre"] = 7571.9100000000,
                        },
                    },
                    [1249027] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 30164,
                            ["Pre"] = 2239.2700000000,
                        },
                    },
                    [1508639] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10937.7000000000,
                        },
                    },
                    [1508101] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9518.8200000000,
                        },
                    },
                    [1513728] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1963.4800000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2293.9600000000,
                        },
                        [3] = 
                        {
                            [1] = 30153,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2475.5800000000,
                        },
                        [4] = 
                        {
                            [1] = 30157,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2480.7000000000,
                        },
                        [5] = 
                        {
                            [1] = 77590,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9250.5100000000,
                        },
                        [6] = 
                        {
                            [1] = 77591,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9762.6100000000,
                        },
                    },
                    [132384] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1177.2600000000,
                        },
                    },
                    [1508635] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3984.8300000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5302.6000000000,
                        },
                    },
                    [9902848] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2258.3700000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2263.4900000000,
                        },
                        [3] = 
                        {
                            [1] = 77589,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9545.4000000000,
                        },
                    },
                    [268037] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1141.6700000000,
                        },
                    },
                    [1513757] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2043.9100000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2049.0300000000,
                        },
                        [3] = 
                        {
                            [1] = 77583,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9330.9400000000,
                        },
                    },
                    [329984] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 580.9000000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1012.5700000000,
                        },
                        [3] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 1105.8900000000,
                        },
                        [4] = 
                        {
                            [1] = 30163,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1537.5600000000,
                        },
                        [5] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3949.0500000000,
                        },
                    },
                    [136963] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7636.3500000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7934.1800000000,
                        },
                    },
                    [136453] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 879.4300000000,
                        },
                    },
                    [132119] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 643.0200000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1484.1700000000,
                        },
                    },
                    [132382] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3689.9400000000,
                        },
                    },
                    [136734] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 77590,
                            ["Pre"] = 310.9800000000,
                        },
                    },
                    [1515264] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7645.9800000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10932.5800000000,
                        },
                    },
                    [1514269] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 77585,
                            [3] = 139019,
                            ["Pre"] = 1938.5200000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 77585,
                            [3] = 139019,
                            ["Pre"] = 1943.6400000000,
                        },
                        [3] = 
                        {
                            [1] = 150789,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2339.9200000000,
                        },
                        [4] = 
                        {
                            [1] = 77583,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2378.0700000000,
                        },
                        [5] = 
                        {
                            [1] = 77589,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2866.8100000000,
                        },
                        [6] = 
                        {
                            [1] = 77585,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9225.5500000000,
                        },
                    },
                    [1508096] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 150671,
                            ["Pre"] = 7577.0300000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7631.2300000000,
                        },
                        [3] = 
                        {
                            [1] = 30153,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7804.6200000000,
                        },
                        [4] = 
                        {
                            [1] = 30157,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7809.7400000000,
                        },
                        [5] = 
                        {
                            [1] = 30153,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7929.0600000000,
                        },
                        [6] = 
                        {
                            [1] = 30158,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9223.8400000000,
                        },
                        [7] = 
                        {
                            [1] = 30161,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9283.1600000000,
                        },
                        [8] = 
                        {
                            [1] = 30160,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9456.5500000000,
                        },
                        [9] = 
                        {
                            [1] = 30164,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 11165.6300000000,
                        },
                    },
                    [1251077] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 30164,
                            ["Pre"] = 2231.7900000000,
                        },
                    },
                    [9895936] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 77589,
                            ["Pre"] = 611.5600000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 139019,
                            ["Pre"] = 1929.3300000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 150671,
                            ["Pre"] = 7564.4300000000,
                        },
                        [4] = 
                        {
                            [1] = 30153,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7893.4700000000,
                        },
                        [5] = 
                        {
                            [1] = 30157,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7898.5900000000,
                        },
                        [6] = 
                        {
                            [1] = 30153,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9211.2400000000,
                        },
                        [7] = 
                        {
                            [1] = 30157,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9216.3600000000,
                        },
                    },
                    [1508608] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 30163,
                            ["Pre"] = 461.2000000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 795.3600000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 150669,
                            ["Pre"] = 807.5100000000,
                        },
                        [4] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            [3] = 139019,
                            ["Pre"] = 2113.1300000000,
                        },
                        [5] = 
                        {
                            [1] = 30157,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2459.4400000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 77589,
                            [3] = 30164,
                            ["Pre"] = 2565.9500000000,
                        },
                        [7] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 150731,
                            ["Pre"] = 3650.6700000000,
                        },
                        [8] = 
                        {
                            [1] = 30157,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3883.7200000000,
                        },
                        [9] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            [3] = 150671,
                            ["Pre"] = 7748.2300000000,
                        },
                        [10] = 
                        {
                            [1] = 30157,
                            [2] = 150669,
                            [3] = 150671,
                            ["Pre"] = 8094.5400000000,
                        },
                    },
                    [1678848] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 862.2300000000,
                        },
                        [2] = 
                        {
                            [1] = 77590,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4236.1900000000,
                        },
                    },
                    [1187584] = 
                    {
                        [1] = 
                        {
                            [1] = 30156,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7655.8900000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10932.7000000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10947.6100000000,
                        },
                        [4] = 
                        {
                            [1] = 77581,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 11541.0200000000,
                        },
                    },
                    [139264] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1172.2600000000,
                        },
                        [2] = 
                        {
                            [1] = 30149,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1191.8800000000,
                        },
                        [3] = 
                        {
                            [1] = 30151,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1203.6000000000,
                        },
                        [4] = 
                        {
                            [1] = 150670,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 2044.7500000000,
                        },
                    },
                    [1511936] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 30156,
                            [3] = 150671,
                            ["Pre"] = 7574.3400000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30156,
                            [3] = 150671,
                            ["Pre"] = 7579.4600000000,
                        },
                        [3] = 
                        {
                            [1] = 30165,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7893.5900000000,
                        },
                        [4] = 
                        {
                            [1] = 30156,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7908.5000000000,
                        },
                        [5] = 
                        {
                            [1] = 30153,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8167.7500000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8172.8700000000,
                        },
                        [7] = 
                        {
                            [1] = 77589,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8501.9100000000,
                        },
                        [8] = 
                        {
                            [1] = 30165,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9211.3600000000,
                        },
                        [9] = 
                        {
                            [1] = 30156,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9226.2700000000,
                        },
                    },
                    [133120] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1264.7100000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1269.7100000000,
                        },
                        [3] = 
                        {
                            [1] = 30149,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1284.3300000000,
                        },
                    },
                    [131858] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7631.3500000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7929.1800000000,
                        },
                    },
                    [8522496] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1216.9300000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1221.9300000000,
                        },
                        [3] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1236.5500000000,
                        },
                        [4] = 
                        {
                            [1] = 30151,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1248.2700000000,
                        },
                        [5] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1256.0800000000,
                        },
                        [6] = 
                        {
                            [1] = 30161,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1586.5600000000,
                        },
                    },
                    [8520448] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 714.0700000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 719.0700000000,
                        },
                        [3] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 733.6900000000,
                        },
                    },
                    [8520704] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1176.4700000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1181.4700000000,
                        },
                        [3] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1215.6200000000,
                        },
                    },
                    [8526080] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 681.4200000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 686.4200000000,
                        },
                        [3] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 701.0400000000,
                        },
                        [4] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 712.7600000000,
                        },
                        [5] = 
                        {
                            [1] = 77590,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1553.9100000000,
                        },
                    },
                    [1446431] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7640.9800000000,
                        },
                    },
                    [9568256] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 77581,
                            ["Pre"] = 895.8700000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 150671,
                            ["Pre"] = 7574.4600000000,
                        },
                        [3] = 
                        {
                            [1] = 30165,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8167.8700000000,
                        },
                        [4] = 
                        {
                            [1] = 30156,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8182.7800000000,
                        },
                    },
                    [919826] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 30163,
                            ["Pre"] = 471.2300000000,
                        },
                        [2] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            [3] = 150671,
                            ["Pre"] = 7758.1400000000,
                        },
                    },
                    [594432] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 77583,
                            ["Pre"] = 407.1300000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 77591,
                            ["Pre"] = 838.8000000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 150671,
                            ["Pre"] = 7694.0400000000,
                        },
                        [4] = 
                        {
                            [1] = 30156,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8125.7100000000,
                        },
                    },
                    [133650] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 77581,
                            ["Pre"] = 900.5800000000,
                        },
                    },
                    [8521216] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 30151,
                            ["Pre"] = 323.6000000000,
                        },
                        [2] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 362.7500000000,
                        },
                        [3] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 395.4000000000,
                        },
                        [4] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 693.2300000000,
                        },
                    },
                    [132626] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 30156,
                            ["Pre"] = 307.1700000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 30151,
                            ["Pre"] = 318.8900000000,
                        },
                    },
                    [1055517] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 139019,
                            ["Pre"] = 1938.6400000000,
                        },
                    },
                    [1053213] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 77581,
                            ["Pre"] = 895.1500000000,
                        },
                    },
                    [1055488] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 77589,
                            ["Pre"] = 620.8700000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 150731,
                            ["Pre"] = 3659.9800000000,
                        },
                    },
                    [1445917] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 150789,
                            ["Pre"] = 368.2600000000,
                        },
                    },
                    [1053184] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 30156,
                            ["Pre"] = 301.7400000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 150671,
                            ["Pre"] = 7573.7400000000,
                        },
                    },
                    [201216] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30158,
                            [3] = 150671,
                            ["Pre"] = 7572.0300000000,
                        },
                        [2] = 
                        {
                            [1] = 30158,
                            [2] = 30156,
                            [3] = 150671,
                            ["Pre"] = 7586.9400000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7646.2600000000,
                        },
                        [4] = 
                        {
                            [1] = 30165,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7804.7400000000,
                        },
                        [5] = 
                        {
                            [1] = 30156,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7819.6500000000,
                        },
                        [6] = 
                        {
                            [1] = 30156,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7944.0900000000,
                        },
                        [7] = 
                        {
                            [1] = 30158,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8180.3500000000,
                        },
                        [8] = 
                        {
                            [1] = 30160,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8413.0600000000,
                        },
                        [9] = 
                        {
                            [1] = 150670,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8537.5000000000,
                        },
                        [10] = 
                        {
                            [1] = 30165,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9513.8200000000,
                        },
                        [11] = 
                        {
                            [1] = 30156,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9528.7300000000,
                        },
                        [12] = 
                        {
                            [1] = 77581,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 10122.1400000000,
                        },
                    },
                    [133896] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30158,
                            [3] = 30152,
                            ["Pre"] = 1157.6100000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 30152,
                            ["Pre"] = 1162.6100000000,
                        },
                        [3] = 
                        {
                            [1] = 30158,
                            [2] = 30149,
                            [3] = 30152,
                            ["Pre"] = 1177.2300000000,
                        },
                        [4] = 
                        {
                            [1] = 30158,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1188.9500000000,
                        },
                        [5] = 
                        {
                            [1] = 30158,
                            [2] = 77590,
                            [3] = 30152,
                            ["Pre"] = 1196.7600000000,
                        },
                        [6] = 
                        {
                            [1] = 30161,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1336.5100000000,
                        },
                        [7] = 
                        {
                            [1] = 30158,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1527.2400000000,
                        },
                    },
                    [133891] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30158,
                            [3] = 30161,
                            ["Pre"] = 356.9200000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 30161,
                            ["Pre"] = 361.9200000000,
                        },
                        [3] = 
                        {
                            [1] = 30158,
                            [2] = 30149,
                            [3] = 30161,
                            ["Pre"] = 376.5400000000,
                        },
                        [4] = 
                        {
                            [1] = 30158,
                            [2] = 77590,
                            [3] = 30161,
                            ["Pre"] = 396.0700000000,
                        },
                    },
                    [1447698] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 150671,
                            ["Pre"] = 7559.4300000000,
                        },
                    },
                    [597504] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 30156,
                            [3] = 77591,
                            ["Pre"] = 837.9900000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1006.7600000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4211.9500000000,
                        },
                    },
                    [132352] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 150669,
                            ["Pre"] = 807.6300000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 150669,
                            ["Pre"] = 846.7800000000,
                        },
                        [3] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 150731,
                            ["Pre"] = 3650.7900000000,
                        },
                        [4] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 150731,
                            ["Pre"] = 3722.5900000000,
                        },
                        [5] = 
                        {
                            [1] = 30157,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4020.4200000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4523.2800000000,
                        },
                    },
                    [136960] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 30151,
                            ["Pre"] = 308.8600000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 77590,
                            ["Pre"] = 316.6700000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 30161,
                            ["Pre"] = 349.3200000000,
                        },
                        [4] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 77589,
                            ["Pre"] = 611.6800000000,
                        },
                        [5] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 150670,
                            ["Pre"] = 647.1500000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 77589,
                            ["Pre"] = 650.8300000000,
                        },
                        [7] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 77589,
                            ["Pre"] = 683.4800000000,
                        },
                        [8] = 
                        {
                            [1] = 30157,
                            [2] = 77589,
                            [3] = 150670,
                            ["Pre"] = 981.3100000000,
                        },
                        [9] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 30152,
                            ["Pre"] = 1150.0100000000,
                        },
                        [10] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 139019,
                            ["Pre"] = 1929.4500000000,
                        },
                        [11] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 1960.7900000000,
                        },
                        [12] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 139019,
                            ["Pre"] = 2001.2500000000,
                        },
                        [13] = 
                        {
                            [1] = 30157,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2801.9400000000,
                        },
                        [14] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            [3] = 150671,
                            ["Pre"] = 7595.8900000000,
                        },
                        [15] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 150671,
                            ["Pre"] = 7603.7000000000,
                        },
                        [16] = 
                        {
                            [1] = 30157,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 8437.0400000000,
                        },
                    },
                    [8519680] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 30151,
                            ["Pre"] = 308.9800000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 77590,
                            ["Pre"] = 316.7900000000,
                        },
                        [3] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 77590,
                            ["Pre"] = 331.4100000000,
                        },
                        [4] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 343.1300000000,
                        },
                        [5] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 348.1300000000,
                        },
                        [6] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 30161,
                            ["Pre"] = 349.4400000000,
                        },
                        [7] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 30161,
                            ["Pre"] = 364.0600000000,
                        },
                        [8] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 375.7800000000,
                        },
                        [9] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 380.7800000000,
                        },
                        [10] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 30161,
                            ["Pre"] = 383.5900000000,
                        },
                        [11] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 30161,
                            ["Pre"] = 388.5900000000,
                        },
                        [12] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 30161,
                            ["Pre"] = 403.2100000000,
                        },
                        [13] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 414.9300000000,
                        },
                        [14] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 150670,
                            ["Pre"] = 647.2700000000,
                        },
                        [15] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 150670,
                            ["Pre"] = 661.8900000000,
                        },
                        [16] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 673.6100000000,
                        },
                        [17] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 678.6100000000,
                        },
                        [18] = 
                        {
                            [1] = 30151,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 745.4100000000,
                        },
                        [19] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 30152,
                            ["Pre"] = 1150.1300000000,
                        },
                        [20] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 30152,
                            ["Pre"] = 1164.7500000000,
                        },
                        [21] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 30152,
                            ["Pre"] = 1184.2800000000,
                        },
                        [22] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 30152,
                            ["Pre"] = 1189.2800000000,
                        },
                        [23] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 30152,
                            ["Pre"] = 1203.9000000000,
                        },
                        [24] = 
                        {
                            [1] = 30165,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1514.7600000000,
                        },
                        [25] = 
                        {
                            [1] = 30157,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1519.7600000000,
                        },
                        [26] = 
                        {
                            [1] = 30149,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1534.3800000000,
                        },
                        [27] = 
                        {
                            [1] = 30151,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1546.1000000000,
                        },
                    },
                    [135680] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 30156,
                            ["Pre"] = 292.5500000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 77590,
                            ["Pre"] = 326.7000000000,
                        },
                        [3] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 30161,
                            ["Pre"] = 359.3500000000,
                        },
                        [4] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 150670,
                            ["Pre"] = 657.1800000000,
                        },
                        [5] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 77581,
                            ["Pre"] = 885.9600000000,
                        },
                        [6] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 912.3000000000,
                        },
                        [7] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 77581,
                            ["Pre"] = 920.1100000000,
                        },
                        [8] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 952.7600000000,
                        },
                        [9] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 30152,
                            ["Pre"] = 1160.0400000000,
                        },
                        [10] = 
                        {
                            [1] = 30165,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1250.5900000000,
                        },
                        [11] = 
                        {
                            [1] = 30165,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1753.4500000000,
                        },
                        [12] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 150671,
                            ["Pre"] = 7579.1700000000,
                        },
                        [13] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            [3] = 150671,
                            ["Pre"] = 7590.8900000000,
                        },
                        [14] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 150671,
                            ["Pre"] = 7598.7000000000,
                        },
                        [15] = 
                        {
                            [1] = 30165,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 8432.0400000000,
                        },
                    },
                    [8523008] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 30149,
                            ["Pre"] = 297.2600000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 30151,
                            ["Pre"] = 328.6000000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 77590,
                            ["Pre"] = 336.4100000000,
                        },
                        [4] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 30161,
                            ["Pre"] = 369.0600000000,
                        },
                        [5] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 150670,
                            ["Pre"] = 666.8900000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 30152,
                            ["Pre"] = 1169.7500000000,
                        },
                    },
                    [136727] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 30153,
                            ["Pre"] = 277.5200000000,
                        },
                    },
                    [983328] = 
                    {
                        [1] = 
                        {
                            [1] = 30166,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1132.3200000000,
                        },
                    },
                    [991232] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 963.4700000000,
                        },
                        [2] = 
                        {
                            [1] = 30166,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 971.9600000000,
                        },
                        [3] = 
                        {
                            [1] = 30153,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1123.8300000000,
                        },
                        [4] = 
                        {
                            [1] = 30158,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1136.4300000000,
                        },
                    },
                    [10354688] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3684.1300000000,
                        },
                        [2] = 
                        {
                            [1] = 77590,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4308.4700000000,
                        },
                    },
                    [983808] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 30160,
                            ["Pre"] = 530.1900000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 150670,
                            ["Pre"] = 654.6300000000,
                        },
                        [3] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 150670,
                            ["Pre"] = 663.1200000000,
                        },
                        [4] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 150671,
                            ["Pre"] = 7580.4000000000,
                        },
                        [5] = 
                        {
                            [1] = 30158,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 7893.3500000000,
                        },
                    },
                    [983299] = 
                    {
                        [1] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 30160,
                            ["Pre"] = 538.6800000000,
                        },
                        [2] = 
                        {
                            [1] = 30158,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 851.6300000000,
                        },
                        [3] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 30164,
                            ["Pre"] = 2247.7600000000,
                        },
                        [4] = 
                        {
                            [1] = 30158,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2560.7100000000,
                        },
                    },
                    [985088] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 77583,
                            ["Pre"] = 404.5800000000,
                        },
                        [2] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 77583,
                            ["Pre"] = 413.0700000000,
                        },
                        [3] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            [3] = 150672,
                            ["Pre"] = 726.0200000000,
                        },
                    },
                    [724739] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 30161,
                            ["Pre"] = 356.8000000000,
                        },
                        [2] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 30161,
                            ["Pre"] = 365.2900000000,
                        },
                        [3] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 150672,
                            ["Pre"] = 678.2400000000,
                        },
                    },
                    [1314560] = 
                    {
                        [1] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 30151,
                            ["Pre"] = 324.8300000000,
                        },
                        [2] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 150672,
                            ["Pre"] = 633.6700000000,
                        },
                    },
                    [9371904] = 
                    {
                        [1] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 150672,
                            ["Pre"] = 602.2100000000,
                        },
                        [2] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 150672,
                            ["Pre"] = 614.8100000000,
                        },
                    },
                    [9371648] = 
                    {
                        [1] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 30158,
                            ["Pre"] = 293.3700000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 150672,
                            ["Pre"] = 606.3200000000,
                        },
                    },
                    [1511168] = 
                    {
                        [1] = 
                        {
                            [1] = 30166,
                            [2] = 30157,
                            [3] = 30153,
                            ["Pre"] = 285.8900000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 30158,
                            ["Pre"] = 290,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 150672,
                            ["Pre"] = 598.8400000000,
                        },
                        [4] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 77589,
                            ["Pre"] = 614.9300000000,
                        },
                        [5] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 77589,
                            ["Pre"] = 619.0400000000,
                        },
                        [6] = 
                        {
                            [1] = 30153,
                            [2] = 77589,
                            [3] = 150672,
                            ["Pre"] = 927.8800000000,
                        },
                        [7] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 139019,
                            ["Pre"] = 1932.7000000000,
                        },
                        [8] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 139019,
                            ["Pre"] = 1936.8100000000,
                        },
                        [9] = 
                        {
                            [1] = 30153,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2245.6500000000,
                        },
                        [10] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 150671,
                            ["Pre"] = 7567.8000000000,
                        },
                        [11] = 
                        {
                            [1] = 30153,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 7880.7500000000,
                        },
                    },
                    [1579934] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4268.5100000000,
                        },
                    },
                    [1809920] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4196.2300000000,
                        },
                    },
                    [1446400] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 30156,
                            ["Pre"] = 275.6700000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 30156,
                            ["Pre"] = 286.7400000000,
                        },
                        [3] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 30156,
                            ["Pre"] = 287.4300000000,
                        },
                        [4] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 150789,
                            ["Pre"] = 368.9800000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 150671,
                            ["Pre"] = 7547.6700000000,
                        },
                        [6] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 150671,
                            ["Pre"] = 7558.7400000000,
                        },
                    },
                    [786688] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 30160,
                            ["Pre"] = 492.5400000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 30160,
                            ["Pre"] = 496.8300000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 30160,
                            ["Pre"] = 505.8700000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 30156,
                            [3] = 30160,
                            ["Pre"] = 520.8600000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 77583,
                            [3] = 30160,
                            ["Pre"] = 625.5300000000,
                        },
                        [6] = 
                        {
                            [1] = 30148,
                            [2] = 30160,
                            [3] = 77589,
                            ["Pre"] = 839.9900000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 30160,
                            [3] = 150669,
                            ["Pre"] = 1035.9400000000,
                        },
                        [8] = 
                        {
                            [1] = 30148,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1114.2700000000,
                        },
                        [9] = 
                        {
                            [1] = 30148,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2157.7600000000,
                        },
                        [10] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 30164,
                            ["Pre"] = 2203.3700000000,
                        },
                        [11] = 
                        {
                            [1] = 30148,
                            [2] = 30160,
                            [3] = 150731,
                            ["Pre"] = 3879.1000000000,
                        },
                        [12] = 
                        {
                            [1] = 30148,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7792.8600000000,
                        },
                    },
                    [1445633] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 30153,
                            ["Pre"] = 269.0100000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 150672,
                            ["Pre"] = 581.9600000000,
                        },
                    },
                    [10165760] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3979.0200000000,
                        },
                    },
                    [136451] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 713.9900000000,
                        },
                        [2] = 
                        {
                            [1] = 30161,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1322.3900000000,
                        },
                    },
                    [1776158] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1229.4000000000,
                        },
                        [2] = 
                        {
                            [1] = 77589,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4603.3600000000,
                        },
                    },
                    [267525] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 150669,
                            ["Pre"] = 777.5600000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 150669,
                            ["Pre"] = 795.9700000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 974.6500000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4164.1200000000,
                        },
                    },
                    [1775872] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2043.2200000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2293.2700000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2474.8900000000,
                        },
                        [4] = 
                        {
                            [1] = 77585,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2489.8900000000,
                        },
                        [5] = 
                        {
                            [1] = 77583,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5417.1800000000,
                        },
                        [6] = 
                        {
                            [1] = 150670,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5667.2300000000,
                        },
                        [7] = 
                        {
                            [1] = 77591,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5848.8500000000,
                        },
                    },
                    [9175303] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 30160,
                            ["Pre"] = 494.2900000000,
                        },
                    },
                    [724744] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 30152,
                            ["Pre"] = 1157.4900000000,
                        },
                        [2] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 30152,
                            ["Pre"] = 1165.9800000000,
                        },
                        [3] = 
                        {
                            [1] = 30158,
                            [2] = 150672,
                            [3] = 30152,
                            ["Pre"] = 1478.9300000000,
                        },
                    },
                    [9306377] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 30163,
                            ["Pre"] = 467.3100000000,
                        },
                    },
                    [134410] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 30149,
                            ["Pre"] = 278.8500000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 30151,
                            ["Pre"] = 310.1900000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 77590,
                            ["Pre"] = 318,
                        },
                        [4] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 30161,
                            ["Pre"] = 350.6500000000,
                        },
                        [5] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 150670,
                            ["Pre"] = 648.4800000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 77581,
                            ["Pre"] = 905.5800000000,
                        },
                        [7] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 30152,
                            ["Pre"] = 1151.3400000000,
                        },
                    },
                    [136459] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1216.8500000000,
                        },
                        [2] = 
                        {
                            [1] = 30161,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1746.9200000000,
                        },
                        [3] = 
                        {
                            [1] = 30161,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1825.2500000000,
                        },
                    },
                    [1613312] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 934.5100000000,
                        },
                    },
                    [136973] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 30149,
                            ["Pre"] = 297.1400000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 77589,
                            ["Pre"] = 631.3000000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 139019,
                            ["Pre"] = 1949.0700000000,
                        },
                        [4] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 150671,
                            ["Pre"] = 7584.1700000000,
                        },
                    },
                    [137502] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 680.6100000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 863.0400000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 868.0400000000,
                        },
                        [4] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 882.6600000000,
                        },
                        [5] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            [3] = 77591,
                            ["Pre"] = 894.3800000000,
                        },
                        [6] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 77591,
                            ["Pre"] = 934.8400000000,
                        },
                        [7] = 
                        {
                            [1] = 77590,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 1735.5300000000,
                        },
                        [8] = 
                        {
                            [1] = 77590,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4054.5700000000,
                        },
                    },
                    [1448735] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3726.4100000000,
                        },
                    },
                    [1578522] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 976.7900000000,
                        },
                    },
                    [1448730] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 687.3000000000,
                        },
                    },
                    [136978] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 150671,
                            ["Pre"] = 7564.5500000000,
                        },
                    },
                    [10158080] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 77589,
                            ["Pre"] = 620.0600000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 139019,
                            ["Pre"] = 1937.8300000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2257.6800000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 150731,
                            ["Pre"] = 3659.1700000000,
                        },
                        [5] = 
                        {
                            [1] = 77585,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3994.0200000000,
                        },
                        [6] = 
                        {
                            [1] = 77584,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5296.7900000000,
                        },
                        [7] = 
                        {
                            [1] = 77585,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5311.7900000000,
                        },
                    },
                    [1250816] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 30164,
                            ["Pre"] = 2225.9800000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 30164,
                            ["Pre"] = 2226.7900000000,
                        },
                        [3] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 30164,
                            ["Pre"] = 2308.2200000000,
                        },
                    },
                    [393472] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 30155,
                            ["Pre"] = 247.7200000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 30166,
                            ["Pre"] = 267.9700000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 30160,
                            ["Pre"] = 504.7900000000,
                        },
                    },
                    [1578497] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 77584,
                            ["Pre"] = 256.0300000000,
                        },
                    },
                    [138752] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 77590,
                            ["Pre"] = 315.9800000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 30149,
                            [3] = 77590,
                            ["Pre"] = 330.6000000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 342.3200000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 30161,
                            ["Pre"] = 382.7800000000,
                        },
                        [5] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 935.3200000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 940.3200000000,
                        },
                        [7] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 954.9400000000,
                        },
                        [8] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            [3] = 139020,
                            ["Pre"] = 966.6600000000,
                        },
                        [9] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 139020,
                            ["Pre"] = 1007.1200000000,
                        },
                        [10] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 30152,
                            ["Pre"] = 1183.4700000000,
                        },
                        [11] = 
                        {
                            [1] = 77590,
                            [2] = 150670,
                            [3] = 139020,
                            ["Pre"] = 1304.9500000000,
                        },
                        [12] = 
                        {
                            [1] = 77590,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1807.8100000000,
                        },
                        [13] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3684.9400000000,
                        },
                        [14] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3704.5600000000,
                        },
                        [15] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            [3] = 150731,
                            ["Pre"] = 3716.2800000000,
                        },
                        [16] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 150731,
                            ["Pre"] = 3756.7400000000,
                        },
                        [17] = 
                        {
                            [1] = 77590,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4557.4300000000,
                        },
                    },
                    [1379075] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30158,
                            [3] = 30161,
                            ["Pre"] = 356.8400000000,
                        },
                        [2] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 965.2400000000,
                        },
                    },
                    [136985] = 
                    {
                        [1] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1968.6000000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2299.0800000000,
                        },
                    },
                    [263962] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1218.5500000000,
                        },
                    },
                    [262427] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 77589,
                            ["Pre"] = 608.9900000000,
                        },
                    },
                    [393500] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 150672,
                            ["Pre"] = 580.9200000000,
                        },
                    },
                    [395549] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 77583,
                            ["Pre"] = 398.0100000000,
                        },
                    },
                    [1448734] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 150731,
                            ["Pre"] = 3633.1000000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 150731,
                            ["Pre"] = 3644.8600000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 150731,
                            ["Pre"] = 3644.9800000000,
                        },
                    },
                    [1711391] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7631.8600000000,
                        },
                    },
                    [267552] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1112.2900000000,
                        },
                    },
                    [262405] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 974.4300000000,
                        },
                    },
                    [265223] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 77591,
                            ["Pre"] = 800.3500000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 139020,
                            ["Pre"] = 872.6300000000,
                        },
                    },
                    [1445915] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 77585,
                            ["Pre"] = 286.0200000000,
                        },
                    },
                    [917769] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30156,
                            [3] = 30163,
                            ["Pre"] = 459.3500000000,
                        },
                        [2] = 
                        {
                            [1] = 30166,
                            [2] = 30156,
                            [3] = 30163,
                            ["Pre"] = 479.6000000000,
                        },
                        [3] = 
                        {
                            [1] = 77585,
                            [2] = 30156,
                            [3] = 30163,
                            ["Pre"] = 485.4200000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 571.9800000000,
                        },
                        [5] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 716.4200000000,
                        },
                        [6] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 792.5500000000,
                        },
                        [7] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1003.6500000000,
                        },
                        [8] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2425.5000000000,
                        },
                    },
                    [856330] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 30149,
                            ["Pre"] = 278.7700000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 30149,
                            ["Pre"] = 287.2200000000,
                        },
                    },
                    [136704] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 30157,
                            ["Pre"] = 276.8300000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 30149,
                            ["Pre"] = 291.4500000000,
                        },
                        [3] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 30149,
                            ["Pre"] = 292.1400000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 30151,
                            ["Pre"] = 303.1700000000,
                        },
                        [5] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 30151,
                            ["Pre"] = 303.8600000000,
                        },
                        [6] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 77590,
                            ["Pre"] = 311.6700000000,
                        },
                        [7] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 150789,
                            ["Pre"] = 359.0700000000,
                        },
                        [8] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 150789,
                            ["Pre"] = 373.6900000000,
                        },
                        [9] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 30151,
                            ["Pre"] = 385.4100000000,
                        },
                        [10] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 77590,
                            ["Pre"] = 393.2200000000,
                        },
                        [11] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 150670,
                            ["Pre"] = 641.4600000000,
                        },
                        [12] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 150670,
                            ["Pre"] = 642.1500000000,
                        },
                        [13] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 150670,
                            ["Pre"] = 723.7000000000,
                        },
                        [14] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 30152,
                            ["Pre"] = 1144.3200000000,
                        },
                        [15] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 30152,
                            ["Pre"] = 1145.0100000000,
                        },
                        [16] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 30152,
                            ["Pre"] = 1226.5600000000,
                        },
                    },
                    [1310720] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 30151,
                            ["Pre"] = 311.5400000000,
                        },
                        [2] = 
                        {
                            [1] = 30166,
                            [2] = 30165,
                            [3] = 30151,
                            ["Pre"] = 312.3500000000,
                        },
                        [3] = 
                        {
                            [1] = 30166,
                            [2] = 30157,
                            [3] = 30151,
                            ["Pre"] = 317.3500000000,
                        },
                        [4] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 30151,
                            ["Pre"] = 326.5400000000,
                        },
                        [5] = 
                        {
                            [1] = 30166,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 351.5000000000,
                        },
                        [6] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 384.1500000000,
                        },
                        [7] = 
                        {
                            [1] = 30166,
                            [2] = 150789,
                            [3] = 30151,
                            ["Pre"] = 393.7800000000,
                        },
                        [8] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 77583,
                            ["Pre"] = 431.9300000000,
                        },
                        [9] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 30163,
                            ["Pre"] = 496.0300000000,
                        },
                        [10] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 30160,
                            ["Pre"] = 557.5400000000,
                        },
                        [11] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 681.9800000000,
                        },
                        [12] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 77591,
                            ["Pre"] = 863.6000000000,
                        },
                        [13] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 920.6700000000,
                        },
                        [14] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 139020,
                            ["Pre"] = 935.8800000000,
                        },
                        [15] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 1964.1600000000,
                        },
                        [16] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 150731,
                            ["Pre"] = 3685.5000000000,
                        },
                        [17] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 150671,
                            ["Pre"] = 7599.2600000000,
                        },
                    },
                    [73728] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1120.0300000000,
                        },
                        [2] = 
                        {
                            [1] = 77585,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1138.1400000000,
                        },
                        [3] = 
                        {
                            [1] = 30160,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1369.1400000000,
                        },
                    },
                    [8454912] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2468.1800000000,
                        },
                        [2] = 
                        {
                            [1] = 30166,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2480.4700000000,
                        },
                        [3] = 
                        {
                            [1] = 77585,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2486.2900000000,
                        },
                        [4] = 
                        {
                            [1] = 30160,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2793.4200000000,
                        },
                    },
                    [1573127] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1137.4400000000,
                        },
                    },
                    [67328] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1065.1600000000,
                        },
                        [2] = 
                        {
                            [1] = 30166,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1077.4500000000,
                        },
                        [3] = 
                        {
                            [1] = 77585,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1083.2700000000,
                        },
                        [4] = 
                        {
                            [1] = 30166,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1149.7300000000,
                        },
                        [5] = 
                        {
                            [1] = 77585,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1155.5500000000,
                        },
                        [6] = 
                        {
                            [1] = 30163,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1325.0400000000,
                        },
                        [7] = 
                        {
                            [1] = 30160,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1390.4000000000,
                        },
                        [8] = 
                        {
                            [1] = 30160,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1462.6800000000,
                        },
                    },
                    [720896] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 77589,
                            ["Pre"] = 690.9600000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1213.0100000000,
                        },
                        [3] = 
                        {
                            [1] = 30166,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1225.3000000000,
                        },
                        [4] = 
                        {
                            [1] = 77585,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1231.1200000000,
                        },
                        [5] = 
                        {
                            [1] = 30161,
                            [2] = 30163,
                            [3] = 30152,
                            ["Pre"] = 1400.6100000000,
                        },
                        [6] = 
                        {
                            [1] = 30161,
                            [2] = 150672,
                            [3] = 30152,
                            ["Pre"] = 1538.2500000000,
                        },
                        [7] = 
                        {
                            [1] = 30158,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 1708.8600000000,
                        },
                        [8] = 
                        {
                            [1] = 30158,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1781.1400000000,
                        },
                        [9] = 
                        {
                            [1] = 30161,
                            [2] = 30152,
                            [3] = 30164,
                            ["Pre"] = 3171.2000000000,
                        },
                    },
                    [395776] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 77581,
                            ["Pre"] = 896.6600000000,
                        },
                    },
                    [917504] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 30165,
                            [3] = 30163,
                            ["Pre"] = 452.4000000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 30163,
                            ["Pre"] = 483.7400000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 77590,
                            [3] = 30163,
                            ["Pre"] = 491.5500000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 30161,
                            [3] = 30163,
                            ["Pre"] = 524.2000000000,
                        },
                        [5] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 150669,
                            ["Pre"] = 813.6200000000,
                        },
                        [6] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            [3] = 150670,
                            ["Pre"] = 822.0300000000,
                        },
                        [7] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            [3] = 30152,
                            ["Pre"] = 1324.8900000000,
                        },
                        [8] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 150731,
                            ["Pre"] = 3656.7800000000,
                        },
                    },
                    [263706] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 628.9000000000,
                        },
                    },
                    [1442075] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 77585,
                            ["Pre"] = 274.1400000000,
                        },
                    },
                    [983324] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 150672,
                            ["Pre"] = 593.2100000000,
                        },
                    },
                    [399901] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 150789,
                            ["Pre"] = 341.0300000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 150789,
                            ["Pre"] = 359.8600000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 150789,
                            ["Pre"] = 364.5700000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 30151,
                            ["Pre"] = 376.2900000000,
                        },
                    },
                    [262432] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1112.0700000000,
                        },
                    },
                    [1573147] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 77585,
                            ["Pre"] = 282.1000000000,
                        },
                    },
                    [1578496] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 30165,
                            ["Pre"] = 267.9100000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 150789,
                            ["Pre"] = 349.3400000000,
                        },
                    },
                    [1250565] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2756.8200000000,
                        },
                    },
                    [1245443] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2471.9800000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2472.0200000000,
                        },
                    },
                    [1245445] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2410.4700000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2410.5100000000,
                        },
                    },
                    [1250563] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2298.6300000000,
                        },
                    },
                    [1377024] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 589.5500000000,
                        },
                        [2] = 
                        {
                            [1] = 30161,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1197.9500000000,
                        },
                        [3] = 
                        {
                            [1] = 30161,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2907.0300000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7631.2700000000,
                        },
                    },
                    [1245952] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30158,
                            [3] = 30164,
                            ["Pre"] = 2239.3100000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2298.5900000000,
                        },
                        [3] = 
                        {
                            [1] = 30153,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2596.4200000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2596.4600000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9513.7400000000,
                        },
                    },
                    [9633792] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 30164,
                            ["Pre"] = 2226.7100000000,
                        },
                    },
                    [1249024] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 30158,
                            ["Pre"] = 284.9200000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 150672,
                            ["Pre"] = 593.7600000000,
                        },
                    },
                    [1579806] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 150731,
                            ["Pre"] = 3641.0600000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 150731,
                            ["Pre"] = 3644.9000000000,
                        },
                    },
                    [1577728] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 30164,
                            ["Pre"] = 2226.0200000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2850.3600000000,
                        },
                    },
                    [9969152] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 139020,
                            ["Pre"] = 891.4400000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 139020,
                            ["Pre"] = 895.2800000000,
                        },
                    },
                    [1579776] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 77585,
                            ["Pre"] = 285.9400000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 139020,
                            ["Pre"] = 909.5500000000,
                        },
                    },
                    [1577729] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 30164,
                            ["Pre"] = 2222.9100000000,
                        },
                    },
                    [1576449] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 30163,
                            ["Pre"] = 451.5900000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 30163,
                            ["Pre"] = 452.3200000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1075.9300000000,
                        },
                    },
                    [1577217] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 30166,
                            ["Pre"] = 277.0100000000,
                        },
                    },
                    [9961472] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 77584,
                            ["Pre"] = 267.8300000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 139020,
                            ["Pre"] = 892.1700000000,
                        },
                    },
                    [267527] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1342.2200000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1414.5000000000,
                        },
                    },
                    [8855040] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1435.7600000000,
                        },
                        [2] = 
                        {
                            [1] = 30160,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1692.6100000000,
                        },
                    },
                    [1384448] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1123.8700000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1160.6000000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1172.1800000000,
                        },
                        [4] = 
                        {
                            [1] = 30161,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1195.7500000000,
                        },
                        [5] = 
                        {
                            [1] = 150672,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1732.2700000000,
                        },
                        [6] = 
                        {
                            [1] = 150670,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1780.5800000000,
                        },
                    },
                    [465152] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1181.8600000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2464.0400000000,
                        },
                        [3] = 
                        {
                            [1] = 30160,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2720.8900000000,
                        },
                    },
                    [820992] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1057.4200000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1129.7000000000,
                        },
                    },
                    [164864] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1164.8100000000,
                        },
                        [2] = 
                        {
                            [1] = 30151,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1510.5100000000,
                        },
                        [3] = 
                        {
                            [1] = 30151,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1706.4600000000,
                        },
                    },
                    [8656128] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 822.3100000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1125.0100000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1663.4600000000,
                        },
                    },
                    [263936] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 77591,
                            ["Pre"] = 843.5700000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 139020,
                            ["Pre"] = 915.8500000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 77589,
                            [3] = 77591,
                            ["Pre"] = 1146.2700000000,
                        },
                    },
                    [465182] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 851.3800000000,
                        },
                        [2] = 
                        {
                            [1] = 77590,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1108.2300000000,
                        },
                    },
                    [1380864] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30156,
                            [3] = 77581,
                            ["Pre"] = 884.2100000000,
                        },
                        [2] = 
                        {
                            [1] = 30156,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 967.6700000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1425.8600000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8156.2100000000,
                        },
                        [5] = 
                        {
                            [1] = 77581,
                            [2] = 150669,
                            [3] = 150671,
                            ["Pre"] = 8697.8600000000,
                        },
                    },
                    [461056] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30156,
                            [3] = 77591,
                            ["Pre"] = 827.1400000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 995.9100000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1083.9900000000,
                        },
                    },
                    [136448] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 30161,
                            ["Pre"] = 337.7800000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 30157,
                            [3] = 30161,
                            ["Pre"] = 349.3600000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 30149,
                            [3] = 30161,
                            ["Pre"] = 352.4000000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 30149,
                            [3] = 30161,
                            ["Pre"] = 363.9800000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 364.1200000000,
                        },
                        [6] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 30161,
                            ["Pre"] = 371.9300000000,
                        },
                        [7] = 
                        {
                            [1] = 30159,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 375.7000000000,
                        },
                        [8] = 
                        {
                            [1] = 30159,
                            [2] = 77590,
                            [3] = 30161,
                            ["Pre"] = 383.5100000000,
                        },
                        [9] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 702.4100000000,
                        },
                        [10] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 894.0500000000,
                        },
                        [11] = 
                        {
                            [1] = 30151,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 905.7700000000,
                        },
                        [12] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 913.5800000000,
                        },
                        [13] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 957.7600000000,
                        },
                        [14] = 
                        {
                            [1] = 30151,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 984.1000000000,
                        },
                        [15] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 991.9100000000,
                        },
                        [16] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1205.2700000000,
                        },
                    },
                    [1777152] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77589,
                            [3] = 77591,
                            ["Pre"] = 1157.1200000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 77584,
                            [3] = 150731,
                            ["Pre"] = 3633.3200000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 150731,
                            ["Pre"] = 3653.3500000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 150731,
                            ["Pre"] = 3657.4600000000,
                        },
                        [5] = 
                        {
                            [1] = 77584,
                            [2] = 30156,
                            [3] = 150731,
                            ["Pre"] = 3659.8900000000,
                        },
                        [6] = 
                        {
                            [1] = 77584,
                            [2] = 30149,
                            [3] = 150731,
                            ["Pre"] = 3664.6000000000,
                        },
                        [7] = 
                        {
                            [1] = 77584,
                            [2] = 30151,
                            [3] = 150731,
                            ["Pre"] = 3676.3200000000,
                        },
                        [8] = 
                        {
                            [1] = 77584,
                            [2] = 30161,
                            [3] = 150731,
                            ["Pre"] = 3716.7800000000,
                        },
                        [9] = 
                        {
                            [1] = 77584,
                            [2] = 30160,
                            [3] = 150731,
                            ["Pre"] = 3890.1700000000,
                        },
                        [10] = 
                        {
                            [1] = 77584,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4014.6100000000,
                        },
                        [11] = 
                        {
                            [1] = 77584,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4517.4700000000,
                        },
                        [12] = 
                        {
                            [1] = 77589,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4531.0800000000,
                        },
                    },
                    [1574686] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 77584,
                            [3] = 139020,
                            ["Pre"] = 883.7000000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1140.5500000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1443.5000000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1447.3400000000,
                        },
                    },
                    [1574656] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 139020,
                            ["Pre"] = 880.5900000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1141.2800000000,
                        },
                    },
                    [396800] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 30156,
                            ["Pre"] = 271.9700000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 30153,
                            [3] = 30156,
                            ["Pre"] = 283.5100000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 30156,
                            ["Pre"] = 296.1100000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 77590,
                            ["Pre"] = 322.7800000000,
                        },
                        [5] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 30161,
                            ["Pre"] = 355.4300000000,
                        },
                        [6] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 150789,
                            ["Pre"] = 365.0600000000,
                        },
                        [7] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 77589,
                            ["Pre"] = 617.6700000000,
                        },
                        [8] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 150670,
                            ["Pre"] = 653.2600000000,
                        },
                        [9] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 30152,
                            ["Pre"] = 1156.1200000000,
                        },
                        [10] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 139019,
                            ["Pre"] = 1935.4400000000,
                        },
                    },
                    [1250560] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 30164,
                            ["Pre"] = 2215.1700000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2835.1500000000,
                        },
                    },
                    [300288] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 150669,
                            ["Pre"] = 790.8900000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1399.2900000000,
                        },
                    },
                    [1578247] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 139020,
                            ["Pre"] = 884.4300000000,
                        },
                    },
                    [1378048] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 577.9700000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 77591,
                            ["Pre"] = 812.1500000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 77591,
                            ["Pre"] = 884.0300000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 139020,
                            ["Pre"] = 956.3100000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 77591,
                            [3] = 77581,
                            ["Pre"] = 1420.5500000000,
                        },
                        [6] = 
                        {
                            [1] = 30154,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 1492.8300000000,
                        },
                    },
                    [9764864] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 30161,
                            ["Pre"] = 332.7000000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 862.7700000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 77581,
                            ["Pre"] = 869.2200000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 874.3500000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 941.1000000000,
                        },
                        [6] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 952.6800000000,
                        },
                        [7] = 
                        {
                            [1] = 30159,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1410.8700000000,
                        },
                        [8] = 
                        {
                            [1] = 30161,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1482.7500000000,
                        },
                    },
                    [1578240] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 30155,
                            ["Pre"] = 256.9800000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 30161,
                            ["Pre"] = 340.4400000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 150669,
                            ["Pre"] = 798.6300000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 77581,
                            ["Pre"] = 876.9600000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 139020,
                            ["Pre"] = 967.8900000000,
                        },
                        [6] = 
                        {
                            [1] = 30159,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1426.0800000000,
                        },
                        [7] = 
                        {
                            [1] = 30159,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 1504.4100000000,
                        },
                    },
                    [330240] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2821.8200000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 77581,
                            [3] = 150731,
                            ["Pre"] = 4240.7000000000,
                        },
                    },
                    [1377546] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1397.5400000000,
                        },
                    },
                    [335872] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1110.5400000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1128.9500000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1158.8500000000,
                        },
                        [4] = 
                        {
                            [1] = 30163,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1355.9400000000,
                        },
                        [5] = 
                        {
                            [1] = 150670,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 3126.5300000000,
                        },
                    },
                    [1514240] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 77585,
                            [3] = 77589,
                            ["Pre"] = 620.7500000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 77585,
                            [3] = 77589,
                            ["Pre"] = 625.8700000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2245.0800000000,
                        },
                        [4] = 
                        {
                            [1] = 30165,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2258.4900000000,
                        },
                        [5] = 
                        {
                            [1] = 30166,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2266.8600000000,
                        },
                        [6] = 
                        {
                            [1] = 30158,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2270.9700000000,
                        },
                        [7] = 
                        {
                            [1] = 30156,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2273.4000000000,
                        },
                        [8] = 
                        {
                            [1] = 30149,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2278.1100000000,
                        },
                        [9] = 
                        {
                            [1] = 30161,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2330.2900000000,
                        },
                        [10] = 
                        {
                            [1] = 30163,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2442.1700000000,
                        },
                        [11] = 
                        {
                            [1] = 30160,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2503.6800000000,
                        },
                        [12] = 
                        {
                            [1] = 77589,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2628.1200000000,
                        },
                        [13] = 
                        {
                            [1] = 77589,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2809.7400000000,
                        },
                        [14] = 
                        {
                            [1] = 30153,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3979.7100000000,
                        },
                        [15] = 
                        {
                            [1] = 77589,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 4212.7600000000,
                        },
                        [16] = 
                        {
                            [1] = 30153,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5297.4800000000,
                        },
                        [17] = 
                        {
                            [1] = 77585,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7907.7800000000,
                        },
                    },
                    [66309] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2423.0700000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2458.6900000000,
                        },
                        [3] = 
                        {
                            [1] = 30160,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5845.2500000000,
                        },
                        [4] = 
                        {
                            [1] = 30163,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9697.5000000000,
                        },
                    },
                    [99584] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2397.1800000000,
                        },
                        [2] = 
                        {
                            [1] = 30163,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2940.5800000000,
                        },
                        [3] = 
                        {
                            [1] = 30163,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5783.7400000000,
                        },
                    },
                    [1377536] = 
                    {
                        [1] = 
                        {
                            [1] = 30159,
                            [2] = 30157,
                            [3] = 150669,
                            ["Pre"] = 807.5500000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 861.0200000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 986.2300000000,
                        },
                        [4] = 
                        {
                            [1] = 30161,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 1058.1100000000,
                        },
                        [5] = 
                        {
                            [1] = 30157,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1415.9500000000,
                        },
                        [6] = 
                        {
                            [1] = 30163,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1594.6300000000,
                        },
                        [7] = 
                        {
                            [1] = 30154,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2745.2400000000,
                        },
                        [8] = 
                        {
                            [1] = 30161,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2828.7000000000,
                        },
                        [9] = 
                        {
                            [1] = 77581,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 3365.2200000000,
                        },
                        [10] = 
                        {
                            [1] = 30159,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4175.7000000000,
                        },
                        [11] = 
                        {
                            [1] = 30161,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4247.5800000000,
                        },
                        [12] = 
                        {
                            [1] = 77581,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4784.1000000000,
                        },
                    },
                    [132096] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 30151,
                            ["Pre"] = 292.3200000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 30151,
                            ["Pre"] = 297.3200000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 331.4700000000,
                        },
                        [4] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 638.0200000000,
                        },
                        [5] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 677.1700000000,
                        },
                        [6] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 833.9700000000,
                        },
                        [7] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 838.9700000000,
                        },
                        [8] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 853.5900000000,
                        },
                        [9] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 873.1200000000,
                        },
                        [10] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 30152,
                            ["Pre"] = 1133.4700000000,
                        },
                        [11] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 30152,
                            ["Pre"] = 1138.4700000000,
                        },
                        [12] = 
                        {
                            [1] = 30154,
                            [2] = 30149,
                            [3] = 30152,
                            ["Pre"] = 1153.0900000000,
                        },
                        [13] = 
                        {
                            [1] = 30162,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1163.0600000000,
                        },
                        [14] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 30152,
                            ["Pre"] = 1172.6200000000,
                        },
                        [15] = 
                        {
                            [1] = 77584,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1175.6600000000,
                        },
                        [16] = 
                        {
                            [1] = 30153,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1176.3500000000,
                        },
                        [17] = 
                        {
                            [1] = 30159,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1176.3900000000,
                        },
                        [18] = 
                        {
                            [1] = 150789,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1257.9000000000,
                        },
                        [19] = 
                        {
                            [1] = 30165,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1479.1700000000,
                        },
                        [20] = 
                        {
                            [1] = 30149,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1498.7900000000,
                        },
                        [21] = 
                        {
                            [1] = 77590,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1518.3200000000,
                        },
                        [22] = 
                        {
                            [1] = 30165,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1675.1200000000,
                        },
                        [23] = 
                        {
                            [1] = 30149,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1694.7400000000,
                        },
                        [24] = 
                        {
                            [1] = 77590,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1714.2700000000,
                        },
                        [25] = 
                        {
                            [1] = 30151,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 1727.7200000000,
                        },
                        [26] = 
                        {
                            [1] = 30151,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1784.7900000000,
                        },
                        [27] = 
                        {
                            [1] = 30151,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1800,
                        },
                        [28] = 
                        {
                            [1] = 30151,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2828.2800000000,
                        },
                        [29] = 
                        {
                            [1] = 30151,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4549.6200000000,
                        },
                    },
                    [335360] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3671.5300000000,
                        },
                        [2] = 
                        {
                            [1] = 77590,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3868.6200000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4183.6300000000,
                        },
                        [4] = 
                        {
                            [1] = 30157,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4202.0400000000,
                        },
                        [5] = 
                        {
                            [1] = 77590,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4214.9300000000,
                        },
                        [6] = 
                        {
                            [1] = 30162,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4255.9100000000,
                        },
                        [7] = 
                        {
                            [1] = 30157,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4274.3200000000,
                        },
                        [8] = 
                        {
                            [1] = 30163,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4453,
                        },
                        [9] = 
                        {
                            [1] = 77591,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4727.0300000000,
                        },
                        [10] = 
                        {
                            [1] = 139020,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4799.3100000000,
                        },
                        [11] = 
                        {
                            [1] = 77590,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5639.2100000000,
                        },
                        [12] = 
                        {
                            [1] = 77591,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 6151.3100000000,
                        },
                        [13] = 
                        {
                            [1] = 139020,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 6223.5900000000,
                        },
                    },
                    [137472] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 431.3700000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 436.3700000000,
                        },
                        [3] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 450.9900000000,
                        },
                        [4] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            [3] = 77583,
                            ["Pre"] = 462.7100000000,
                        },
                        [5] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 77583,
                            ["Pre"] = 503.1700000000,
                        },
                        [6] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 668.0100000000,
                        },
                        [7] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 669.7600000000,
                        },
                        [8] = 
                        {
                            [1] = 30153,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 681.3000000000,
                        },
                        [9] = 
                        {
                            [1] = 30159,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 681.3400000000,
                        },
                        [10] = 
                        {
                            [1] = 30156,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 696.3300000000,
                        },
                        [11] = 
                        {
                            [1] = 30165,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 761.8500000000,
                        },
                        [12] = 
                        {
                            [1] = 30157,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 766.8500000000,
                        },
                        [13] = 
                        {
                            [1] = 30149,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 781.4700000000,
                        },
                        [14] = 
                        {
                            [1] = 30151,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 793.1900000000,
                        },
                        [15] = 
                        {
                            [1] = 30165,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1193.5200000000,
                        },
                        [16] = 
                        {
                            [1] = 30157,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1198.5200000000,
                        },
                        [17] = 
                        {
                            [1] = 30149,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1213.1400000000,
                        },
                        [18] = 
                        {
                            [1] = 30151,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1224.8600000000,
                        },
                        [19] = 
                        {
                            [1] = 77590,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1289.7400000000,
                        },
                        [20] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1963.6000000000,
                        },
                        [21] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1983.2200000000,
                        },
                        [22] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 1994.9400000000,
                        },
                        [23] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 139019,
                            ["Pre"] = 2035.4000000000,
                        },
                        [24] = 
                        {
                            [1] = 150670,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 2066.0100000000,
                        },
                        [25] = 
                        {
                            [1] = 30165,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2294.0800000000,
                        },
                        [26] = 
                        {
                            [1] = 30149,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2313.7000000000,
                        },
                        [27] = 
                        {
                            [1] = 30151,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2325.4200000000,
                        },
                        [28] = 
                        {
                            [1] = 77590,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2836.0900000000,
                        },
                        [29] = 
                        {
                            [1] = 150670,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 3166.5700000000,
                        },
                    },
                    [335616] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3713.8100000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3732.2200000000,
                        },
                        [3] = 
                        {
                            [1] = 150789,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3910.9000000000,
                        },
                        [4] = 
                        {
                            [1] = 150789,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5681.4900000000,
                        },
                        [5] = 
                        {
                            [1] = 30162,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10919.2900000000,
                        },
                        [6] = 
                        {
                            [1] = 30163,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 11116.3800000000,
                        },
                    },
                    [887296] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 77581,
                            ["Pre"] = 887.1700000000,
                        },
                    },
                    [334592] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 77585,
                            [3] = 150731,
                            ["Pre"] = 3646.5700000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 77585,
                            [3] = 150731,
                            ["Pre"] = 3664.9800000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3966.4200000000,
                        },
                        [4] = 
                        {
                            [1] = 30163,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 4163.5100000000,
                        },
                        [5] = 
                        {
                            [1] = 77585,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4189.9700000000,
                        },
                        [6] = 
                        {
                            [1] = 30162,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5284.1900000000,
                        },
                        [7] = 
                        {
                            [1] = 30163,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5481.2800000000,
                        },
                        [8] = 
                        {
                            [1] = 150669,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5827.5900000000,
                        },
                        [9] = 
                        {
                            [1] = 77589,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5934.1000000000,
                        },
                        [10] = 
                        {
                            [1] = 30164,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 7251.8700000000,
                        },
                    },
                    [1776896] = 
                    {
                        [1] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            [3] = 77589,
                            ["Pre"] = 740.4500000000,
                        },
                        [2] = 
                        {
                            [1] = 77585,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1229.1900000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 77585,
                            [3] = 139019,
                            ["Pre"] = 1925.2300000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 139019,
                            ["Pre"] = 1926.9800000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 77585,
                            [3] = 139019,
                            ["Pre"] = 1938.5600000000,
                        },
                        [6] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 139019,
                            ["Pre"] = 1951.1200000000,
                        },
                        [7] = 
                        {
                            [1] = 77585,
                            [2] = 30156,
                            [3] = 139019,
                            ["Pre"] = 1953.5500000000,
                        },
                        [8] = 
                        {
                            [1] = 77585,
                            [2] = 30149,
                            [3] = 139019,
                            ["Pre"] = 1958.2600000000,
                        },
                        [9] = 
                        {
                            [1] = 77585,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 1969.9800000000,
                        },
                        [10] = 
                        {
                            [1] = 77585,
                            [2] = 30161,
                            [3] = 139019,
                            ["Pre"] = 2010.4400000000,
                        },
                        [11] = 
                        {
                            [1] = 77585,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2468.6300000000,
                        },
                        [12] = 
                        {
                            [1] = 77585,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2811.1300000000,
                        },
                    },
                    [197888] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30158,
                            [3] = 30164,
                            ["Pre"] = 2225.9800000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 30164,
                            ["Pre"] = 2244.3900000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2285.3000000000,
                        },
                        [4] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2303.7100000000,
                        },
                        [5] = 
                        {
                            [1] = 30157,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2477.1000000000,
                        },
                        [6] = 
                        {
                            [1] = 30161,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2482.3900000000,
                        },
                        [7] = 
                        {
                            [1] = 30162,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2583.1300000000,
                        },
                        [8] = 
                        {
                            [1] = 30157,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2601.5400000000,
                        },
                        [9] = 
                        {
                            [1] = 30163,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2780.2200000000,
                        },
                        [10] = 
                        {
                            [1] = 30158,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5612.5400000000,
                        },
                        [11] = 
                        {
                            [1] = 30161,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5671.8600000000,
                        },
                        [12] = 
                        {
                            [1] = 150670,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5969.6900000000,
                        },
                        [13] = 
                        {
                            [1] = 30162,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9500.4100000000,
                        },
                    },
                    [1246464] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30153,
                            [3] = 30164,
                            ["Pre"] = 2213.3800000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 30157,
                            [3] = 30164,
                            ["Pre"] = 2231.8300000000,
                        },
                        [3] = 
                        {
                            [1] = 30153,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2756.7800000000,
                        },
                        [4] = 
                        {
                            [1] = 30153,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5599.9400000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5599.9800000000,
                        },
                    },
                    [886016] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 150669,
                            ["Pre"] = 794.2200000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 30164,
                            ["Pre"] = 2218.5000000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 150731,
                            ["Pre"] = 3637.3800000000,
                        },
                    },
                    [853258] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 77581,
                            ["Pre"] = 872.5500000000,
                        },
                    },
                    [8716288] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 30163,
                            ["Pre"] = 447.9100000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 972.9000000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 991.3100000000,
                        },
                        [4] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2415.5900000000,
                        },
                        [5] = 
                        {
                            [1] = 30162,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2743.4900000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2761.9000000000,
                        },
                        [7] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3816.0600000000,
                        },
                        [8] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3834.4700000000,
                        },
                        [9] = 
                        {
                            [1] = 30162,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4162.3700000000,
                        },
                        [10] = 
                        {
                            [1] = 30157,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4180.7800000000,
                        },
                        [11] = 
                        {
                            [1] = 30163,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4359.4600000000,
                        },
                        [12] = 
                        {
                            [1] = 30162,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5586.6500000000,
                        },
                        [13] = 
                        {
                            [1] = 30157,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5605.0600000000,
                        },
                        [14] = 
                        {
                            [1] = 150669,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 6130.0500000000,
                        },
                    },
                    [167178] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 30149,
                            ["Pre"] = 283.8500000000,
                        },
                    },
                    [1510661] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 30153,
                            ["Pre"] = 264.1100000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 77589,
                            ["Pre"] = 598.2700000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 139019,
                            ["Pre"] = 1916.0400000000,
                        },
                        [4] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 150671,
                            ["Pre"] = 7551.1400000000,
                        },
                    },
                    [1048576] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 77585,
                            ["Pre"] = 273.4200000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 77585,
                            ["Pre"] = 275.1700000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 30165,
                            [3] = 77585,
                            ["Pre"] = 282.9100000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 30165,
                            [3] = 77585,
                            ["Pre"] = 286.7500000000,
                        },
                        [5] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 77585,
                            ["Pre"] = 291.8300000000,
                        },
                        [6] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 30149,
                            ["Pre"] = 306.4500000000,
                        },
                        [7] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 30151,
                            ["Pre"] = 318.1700000000,
                        },
                        [8] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 77590,
                            ["Pre"] = 325.9800000000,
                        },
                        [9] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 30161,
                            ["Pre"] = 358.6300000000,
                        },
                        [10] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 30163,
                            ["Pre"] = 470.5100000000,
                        },
                        [11] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 30160,
                            ["Pre"] = 532.0200000000,
                        },
                        [12] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 150670,
                            ["Pre"] = 656.4600000000,
                        },
                        [13] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 150669,
                            ["Pre"] = 816.8200000000,
                        },
                        [14] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 77591,
                            ["Pre"] = 838.0800000000,
                        },
                        [15] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 139020,
                            ["Pre"] = 910.3600000000,
                        },
                        [16] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 30152,
                            ["Pre"] = 1159.3200000000,
                        },
                        [17] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 30164,
                            ["Pre"] = 2241.1000000000,
                        },
                    },
                    [134405] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 30157,
                            ["Pre"] = 264.2300000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 77590,
                            ["Pre"] = 303.3800000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 30161,
                            ["Pre"] = 336.0300000000,
                        },
                        [4] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 150670,
                            ["Pre"] = 633.8600000000,
                        },
                        [5] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 30152,
                            ["Pre"] = 1136.7200000000,
                        },
                    },
                    [987393] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 150672,
                            ["Pre"] = 588.9200000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 150672,
                            ["Pre"] = 602.2500000000,
                        },
                    },
                    [1114373] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 30163,
                            ["Pre"] = 451.2800000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 30164,
                            ["Pre"] = 2221.8700000000,
                        },
                    },
                    [1315072] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 30151,
                            ["Pre"] = 298.9400000000,
                        },
                    },
                    [987392] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 30153,
                            ["Pre"] = 267.4800000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 30158,
                            ["Pre"] = 280.0800000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 30153,
                            ["Pre"] = 280.8100000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 30158,
                            ["Pre"] = 293.4100000000,
                        },
                    },
                    [334622] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 150731,
                            ["Pre"] = 3631.5700000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 150731,
                            ["Pre"] = 3649.9800000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3828.6600000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4174.9700000000,
                        },
                        [5] = 
                        {
                            [1] = 77584,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5599.2500000000,
                        },
                    },
                    [1580544] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 77590,
                            ["Pre"] = 307.0600000000,
                        },
                        [2] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 77590,
                            ["Pre"] = 310.9000000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 77591,
                            ["Pre"] = 819.1600000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 77591,
                            ["Pre"] = 823,
                        },
                        [5] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 139020,
                            ["Pre"] = 881.9500000000,
                        },
                        [6] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 139020,
                            ["Pre"] = 903.7300000000,
                        },
                        [7] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 139020,
                            ["Pre"] = 907.8400000000,
                        },
                        [8] = 
                        {
                            [1] = 77584,
                            [2] = 30156,
                            [3] = 139020,
                            ["Pre"] = 910.2700000000,
                        },
                        [9] = 
                        {
                            [1] = 77584,
                            [2] = 30149,
                            [3] = 139020,
                            ["Pre"] = 914.9800000000,
                        },
                        [10] = 
                        {
                            [1] = 77584,
                            [2] = 30151,
                            [3] = 139020,
                            ["Pre"] = 926.7000000000,
                        },
                        [11] = 
                        {
                            [1] = 30155,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 931.4000000000,
                        },
                        [12] = 
                        {
                            [1] = 30159,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 935.2400000000,
                        },
                        [13] = 
                        {
                            [1] = 77584,
                            [2] = 30161,
                            [3] = 139020,
                            ["Pre"] = 967.1600000000,
                        },
                        [14] = 
                        {
                            [1] = 77584,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1079.0400000000,
                        },
                        [15] = 
                        {
                            [1] = 77584,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1216.6800000000,
                        },
                        [16] = 
                        {
                            [1] = 77584,
                            [2] = 150670,
                            [3] = 139020,
                            ["Pre"] = 1264.9900000000,
                        },
                        [17] = 
                        {
                            [1] = 77584,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1425.3500000000,
                        },
                        [18] = 
                        {
                            [1] = 77584,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1767.8500000000,
                        },
                        [19] = 
                        {
                            [1] = 77584,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2849.6300000000,
                        },
                        [20] = 
                        {
                            [1] = 30155,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4265.4000000000,
                        },
                        [21] = 
                        {
                            [1] = 30159,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4269.2400000000,
                        },
                    },
                    [1249541] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 30164,
                            ["Pre"] = 2213.4200000000,
                        },
                    },
                    [1380613] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 150669,
                            ["Pre"] = 789.1400000000,
                        },
                    },
                    [1115392] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 30163,
                            ["Pre"] = 442.8300000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 150669,
                            ["Pre"] = 797.5900000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 150731,
                            ["Pre"] = 3632.3000000000,
                        },
                        [4] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 150731,
                            ["Pre"] = 3640.7500000000,
                        },
                    },
                    [1249536] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 30153,
                            ["Pre"] = 259.0300000000,
                        },
                    },
                    [856325] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 30157,
                            ["Pre"] = 264.1500000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 30157,
                            ["Pre"] = 272.6000000000,
                        },
                    },
                    [9502720] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 30166,
                            ["Pre"] = 267.5200000000,
                        },
                    },
                    [1577216] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 30155,
                            ["Pre"] = 255.2300000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 77584,
                            ["Pre"] = 258.3400000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 30166,
                            ["Pre"] = 280.1200000000,
                        },
                        [4] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 139020,
                            ["Pre"] = 882.6800000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 139020,
                            ["Pre"] = 904.4600000000,
                        },
                    },
                    [1378816] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 77581,
                            ["Pre"] = 855.8900000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 77581,
                            ["Pre"] = 867.4700000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 30149,
                            [3] = 77581,
                            ["Pre"] = 888.9200000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 30149,
                            [3] = 77581,
                            ["Pre"] = 900.5000000000,
                        },
                        [5] = 
                        {
                            [1] = 30162,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 939.3500000000,
                        },
                        [6] = 
                        {
                            [1] = 30149,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1430.5700000000,
                        },
                    },
                    [1380608] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 30159,
                            ["Pre"] = 247.4900000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 30166,
                            ["Pre"] = 269.2700000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 30161,
                            ["Pre"] = 330.9500000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 30161,
                            ["Pre"] = 352.7300000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 150669,
                            ["Pre"] = 810.9200000000,
                        },
                    },
                    [1769472] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 77585,
                            ["Pre"] = 272.6100000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 77584,
                            [3] = 77585,
                            ["Pre"] = 274.3600000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 77585,
                            ["Pre"] = 291.0200000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 77585,
                            ["Pre"] = 298.5000000000,
                        },
                        [5] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 30156,
                            ["Pre"] = 300.9300000000,
                        },
                        [6] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 30149,
                            ["Pre"] = 305.6400000000,
                        },
                        [7] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 30151,
                            ["Pre"] = 317.3600000000,
                        },
                        [8] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 30161,
                            ["Pre"] = 357.8200000000,
                        },
                        [9] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 77583,
                            ["Pre"] = 405.6000000000,
                        },
                        [10] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 77589,
                            ["Pre"] = 592.4600000000,
                        },
                        [11] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 77589,
                            ["Pre"] = 601.9500000000,
                        },
                        [12] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 77589,
                            ["Pre"] = 605.7900000000,
                        },
                        [13] = 
                        {
                            [1] = 30162,
                            [2] = 77585,
                            [3] = 77589,
                            ["Pre"] = 607.4600000000,
                        },
                        [14] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 77589,
                            ["Pre"] = 610.8700000000,
                        },
                        [15] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 77589,
                            ["Pre"] = 614.2400000000,
                        },
                        [16] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 77589,
                            ["Pre"] = 618.3500000000,
                        },
                        [17] = 
                        {
                            [1] = 77584,
                            [2] = 30156,
                            [3] = 77589,
                            ["Pre"] = 620.7800000000,
                        },
                        [18] = 
                        {
                            [1] = 30159,
                            [2] = 77585,
                            [3] = 77589,
                            ["Pre"] = 620.7900000000,
                        },
                        [19] = 
                        {
                            [1] = 77584,
                            [2] = 30149,
                            [3] = 77589,
                            ["Pre"] = 625.4900000000,
                        },
                        [20] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 77589,
                            ["Pre"] = 633.3500000000,
                        },
                        [21] = 
                        {
                            [1] = 77585,
                            [2] = 30156,
                            [3] = 77589,
                            ["Pre"] = 635.7800000000,
                        },
                        [22] = 
                        {
                            [1] = 77585,
                            [2] = 30149,
                            [3] = 77589,
                            ["Pre"] = 640.4900000000,
                        },
                        [23] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 150670,
                            ["Pre"] = 655.6500000000,
                        },
                        [24] = 
                        {
                            [1] = 77584,
                            [2] = 30161,
                            [3] = 77589,
                            ["Pre"] = 677.6700000000,
                        },
                        [25] = 
                        {
                            [1] = 77585,
                            [2] = 30161,
                            [3] = 77589,
                            ["Pre"] = 692.6700000000,
                        },
                        [26] = 
                        {
                            [1] = 77584,
                            [2] = 77583,
                            [3] = 77589,
                            ["Pre"] = 725.4500000000,
                        },
                        [27] = 
                        {
                            [1] = 77584,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 789.5500000000,
                        },
                        [28] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 150669,
                            ["Pre"] = 816.0100000000,
                        },
                        [29] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 77591,
                            ["Pre"] = 837.2700000000,
                        },
                        [30] = 
                        {
                            [1] = 77584,
                            [2] = 30160,
                            [3] = 77589,
                            ["Pre"] = 851.0600000000,
                        },
                        [31] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 77581,
                            ["Pre"] = 894.3400000000,
                        },
                        [32] = 
                        {
                            [1] = 77584,
                            [2] = 77589,
                            [3] = 150670,
                            ["Pre"] = 975.5000000000,
                        },
                        [33] = 
                        {
                            [1] = 77585,
                            [2] = 77589,
                            [3] = 150670,
                            ["Pre"] = 990.5000000000,
                        },
                        [34] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 30152,
                            ["Pre"] = 1158.5100000000,
                        },
                        [35] = 
                        {
                            [1] = 77585,
                            [2] = 77589,
                            [3] = 77591,
                            ["Pre"] = 1172.1200000000,
                        },
                        [36] = 
                        {
                            [1] = 77584,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1214.1900000000,
                        },
                        [37] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 139019,
                            ["Pre"] = 1910.2300000000,
                        },
                        [38] = 
                        {
                            [1] = 30154,
                            [2] = 77584,
                            [3] = 139019,
                            ["Pre"] = 1911.9800000000,
                        },
                        [39] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 139019,
                            ["Pre"] = 1919.7200000000,
                        },
                        [40] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 139019,
                            ["Pre"] = 1923.5600000000,
                        },
                        [41] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 139019,
                            ["Pre"] = 1928.6400000000,
                        },
                        [42] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 139019,
                            ["Pre"] = 1932.0100000000,
                        },
                        [43] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 139019,
                            ["Pre"] = 1936.1200000000,
                        },
                        [44] = 
                        {
                            [1] = 77584,
                            [2] = 30156,
                            [3] = 139019,
                            ["Pre"] = 1938.5500000000,
                        },
                        [45] = 
                        {
                            [1] = 77584,
                            [2] = 30149,
                            [3] = 139019,
                            ["Pre"] = 1943.2600000000,
                        },
                        [46] = 
                        {
                            [1] = 77584,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 1954.9800000000,
                        },
                        [47] = 
                        {
                            [1] = 77584,
                            [2] = 30161,
                            [3] = 139019,
                            ["Pre"] = 1995.4400000000,
                        },
                        [48] = 
                        {
                            [1] = 77584,
                            [2] = 30163,
                            [3] = 139019,
                            ["Pre"] = 2107.3200000000,
                        },
                        [49] = 
                        {
                            [1] = 77584,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2168.8300000000,
                        },
                        [50] = 
                        {
                            [1] = 30155,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2254.5700000000,
                        },
                        [51] = 
                        {
                            [1] = 30159,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2258.4100000000,
                        },
                        [52] = 
                        {
                            [1] = 77584,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2453.6300000000,
                        },
                        [53] = 
                        {
                            [1] = 77584,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2531.9600000000,
                        },
                        [54] = 
                        {
                            [1] = 77584,
                            [2] = 139020,
                            [3] = 139019,
                            ["Pre"] = 2547.1700000000,
                        },
                        [55] = 
                        {
                            [1] = 77584,
                            [2] = 77589,
                            [3] = 30164,
                            ["Pre"] = 2560.1400000000,
                        },
                        [56] = 
                        {
                            [1] = 77585,
                            [2] = 139020,
                            [3] = 139019,
                            ["Pre"] = 2562.1700000000,
                        },
                        [57] = 
                        {
                            [1] = 77584,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2796.1300000000,
                        },
                        [58] = 
                        {
                            [1] = 77589,
                            [2] = 139020,
                            [3] = 139019,
                            ["Pre"] = 2882.0200000000,
                        },
                        [59] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 150731,
                            ["Pre"] = 3648.3200000000,
                        },
                        [60] = 
                        {
                            [1] = 30153,
                            [2] = 77585,
                            [3] = 150731,
                            ["Pre"] = 3659.8600000000,
                        },
                        [61] = 
                        {
                            [1] = 30159,
                            [2] = 77585,
                            [3] = 150731,
                            ["Pre"] = 3659.9000000000,
                        },
                        [62] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 150731,
                            ["Pre"] = 3672.4600000000,
                        },
                        [63] = 
                        {
                            [1] = 77585,
                            [2] = 30156,
                            [3] = 150731,
                            ["Pre"] = 3674.8900000000,
                        },
                        [64] = 
                        {
                            [1] = 77585,
                            [2] = 30149,
                            [3] = 150731,
                            ["Pre"] = 3679.6000000000,
                        },
                        [65] = 
                        {
                            [1] = 77585,
                            [2] = 30151,
                            [3] = 150731,
                            ["Pre"] = 3691.3200000000,
                        },
                        [66] = 
                        {
                            [1] = 77585,
                            [2] = 30161,
                            [3] = 150731,
                            ["Pre"] = 3731.7800000000,
                        },
                        [67] = 
                        {
                            [1] = 77584,
                            [2] = 77583,
                            [3] = 150731,
                            ["Pre"] = 3764.5600000000,
                        },
                        [68] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            [3] = 150731,
                            ["Pre"] = 3779.5600000000,
                        },
                        [69] = 
                        {
                            [1] = 77584,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3877.9100000000,
                        },
                        [70] = 
                        {
                            [1] = 30155,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3975.9100000000,
                        },
                        [71] = 
                        {
                            [1] = 30159,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3979.7500000000,
                        },
                        [72] = 
                        {
                            [1] = 30165,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3979.8300000000,
                        },
                        [73] = 
                        {
                            [1] = 30166,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3988.2000000000,
                        },
                        [74] = 
                        {
                            [1] = 30158,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3992.3100000000,
                        },
                        [75] = 
                        {
                            [1] = 30156,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3994.7400000000,
                        },
                        [76] = 
                        {
                            [1] = 30149,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3999.4500000000,
                        },
                        [77] = 
                        {
                            [1] = 77585,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4029.6100000000,
                        },
                        [78] = 
                        {
                            [1] = 30161,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 4051.6300000000,
                        },
                        [79] = 
                        {
                            [1] = 77583,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 4099.4100000000,
                        },
                        [80] = 
                        {
                            [1] = 77585,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4211.2300000000,
                        },
                        [81] = 
                        {
                            [1] = 30160,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 4225.0200000000,
                        },
                        [82] = 
                        {
                            [1] = 77584,
                            [2] = 77581,
                            [3] = 150731,
                            ["Pre"] = 4253.3000000000,
                        },
                        [83] = 
                        {
                            [1] = 77585,
                            [2] = 77581,
                            [3] = 150731,
                            ["Pre"] = 4268.3000000000,
                        },
                        [84] = 
                        {
                            [1] = 77585,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4283.5100000000,
                        },
                        [85] = 
                        {
                            [1] = 77589,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4349.4600000000,
                        },
                        [86] = 
                        {
                            [1] = 77585,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4532.4700000000,
                        },
                        [87] = 
                        {
                            [1] = 77589,
                            [2] = 77581,
                            [3] = 150731,
                            ["Pre"] = 4588.1500000000,
                        },
                        [88] = 
                        {
                            [1] = 30148,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5285.7200000000,
                        },
                        [89] = 
                        {
                            [1] = 30154,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5285.9400000000,
                        },
                        [90] = 
                        {
                            [1] = 30155,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5293.6800000000,
                        },
                        [91] = 
                        {
                            [1] = 30159,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5297.5200000000,
                        },
                        [92] = 
                        {
                            [1] = 30165,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5297.6000000000,
                        },
                        [93] = 
                        {
                            [1] = 30166,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5305.9700000000,
                        },
                        [94] = 
                        {
                            [1] = 30158,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5310.0800000000,
                        },
                        [95] = 
                        {
                            [1] = 30156,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5312.5100000000,
                        },
                        [96] = 
                        {
                            [1] = 30149,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5317.2200000000,
                        },
                        [97] = 
                        {
                            [1] = 30151,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5328.9400000000,
                        },
                        [98] = 
                        {
                            [1] = 30161,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5369.4000000000,
                        },
                        [99] = 
                        {
                            [1] = 30160,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5542.7900000000,
                        },
                        [100] = 
                        {
                            [1] = 77581,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5905.9200000000,
                        },
                        [101] = 
                        {
                            [1] = 139020,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5921.1300000000,
                        },
                        [102] = 
                        {
                            [1] = 30152,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 6170.0900000000,
                        },
                        [103] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 150671,
                            ["Pre"] = 7572.9300000000,
                        },
                        [104] = 
                        {
                            [1] = 77584,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7892.7800000000,
                        },
                        [105] = 
                        {
                            [1] = 77584,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9210.5500000000,
                        },
                    },
                    [134019] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 726.5500000000,
                        },
                    },
                    [269056] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 77584,
                            [3] = 77589,
                            ["Pre"] = 594.2100000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 77589,
                            ["Pre"] = 609.2100000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 637.2100000000,
                        },
                        [4] = 
                        {
                            [1] = 77585,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 652.2100000000,
                        },
                        [5] = 
                        {
                            [1] = 77584,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1135.8600000000,
                        },
                        [6] = 
                        {
                            [1] = 77585,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1150.8600000000,
                        },
                        [7] = 
                        {
                            [1] = 77584,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1478.3600000000,
                        },
                        [8] = 
                        {
                            [1] = 77585,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1493.3600000000,
                        },
                        [9] = 
                        {
                            [1] = 30148,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3967.9500000000,
                        },
                        [10] = 
                        {
                            [1] = 30154,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3968.1700000000,
                        },
                        [11] = 
                        {
                            [1] = 30151,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 4011.1700000000,
                        },
                        [12] = 
                        {
                            [1] = 77589,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4852.3200000000,
                        },
                    },
                    [268059] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2246.6100000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2246.8300000000,
                        },
                        [3] = 
                        {
                            [1] = 30151,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2289.8300000000,
                        },
                        [4] = 
                        {
                            [1] = 77589,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2788.4800000000,
                        },
                        [5] = 
                        {
                            [1] = 77589,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 3130.9800000000,
                        },
                    },
                    [786695] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 30160,
                            ["Pre"] = 502.2500000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 30160,
                            ["Pre"] = 514.5400000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 30160,
                            ["Pre"] = 520.3600000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 689.8500000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 827.4900000000,
                        },
                        [6] = 
                        {
                            [1] = 30148,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1057.2000000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1129.4800000000,
                        },
                        [8] = 
                        {
                            [1] = 30154,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2460.4400000000,
                        },
                    },
                    [8455424] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2398.7100000000,
                        },
                        [2] = 
                        {
                            [1] = 30166,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2418.9600000000,
                        },
                        [3] = 
                        {
                            [1] = 77585,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2424.7800000000,
                        },
                        [4] = 
                        {
                            [1] = 30163,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2731.9100000000,
                        },
                    },
                    [1645824] = 
                    {
                        [1] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 776.0400000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1370.1700000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2030.6200000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2032.1500000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2032.3700000000,
                        },
                        [6] = 
                        {
                            [1] = 30155,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2040.1100000000,
                        },
                        [7] = 
                        {
                            [1] = 30159,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2043.9500000000,
                        },
                        [8] = 
                        {
                            [1] = 30165,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2044.0300000000,
                        },
                        [9] = 
                        {
                            [1] = 30166,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2052.4000000000,
                        },
                        [10] = 
                        {
                            [1] = 30149,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2063.6500000000,
                        },
                        [11] = 
                        {
                            [1] = 30151,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2075.3700000000,
                        },
                        [12] = 
                        {
                            [1] = 30161,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2115.8300000000,
                        },
                        [13] = 
                        {
                            [1] = 77583,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2289.2200000000,
                        },
                        [14] = 
                        {
                            [1] = 77583,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2365.3500000000,
                        },
                        [15] = 
                        {
                            [1] = 77583,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2574.0200000000,
                        },
                        [16] = 
                        {
                            [1] = 150670,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2902.4000000000,
                        },
                        [17] = 
                        {
                            [1] = 77583,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3998.3000000000,
                        },
                    },
                    [264192] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1252.8300000000,
                        },
                        [2] = 
                        {
                            [1] = 77583,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1598.7500000000,
                        },
                        [3] = 
                        {
                            [1] = 77583,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1794.7000000000,
                        },
                    },
                    [596224] = 
                    {
                        [1] = 
                        {
                            [1] = 30156,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 446.2800000000,
                        },
                        [2] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 615.0500000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 776.7600000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 931.5900000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 931.8100000000,
                        },
                        [6] = 
                        {
                            [1] = 30155,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 939.5500000000,
                        },
                        [7] = 
                        {
                            [1] = 77584,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 942.6600000000,
                        },
                        [8] = 
                        {
                            [1] = 30153,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 943.3500000000,
                        },
                        [9] = 
                        {
                            [1] = 30159,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 943.3900000000,
                        },
                        [10] = 
                        {
                            [1] = 30165,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 943.4700000000,
                        },
                        [11] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            [3] = 150670,
                            ["Pre"] = 945.5300000000,
                        },
                        [12] = 
                        {
                            [1] = 30157,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 948.4700000000,
                        },
                        [13] = 
                        {
                            [1] = 30166,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 951.8400000000,
                        },
                        [14] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 955.9500000000,
                        },
                        [15] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 957.6600000000,
                        },
                        [16] = 
                        {
                            [1] = 30151,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 974.8100000000,
                        },
                        [17] = 
                        {
                            [1] = 30161,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 1015.2700000000,
                        },
                        [18] = 
                        {
                            [1] = 77583,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1188.6600000000,
                        },
                        [19] = 
                        {
                            [1] = 30156,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1208.4300000000,
                        },
                        [20] = 
                        {
                            [1] = 77583,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1264.7900000000,
                        },
                        [21] = 
                        {
                            [1] = 30163,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1377.2000000000,
                        },
                        [22] = 
                        {
                            [1] = 77583,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1473.4600000000,
                        },
                        [23] = 
                        {
                            [1] = 77583,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 1815.9600000000,
                        },
                        [24] = 
                        {
                            [1] = 30156,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2490.6100000000,
                        },
                        [25] = 
                        {
                            [1] = 30163,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2659.3800000000,
                        },
                        [26] = 
                        {
                            [1] = 77583,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2897.7400000000,
                        },
                        [27] = 
                        {
                            [1] = 77583,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4316.6200000000,
                        },
                        [28] = 
                        {
                            [1] = 77583,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8230.3800000000,
                        },
                    },
                    [67840] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 564.0200000000,
                        },
                        [2] = 
                        {
                            [1] = 30166,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 584.2700000000,
                        },
                        [3] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 821.0900000000,
                        },
                        [4] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 897.2200000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 995.6900000000,
                        },
                        [6] = 
                        {
                            [1] = 30166,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1015.9400000000,
                        },
                        [7] = 
                        {
                            [1] = 77585,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1021.7600000000,
                        },
                        [8] = 
                        {
                            [1] = 30163,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1328.8900000000,
                        },
                    },
                    [1966080] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 77590,
                            ["Pre"] = 297.5700000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 77584,
                            [3] = 77590,
                            ["Pre"] = 299.3200000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 77590,
                            ["Pre"] = 319.3500000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 77590,
                            ["Pre"] = 323.4600000000,
                        },
                        [5] = 
                        {
                            [1] = 77584,
                            [2] = 30156,
                            [3] = 77590,
                            ["Pre"] = 325.8900000000,
                        },
                        [6] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 30163,
                            ["Pre"] = 494.6600000000,
                        },
                        [7] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 30160,
                            ["Pre"] = 556.1700000000,
                        },
                        [8] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 632.3000000000,
                        },
                        [9] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 77589,
                            ["Pre"] = 645.0200000000,
                        },
                        [10] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 77591,
                            ["Pre"] = 809.6700000000,
                        },
                        [11] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 77591,
                            ["Pre"] = 828.0800000000,
                        },
                        [12] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 77591,
                            ["Pre"] = 831.4500000000,
                        },
                        [13] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 77591,
                            ["Pre"] = 835.5600000000,
                        },
                        [14] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 150669,
                            ["Pre"] = 840.9700000000,
                        },
                        [15] = 
                        {
                            [1] = 77584,
                            [2] = 30149,
                            [3] = 77591,
                            ["Pre"] = 842.7000000000,
                        },
                        [16] = 
                        {
                            [1] = 77584,
                            [2] = 30151,
                            [3] = 77591,
                            ["Pre"] = 854.4200000000,
                        },
                        [17] = 
                        {
                            [1] = 77584,
                            [2] = 30161,
                            [3] = 77591,
                            ["Pre"] = 894.8800000000,
                        },
                        [18] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 139020,
                            ["Pre"] = 900.3600000000,
                        },
                        [19] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 921.9100000000,
                        },
                        [20] = 
                        {
                            [1] = 30148,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 923.4400000000,
                        },
                        [21] = 
                        {
                            [1] = 30153,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 935.2000000000,
                        },
                        [22] = 
                        {
                            [1] = 30166,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 943.6900000000,
                        },
                        [23] = 
                        {
                            [1] = 30158,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 947.8000000000,
                        },
                        [24] = 
                        {
                            [1] = 30156,
                            [2] = 77590,
                            [3] = 139020,
                            ["Pre"] = 950.2300000000,
                        },
                        [25] = 
                        {
                            [1] = 77590,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1119,
                        },
                        [26] = 
                        {
                            [1] = 77584,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1144.4000000000,
                        },
                        [27] = 
                        {
                            [1] = 77590,
                            [2] = 77589,
                            [3] = 77591,
                            ["Pre"] = 1197.0800000000,
                        },
                        [28] = 
                        {
                            [1] = 77590,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1269.3600000000,
                        },
                        [29] = 
                        {
                            [1] = 77584,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1353.0700000000,
                        },
                        [30] = 
                        {
                            [1] = 30158,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1459.9000000000,
                        },
                        [31] = 
                        {
                            [1] = 77590,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1465.3100000000,
                        },
                        [32] = 
                        {
                            [1] = 77584,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 1695.5700000000,
                        },
                        [33] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 30164,
                            ["Pre"] = 2265.2500000000,
                        },
                        [34] = 
                        {
                            [1] = 77591,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 2319.9100000000,
                        },
                        [35] = 
                        {
                            [1] = 77584,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2777.3500000000,
                        },
                        [36] = 
                        {
                            [1] = 77590,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2889.5900000000,
                        },
                        [37] = 
                        {
                            [1] = 30148,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3673.0600000000,
                        },
                        [38] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3673.2800000000,
                        },
                        [39] = 
                        {
                            [1] = 30155,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3681.0200000000,
                        },
                        [40] = 
                        {
                            [1] = 30153,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3684.8200000000,
                        },
                        [41] = 
                        {
                            [1] = 30159,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3684.8600000000,
                        },
                        [42] = 
                        {
                            [1] = 30166,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3693.3100000000,
                        },
                        [43] = 
                        {
                            [1] = 30158,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3697.4200000000,
                        },
                        [44] = 
                        {
                            [1] = 30156,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3699.8500000000,
                        },
                        [45] = 
                        {
                            [1] = 77590,
                            [2] = 30160,
                            [3] = 150731,
                            ["Pre"] = 3930.1300000000,
                        },
                        [46] = 
                        {
                            [1] = 77584,
                            [2] = 150672,
                            [3] = 150731,
                            ["Pre"] = 3966.3000000000,
                        },
                        [47] = 
                        {
                            [1] = 77590,
                            [2] = 150672,
                            [3] = 150731,
                            ["Pre"] = 4006.2600000000,
                        },
                        [48] = 
                        {
                            [1] = 77590,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 4018.9800000000,
                        },
                        [49] = 
                        {
                            [1] = 30148,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4185.1600000000,
                        },
                        [50] = 
                        {
                            [1] = 30155,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4193.1200000000,
                        },
                        [51] = 
                        {
                            [1] = 30153,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4196.9200000000,
                        },
                        [52] = 
                        {
                            [1] = 30159,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4196.9600000000,
                        },
                        [53] = 
                        {
                            [1] = 30165,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4197.0400000000,
                        },
                        [54] = 
                        {
                            [1] = 30166,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4205.4100000000,
                        },
                        [55] = 
                        {
                            [1] = 30158,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4209.5200000000,
                        },
                        [56] = 
                        {
                            [1] = 30149,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4216.6600000000,
                        },
                        [57] = 
                        {
                            [1] = 30151,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4228.3800000000,
                        },
                        [58] = 
                        {
                            [1] = 30148,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4257.4400000000,
                        },
                        [59] = 
                        {
                            [1] = 30161,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4268.8400000000,
                        },
                        [60] = 
                        {
                            [1] = 30153,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4269.2000000000,
                        },
                        [61] = 
                        {
                            [1] = 30165,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4269.3200000000,
                        },
                        [62] = 
                        {
                            [1] = 30166,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4277.6900000000,
                        },
                        [63] = 
                        {
                            [1] = 30158,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4281.8000000000,
                        },
                        [64] = 
                        {
                            [1] = 30156,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4284.2300000000,
                        },
                        [65] = 
                        {
                            [1] = 30149,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4288.9400000000,
                        },
                        [66] = 
                        {
                            [1] = 30151,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4300.6600000000,
                        },
                        [67] = 
                        {
                            [1] = 30161,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4341.1200000000,
                        },
                        [68] = 
                        {
                            [1] = 150672,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4518.3600000000,
                        },
                        [69] = 
                        {
                            [1] = 150672,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4590.6400000000,
                        },
                        [70] = 
                        {
                            [1] = 150670,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4638.9500000000,
                        },
                        [71] = 
                        {
                            [1] = 77591,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 5069.5300000000,
                        },
                        [72] = 
                        {
                            [1] = 139020,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 5141.8100000000,
                        },
                        [73] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 150671,
                            ["Pre"] = 7597.8900000000,
                        },
                        [74] = 
                        {
                            [1] = 77584,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8109.9900000000,
                        },
                        [75] = 
                        {
                            [1] = 77584,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8182.2700000000,
                        },
                        [76] = 
                        {
                            [1] = 77590,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8222.2300000000,
                        },
                    },
                    [1646080] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 849.6300000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 851.1600000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 859.1200000000,
                        },
                        [4] = 
                        {
                            [1] = 30153,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 862.9200000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 862.9600000000,
                        },
                        [6] = 
                        {
                            [1] = 30166,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 871.4100000000,
                        },
                        [7] = 
                        {
                            [1] = 30158,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 875.5200000000,
                        },
                        [8] = 
                        {
                            [1] = 77584,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1192.7100000000,
                        },
                        [9] = 
                        {
                            [1] = 77590,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1393.0300000000,
                        },
                        [10] = 
                        {
                            [1] = 77590,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2817.3100000000,
                        },
                        [11] = 
                        {
                            [1] = 150670,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4566.6700000000,
                        },
                        [12] = 
                        {
                            [1] = 77590,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8149.9500000000,
                        },
                    },
                    [1638400] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 417.9600000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 419.4900000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 419.7100000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 427.4500000000,
                        },
                        [5] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 430.5600000000,
                        },
                        [6] = 
                        {
                            [1] = 30153,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 431.2500000000,
                        },
                        [7] = 
                        {
                            [1] = 30159,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 431.2900000000,
                        },
                        [8] = 
                        {
                            [1] = 30166,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 439.7400000000,
                        },
                        [9] = 
                        {
                            [1] = 77585,
                            [2] = 77590,
                            [3] = 77583,
                            ["Pre"] = 445.5600000000,
                        },
                        [10] = 
                        {
                            [1] = 30148,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 669.5400000000,
                        },
                        [11] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            [3] = 30160,
                            ["Pre"] = 676.5600000000,
                        },
                        [12] = 
                        {
                            [1] = 30155,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 677.5000000000,
                        },
                        [13] = 
                        {
                            [1] = 30166,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 689.7900000000,
                        },
                        [14] = 
                        {
                            [1] = 77585,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 695.6100000000,
                        },
                        [15] = 
                        {
                            [1] = 30162,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 748.4400000000,
                        },
                        [16] = 
                        {
                            [1] = 30148,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 749.9700000000,
                        },
                        [17] = 
                        {
                            [1] = 30154,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 750.1900000000,
                        },
                        [18] = 
                        {
                            [1] = 30155,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 757.9300000000,
                        },
                        [19] = 
                        {
                            [1] = 77584,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 761.0400000000,
                        },
                        [20] = 
                        {
                            [1] = 30153,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 761.7300000000,
                        },
                        [21] = 
                        {
                            [1] = 30159,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 761.7700000000,
                        },
                        [22] = 
                        {
                            [1] = 30166,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 770.2200000000,
                        },
                        [23] = 
                        {
                            [1] = 77590,
                            [2] = 30163,
                            [3] = 150670,
                            ["Pre"] = 865.1000000000,
                        },
                        [24] = 
                        {
                            [1] = 77585,
                            [2] = 77590,
                            [3] = 77591,
                            ["Pre"] = 877.2300000000,
                        },
                        [25] = 
                        {
                            [1] = 30162,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 930.0600000000,
                        },
                        [26] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            [3] = 150669,
                            ["Pre"] = 961.3600000000,
                        },
                        [27] = 
                        {
                            [1] = 30149,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 963.0900000000,
                        },
                        [28] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 1039.6900000000,
                        },
                        [29] = 
                        {
                            [1] = 30162,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1180.1100000000,
                        },
                        [30] = 
                        {
                            [1] = 30148,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1181.6400000000,
                        },
                        [31] = 
                        {
                            [1] = 30155,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1189.6000000000,
                        },
                        [32] = 
                        {
                            [1] = 30153,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1193.4000000000,
                        },
                        [33] = 
                        {
                            [1] = 30159,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1193.4400000000,
                        },
                        [34] = 
                        {
                            [1] = 30166,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1201.8900000000,
                        },
                        [35] = 
                        {
                            [1] = 77585,
                            [2] = 150670,
                            [3] = 77591,
                            ["Pre"] = 1207.7100000000,
                        },
                        [36] = 
                        {
                            [1] = 77590,
                            [2] = 77591,
                            [3] = 77581,
                            ["Pre"] = 1471.3600000000,
                        },
                        [37] = 
                        {
                            [1] = 77583,
                            [2] = 77591,
                            [3] = 77581,
                            ["Pre"] = 1551.7900000000,
                        },
                        [38] = 
                        {
                            [1] = 150670,
                            [2] = 77591,
                            [3] = 77581,
                            ["Pre"] = 1801.8400000000,
                        },
                        [39] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1950.1900000000,
                        },
                        [40] = 
                        {
                            [1] = 30148,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1951.7200000000,
                        },
                        [41] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1951.9400000000,
                        },
                        [42] = 
                        {
                            [1] = 30155,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1959.6800000000,
                        },
                        [43] = 
                        {
                            [1] = 77584,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1962.7900000000,
                        },
                        [44] = 
                        {
                            [1] = 30159,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1963.5200000000,
                        },
                        [45] = 
                        {
                            [1] = 30166,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1971.9700000000,
                        },
                        [46] = 
                        {
                            [1] = 30158,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1976.0800000000,
                        },
                        [47] = 
                        {
                            [1] = 77585,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1977.7900000000,
                        },
                        [48] = 
                        {
                            [1] = 30156,
                            [2] = 77590,
                            [3] = 139019,
                            ["Pre"] = 1978.5100000000,
                        },
                        [49] = 
                        {
                            [1] = 77590,
                            [2] = 30163,
                            [3] = 139019,
                            ["Pre"] = 2147.2800000000,
                        },
                        [50] = 
                        {
                            [1] = 77590,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2208.7900000000,
                        },
                        [51] = 
                        {
                            [1] = 30162,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2280.6700000000,
                        },
                        [52] = 
                        {
                            [1] = 30148,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2282.2000000000,
                        },
                        [53] = 
                        {
                            [1] = 30154,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2282.4200000000,
                        },
                        [54] = 
                        {
                            [1] = 77590,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2284.9200000000,
                        },
                        [55] = 
                        {
                            [1] = 30155,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2290.1600000000,
                        },
                        [56] = 
                        {
                            [1] = 30159,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2294,
                        },
                        [57] = 
                        {
                            [1] = 30166,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2302.4500000000,
                        },
                        [58] = 
                        {
                            [1] = 30156,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2308.9900000000,
                        },
                        [59] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2385.6400000000,
                        },
                        [60] = 
                        {
                            [1] = 30162,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2462.2900000000,
                        },
                        [61] = 
                        {
                            [1] = 30148,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2463.8200000000,
                        },
                        [62] = 
                        {
                            [1] = 30155,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2471.7800000000,
                        },
                        [63] = 
                        {
                            [1] = 30159,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2475.6200000000,
                        },
                        [64] = 
                        {
                            [1] = 30165,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2475.7000000000,
                        },
                        [65] = 
                        {
                            [1] = 30163,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2477.7600000000,
                        },
                        [66] = 
                        {
                            [1] = 30166,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2484.0700000000,
                        },
                        [67] = 
                        {
                            [1] = 30158,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2488.1800000000,
                        },
                        [68] = 
                        {
                            [1] = 77590,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2493.5900000000,
                        },
                        [69] = 
                        {
                            [1] = 30149,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2495.3200000000,
                        },
                        [70] = 
                        {
                            [1] = 30151,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2507.0400000000,
                        },
                        [71] = 
                        {
                            [1] = 30161,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2547.5000000000,
                        },
                        [72] = 
                        {
                            [1] = 77590,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2571.9200000000,
                        },
                        [73] = 
                        {
                            [1] = 150672,
                            [2] = 77591,
                            [3] = 139019,
                            ["Pre"] = 2797.0200000000,
                        },
                        [74] = 
                        {
                            [1] = 77591,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 3005.6900000000,
                        },
                        [75] = 
                        {
                            [1] = 77591,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 3084.0200000000,
                        },
                        [76] = 
                        {
                            [1] = 77591,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 3348.1900000000,
                        },
                        [77] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            [3] = 150731,
                            ["Pre"] = 3804.5200000000,
                        },
                        [78] = 
                        {
                            [1] = 77590,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3917.8700000000,
                        },
                        [79] = 
                        {
                            [1] = 77583,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4135,
                        },
                        [80] = 
                        {
                            [1] = 77591,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 4429.9700000000,
                        },
                        [81] = 
                        {
                            [1] = 77590,
                            [2] = 139019,
                            [3] = 150731,
                            ["Pre"] = 5336.7500000000,
                        },
                        [82] = 
                        {
                            [1] = 77590,
                            [2] = 77583,
                            [3] = 150671,
                            ["Pre"] = 7718.2800000000,
                        },
                    },
                    [1449728] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3715.3400000000,
                        },
                        [2] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3727.1000000000,
                        },
                        [3] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3727.2200000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7629.1000000000,
                        },
                        [5] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7640.1700000000,
                        },
                    },
                    [267802] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 676.2300000000,
                        },
                    },
                    [1449216] = 
                    {
                        [1] = 
                        {
                            [1] = 30153,
                            [2] = 77585,
                            [3] = 150789,
                            ["Pre"] = 368.1400000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 461.7700000000,
                        },
                        [3] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 473.5300000000,
                        },
                        [4] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 473.6500000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 1994,
                        },
                        [6] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 2005.8800000000,
                        },
                    },
                    [72448] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 77585,
                            ["Pre"] = 294.3900000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 30163,
                            ["Pre"] = 469.7000000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 30160,
                            ["Pre"] = 531.2100000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 77589,
                            ["Pre"] = 616.9500000000,
                        },
                        [5] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 77589,
                            ["Pre"] = 629.2400000000,
                        },
                        [6] = 
                        {
                            [1] = 77585,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 804.5500000000,
                        },
                        [7] = 
                        {
                            [1] = 77585,
                            [2] = 30160,
                            [3] = 77589,
                            ["Pre"] = 866.0600000000,
                        },
                        [8] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 30164,
                            ["Pre"] = 2240.2900000000,
                        },
                        [9] = 
                        {
                            [1] = 77585,
                            [2] = 77589,
                            [3] = 30164,
                            ["Pre"] = 2575.1400000000,
                        },
                        [10] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 150731,
                            ["Pre"] = 3648.1000000000,
                        },
                        [11] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 150731,
                            ["Pre"] = 3656.0600000000,
                        },
                        [12] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 150731,
                            ["Pre"] = 3668.3500000000,
                        },
                        [13] = 
                        {
                            [1] = 77585,
                            [2] = 30160,
                            [3] = 150731,
                            ["Pre"] = 3905.1700000000,
                        },
                    },
                    [72477] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 139019,
                            ["Pre"] = 1926.7600000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 139019,
                            ["Pre"] = 1934.7200000000,
                        },
                        [3] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 139019,
                            ["Pre"] = 1947.0100000000,
                        },
                        [4] = 
                        {
                            [1] = 77585,
                            [2] = 30163,
                            [3] = 139019,
                            ["Pre"] = 2122.3200000000,
                        },
                        [5] = 
                        {
                            [1] = 77585,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2183.8300000000,
                        },
                        [6] = 
                        {
                            [1] = 77585,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3892.9100000000,
                        },
                    },
                    [1442077] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 150789,
                            ["Pre"] = 356.3800000000,
                        },
                    },
                    [524288] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30158,
                            [3] = 77583,
                            ["Pre"] = 391.2900000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30158,
                            [3] = 77583,
                            ["Pre"] = 392.8200000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 77583,
                            ["Pre"] = 400.7800000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 77583,
                            ["Pre"] = 403.8900000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 30158,
                            [3] = 77583,
                            ["Pre"] = 404.6200000000,
                        },
                        [6] = 
                        {
                            [1] = 30165,
                            [2] = 30158,
                            [3] = 77583,
                            ["Pre"] = 404.7000000000,
                        },
                        [7] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 77583,
                            ["Pre"] = 409.7000000000,
                        },
                        [8] = 
                        {
                            [1] = 30158,
                            [2] = 30149,
                            [3] = 77583,
                            ["Pre"] = 424.3200000000,
                        },
                        [9] = 
                        {
                            [1] = 30158,
                            [2] = 30151,
                            [3] = 77583,
                            ["Pre"] = 436.0400000000,
                        },
                        [10] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            [3] = 77589,
                            ["Pre"] = 738.7400000000,
                        },
                        [11] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            [3] = 150669,
                            ["Pre"] = 934.6900000000,
                        },
                        [12] = 
                        {
                            [1] = 30148,
                            [2] = 30158,
                            [3] = 30152,
                            ["Pre"] = 1145.7300000000,
                        },
                        [13] = 
                        {
                            [1] = 30162,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1251.3000000000,
                        },
                        [14] = 
                        {
                            [1] = 30155,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1260.7900000000,
                        },
                        [15] = 
                        {
                            [1] = 77584,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1263.9000000000,
                        },
                        [16] = 
                        {
                            [1] = 30153,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1264.5900000000,
                        },
                        [17] = 
                        {
                            [1] = 30159,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1264.6300000000,
                        },
                        [18] = 
                        {
                            [1] = 30166,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1273.0800000000,
                        },
                        [19] = 
                        {
                            [1] = 77583,
                            [2] = 150672,
                            [3] = 30152,
                            ["Pre"] = 1586.0300000000,
                        },
                        [20] = 
                        {
                            [1] = 77583,
                            [2] = 30152,
                            [3] = 30164,
                            ["Pre"] = 3218.9800000000,
                        },
                        [21] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            [3] = 150731,
                            ["Pre"] = 3777.8500000000,
                        },
                        [22] = 
                        {
                            [1] = 77583,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4637.8600000000,
                        },
                        [23] = 
                        {
                            [1] = 77583,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 8551.6200000000,
                        },
                    },
                    [1250817] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 30164,
                            ["Pre"] = 2214.9100000000,
                        },
                    },
                    [393216] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 30155,
                            ["Pre"] = 247.9400000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 30153,
                            ["Pre"] = 259.4800000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 30165,
                            ["Pre"] = 259.6000000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 30156,
                            ["Pre"] = 266.5500000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 30156,
                            ["Pre"] = 266.7700000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 30149,
                            ["Pre"] = 271.2600000000,
                        },
                        [7] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 30149,
                            ["Pre"] = 271.4800000000,
                        },
                        [8] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 30158,
                            ["Pre"] = 272.0800000000,
                        },
                        [9] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 30149,
                            ["Pre"] = 276.4600000000,
                        },
                        [10] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 30149,
                            ["Pre"] = 276.6800000000,
                        },
                        [11] = 
                        {
                            [1] = 77587,
                            [2] = 77584,
                            [3] = 30156,
                            ["Pre"] = 277.6200000000,
                        },
                        [12] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 30156,
                            ["Pre"] = 278.3100000000,
                        },
                        [13] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 30156,
                            ["Pre"] = 278.3500000000,
                        },
                        [14] = 
                        {
                            [1] = 77587,
                            [2] = 77584,
                            [3] = 30149,
                            ["Pre"] = 282.3300000000,
                        },
                        [15] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 30149,
                            ["Pre"] = 283.0200000000,
                        },
                        [16] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 30149,
                            ["Pre"] = 283.0600000000,
                        },
                        [17] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 30156,
                            ["Pre"] = 286.8000000000,
                        },
                        [18] = 
                        {
                            [1] = 30155,
                            [2] = 30153,
                            [3] = 30149,
                            ["Pre"] = 288.2200000000,
                        },
                        [19] = 
                        {
                            [1] = 30155,
                            [2] = 30165,
                            [3] = 30149,
                            ["Pre"] = 288.3400000000,
                        },
                        [20] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 30156,
                            ["Pre"] = 290.9100000000,
                        },
                        [21] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 30149,
                            ["Pre"] = 291.5100000000,
                        },
                        [22] = 
                        {
                            [1] = 77587,
                            [2] = 77584,
                            [3] = 30151,
                            ["Pre"] = 294.0500000000,
                        },
                        [23] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 30151,
                            ["Pre"] = 294.7400000000,
                        },
                        [24] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 30151,
                            ["Pre"] = 294.7800000000,
                        },
                        [25] = 
                        {
                            [1] = 30148,
                            [2] = 30149,
                            [3] = 30156,
                            ["Pre"] = 295.2900000000,
                        },
                        [26] = 
                        {
                            [1] = 30154,
                            [2] = 30149,
                            [3] = 30156,
                            ["Pre"] = 295.5100000000,
                        },
                        [27] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 30149,
                            ["Pre"] = 295.6200000000,
                        },
                        [28] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 30149,
                            ["Pre"] = 296.7100000000,
                        },
                        [29] = 
                        {
                            [1] = 30155,
                            [2] = 30153,
                            [3] = 30151,
                            ["Pre"] = 299.9400000000,
                        },
                        [30] = 
                        {
                            [1] = 30155,
                            [2] = 30165,
                            [3] = 30151,
                            ["Pre"] = 300.0600000000,
                        },
                        [31] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 30149,
                            ["Pre"] = 300.8200000000,
                        },
                        [32] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 30149,
                            ["Pre"] = 302.5300000000,
                        },
                        [33] = 
                        {
                            [1] = 77584,
                            [2] = 30149,
                            [3] = 30156,
                            ["Pre"] = 306.3600000000,
                        },
                        [34] = 
                        {
                            [1] = 30153,
                            [2] = 30149,
                            [3] = 30156,
                            ["Pre"] = 307.0500000000,
                        },
                        [35] = 
                        {
                            [1] = 30159,
                            [2] = 30149,
                            [3] = 30156,
                            ["Pre"] = 307.0900000000,
                        },
                        [36] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 30151,
                            ["Pre"] = 307.3400000000,
                        },
                        [37] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 30151,
                            ["Pre"] = 312.5400000000,
                        },
                        [38] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 30151,
                            ["Pre"] = 314.2500000000,
                        },
                        [39] = 
                        {
                            [1] = 30166,
                            [2] = 30149,
                            [3] = 30156,
                            ["Pre"] = 315.5400000000,
                        },
                        [40] = 
                        {
                            [1] = 77584,
                            [2] = 30156,
                            [3] = 30151,
                            ["Pre"] = 318.0800000000,
                        },
                        [41] = 
                        {
                            [1] = 30153,
                            [2] = 30156,
                            [3] = 30151,
                            ["Pre"] = 318.7700000000,
                        },
                        [42] = 
                        {
                            [1] = 30159,
                            [2] = 30156,
                            [3] = 30151,
                            ["Pre"] = 318.8100000000,
                        },
                        [43] = 
                        {
                            [1] = 30158,
                            [2] = 30149,
                            [3] = 30156,
                            ["Pre"] = 319.6500000000,
                        },
                        [44] = 
                        {
                            [1] = 77585,
                            [2] = 30149,
                            [3] = 30156,
                            ["Pre"] = 321.3600000000,
                        },
                        [45] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 77590,
                            ["Pre"] = 327.4900000000,
                        },
                        [46] = 
                        {
                            [1] = 30158,
                            [2] = 30156,
                            [3] = 30151,
                            ["Pre"] = 331.3700000000,
                        },
                        [47] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 30161,
                            ["Pre"] = 331.4000000000,
                        },
                        [48] = 
                        {
                            [1] = 77585,
                            [2] = 30156,
                            [3] = 30151,
                            ["Pre"] = 333.0800000000,
                        },
                        [49] = 
                        {
                            [1] = 77585,
                            [2] = 30149,
                            [3] = 30151,
                            ["Pre"] = 337.7900000000,
                        },
                        [50] = 
                        {
                            [1] = 30155,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 339.2100000000,
                        },
                        [51] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 30161,
                            ["Pre"] = 350.2300000000,
                        },
                        [52] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 30161,
                            ["Pre"] = 360.1400000000,
                        },
                        [53] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 150789,
                            ["Pre"] = 369.7700000000,
                        },
                        [54] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 371.8600000000,
                        },
                        [55] = 
                        {
                            [1] = 30155,
                            [2] = 150789,
                            [3] = 30151,
                            ["Pre"] = 381.4900000000,
                        },
                        [56] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 150789,
                            ["Pre"] = 388.6000000000,
                        },
                        [57] = 
                        {
                            [1] = 30156,
                            [2] = 150789,
                            [3] = 30151,
                            ["Pre"] = 400.3200000000,
                        },
                        [58] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 77583,
                            ["Pre"] = 407.9200000000,
                        },
                        [59] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 77583,
                            ["Pre"] = 419.6400000000,
                        },
                        [60] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 77583,
                            ["Pre"] = 426.7500000000,
                        },
                        [61] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 30160,
                            ["Pre"] = 523.6200000000,
                        },
                        [62] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 30160,
                            ["Pre"] = 528.3300000000,
                        },
                        [63] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 30160,
                            ["Pre"] = 533.5300000000,
                        },
                        [64] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            [3] = 30160,
                            ["Pre"] = 540.0500000000,
                        },
                        [65] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 30160,
                            ["Pre"] = 545.2500000000,
                        },
                        [66] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 30160,
                            ["Pre"] = 552.3600000000,
                        },
                        [67] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 30160,
                            ["Pre"] = 564.0800000000,
                        },
                        [68] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 30160,
                            ["Pre"] = 568.7900000000,
                        },
                        [69] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 150672,
                            ["Pre"] = 609.6600000000,
                        },
                        [70] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 150672,
                            ["Pre"] = 621.3800000000,
                        },
                        [71] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 77589,
                            ["Pre"] = 622.3800000000,
                        },
                        [72] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 150672,
                            ["Pre"] = 628.4900000000,
                        },
                        [73] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 150670,
                            ["Pre"] = 629.2300000000,
                        },
                        [74] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 150672,
                            ["Pre"] = 640.2100000000,
                        },
                        [75] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 77589,
                            ["Pre"] = 641.2100000000,
                        },
                        [76] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 150672,
                            ["Pre"] = 644.9200000000,
                        },
                        [77] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 150670,
                            ["Pre"] = 648.0600000000,
                        },
                        [78] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 150670,
                            ["Pre"] = 657.9700000000,
                        },
                        [79] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 669.6900000000,
                        },
                        [80] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 77591,
                            ["Pre"] = 810.8500000000,
                        },
                        [81] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 77591,
                            ["Pre"] = 834.3900000000,
                        },
                        [82] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 77591,
                            ["Pre"] = 839.5900000000,
                        },
                        [83] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            [3] = 77591,
                            ["Pre"] = 846.1100000000,
                        },
                        [84] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 77591,
                            ["Pre"] = 851.3100000000,
                        },
                        [85] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 77591,
                            ["Pre"] = 858.4200000000,
                        },
                        [86] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 908.3800000000,
                        },
                        [87] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 139020,
                            ["Pre"] = 930.7000000000,
                        },
                        [88] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 139020,
                            ["Pre"] = 942.4200000000,
                        },
                        [89] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 30152,
                            ["Pre"] = 1132.0900000000,
                        },
                        [90] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 30152,
                            ["Pre"] = 1150.9200000000,
                        },
                        [91] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 30152,
                            ["Pre"] = 1160.8300000000,
                        },
                        [92] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 139019,
                            ["Pre"] = 1940.1500000000,
                        },
                        [93] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 1951.8700000000,
                        },
                        [94] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 139019,
                            ["Pre"] = 1958.9800000000,
                        },
                        [95] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 1970.7000000000,
                        },
                        [96] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 150671,
                            ["Pre"] = 7546.5100000000,
                        },
                        [97] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 150671,
                            ["Pre"] = 7570.0500000000,
                        },
                        [98] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 150671,
                            ["Pre"] = 7575.2500000000,
                        },
                        [99] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            [3] = 150671,
                            ["Pre"] = 7581.7700000000,
                        },
                        [100] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 150671,
                            ["Pre"] = 7586.9700000000,
                        },
                    },
                    [265217] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 30155,
                            ["Pre"] = 245.1800000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 30166,
                            ["Pre"] = 257.4700000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 77585,
                            ["Pre"] = 263.2900000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 30163,
                            ["Pre"] = 432.7800000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 150672,
                            ["Pre"] = 570.4200000000,
                        },
                    },
                    [9830400] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 30153,
                            ["Pre"] = 259.8300000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 30165,
                            ["Pre"] = 259.9500000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 30153,
                            ["Pre"] = 260.6400000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 30153,
                            ["Pre"] = 271.7100000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 150789,
                            ["Pre"] = 341.3800000000,
                        },
                        [6] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 150789,
                            ["Pre"] = 342.0700000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 150789,
                            ["Pre"] = 342.1900000000,
                        },
                        [8] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 150789,
                            ["Pre"] = 353.1400000000,
                        },
                        [9] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 150789,
                            ["Pre"] = 353.2600000000,
                        },
                        [10] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 150789,
                            ["Pre"] = 353.9500000000,
                        },
                    },
                    [1445632] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 30158,
                            ["Pre"] = 273.1200000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 30153,
                            ["Pre"] = 280.0800000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 30158,
                            ["Pre"] = 284.1900000000,
                        },
                        [4] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 150789,
                            ["Pre"] = 362.3200000000,
                        },
                        [5] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 150789,
                            ["Pre"] = 366.4300000000,
                        },
                        [6] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 150672,
                            ["Pre"] = 593.0300000000,
                        },
                        [7] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 150672,
                            ["Pre"] = 675.2700000000,
                        },
                    },
                    [268032] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30153,
                            [3] = 77589,
                            ["Pre"] = 594.9000000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30157,
                            [3] = 77589,
                            ["Pre"] = 599.8000000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 77589,
                            ["Pre"] = 600.0200000000,
                        },
                        [4] = 
                        {
                            [1] = 30153,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 637.9000000000,
                        },
                        [5] = 
                        {
                            [1] = 30153,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1136.5500000000,
                        },
                        [6] = 
                        {
                            [1] = 30153,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1479.0500000000,
                        },
                    },
                    [1447680] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30157,
                            [3] = 30153,
                            ["Pre"] = 265.6400000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 150789,
                            ["Pre"] = 358.9500000000,
                        },
                        [3] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 77589,
                            ["Pre"] = 606.5600000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 139019,
                            ["Pre"] = 1912.4500000000,
                        },
                        [5] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 139019,
                            ["Pre"] = 1924.3300000000,
                        },
                        [6] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 150671,
                            ["Pre"] = 7547.5500000000,
                        },
                    },
                    [1776029] = 
                    {
                        [1] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2058.2200000000,
                        },
                    },
                    [1574814] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1446.6100000000,
                        },
                    },
                    [1445888] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 77585,
                            ["Pre"] = 274.9500000000,
                        },
                    },
                    [1016064] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 150672,
                            ["Pre"] = 590.4500000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 150672,
                            ["Pre"] = 598.4100000000,
                        },
                        [3] = 
                        {
                            [1] = 30166,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 786.0100000000,
                        },
                        [4] = 
                        {
                            [1] = 30166,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 847.5200000000,
                        },
                        [5] = 
                        {
                            [1] = 30166,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2556.6000000000,
                        },
                    },
                    [1311744] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 30151,
                            ["Pre"] = 300.4700000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 30151,
                            ["Pre"] = 300.6900000000,
                        },
                        [3] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 646.3900000000,
                        },
                        [4] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 842.3400000000,
                        },
                        [5] = 
                        {
                            [1] = 30166,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1184.8400000000,
                        },
                    },
                    [983296] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 30153,
                            ["Pre"] = 276.9700000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 30158,
                            ["Pre"] = 281.6100000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 30158,
                            ["Pre"] = 289.5700000000,
                        },
                        [4] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 30163,
                            ["Pre"] = 464.5700000000,
                        },
                        [5] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 30163,
                            ["Pre"] = 477.1700000000,
                        },
                        [6] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 30160,
                            ["Pre"] = 526.0800000000,
                        },
                        [7] = 
                        {
                            [1] = 30155,
                            [2] = 30153,
                            [3] = 150672,
                            ["Pre"] = 589.9200000000,
                        },
                        [8] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 150672,
                            ["Pre"] = 590.6700000000,
                        },
                        [9] = 
                        {
                            [1] = 30148,
                            [2] = 30158,
                            [3] = 150672,
                            ["Pre"] = 594.5600000000,
                        },
                        [10] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 150672,
                            ["Pre"] = 601.5200000000,
                        },
                        [11] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 150672,
                            ["Pre"] = 602.5200000000,
                        },
                        [12] = 
                        {
                            [1] = 30166,
                            [2] = 30156,
                            [3] = 150672,
                            ["Pre"] = 617.2400000000,
                        },
                        [13] = 
                        {
                            [1] = 30166,
                            [2] = 150789,
                            [3] = 150672,
                            ["Pre"] = 683.7600000000,
                        },
                        [14] = 
                        {
                            [1] = 30166,
                            [2] = 77583,
                            [3] = 150672,
                            ["Pre"] = 721.9100000000,
                        },
                        [15] = 
                        {
                            [1] = 30153,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 777.5200000000,
                        },
                        [16] = 
                        {
                            [1] = 30158,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 790.1200000000,
                        },
                        [17] = 
                        {
                            [1] = 30153,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 839.0300000000,
                        },
                        [18] = 
                        {
                            [1] = 30166,
                            [2] = 77589,
                            [3] = 150672,
                            ["Pre"] = 936.3700000000,
                        },
                        [19] = 
                        {
                            [1] = 30166,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1153.5800000000,
                        },
                        [20] = 
                        {
                            [1] = 30166,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1210.6500000000,
                        },
                        [21] = 
                        {
                            [1] = 30166,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1225.8600000000,
                        },
                        [22] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 30164,
                            ["Pre"] = 2235.1600000000,
                        },
                        [23] = 
                        {
                            [1] = 30166,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2254.1400000000,
                        },
                        [24] = 
                        {
                            [1] = 30166,
                            [2] = 150672,
                            [3] = 150731,
                            ["Pre"] = 3975.4800000000,
                        },
                        [25] = 
                        {
                            [1] = 30166,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 7889.2400000000,
                        },
                    },
                    [1448704] = 
                    {
                        [1] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 77585,
                            ["Pre"] = 285.9000000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 150789,
                            ["Pre"] = 367.4500000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 77589,
                            ["Pre"] = 605.7500000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 77589,
                            ["Pre"] = 605.8700000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 139019,
                            ["Pre"] = 1911.7600000000,
                        },
                        [6] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 139019,
                            ["Pre"] = 1923.5200000000,
                        },
                        [7] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 139019,
                            ["Pre"] = 1923.6400000000,
                        },
                        [8] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 2005.0700000000,
                        },
                    },
                    [396801] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 30156,
                            ["Pre"] = 271.7500000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 30156,
                            ["Pre"] = 292,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 30156,
                            ["Pre"] = 297.8200000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 30160,
                            ["Pre"] = 528.8200000000,
                        },
                        [5] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 150672,
                            ["Pre"] = 604.9500000000,
                        },
                    },
                    [267776] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 30151,
                            ["Pre"] = 291.2900000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 30151,
                            ["Pre"] = 291.9800000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 30151,
                            ["Pre"] = 292.1000000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 30151,
                            ["Pre"] = 373.5300000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 77589,
                            ["Pre"] = 594.8000000000,
                        },
                        [6] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 30152,
                            ["Pre"] = 1132.4400000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 30152,
                            ["Pre"] = 1133.1300000000,
                        },
                        [8] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 30152,
                            ["Pre"] = 1133.2500000000,
                        },
                        [9] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 30152,
                            ["Pre"] = 1214.6800000000,
                        },
                    },
                    [1449472] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 77590,
                            ["Pre"] = 299.1000000000,
                        },
                        [2] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 77590,
                            ["Pre"] = 310.8600000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 77591,
                            ["Pre"] = 811.2000000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 77591,
                            ["Pre"] = 822.9600000000,
                        },
                        [5] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 77591,
                            ["Pre"] = 823.0800000000,
                        },
                        [6] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 139020,
                            ["Pre"] = 895.2400000000,
                        },
                    },
                    [950528] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 30163,
                            ["Pre"] = 440.5200000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 30163,
                            ["Pre"] = 460.7700000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 30163,
                            ["Pre"] = 466.5900000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 697.5900000000,
                        },
                        [5] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 773.7200000000,
                        },
                        [6] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2406.6700000000,
                        },
                    },
                    [262400] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 77589,
                            ["Pre"] = 590.8800000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 77589,
                            ["Pre"] = 603.1700000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 778.4800000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 150669,
                            ["Pre"] = 786.8300000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 150669,
                            ["Pre"] = 799.1200000000,
                        },
                        [6] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 150669,
                            ["Pre"] = 804.9400000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 77589,
                            [3] = 150672,
                            ["Pre"] = 916.1200000000,
                        },
                    },
                    [819456] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 30160,
                            ["Pre"] = 502.0300000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 30160,
                            ["Pre"] = 514.3200000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 30160,
                            ["Pre"] = 520.1400000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 689.6300000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 827.2700000000,
                        },
                        [6] = 
                        {
                            [1] = 30148,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2460.2200000000,
                        },
                    },
                    [393501] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 77585,
                            ["Pre"] = 273.7900000000,
                        },
                    },
                    [1442048] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 30153,
                            ["Pre"] = 256.7200000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 30166,
                            ["Pre"] = 268.3200000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 77585,
                            ["Pre"] = 274.8300000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 150789,
                            ["Pre"] = 338.2700000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 150789,
                            ["Pre"] = 350.5600000000,
                        },
                        [6] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 30163,
                            ["Pre"] = 443.6300000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 30163,
                            ["Pre"] = 444.3200000000,
                        },
                        [8] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 30163,
                            ["Pre"] = 525.8700000000,
                        },
                        [9] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 150672,
                            ["Pre"] = 581.2700000000,
                        },
                        [10] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 150672,
                            ["Pre"] = 663.5100000000,
                        },
                        [11] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 30164,
                            ["Pre"] = 2214.2200000000,
                        },
                        [12] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 30164,
                            ["Pre"] = 2296.4600000000,
                        },
                    },
                    [8454144] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 30166,
                            ["Pre"] = 265.2100000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 77585,
                            ["Pre"] = 271.0300000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 77585,
                            ["Pre"] = 283.3200000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 77585,
                            ["Pre"] = 291.2800000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 30163,
                            ["Pre"] = 452.8100000000,
                        },
                        [6] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 30163,
                            ["Pre"] = 458.6300000000,
                        },
                        [7] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 30163,
                            ["Pre"] = 478.8800000000,
                        },
                        [8] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 30160,
                            ["Pre"] = 522.2800000000,
                        },
                        [9] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 30160,
                            ["Pre"] = 528.1000000000,
                        },
                        [10] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 30160,
                            ["Pre"] = 540.3900000000,
                        },
                        [11] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 150672,
                            ["Pre"] = 578.1600000000,
                        },
                        [12] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 150672,
                            ["Pre"] = 596.2700000000,
                        },
                        [13] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 150672,
                            ["Pre"] = 604.2300000000,
                        },
                        [14] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 150672,
                            ["Pre"] = 616.5200000000,
                        },
                        [15] = 
                        {
                            [1] = 30166,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 709.8800000000,
                        },
                        [16] = 
                        {
                            [1] = 77585,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 715.7000000000,
                        },
                        [17] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 765.7600000000,
                        },
                        [18] = 
                        {
                            [1] = 77585,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 791.8300000000,
                        },
                        [19] = 
                        {
                            [1] = 30155,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 835.2300000000,
                        },
                        [20] = 
                        {
                            [1] = 77585,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 853.3400000000,
                        },
                        [21] = 
                        {
                            [1] = 30163,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 1022.8300000000,
                        },
                        [22] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 30164,
                            ["Pre"] = 2211.1100000000,
                        },
                        [23] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 30164,
                            ["Pre"] = 2223.4000000000,
                        },
                        [24] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 30164,
                            ["Pre"] = 2229.2200000000,
                        },
                        [25] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 30164,
                            ["Pre"] = 2231.3600000000,
                        },
                        [26] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 30164,
                            ["Pre"] = 2237.1800000000,
                        },
                        [27] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 30164,
                            ["Pre"] = 2249.4700000000,
                        },
                        [28] = 
                        {
                            [1] = 30148,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2536.3500000000,
                        },
                        [29] = 
                        {
                            [1] = 30155,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2544.3100000000,
                        },
                        [30] = 
                        {
                            [1] = 77585,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2562.4200000000,
                        },
                    },
                    [1245440] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 30164,
                            ["Pre"] = 2214.9500000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 30153,
                            [3] = 30164,
                            ["Pre"] = 2222.8700000000,
                        },
                        [3] = 
                        {
                            [1] = 30153,
                            [2] = 77585,
                            [3] = 30164,
                            ["Pre"] = 2240.9800000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 77585,
                            [3] = 30164,
                            ["Pre"] = 2241.0200000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2548.1500000000,
                        },
                    },
                    [1573120] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 30155,
                            ["Pre"] = 256.7600000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 30166,
                            ["Pre"] = 276.2800000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 77585,
                            ["Pre"] = 282.8300000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 30160,
                            ["Pre"] = 513.1000000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 30160,
                            ["Pre"] = 513.8300000000,
                        },
                        [6] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 150672,
                            ["Pre"] = 589.2300000000,
                        },
                        [7] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 150672,
                            ["Pre"] = 589.9600000000,
                        },
                        [8] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 139020,
                            ["Pre"] = 880.3700000000,
                        },
                        [9] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 139020,
                            ["Pre"] = 900.6200000000,
                        },
                        [10] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 139020,
                            ["Pre"] = 906.4400000000,
                        },
                        [11] = 
                        {
                            [1] = 30155,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1213.5700000000,
                        },
                        [12] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 30164,
                            ["Pre"] = 2222.1800000000,
                        },
                        [13] = 
                        {
                            [1] = 30155,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2846.5200000000,
                        },
                    },
                    [8650752] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 626.1400000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 626.3600000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 822.0900000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 30152,
                            ["Pre"] = 1121.5900000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1124.7900000000,
                        },
                        [6] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1164.5900000000,
                        },
                        [7] = 
                        {
                            [1] = 30151,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1168.0100000000,
                        },
                        [8] = 
                        {
                            [1] = 30148,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1467.2900000000,
                        },
                        [9] = 
                        {
                            [1] = 30154,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1467.5100000000,
                        },
                        [10] = 
                        {
                            [1] = 30148,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1663.2400000000,
                        },
                        [11] = 
                        {
                            [1] = 77589,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 2009.1600000000,
                        },
                    },
                    [786432] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30157,
                            [3] = 30160,
                            ["Pre"] = 510.9500000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30149,
                            [3] = 30160,
                            ["Pre"] = 525.5700000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            [3] = 30160,
                            ["Pre"] = 537.2900000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 77590,
                            [3] = 30160,
                            ["Pre"] = 545.1000000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 150670,
                            ["Pre"] = 618.7300000000,
                        },
                        [6] = 
                        {
                            [1] = 30154,
                            [2] = 77583,
                            [3] = 30160,
                            ["Pre"] = 625.7500000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 875.5800000000,
                        },
                        [8] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 150671,
                            ["Pre"] = 7536.0100000000,
                        },
                    },
                    [8653824] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 30151,
                            ["Pre"] = 280.4400000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 77589,
                            ["Pre"] = 583.1400000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 150669,
                            ["Pre"] = 779.0900000000,
                        },
                    },
                    [327680] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 30163,
                            ["Pre"] = 431.2500000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 30163,
                            ["Pre"] = 442.1000000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 30153,
                            [3] = 30163,
                            ["Pre"] = 442.7900000000,
                        },
                        [4] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 30163,
                            ["Pre"] = 442.9100000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 30157,
                            [3] = 30163,
                            ["Pre"] = 449.4400000000,
                        },
                        [6] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 30163,
                            ["Pre"] = 449.6600000000,
                        },
                        [7] = 
                        {
                            [1] = 30162,
                            [2] = 30158,
                            [3] = 30163,
                            ["Pre"] = 455.3900000000,
                        },
                        [8] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 30163,
                            ["Pre"] = 460.5100000000,
                        },
                        [9] = 
                        {
                            [1] = 30159,
                            [2] = 30157,
                            [3] = 30163,
                            ["Pre"] = 461.2400000000,
                        },
                        [10] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 30163,
                            ["Pre"] = 461.3200000000,
                        },
                        [11] = 
                        {
                            [1] = 30166,
                            [2] = 30157,
                            [3] = 30163,
                            ["Pre"] = 469.6900000000,
                        },
                        [12] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 30163,
                            ["Pre"] = 473.8000000000,
                        },
                        [13] = 
                        {
                            [1] = 30157,
                            [2] = 77585,
                            [3] = 30163,
                            ["Pre"] = 475.5100000000,
                        },
                        [14] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 30163,
                            ["Pre"] = 482.0600000000,
                        },
                        [15] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 30163,
                            ["Pre"] = 500.4700000000,
                        },
                        [16] = 
                        {
                            [1] = 30162,
                            [2] = 30161,
                            [3] = 30163,
                            ["Pre"] = 514.7100000000,
                        },
                        [17] = 
                        {
                            [1] = 30162,
                            [2] = 150789,
                            [3] = 30163,
                            ["Pre"] = 524.3400000000,
                        },
                        [18] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 30163,
                            ["Pre"] = 533.1200000000,
                        },
                        [19] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 30163,
                            ["Pre"] = 542.7500000000,
                        },
                        [20] = 
                        {
                            [1] = 30162,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 562.4900000000,
                        },
                        [21] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 706.5100000000,
                        },
                        [22] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 776.9500000000,
                        },
                        [23] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 782.6400000000,
                        },
                        [24] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 150669,
                            ["Pre"] = 788.4100000000,
                        },
                        [25] = 
                        {
                            [1] = 30162,
                            [2] = 30153,
                            [3] = 150669,
                            ["Pre"] = 789.1000000000,
                        },
                        [26] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 150669,
                            ["Pre"] = 789.2200000000,
                        },
                        [27] = 
                        {
                            [1] = 30162,
                            [2] = 30158,
                            [3] = 150669,
                            ["Pre"] = 801.7000000000,
                        },
                        [28] = 
                        {
                            [1] = 30162,
                            [2] = 77585,
                            [3] = 150669,
                            ["Pre"] = 803.4100000000,
                        },
                        [29] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 150669,
                            ["Pre"] = 806.8200000000,
                        },
                        [30] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            [3] = 150670,
                            ["Pre"] = 812.5400000000,
                        },
                        [31] = 
                        {
                            [1] = 30166,
                            [2] = 30157,
                            [3] = 150669,
                            ["Pre"] = 816,
                        },
                        [32] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 150669,
                            ["Pre"] = 820.1100000000,
                        },
                        [33] = 
                        {
                            [1] = 30157,
                            [2] = 77585,
                            [3] = 150669,
                            ["Pre"] = 821.8200000000,
                        },
                        [34] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 150669,
                            ["Pre"] = 828.3700000000,
                        },
                        [35] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            [3] = 150670,
                            ["Pre"] = 830.9500000000,
                        },
                        [36] = 
                        {
                            [1] = 30162,
                            [2] = 150789,
                            [3] = 150669,
                            ["Pre"] = 870.6500000000,
                        },
                        [37] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 150669,
                            ["Pre"] = 889.0600000000,
                        },
                        [38] = 
                        {
                            [1] = 30162,
                            [2] = 77583,
                            [3] = 150669,
                            ["Pre"] = 908.8000000000,
                        },
                        [39] = 
                        {
                            [1] = 30157,
                            [2] = 77583,
                            [3] = 150669,
                            ["Pre"] = 927.2100000000,
                        },
                        [40] = 
                        {
                            [1] = 77584,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 985.5000000000,
                        },
                        [41] = 
                        {
                            [1] = 30153,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 986.1900000000,
                        },
                        [42] = 
                        {
                            [1] = 30165,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 986.3100000000,
                        },
                        [43] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 994.1600000000,
                        },
                        [44] = 
                        {
                            [1] = 30158,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 998.7900000000,
                        },
                        [45] = 
                        {
                            [1] = 77590,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 1025.4600000000,
                        },
                        [46] = 
                        {
                            [1] = 30162,
                            [2] = 30160,
                            [3] = 150669,
                            ["Pre"] = 1034.4100000000,
                        },
                        [47] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1051.2300000000,
                        },
                        [48] = 
                        {
                            [1] = 30157,
                            [2] = 30160,
                            [3] = 150669,
                            ["Pre"] = 1052.8200000000,
                        },
                        [49] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1066.4400000000,
                        },
                        [50] = 
                        {
                            [1] = 150789,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 1067.7400000000,
                        },
                        [51] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1069.6400000000,
                        },
                        [52] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1084.8500000000,
                        },
                        [53] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            [3] = 30152,
                            ["Pre"] = 1315.4000000000,
                        },
                        [54] = 
                        {
                            [1] = 30157,
                            [2] = 30163,
                            [3] = 30152,
                            ["Pre"] = 1333.8100000000,
                        },
                        [55] = 
                        {
                            [1] = 30162,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1340.4700000000,
                        },
                        [56] = 
                        {
                            [1] = 30157,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1358.8800000000,
                        },
                        [57] = 
                        {
                            [1] = 30162,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1412.7500000000,
                        },
                        [58] = 
                        {
                            [1] = 30157,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1431.1600000000,
                        },
                        [59] = 
                        {
                            [1] = 30163,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1609.8400000000,
                        },
                        [60] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            [3] = 139019,
                            ["Pre"] = 2094.7200000000,
                        },
                        [61] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 30164,
                            ["Pre"] = 2201.8400000000,
                        },
                        [62] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 30164,
                            ["Pre"] = 2212.6900000000,
                        },
                        [63] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 30164,
                            ["Pre"] = 2213.5000000000,
                        },
                        [64] = 
                        {
                            [1] = 30148,
                            [2] = 30157,
                            [3] = 30164,
                            ["Pre"] = 2220.0300000000,
                        },
                        [65] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 30164,
                            ["Pre"] = 2220.2500000000,
                        },
                        [66] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 30164,
                            ["Pre"] = 2231.1000000000,
                        },
                        [67] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 30164,
                            ["Pre"] = 2231.9100000000,
                        },
                        [68] = 
                        {
                            [1] = 30166,
                            [2] = 30157,
                            [3] = 30164,
                            ["Pre"] = 2240.2800000000,
                        },
                        [69] = 
                        {
                            [1] = 30157,
                            [2] = 77585,
                            [3] = 30164,
                            ["Pre"] = 2246.1000000000,
                        },
                        [70] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 30164,
                            ["Pre"] = 2252.6500000000,
                        },
                        [71] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 30164,
                            ["Pre"] = 2271.0600000000,
                        },
                        [72] = 
                        {
                            [1] = 30162,
                            [2] = 150789,
                            [3] = 30164,
                            ["Pre"] = 2294.9300000000,
                        },
                        [73] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 30164,
                            ["Pre"] = 2313.3400000000,
                        },
                        [74] = 
                        {
                            [1] = 30162,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2333.0800000000,
                        },
                        [75] = 
                        {
                            [1] = 30157,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2351.4900000000,
                        },
                        [76] = 
                        {
                            [1] = 30165,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2410.5900000000,
                        },
                        [77] = 
                        {
                            [1] = 30162,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2441.0300000000,
                        },
                        [78] = 
                        {
                            [1] = 77590,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2449.7400000000,
                        },
                        [79] = 
                        {
                            [1] = 30162,
                            [2] = 77589,
                            [3] = 30164,
                            ["Pre"] = 2547.5400000000,
                        },
                        [80] = 
                        {
                            [1] = 30157,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2553.2300000000,
                        },
                        [81] = 
                        {
                            [1] = 30163,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2638.1200000000,
                        },
                        [82] = 
                        {
                            [1] = 77584,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2756.0900000000,
                        },
                        [83] = 
                        {
                            [1] = 30165,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2756.9000000000,
                        },
                        [84] = 
                        {
                            [1] = 30162,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2764.7500000000,
                        },
                        [85] = 
                        {
                            [1] = 30158,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2769.3800000000,
                        },
                        [86] = 
                        {
                            [1] = 30157,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2783.1600000000,
                        },
                        [87] = 
                        {
                            [1] = 77590,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2796.0500000000,
                        },
                        [88] = 
                        {
                            [1] = 30162,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2837.0300000000,
                        },
                        [89] = 
                        {
                            [1] = 150789,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2838.3300000000,
                        },
                        [90] = 
                        {
                            [1] = 30157,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2840.2300000000,
                        },
                        [91] = 
                        {
                            [1] = 30157,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2855.4400000000,
                        },
                        [92] = 
                        {
                            [1] = 77583,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2876.4800000000,
                        },
                        [93] = 
                        {
                            [1] = 30162,
                            [2] = 30152,
                            [3] = 30164,
                            ["Pre"] = 3085.9900000000,
                        },
                        [94] = 
                        {
                            [1] = 77589,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 3090.9400000000,
                        },
                        [95] = 
                        {
                            [1] = 30157,
                            [2] = 30152,
                            [3] = 30164,
                            ["Pre"] = 3104.4000000000,
                        },
                        [96] = 
                        {
                            [1] = 30163,
                            [2] = 30152,
                            [3] = 30164,
                            ["Pre"] = 3283.0800000000,
                        },
                        [97] = 
                        {
                            [1] = 77591,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 3308.1500000000,
                        },
                        [98] = 
                        {
                            [1] = 139020,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 3380.4300000000,
                        },
                        [99] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 150731,
                            ["Pre"] = 3620.5000000000,
                        },
                        [100] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 150731,
                            ["Pre"] = 3620.7200000000,
                        },
                        [101] = 
                        {
                            [1] = 150669,
                            [2] = 30152,
                            [3] = 30164,
                            ["Pre"] = 3629.3900000000,
                        },
                        [102] = 
                        {
                            [1] = 30162,
                            [2] = 30153,
                            [3] = 150731,
                            ["Pre"] = 3632.2600000000,
                        },
                        [103] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 150731,
                            ["Pre"] = 3632.3800000000,
                        },
                        [104] = 
                        {
                            [1] = 30148,
                            [2] = 30157,
                            [3] = 150731,
                            ["Pre"] = 3638.9100000000,
                        },
                        [105] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 150731,
                            ["Pre"] = 3639.1300000000,
                        },
                        [106] = 
                        {
                            [1] = 30162,
                            [2] = 30158,
                            [3] = 150731,
                            ["Pre"] = 3644.8600000000,
                        },
                        [107] = 
                        {
                            [1] = 30159,
                            [2] = 30157,
                            [3] = 150731,
                            ["Pre"] = 3650.7100000000,
                        },
                        [108] = 
                        {
                            [1] = 30166,
                            [2] = 30157,
                            [3] = 150731,
                            ["Pre"] = 3659.1600000000,
                        },
                        [109] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 150731,
                            ["Pre"] = 3663.2700000000,
                        },
                        [110] = 
                        {
                            [1] = 30162,
                            [2] = 30161,
                            [3] = 150731,
                            ["Pre"] = 3704.1800000000,
                        },
                        [111] = 
                        {
                            [1] = 30162,
                            [2] = 77583,
                            [3] = 150731,
                            ["Pre"] = 3751.9600000000,
                        },
                        [112] = 
                        {
                            [1] = 30157,
                            [2] = 77583,
                            [3] = 150731,
                            ["Pre"] = 3770.3700000000,
                        },
                        [113] = 
                        {
                            [1] = 30154,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3817.8100000000,
                        },
                        [114] = 
                        {
                            [1] = 30153,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3829.3500000000,
                        },
                        [115] = 
                        {
                            [1] = 30159,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3829.3900000000,
                        },
                        [116] = 
                        {
                            [1] = 30165,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3829.4700000000,
                        },
                        [117] = 
                        {
                            [1] = 30158,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3841.9500000000,
                        },
                        [118] = 
                        {
                            [1] = 30162,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3865.3100000000,
                        },
                        [119] = 
                        {
                            [1] = 30162,
                            [2] = 30160,
                            [3] = 150731,
                            ["Pre"] = 3877.5700000000,
                        },
                        [120] = 
                        {
                            [1] = 30157,
                            [2] = 30160,
                            [3] = 150731,
                            ["Pre"] = 3895.9800000000,
                        },
                        [121] = 
                        {
                            [1] = 30161,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3901.2700000000,
                        },
                        [122] = 
                        {
                            [1] = 30162,
                            [2] = 150672,
                            [3] = 150731,
                            ["Pre"] = 3953.7000000000,
                        },
                        [123] = 
                        {
                            [1] = 30157,
                            [2] = 150672,
                            [3] = 150731,
                            ["Pre"] = 3972.1100000000,
                        },
                        [124] = 
                        {
                            [1] = 30162,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4002.0100000000,
                        },
                        [125] = 
                        {
                            [1] = 30153,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4175.6600000000,
                        },
                        [126] = 
                        {
                            [1] = 30165,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4175.7800000000,
                        },
                        [127] = 
                        {
                            [1] = 30166,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4184.1500000000,
                        },
                        [128] = 
                        {
                            [1] = 30158,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4188.2600000000,
                        },
                        [129] = 
                        {
                            [1] = 30163,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4199.1000000000,
                        },
                        [130] = 
                        {
                            [1] = 150789,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4257.2100000000,
                        },
                        [131] = 
                        {
                            [1] = 30157,
                            [2] = 77581,
                            [3] = 150731,
                            ["Pre"] = 4259.1100000000,
                        },
                        [132] = 
                        {
                            [1] = 77583,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4295.3600000000,
                        },
                        [133] = 
                        {
                            [1] = 150669,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 4408.7100000000,
                        },
                        [134] = 
                        {
                            [1] = 30160,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4420.9700000000,
                        },
                        [135] = 
                        {
                            [1] = 30163,
                            [2] = 77581,
                            [3] = 150731,
                            ["Pre"] = 4437.7900000000,
                        },
                        [136] = 
                        {
                            [1] = 150672,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4497.1000000000,
                        },
                        [137] = 
                        {
                            [1] = 30162,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4504.8700000000,
                        },
                        [138] = 
                        {
                            [1] = 150670,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4545.4100000000,
                        },
                        [139] = 
                        {
                            [1] = 30163,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4701.9600000000,
                        },
                        [140] = 
                        {
                            [1] = 30154,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5588.4000000000,
                        },
                        [141] = 
                        {
                            [1] = 30165,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5600.0600000000,
                        },
                        [142] = 
                        {
                            [1] = 77583,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5719.6400000000,
                        },
                        [143] = 
                        {
                            [1] = 77581,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 6208.3800000000,
                        },
                        [144] = 
                        {
                            [1] = 30152,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 6472.5500000000,
                        },
                        [145] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            [3] = 150671,
                            ["Pre"] = 7729.8200000000,
                        },
                        [146] = 
                        {
                            [1] = 30162,
                            [2] = 150669,
                            [3] = 150671,
                            ["Pre"] = 8076.1300000000,
                        },
                        [147] = 
                        {
                            [1] = 30163,
                            [2] = 150669,
                            [3] = 150671,
                            ["Pre"] = 8273.2200000000,
                        },
                        [148] = 
                        {
                            [1] = 150669,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 10043.8100000000,
                        },
                        [149] = 
                        {
                            [1] = 150669,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 11462.6900000000,
                        },
                    },
                    [263424] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 150669,
                            ["Pre"] = 777.3400000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30157,
                            [3] = 150669,
                            ["Pre"] = 795.7500000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1123.2600000000,
                        },
                        [4] = 
                        {
                            [1] = 30163,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1320.3500000000,
                        },
                        [5] = 
                        {
                            [1] = 30162,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1661.7100000000,
                        },
                        [6] = 
                        {
                            [1] = 30163,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1858.8000000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4163.9000000000,
                        },
                        [8] = 
                        {
                            [1] = 150669,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 5048.2700000000,
                        },
                    },
                    [655360] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30155,
                            [3] = 30149,
                            ["Pre"] = 274.9300000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 77581,
                            ["Pre"] = 855.6700000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 30155,
                            [3] = 77581,
                            ["Pre"] = 863.6300000000,
                        },
                        [4] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 77581,
                            ["Pre"] = 866.7400000000,
                        },
                        [5] = 
                        {
                            [1] = 30162,
                            [2] = 30153,
                            [3] = 77581,
                            ["Pre"] = 867.4300000000,
                        },
                        [6] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 77581,
                            ["Pre"] = 867.5500000000,
                        },
                        [7] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 77581,
                            ["Pre"] = 875.9200000000,
                        },
                        [8] = 
                        {
                            [1] = 30162,
                            [2] = 30158,
                            [3] = 77581,
                            ["Pre"] = 880.0300000000,
                        },
                        [9] = 
                        {
                            [1] = 30148,
                            [2] = 30149,
                            [3] = 77581,
                            ["Pre"] = 888.7000000000,
                        },
                        [10] = 
                        {
                            [1] = 30162,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 898.8900000000,
                        },
                        [11] = 
                        {
                            [1] = 77584,
                            [2] = 30149,
                            [3] = 77581,
                            ["Pre"] = 899.7700000000,
                        },
                        [12] = 
                        {
                            [1] = 30153,
                            [2] = 30149,
                            [3] = 77581,
                            ["Pre"] = 900.4600000000,
                        },
                        [13] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 77581,
                            ["Pre"] = 906.7000000000,
                        },
                        [14] = 
                        {
                            [1] = 30166,
                            [2] = 30149,
                            [3] = 77581,
                            ["Pre"] = 908.9500000000,
                        },
                        [15] = 
                        {
                            [1] = 30158,
                            [2] = 30149,
                            [3] = 77581,
                            ["Pre"] = 913.0600000000,
                        },
                        [16] = 
                        {
                            [1] = 30162,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1112.7400000000,
                        },
                        [17] = 
                        {
                            [1] = 30149,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1145.7700000000,
                        },
                        [18] = 
                        {
                            [1] = 30162,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1188.8700000000,
                        },
                        [19] = 
                        {
                            [1] = 30162,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1201.5900000000,
                        },
                        [20] = 
                        {
                            [1] = 30149,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1221.9000000000,
                        },
                        [21] = 
                        {
                            [1] = 30149,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1234.6200000000,
                        },
                        [22] = 
                        {
                            [1] = 30162,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1237.1800000000,
                        },
                        [23] = 
                        {
                            [1] = 30162,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 1491.0800000000,
                        },
                        [24] = 
                        {
                            [1] = 30149,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 1524.1100000000,
                        },
                        [25] = 
                        {
                            [1] = 30162,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1740.0400000000,
                        },
                        [26] = 
                        {
                            [1] = 30149,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2854.8500000000,
                        },
                        [27] = 
                        {
                            [1] = 30149,
                            [2] = 77581,
                            [3] = 150731,
                            ["Pre"] = 4273.7300000000,
                        },
                        [28] = 
                        {
                            [1] = 30162,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8154.4600000000,
                        },
                    },
                    [66816] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 30163,
                            ["Pre"] = 431.0300000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 77585,
                            [3] = 30163,
                            ["Pre"] = 457.1000000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 688.1000000000,
                        },
                        [4] = 
                        {
                            [1] = 30162,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 764.2300000000,
                        },
                        [5] = 
                        {
                            [1] = 30166,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 994.6800000000,
                        },
                        [6] = 
                        {
                            [1] = 77585,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 1000.5000000000,
                        },
                        [7] = 
                        {
                            [1] = 30163,
                            [2] = 30160,
                            [3] = 150669,
                            ["Pre"] = 1231.5000000000,
                        },
                        [8] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 30164,
                            ["Pre"] = 2201.6200000000,
                        },
                        [9] = 
                        {
                            [1] = 30162,
                            [2] = 77585,
                            [3] = 30164,
                            ["Pre"] = 2227.6900000000,
                        },
                        [10] = 
                        {
                            [1] = 30154,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2398.9300000000,
                        },
                        [11] = 
                        {
                            [1] = 77584,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2409.7800000000,
                        },
                        [12] = 
                        {
                            [1] = 150789,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2492.0200000000,
                        },
                        [13] = 
                        {
                            [1] = 30162,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2534.8200000000,
                        },
                        [14] = 
                        {
                            [1] = 30163,
                            [2] = 77589,
                            [3] = 30164,
                            ["Pre"] = 2744.6300000000,
                        },
                        [15] = 
                        {
                            [1] = 30148,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2745.0200000000,
                        },
                        [16] = 
                        {
                            [1] = 30166,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2765.2700000000,
                        },
                        [17] = 
                        {
                            [1] = 77585,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2771.0900000000,
                        },
                        [18] = 
                        {
                            [1] = 30160,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 3002.0900000000,
                        },
                        [19] = 
                        {
                            [1] = 30163,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 3018.9100000000,
                        },
                        [20] = 
                        {
                            [1] = 30163,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 3034.1200000000,
                        },
                        [21] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3817.5900000000,
                        },
                        [22] = 
                        {
                            [1] = 30166,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3837.8400000000,
                        },
                        [23] = 
                        {
                            [1] = 30163,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 4062.4000000000,
                        },
                        [24] = 
                        {
                            [1] = 30163,
                            [2] = 30160,
                            [3] = 150731,
                            ["Pre"] = 4074.6600000000,
                        },
                        [25] = 
                        {
                            [1] = 30163,
                            [2] = 150672,
                            [3] = 150731,
                            ["Pre"] = 4150.7900000000,
                        },
                        [26] = 
                        {
                            [1] = 30148,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5588.1800000000,
                        },
                        [27] = 
                        {
                            [1] = 30166,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5608.4300000000,
                        },
                        [28] = 
                        {
                            [1] = 150672,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5921.3800000000,
                        },
                    },
                    [853248] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 30157,
                            ["Pre"] = 252.3500000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 30157,
                            ["Pre"] = 252.5700000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 30157,
                            ["Pre"] = 263.4200000000,
                        },
                        [4] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 30158,
                            ["Pre"] = 276.7100000000,
                        },
                        [5] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 77585,
                            ["Pre"] = 278.4200000000,
                        },
                        [6] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 150789,
                            ["Pre"] = 345.6600000000,
                        },
                        [7] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 77583,
                            ["Pre"] = 383.8100000000,
                        },
                        [8] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 30160,
                            ["Pre"] = 509.4200000000,
                        },
                        [9] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 150672,
                            ["Pre"] = 585.5500000000,
                        },
                        [10] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 77591,
                            ["Pre"] = 815.4800000000,
                        },
                        [11] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 139020,
                            ["Pre"] = 887.7600000000,
                        },
                    },
                    [1114368] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 30166,
                            ["Pre"] = 255.7200000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30155,
                            [3] = 30166,
                            ["Pre"] = 263.6800000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 30166,
                            ["Pre"] = 269.0500000000,
                        },
                        [4] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 77585,
                            ["Pre"] = 281.7900000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 77585,
                            ["Pre"] = 295.1200000000,
                        },
                        [6] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 30163,
                            ["Pre"] = 464.6100000000,
                        },
                        [7] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 30160,
                            ["Pre"] = 512.7900000000,
                        },
                        [8] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 30160,
                            ["Pre"] = 526.1200000000,
                        },
                        [9] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 30164,
                            ["Pre"] = 2235.2000000000,
                        },
                    },
                    [2031616] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3715.5600000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3723.3000000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3727.1400000000,
                        },
                        [4] = 
                        {
                            [1] = 30166,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3735.5900000000,
                        },
                        [5] = 
                        {
                            [1] = 30158,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3739.7000000000,
                        },
                        [6] = 
                        {
                            [1] = 30156,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3742.1300000000,
                        },
                        [7] = 
                        {
                            [1] = 30149,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3746.8400000000,
                        },
                        [8] = 
                        {
                            [1] = 150789,
                            [2] = 30151,
                            [3] = 150731,
                            ["Pre"] = 3758.5600000000,
                        },
                        [9] = 
                        {
                            [1] = 150789,
                            [2] = 77590,
                            [3] = 150731,
                            ["Pre"] = 3766.3700000000,
                        },
                        [10] = 
                        {
                            [1] = 150789,
                            [2] = 30161,
                            [3] = 150731,
                            ["Pre"] = 3799.0200000000,
                        },
                        [11] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            [3] = 150731,
                            ["Pre"] = 3846.8000000000,
                        },
                        [12] = 
                        {
                            [1] = 150789,
                            [2] = 30160,
                            [3] = 150731,
                            ["Pre"] = 3972.4100000000,
                        },
                        [13] = 
                        {
                            [1] = 150789,
                            [2] = 77591,
                            [3] = 150731,
                            ["Pre"] = 4278.4700000000,
                        },
                        [14] = 
                        {
                            [1] = 150789,
                            [2] = 77581,
                            [3] = 150731,
                            ["Pre"] = 4335.5400000000,
                        },
                        [15] = 
                        {
                            [1] = 150789,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4599.7100000000,
                        },
                        [16] = 
                        {
                            [1] = 30162,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7627.5700000000,
                        },
                        [17] = 
                        {
                            [1] = 30154,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7629.3200000000,
                        },
                        [18] = 
                        {
                            [1] = 30155,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7637.0600000000,
                        },
                        [19] = 
                        {
                            [1] = 30159,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7640.9000000000,
                        },
                        [20] = 
                        {
                            [1] = 30166,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7649.3500000000,
                        },
                        [21] = 
                        {
                            [1] = 30149,
                            [2] = 150789,
                            [3] = 150671,
                            ["Pre"] = 7660.6000000000,
                        },
                        [22] = 
                        {
                            [1] = 150789,
                            [2] = 30151,
                            [3] = 150671,
                            ["Pre"] = 7672.3200000000,
                        },
                        [23] = 
                        {
                            [1] = 150789,
                            [2] = 77590,
                            [3] = 150671,
                            ["Pre"] = 7680.1300000000,
                        },
                        [24] = 
                        {
                            [1] = 150789,
                            [2] = 30163,
                            [3] = 150671,
                            ["Pre"] = 7824.6600000000,
                        },
                        [25] = 
                        {
                            [1] = 150789,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8192.2300000000,
                        },
                        [26] = 
                        {
                            [1] = 150789,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 8513.4700000000,
                        },
                        [27] = 
                        {
                            [1] = 30148,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10920.8200000000,
                        },
                        [28] = 
                        {
                            [1] = 30154,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10921.0400000000,
                        },
                        [29] = 
                        {
                            [1] = 77587,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10923.5800000000,
                        },
                        [30] = 
                        {
                            [1] = 30155,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10928.7800000000,
                        },
                        [31] = 
                        {
                            [1] = 30159,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10932.6200000000,
                        },
                        [32] = 
                        {
                            [1] = 30166,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10941.0700000000,
                        },
                        [33] = 
                        {
                            [1] = 30149,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10952.3200000000,
                        },
                        [34] = 
                        {
                            [1] = 30151,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 10964.0400000000,
                        },
                        [35] = 
                        {
                            [1] = 77583,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 11052.2800000000,
                        },
                        [36] = 
                        {
                            [1] = 30152,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 11805.1900000000,
                        },
                    },
                    [2097152] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 950.1800000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 951.7100000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 951.9300000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 959.6700000000,
                        },
                        [5] = 
                        {
                            [1] = 77584,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 962.7800000000,
                        },
                        [6] = 
                        {
                            [1] = 30159,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 963.5100000000,
                        },
                        [7] = 
                        {
                            [1] = 30165,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 963.5900000000,
                        },
                        [8] = 
                        {
                            [1] = 30157,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 968.5900000000,
                        },
                        [9] = 
                        {
                            [1] = 77585,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 977.7800000000,
                        },
                        [10] = 
                        {
                            [1] = 30156,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 978.5000000000,
                        },
                        [11] = 
                        {
                            [1] = 30149,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 983.2100000000,
                        },
                        [12] = 
                        {
                            [1] = 30151,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 994.9300000000,
                        },
                        [13] = 
                        {
                            [1] = 77584,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1123.1400000000,
                        },
                        [14] = 
                        {
                            [1] = 30165,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1123.9500000000,
                        },
                        [15] = 
                        {
                            [1] = 30156,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1138.8600000000,
                        },
                        [16] = 
                        {
                            [1] = 30149,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1143.5700000000,
                        },
                        [17] = 
                        {
                            [1] = 30163,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 1147.2700000000,
                        },
                        [18] = 
                        {
                            [1] = 30148,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1160.3800000000,
                        },
                        [19] = 
                        {
                            [1] = 77587,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1163.1400000000,
                        },
                        [20] = 
                        {
                            [1] = 30155,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1168.3400000000,
                        },
                        [21] = 
                        {
                            [1] = 77584,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1171.4500000000,
                        },
                        [22] = 
                        {
                            [1] = 30153,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1172.1400000000,
                        },
                        [23] = 
                        {
                            [1] = 30166,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1180.6300000000,
                        },
                        [24] = 
                        {
                            [1] = 30158,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1184.7400000000,
                        },
                        [25] = 
                        {
                            [1] = 77585,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1186.4500000000,
                        },
                        [26] = 
                        {
                            [1] = 30156,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1187.1700000000,
                        },
                        [27] = 
                        {
                            [1] = 77583,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1243.5300000000,
                        },
                        [28] = 
                        {
                            [1] = 77589,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 1297.6300000000,
                        },
                        [29] = 
                        {
                            [1] = 30160,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1417.4500000000,
                        },
                        [30] = 
                        {
                            [1] = 77589,
                            [2] = 150670,
                            [3] = 150669,
                            ["Pre"] = 1506.3000000000,
                        },
                        [31] = 
                        {
                            [1] = 150672,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1571.9100000000,
                        },
                        [32] = 
                        {
                            [1] = 150672,
                            [2] = 150670,
                            [3] = 139020,
                            ["Pre"] = 1587.1200000000,
                        },
                        [33] = 
                        {
                            [1] = 150672,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1675.2000000000,
                        },
                        [34] = 
                        {
                            [1] = 150672,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1747.4800000000,
                        },
                        [35] = 
                        {
                            [1] = 150670,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1795.7900000000,
                        },
                        [36] = 
                        {
                            [1] = 150672,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1836.0800000000,
                        },
                        [37] = 
                        {
                            [1] = 150672,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2775.7600000000,
                        },
                    },
                    [1841664] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1208.3700000000,
                        },
                    },
                    [1843200] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 150672,
                            [3] = 150670,
                            ["Pre"] = 954.4700000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1114.8300000000,
                        },
                        [3] = 
                        {
                            [1] = 77590,
                            [2] = 150672,
                            [3] = 150669,
                            ["Pre"] = 1163.1000000000,
                        },
                    },
                    [66304] = 
                    {
                        [1] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 30160,
                            ["Pre"] = 526.3900000000,
                        },
                        [2] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 30160,
                            ["Pre"] = 544.5000000000,
                        },
                        [3] = 
                        {
                            [1] = 30158,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 713.9900000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 30164,
                            ["Pre"] = 2235.4700000000,
                        },
                        [5] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 30164,
                            ["Pre"] = 2253.5800000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2462.9800000000,
                        },
                        [7] = 
                        {
                            [1] = 77584,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2471.2900000000,
                        },
                        [8] = 
                        {
                            [1] = 30156,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2487.0100000000,
                        },
                        [9] = 
                        {
                            [1] = 150789,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2553.5300000000,
                        },
                        [10] = 
                        {
                            [1] = 77583,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2591.6800000000,
                        },
                        [11] = 
                        {
                            [1] = 30160,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 3080.4200000000,
                        },
                        [12] = 
                        {
                            [1] = 30160,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 4123.9100000000,
                        },
                        [13] = 
                        {
                            [1] = 30155,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7800.8200000000,
                        },
                        [14] = 
                        {
                            [1] = 30166,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7813.1100000000,
                        },
                        [15] = 
                        {
                            [1] = 77585,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7818.9300000000,
                        },
                        [16] = 
                        {
                            [1] = 30163,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7988.4200000000,
                        },
                        [17] = 
                        {
                            [1] = 30160,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 8126.0600000000,
                        },
                        [18] = 
                        {
                            [1] = 30155,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9509.9000000000,
                        },
                        [19] = 
                        {
                            [1] = 30166,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9522.1900000000,
                        },
                        [20] = 
                        {
                            [1] = 77585,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9528.0100000000,
                        },
                        [21] = 
                        {
                            [1] = 150672,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9835.1400000000,
                        },
                    },
                    [589824] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30156,
                            [3] = 77583,
                            ["Pre"] = 395.2500000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30156,
                            [3] = 77583,
                            ["Pre"] = 395.4700000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 30156,
                            [3] = 77583,
                            ["Pre"] = 406.3200000000,
                        },
                        [4] = 
                        {
                            [1] = 30153,
                            [2] = 30156,
                            [3] = 77583,
                            ["Pre"] = 407.0100000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 30156,
                            [3] = 77583,
                            ["Pre"] = 407.0500000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 30156,
                            [3] = 77583,
                            ["Pre"] = 412.1300000000,
                        },
                        [7] = 
                        {
                            [1] = 30166,
                            [2] = 30156,
                            [3] = 77583,
                            ["Pre"] = 415.5000000000,
                        },
                        [8] = 
                        {
                            [1] = 30157,
                            [2] = 30156,
                            [3] = 30163,
                            ["Pre"] = 476.2300000000,
                        },
                        [9] = 
                        {
                            [1] = 30156,
                            [2] = 30161,
                            [3] = 77583,
                            ["Pre"] = 478.9300000000,
                        },
                        [10] = 
                        {
                            [1] = 30154,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 564.2400000000,
                        },
                        [11] = 
                        {
                            [1] = 77584,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 575.0900000000,
                        },
                        [12] = 
                        {
                            [1] = 30153,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 575.7800000000,
                        },
                        [13] = 
                        {
                            [1] = 30159,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 575.8200000000,
                        },
                        [14] = 
                        {
                            [1] = 30165,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 575.9000000000,
                        },
                        [15] = 
                        {
                            [1] = 30151,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 607.2400000000,
                        },
                        [16] = 
                        {
                            [1] = 30161,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 647.7000000000,
                        },
                        [17] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 30160,
                            ["Pre"] = 652.3200000000,
                        },
                        [18] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 150672,
                            ["Pre"] = 728.4500000000,
                        },
                        [19] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 77589,
                            ["Pre"] = 741.1700000000,
                        },
                        [20] = 
                        {
                            [1] = 30148,
                            [2] = 30156,
                            [3] = 77591,
                            ["Pre"] = 826.9200000000,
                        },
                        [21] = 
                        {
                            [1] = 30153,
                            [2] = 30156,
                            [3] = 77591,
                            ["Pre"] = 838.6800000000,
                        },
                        [22] = 
                        {
                            [1] = 30159,
                            [2] = 30156,
                            [3] = 77591,
                            ["Pre"] = 838.7200000000,
                        },
                        [23] = 
                        {
                            [1] = 30157,
                            [2] = 30156,
                            [3] = 77591,
                            ["Pre"] = 843.8000000000,
                        },
                        [24] = 
                        {
                            [1] = 30166,
                            [2] = 30156,
                            [3] = 77591,
                            ["Pre"] = 847.1700000000,
                        },
                        [25] = 
                        {
                            [1] = 30158,
                            [2] = 30156,
                            [3] = 77591,
                            ["Pre"] = 851.2800000000,
                        },
                        [26] = 
                        {
                            [1] = 77585,
                            [2] = 30156,
                            [3] = 77591,
                            ["Pre"] = 852.9900000000,
                        },
                        [27] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 909.9400000000,
                        },
                        [28] = 
                        {
                            [1] = 30156,
                            [2] = 30161,
                            [3] = 77591,
                            ["Pre"] = 910.6000000000,
                        },
                        [29] = 
                        {
                            [1] = 30156,
                            [2] = 150789,
                            [3] = 77591,
                            ["Pre"] = 920.2300000000,
                        },
                        [30] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 934.3500000000,
                        },
                        [31] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 150669,
                            ["Pre"] = 937.1200000000,
                        },
                        [32] = 
                        {
                            [1] = 77587,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 998.4500000000,
                        },
                        [33] = 
                        {
                            [1] = 30153,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1007.4500000000,
                        },
                        [34] = 
                        {
                            [1] = 30159,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1007.4900000000,
                        },
                        [35] = 
                        {
                            [1] = 30165,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1007.5700000000,
                        },
                        [36] = 
                        {
                            [1] = 30158,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1020.0500000000,
                        },
                        [37] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            [3] = 77591,
                            ["Pre"] = 1024.9000000000,
                        },
                        [38] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 139020,
                            ["Pre"] = 1030.6600000000,
                        },
                        [39] = 
                        {
                            [1] = 30151,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1038.9100000000,
                        },
                        [40] = 
                        {
                            [1] = 30161,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1079.3700000000,
                        },
                        [41] = 
                        {
                            [1] = 150789,
                            [2] = 30163,
                            [3] = 77591,
                            ["Pre"] = 1089,
                        },
                        [42] = 
                        {
                            [1] = 30156,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1160.1200000000,
                        },
                        [43] = 
                        {
                            [1] = 30156,
                            [2] = 77589,
                            [3] = 77591,
                            ["Pre"] = 1172.8400000000,
                        },
                        [44] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1199.4300000000,
                        },
                        [45] = 
                        {
                            [1] = 77583,
                            [2] = 77589,
                            [3] = 77591,
                            ["Pre"] = 1277.5100000000,
                        },
                        [46] = 
                        {
                            [1] = 30163,
                            [2] = 77589,
                            [3] = 77591,
                            ["Pre"] = 1341.6100000000,
                        },
                        [47] = 
                        {
                            [1] = 30156,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1368.7900000000,
                        },
                        [48] = 
                        {
                            [1] = 77583,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1567,
                        },
                        [49] = 
                        {
                            [1] = 30156,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 1711.2900000000,
                        },
                        [50] = 
                        {
                            [1] = 30163,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 1880.0600000000,
                        },
                        [51] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2361.4000000000,
                        },
                        [52] = 
                        {
                            [1] = 30156,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2793.0700000000,
                        },
                        [53] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 150731,
                            ["Pre"] = 3780.2800000000,
                        },
                        [54] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            [3] = 150671,
                            ["Pre"] = 7862.8100000000,
                        },
                        [55] = 
                        {
                            [1] = 30163,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8294.4800000000,
                        },
                    },
                    [1842432] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            [3] = 150672,
                            ["Pre"] = 704.4200000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1193.1600000000,
                        },
                    },
                    [597248] = 
                    {
                        [1] = 
                        {
                            [1] = 77585,
                            [2] = 30156,
                            [3] = 77583,
                            ["Pre"] = 421.3200000000,
                        },
                        [2] = 
                        {
                            [1] = 30156,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 488.5600000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 566.7800000000,
                        },
                        [4] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            [3] = 30163,
                            ["Pre"] = 657.3300000000,
                        },
                    },
                    [133888] = 
                    {
                        [1] = 
                        {
                            [1] = 30158,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 388.2600000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1203.5200000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1207.8100000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1216.1200000000,
                        },
                        [5] = 
                        {
                            [1] = 30153,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1216.8100000000,
                        },
                        [6] = 
                        {
                            [1] = 30156,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1231.8400000000,
                        },
                        [7] = 
                        {
                            [1] = 150789,
                            [2] = 30161,
                            [3] = 30152,
                            ["Pre"] = 1298.3600000000,
                        },
                        [8] = 
                        {
                            [1] = 30161,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1550.9700000000,
                        },
                        [9] = 
                        {
                            [1] = 30161,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 1768.1800000000,
                        },
                        [10] = 
                        {
                            [1] = 30161,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1840.4600000000,
                        },
                        [11] = 
                        {
                            [1] = 30161,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2868.7400000000,
                        },
                        [12] = 
                        {
                            [1] = 30161,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4590.0800000000,
                        },
                        [13] = 
                        {
                            [1] = 30161,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 8503.8400000000,
                        },
                    },
                    [131840] = 
                    {
                        [1] = 
                        {
                            [1] = 30165,
                            [2] = 30158,
                            [3] = 150670,
                            ["Pre"] = 654.7500000000,
                        },
                        [2] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 150670,
                            ["Pre"] = 659.7500000000,
                        },
                        [3] = 
                        {
                            [1] = 30158,
                            [2] = 30149,
                            [3] = 150670,
                            ["Pre"] = 674.3700000000,
                        },
                        [4] = 
                        {
                            [1] = 30162,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 700.6600000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 704.9500000000,
                        },
                        [6] = 
                        {
                            [1] = 77584,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 713.2600000000,
                        },
                        [7] = 
                        {
                            [1] = 30153,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 713.9500000000,
                        },
                        [8] = 
                        {
                            [1] = 30156,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 728.9800000000,
                        },
                        [9] = 
                        {
                            [1] = 150789,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 795.5000000000,
                        },
                        [10] = 
                        {
                            [1] = 30161,
                            [2] = 150670,
                            [3] = 139020,
                            ["Pre"] = 1337.6000000000,
                        },
                        [11] = 
                        {
                            [1] = 30161,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4087.2200000000,
                        },
                        [12] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7650.9700000000,
                        },
                        [13] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7670.5000000000,
                        },
                        [14] = 
                        {
                            [1] = 30149,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7948.8000000000,
                        },
                    },
                    [10223616] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 623.9900000000,
                        },
                    },
                    [1711872] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 150731,
                            ["Pre"] = 3718.1000000000,
                        },
                        [2] = 
                        {
                            [1] = 150789,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4350.7500000000,
                        },
                        [3] = 
                        {
                            [1] = 150789,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8264.5100000000,
                        },
                    },
                    [10092544] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 968.4800000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1221.0900000000,
                        },
                        [3] = 
                        {
                            [1] = 150789,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1311.6400000000,
                        },
                    },
                    [1841693] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 150672,
                            ["Pre"] = 666.2700000000,
                        },
                    },
                    [10099968] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 678.9900000000,
                        },
                    },
                    [397853] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 77581,
                            ["Pre"] = 886.7500000000,
                        },
                    },
                    [395520] = 
                    {
                        [1] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 77583,
                            ["Pre"] = 438.4700000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 77591,
                            ["Pre"] = 829.6800000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 77591,
                            ["Pre"] = 870.1400000000,
                        },
                    },
                    [919808] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30156,
                            [3] = 30163,
                            ["Pre"] = 459.5700000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 30163,
                            ["Pre"] = 462.1100000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 30156,
                            [3] = 30163,
                            ["Pre"] = 470.4200000000,
                        },
                        [4] = 
                        {
                            [1] = 30153,
                            [2] = 30156,
                            [3] = 30163,
                            ["Pre"] = 471.1100000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 30156,
                            [3] = 30163,
                            ["Pre"] = 471.1500000000,
                        },
                        [6] = 
                        {
                            [1] = 30158,
                            [2] = 30156,
                            [3] = 30163,
                            ["Pre"] = 483.7100000000,
                        },
                        [7] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 30163,
                            ["Pre"] = 502.5700000000,
                        },
                        [8] = 
                        {
                            [1] = 30156,
                            [2] = 77590,
                            [3] = 30163,
                            ["Pre"] = 510.3800000000,
                        },
                        [9] = 
                        {
                            [1] = 30156,
                            [2] = 30161,
                            [3] = 30163,
                            ["Pre"] = 543.0300000000,
                        },
                        [10] = 
                        {
                            [1] = 30156,
                            [2] = 150789,
                            [3] = 30163,
                            ["Pre"] = 552.6600000000,
                        },
                        [11] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 805.2700000000,
                        },
                        [12] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            [3] = 150670,
                            ["Pre"] = 840.8600000000,
                        },
                        [13] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 1001.2200000000,
                        },
                        [14] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1094.7600000000,
                        },
                        [15] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            [3] = 30152,
                            ["Pre"] = 1343.7200000000,
                        },
                        [16] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            [3] = 139019,
                            ["Pre"] = 2123.0400000000,
                        },
                        [17] = 
                        {
                            [1] = 30156,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3844.3800000000,
                        },
                    },
                    [395805] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 77581,
                            ["Pre"] = 891.4600000000,
                        },
                    },
                    [72960] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 77585,
                            ["Pre"] = 265.8300000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 77585,
                            ["Pre"] = 286.0800000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 150789,
                            ["Pre"] = 364.3400000000,
                        },
                        [4] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 150789,
                            ["Pre"] = 376.6300000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 77583,
                            ["Pre"] = 394.5300000000,
                        },
                        [6] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 77583,
                            ["Pre"] = 402.4900000000,
                        },
                        [7] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 77583,
                            ["Pre"] = 414.7800000000,
                        },
                        [8] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 30163,
                            ["Pre"] = 461.3900000000,
                        },
                        [9] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 30160,
                            ["Pre"] = 522.9000000000,
                        },
                        [10] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 30163,
                            ["Pre"] = 551.9400000000,
                        },
                        [11] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 150672,
                            ["Pre"] = 599.0300000000,
                        },
                        [12] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 30160,
                            ["Pre"] = 613.4500000000,
                        },
                        [13] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            [3] = 30160,
                            ["Pre"] = 651.6000000000,
                        },
                        [14] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 150672,
                            ["Pre"] = 689.5800000000,
                        },
                        [15] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            [3] = 150672,
                            ["Pre"] = 727.7300000000,
                        },
                        [16] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 77581,
                            ["Pre"] = 883.2700000000,
                        },
                        [17] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 77581,
                            ["Pre"] = 891.2300000000,
                        },
                        [18] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 77581,
                            ["Pre"] = 903.5200000000,
                        },
                        [19] = 
                        {
                            [1] = 77585,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1078.8300000000,
                        },
                        [20] = 
                        {
                            [1] = 77585,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1140.3400000000,
                        },
                        [21] = 
                        {
                            [1] = 77585,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1216.4700000000,
                        },
                        [22] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 30164,
                            ["Pre"] = 2231.9800000000,
                        },
                        [23] = 
                        {
                            [1] = 77585,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2259.9600000000,
                        },
                        [24] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 30164,
                            ["Pre"] = 2322.5300000000,
                        },
                        [25] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2360.6800000000,
                        },
                        [26] = 
                        {
                            [1] = 77585,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2849.4200000000,
                        },
                    },
                    [165376] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 30151,
                            ["Pre"] = 314.4800000000,
                        },
                        [2] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 30151,
                            ["Pre"] = 338.5100000000,
                        },
                    },
                    [10289152] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 77583,
                            ["Pre"] = 397.2900000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 464.5300000000,
                        },
                        [3] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 487.8400000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 77581,
                            ["Pre"] = 886.0300000000,
                        },
                        [5] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 976.5800000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 991.4200000000,
                        },
                        [7] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 1014.7300000000,
                        },
                        [8] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 1081.9700000000,
                        },
                        [9] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 139019,
                            ["Pre"] = 1929.5200000000,
                        },
                        [10] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 1996.7600000000,
                        },
                        [11] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2034.9100000000,
                        },
                        [12] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            [3] = 139019,
                            ["Pre"] = 2125.4600000000,
                        },
                        [13] = 
                        {
                            [1] = 77587,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2523.6500000000,
                        },
                        [14] = 
                        {
                            [1] = 150789,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2614.2000000000,
                        },
                    },
                    [1744128] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 150789,
                            ["Pre"] = 359.1400000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 953.2700000000,
                        },
                    },
                    [722944] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30158,
                            [3] = 30152,
                            ["Pre"] = 1144.2000000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 30152,
                            ["Pre"] = 1148.4900000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 30152,
                            ["Pre"] = 1153.6900000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 30152,
                            ["Pre"] = 1156.8000000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 30158,
                            [3] = 30152,
                            ["Pre"] = 1157.5300000000,
                        },
                        [6] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 30152,
                            ["Pre"] = 1171.8000000000,
                        },
                        [7] = 
                        {
                            [1] = 30158,
                            [2] = 30156,
                            [3] = 30152,
                            ["Pre"] = 1172.5200000000,
                        },
                        [8] = 
                        {
                            [1] = 30158,
                            [2] = 150789,
                            [3] = 30152,
                            ["Pre"] = 1239.0400000000,
                        },
                        [9] = 
                        {
                            [1] = 30158,
                            [2] = 30163,
                            [3] = 30152,
                            ["Pre"] = 1341.2900000000,
                        },
                        [10] = 
                        {
                            [1] = 30158,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1491.6500000000,
                        },
                        [11] = 
                        {
                            [1] = 30158,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1687.6000000000,
                        },
                        [12] = 
                        {
                            [1] = 30158,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1765.9300000000,
                        },
                        [13] = 
                        {
                            [1] = 30158,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2809.4200000000,
                        },
                        [14] = 
                        {
                            [1] = 30158,
                            [2] = 30152,
                            [3] = 30164,
                            ["Pre"] = 3111.8800000000,
                        },
                        [15] = 
                        {
                            [1] = 30158,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4530.7600000000,
                        },
                        [16] = 
                        {
                            [1] = 30158,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 8444.5200000000,
                        },
                    },
                    [196608] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30158,
                            [3] = 30160,
                            ["Pre"] = 516.9000000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 30160,
                            ["Pre"] = 521.1900000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 30160,
                            ["Pre"] = 529.5000000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 30158,
                            [3] = 30160,
                            ["Pre"] = 530.2300000000,
                        },
                        [5] = 
                        {
                            [1] = 30165,
                            [2] = 30158,
                            [3] = 30160,
                            ["Pre"] = 530.3100000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 30160,
                            ["Pre"] = 535.3100000000,
                        },
                        [7] = 
                        {
                            [1] = 30158,
                            [2] = 30156,
                            [3] = 30160,
                            ["Pre"] = 545.2200000000,
                        },
                        [8] = 
                        {
                            [1] = 30158,
                            [2] = 30149,
                            [3] = 30160,
                            ["Pre"] = 549.9300000000,
                        },
                        [9] = 
                        {
                            [1] = 30158,
                            [2] = 77590,
                            [3] = 30160,
                            ["Pre"] = 569.4600000000,
                        },
                        [10] = 
                        {
                            [1] = 30162,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 576.2200000000,
                        },
                        [11] = 
                        {
                            [1] = 77587,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 580.5100000000,
                        },
                        [12] = 
                        {
                            [1] = 30155,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 585.7100000000,
                        },
                        [13] = 
                        {
                            [1] = 77584,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 588.8200000000,
                        },
                        [14] = 
                        {
                            [1] = 30153,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 589.5100000000,
                        },
                        [15] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 589.6300000000,
                        },
                        [16] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 594.6300000000,
                        },
                        [17] = 
                        {
                            [1] = 30166,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 598,
                        },
                        [18] = 
                        {
                            [1] = 77585,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 603.8200000000,
                        },
                        [19] = 
                        {
                            [1] = 30156,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 604.5400000000,
                        },
                        [20] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 609.2500000000,
                        },
                        [21] = 
                        {
                            [1] = 30158,
                            [2] = 150789,
                            [3] = 30160,
                            ["Pre"] = 611.7400000000,
                        },
                        [22] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 628.7800000000,
                        },
                        [23] = 
                        {
                            [1] = 30162,
                            [2] = 30158,
                            [3] = 150670,
                            ["Pre"] = 641.3400000000,
                        },
                        [24] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 150670,
                            ["Pre"] = 645.6300000000,
                        },
                        [25] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            [3] = 30160,
                            ["Pre"] = 649.8900000000,
                        },
                        [26] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 150670,
                            ["Pre"] = 650.8300000000,
                        },
                        [27] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 150670,
                            ["Pre"] = 653.9400000000,
                        },
                        [28] = 
                        {
                            [1] = 30159,
                            [2] = 30158,
                            [3] = 150670,
                            ["Pre"] = 654.6700000000,
                        },
                        [29] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 150670,
                            ["Pre"] = 668.9400000000,
                        },
                        [30] = 
                        {
                            [1] = 30158,
                            [2] = 30156,
                            [3] = 150670,
                            ["Pre"] = 669.6600000000,
                        },
                        [31] = 
                        {
                            [1] = 150789,
                            [2] = 30161,
                            [3] = 30160,
                            ["Pre"] = 671.0600000000,
                        },
                        [32] = 
                        {
                            [1] = 30161,
                            [2] = 77583,
                            [3] = 30160,
                            ["Pre"] = 709.2100000000,
                        },
                        [33] = 
                        {
                            [1] = 30155,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 710.1500000000,
                        },
                        [34] = 
                        {
                            [1] = 30166,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 722.4400000000,
                        },
                        [35] = 
                        {
                            [1] = 77585,
                            [2] = 30161,
                            [3] = 150670,
                            ["Pre"] = 728.2600000000,
                        },
                        [36] = 
                        {
                            [1] = 30158,
                            [2] = 150789,
                            [3] = 150670,
                            ["Pre"] = 736.1800000000,
                        },
                        [37] = 
                        {
                            [1] = 30161,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 773.3100000000,
                        },
                        [38] = 
                        {
                            [1] = 30158,
                            [2] = 30163,
                            [3] = 150670,
                            ["Pre"] = 838.4300000000,
                        },
                        [39] = 
                        {
                            [1] = 30162,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 874.0500000000,
                        },
                        [40] = 
                        {
                            [1] = 77587,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 878.3400000000,
                        },
                        [41] = 
                        {
                            [1] = 30155,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 883.5400000000,
                        },
                        [42] = 
                        {
                            [1] = 77584,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 886.6500000000,
                        },
                        [43] = 
                        {
                            [1] = 30153,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 887.3400000000,
                        },
                        [44] = 
                        {
                            [1] = 30159,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 887.3800000000,
                        },
                        [45] = 
                        {
                            [1] = 30165,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 887.4600000000,
                        },
                        [46] = 
                        {
                            [1] = 30157,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 892.4600000000,
                        },
                        [47] = 
                        {
                            [1] = 30166,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 895.8300000000,
                        },
                        [48] = 
                        {
                            [1] = 30161,
                            [2] = 30163,
                            [3] = 150670,
                            ["Pre"] = 897.7500000000,
                        },
                        [49] = 
                        {
                            [1] = 77585,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 901.6500000000,
                        },
                        [50] = 
                        {
                            [1] = 30156,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 902.3700000000,
                        },
                        [51] = 
                        {
                            [1] = 30149,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 907.0800000000,
                        },
                        [52] = 
                        {
                            [1] = 30161,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 910.9500000000,
                        },
                        [53] = 
                        {
                            [1] = 150789,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 968.8900000000,
                        },
                        [54] = 
                        {
                            [1] = 30163,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 1071.1400000000,
                        },
                        [55] = 
                        {
                            [1] = 30158,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1081.5600000000,
                        },
                        [56] = 
                        {
                            [1] = 30158,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1138.6300000000,
                        },
                        [57] = 
                        {
                            [1] = 30158,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1153.8400000000,
                        },
                        [58] = 
                        {
                            [1] = 30158,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1263.0700000000,
                        },
                        [59] = 
                        {
                            [1] = 30158,
                            [2] = 150670,
                            [3] = 139020,
                            ["Pre"] = 1278.2800000000,
                        },
                        [60] = 
                        {
                            [1] = 30160,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1495.7800000000,
                        },
                        [61] = 
                        {
                            [1] = 30158,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2182.1200000000,
                        },
                        [62] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 30164,
                            ["Pre"] = 2230.2700000000,
                        },
                        [63] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 30164,
                            ["Pre"] = 2238.5800000000,
                        },
                        [64] = 
                        {
                            [1] = 30165,
                            [2] = 30158,
                            [3] = 30164,
                            ["Pre"] = 2239.3900000000,
                        },
                        [65] = 
                        {
                            [1] = 30161,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2241.4400000000,
                        },
                        [66] = 
                        {
                            [1] = 30158,
                            [2] = 30156,
                            [3] = 30164,
                            ["Pre"] = 2254.3000000000,
                        },
                        [67] = 
                        {
                            [1] = 30158,
                            [2] = 30149,
                            [3] = 30164,
                            ["Pre"] = 2259.0100000000,
                        },
                        [68] = 
                        {
                            [1] = 30158,
                            [2] = 77590,
                            [3] = 30164,
                            ["Pre"] = 2278.5400000000,
                        },
                        [69] = 
                        {
                            [1] = 77587,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2289.5900000000,
                        },
                        [70] = 
                        {
                            [1] = 30155,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2294.7900000000,
                        },
                        [71] = 
                        {
                            [1] = 77584,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2297.9000000000,
                        },
                        [72] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2298.7100000000,
                        },
                        [73] = 
                        {
                            [1] = 30166,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2307.0800000000,
                        },
                        [74] = 
                        {
                            [1] = 77585,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2312.9000000000,
                        },
                        [75] = 
                        {
                            [1] = 30156,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2313.6200000000,
                        },
                        [76] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2318.3300000000,
                        },
                        [77] = 
                        {
                            [1] = 30158,
                            [2] = 150789,
                            [3] = 30164,
                            ["Pre"] = 2320.8200000000,
                        },
                        [78] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2337.8600000000,
                        },
                        [79] = 
                        {
                            [1] = 150789,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2380.1400000000,
                        },
                        [80] = 
                        {
                            [1] = 30161,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2418.2900000000,
                        },
                        [81] = 
                        {
                            [1] = 30165,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2472.1000000000,
                        },
                        [82] = 
                        {
                            [1] = 30149,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2491.7200000000,
                        },
                        [83] = 
                        {
                            [1] = 77590,
                            [2] = 30160,
                            [3] = 30164,
                            ["Pre"] = 2511.2500000000,
                        },
                        [84] = 
                        {
                            [1] = 77587,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2587.4200000000,
                        },
                        [85] = 
                        {
                            [1] = 30155,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2592.6200000000,
                        },
                        [86] = 
                        {
                            [1] = 77584,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2595.7300000000,
                        },
                        [87] = 
                        {
                            [1] = 30165,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2596.5400000000,
                        },
                        [88] = 
                        {
                            [1] = 30166,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2604.9100000000,
                        },
                        [89] = 
                        {
                            [1] = 77585,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2610.7300000000,
                        },
                        [90] = 
                        {
                            [1] = 30156,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2611.4500000000,
                        },
                        [91] = 
                        {
                            [1] = 30149,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2616.1600000000,
                        },
                        [92] = 
                        {
                            [1] = 30161,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2620.0300000000,
                        },
                        [93] = 
                        {
                            [1] = 150789,
                            [2] = 150670,
                            [3] = 30164,
                            ["Pre"] = 2677.9700000000,
                        },
                        [94] = 
                        {
                            [1] = 30158,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2790.6400000000,
                        },
                        [95] = 
                        {
                            [1] = 30158,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2847.7100000000,
                        },
                        [96] = 
                        {
                            [1] = 30161,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2849.9600000000,
                        },
                        [97] = 
                        {
                            [1] = 30158,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2862.9200000000,
                        },
                        [98] = 
                        {
                            [1] = 30161,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2922.2400000000,
                        },
                        [99] = 
                        {
                            [1] = 150670,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 3204.8600000000,
                        },
                        [100] = 
                        {
                            [1] = 150670,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 3220.0700000000,
                        },
                        [101] = 
                        {
                            [1] = 30158,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3891.2000000000,
                        },
                        [102] = 
                        {
                            [1] = 30158,
                            [2] = 30160,
                            [3] = 150731,
                            ["Pre"] = 3903.4600000000,
                        },
                        [103] = 
                        {
                            [1] = 30161,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3950.5200000000,
                        },
                        [104] = 
                        {
                            [1] = 30161,
                            [2] = 30160,
                            [3] = 150731,
                            ["Pre"] = 3962.7800000000,
                        },
                        [105] = 
                        {
                            [1] = 30158,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4027.9000000000,
                        },
                        [106] = 
                        {
                            [1] = 30160,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4260.6100000000,
                        },
                        [107] = 
                        {
                            [1] = 30162,
                            [2] = 30158,
                            [3] = 150671,
                            ["Pre"] = 7558.6200000000,
                        },
                        [108] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 150671,
                            ["Pre"] = 7562.9100000000,
                        },
                        [109] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 150671,
                            ["Pre"] = 7568.1100000000,
                        },
                        [110] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 150671,
                            ["Pre"] = 7571.2200000000,
                        },
                        [111] = 
                        {
                            [1] = 30159,
                            [2] = 30158,
                            [3] = 150671,
                            ["Pre"] = 7571.9500000000,
                        },
                        [112] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 150671,
                            ["Pre"] = 7586.2200000000,
                        },
                        [113] = 
                        {
                            [1] = 30158,
                            [2] = 30149,
                            [3] = 150671,
                            ["Pre"] = 7591.6500000000,
                        },
                        [114] = 
                        {
                            [1] = 30158,
                            [2] = 77590,
                            [3] = 150671,
                            ["Pre"] = 7611.1800000000,
                        },
                        [115] = 
                        {
                            [1] = 30162,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7617.9400000000,
                        },
                        [116] = 
                        {
                            [1] = 77587,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7622.2300000000,
                        },
                        [117] = 
                        {
                            [1] = 30155,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7627.4300000000,
                        },
                        [118] = 
                        {
                            [1] = 77584,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7630.5400000000,
                        },
                        [119] = 
                        {
                            [1] = 30166,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7639.7200000000,
                        },
                        [120] = 
                        {
                            [1] = 77585,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7645.5400000000,
                        },
                        [121] = 
                        {
                            [1] = 30161,
                            [2] = 77583,
                            [3] = 150671,
                            ["Pre"] = 7750.9300000000,
                        },
                        [122] = 
                        {
                            [1] = 30158,
                            [2] = 30163,
                            [3] = 150671,
                            ["Pre"] = 7755.7100000000,
                        },
                        [123] = 
                        {
                            [1] = 30162,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7791.3300000000,
                        },
                        [124] = 
                        {
                            [1] = 77587,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7795.6200000000,
                        },
                        [125] = 
                        {
                            [1] = 77584,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7803.9300000000,
                        },
                        [126] = 
                        {
                            [1] = 30159,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7804.6600000000,
                        },
                        [127] = 
                        {
                            [1] = 30161,
                            [2] = 30163,
                            [3] = 150671,
                            ["Pre"] = 7815.0300000000,
                        },
                        [128] = 
                        {
                            [1] = 30149,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7824.3600000000,
                        },
                        [129] = 
                        {
                            [1] = 77590,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7843.8900000000,
                        },
                        [130] = 
                        {
                            [1] = 30162,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7915.7700000000,
                        },
                        [131] = 
                        {
                            [1] = 77587,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7920.0600000000,
                        },
                        [132] = 
                        {
                            [1] = 77583,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7924.3200000000,
                        },
                        [133] = 
                        {
                            [1] = 30155,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7925.2600000000,
                        },
                        [134] = 
                        {
                            [1] = 77584,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7928.3700000000,
                        },
                        [135] = 
                        {
                            [1] = 30159,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7929.1000000000,
                        },
                        [136] = 
                        {
                            [1] = 30166,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7937.5500000000,
                        },
                        [137] = 
                        {
                            [1] = 77585,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7943.3700000000,
                        },
                        [138] = 
                        {
                            [1] = 30161,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 7952.6700000000,
                        },
                        [139] = 
                        {
                            [1] = 150789,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 8010.6100000000,
                        },
                        [140] = 
                        {
                            [1] = 30163,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 8112.8600000000,
                        },
                        [141] = 
                        {
                            [1] = 30158,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8123.2800000000,
                        },
                        [142] = 
                        {
                            [1] = 30161,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8182.6000000000,
                        },
                        [143] = 
                        {
                            [1] = 30158,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8195.5600000000,
                        },
                        [144] = 
                        {
                            [1] = 150672,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 8250.5000000000,
                        },
                        [145] = 
                        {
                            [1] = 30161,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8254.8800000000,
                        },
                        [146] = 
                        {
                            [1] = 150670,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8552.7100000000,
                        },
                        [147] = 
                        {
                            [1] = 77587,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9504.7000000000,
                        },
                        [148] = 
                        {
                            [1] = 77584,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9513.0100000000,
                        },
                        [149] = 
                        {
                            [1] = 30149,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9533.4400000000,
                        },
                        [150] = 
                        {
                            [1] = 77590,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9552.9700000000,
                        },
                        [151] = 
                        {
                            [1] = 77583,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9633.4000000000,
                        },
                        [152] = 
                        {
                            [1] = 77591,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 10065.0700000000,
                        },
                        [153] = 
                        {
                            [1] = 139020,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 10137.3500000000,
                        },
                        [154] = 
                        {
                            [1] = 150670,
                            [2] = 150731,
                            [3] = 150671,
                            ["Pre"] = 11302.3300000000,
                        },
                    },
                    [531712] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 77583,
                            ["Pre"] = 395.5800000000,
                        },
                        [2] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 77583,
                            ["Pre"] = 418.8900000000,
                        },
                        [3] = 
                        {
                            [1] = 30158,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 486.1300000000,
                        },
                        [4] = 
                        {
                            [1] = 30158,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 1013.0200000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1255.5900000000,
                        },
                        [6] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1278.9000000000,
                        },
                        [7] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1346.1400000000,
                        },
                        [8] = 
                        {
                            [1] = 77583,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1873.0300000000,
                        },
                    },
                    [721664] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30158,
                            [3] = 30161,
                            ["Pre"] = 343.5100000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 30161,
                            ["Pre"] = 347.8000000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 30161,
                            ["Pre"] = 353,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 30161,
                            ["Pre"] = 356.1100000000,
                        },
                        [5] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 30161,
                            ["Pre"] = 371.1100000000,
                        },
                        [6] = 
                        {
                            [1] = 30158,
                            [2] = 30156,
                            [3] = 30161,
                            ["Pre"] = 371.8300000000,
                        },
                        [7] = 
                        {
                            [1] = 30158,
                            [2] = 150789,
                            [3] = 30161,
                            ["Pre"] = 438.3500000000,
                        },
                        [8] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 30163,
                            ["Pre"] = 540.6000000000,
                        },
                        [9] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 77591,
                            ["Pre"] = 908.1700000000,
                        },
                        [10] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 139020,
                            ["Pre"] = 980.4500000000,
                        },
                        [11] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 139019,
                            ["Pre"] = 2008.7300000000,
                        },
                        [12] = 
                        {
                            [1] = 30158,
                            [2] = 30161,
                            [3] = 150731,
                            ["Pre"] = 3730.0700000000,
                        },
                    },
                    [990208] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 150672,
                            ["Pre"] = 584.7200000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 150672,
                            ["Pre"] = 597.3200000000,
                        },
                        [3] = 
                        {
                            [1] = 30153,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 632.9900000000,
                        },
                        [4] = 
                        {
                            [1] = 30166,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 641.4800000000,
                        },
                        [5] = 
                        {
                            [1] = 30158,
                            [2] = 77590,
                            [3] = 150672,
                            ["Pre"] = 645.5900000000,
                        },
                    },
                    [1514752] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 139019,
                            ["Pre"] = 1915.2100000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 139019,
                            ["Pre"] = 1920.3300000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 2010.8800000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2249.3700000000,
                        },
                        [5] = 
                        {
                            [1] = 30153,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2532.6500000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2537.7700000000,
                        },
                        [7] = 
                        {
                            [1] = 77587,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9202.2400000000,
                        },
                    },
                    [1513984] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 77589,
                            ["Pre"] = 597.4400000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 77589,
                            ["Pre"] = 602.5600000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 693.1100000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7884.4700000000,
                        },
                    },
                    [134400] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 30149,
                            ["Pre"] = 285.6000000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 30149,
                            ["Pre"] = 288.1400000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 30157,
                            [3] = 30151,
                            ["Pre"] = 295.5700000000,
                        },
                        [4] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 30149,
                            ["Pre"] = 296.4500000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 30157,
                            [3] = 30149,
                            ["Pre"] = 297.1800000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 30149,
                            ["Pre"] = 309.7400000000,
                        },
                        [7] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 150789,
                            ["Pre"] = 378.6900000000,
                        },
                        [8] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 77583,
                            ["Pre"] = 416.8400000000,
                        },
                        [9] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 150669,
                            ["Pre"] = 827.2500000000,
                        },
                        [10] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 77591,
                            ["Pre"] = 848.5100000000,
                        },
                        [11] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 139020,
                            ["Pre"] = 920.7900000000,
                        },
                        [12] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 150731,
                            ["Pre"] = 3670.4100000000,
                        },
                    },
                    [1507328] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 30153,
                            ["Pre"] = 265.8600000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 30153,
                            ["Pre"] = 268.4000000000,
                        },
                        [3] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 77585,
                            ["Pre"] = 291.7100000000,
                        },
                        [4] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 30156,
                            ["Pre"] = 292.4300000000,
                        },
                        [5] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 77583,
                            ["Pre"] = 397.1000000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 30160,
                            ["Pre"] = 522.7100000000,
                        },
                        [7] = 
                        {
                            [1] = 30162,
                            [2] = 30153,
                            [3] = 77589,
                            ["Pre"] = 593.1500000000,
                        },
                        [8] = 
                        {
                            [1] = 30166,
                            [2] = 30157,
                            [3] = 77589,
                            ["Pre"] = 620.0500000000,
                        },
                        [9] = 
                        {
                            [1] = 30153,
                            [2] = 30156,
                            [3] = 77589,
                            ["Pre"] = 621.4700000000,
                        },
                        [10] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 77589,
                            ["Pre"] = 624.1600000000,
                        },
                        [11] = 
                        {
                            [1] = 30153,
                            [2] = 30149,
                            [3] = 77589,
                            ["Pre"] = 626.1800000000,
                        },
                        [12] = 
                        {
                            [1] = 30157,
                            [2] = 30156,
                            [3] = 77589,
                            ["Pre"] = 626.5900000000,
                        },
                        [13] = 
                        {
                            [1] = 30153,
                            [2] = 77590,
                            [3] = 77589,
                            ["Pre"] = 645.7100000000,
                        },
                        [14] = 
                        {
                            [1] = 30153,
                            [2] = 30161,
                            [3] = 77589,
                            ["Pre"] = 678.3600000000,
                        },
                        [15] = 
                        {
                            [1] = 30153,
                            [2] = 77583,
                            [3] = 77589,
                            ["Pre"] = 726.1400000000,
                        },
                        [16] = 
                        {
                            [1] = 30157,
                            [2] = 77583,
                            [3] = 77589,
                            ["Pre"] = 731.2600000000,
                        },
                        [17] = 
                        {
                            [1] = 30153,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 790.2400000000,
                        },
                        [18] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 77591,
                            ["Pre"] = 828.7700000000,
                        },
                        [19] = 
                        {
                            [1] = 30153,
                            [2] = 30160,
                            [3] = 77589,
                            ["Pre"] = 851.7500000000,
                        },
                        [20] = 
                        {
                            [1] = 30157,
                            [2] = 30160,
                            [3] = 77589,
                            ["Pre"] = 856.8700000000,
                        },
                        [21] = 
                        {
                            [1] = 30157,
                            [2] = 30153,
                            [3] = 77581,
                            ["Pre"] = 885.8400000000,
                        },
                        [22] = 
                        {
                            [1] = 30157,
                            [2] = 77589,
                            [3] = 150672,
                            ["Pre"] = 933,
                        },
                        [23] = 
                        {
                            [1] = 30153,
                            [2] = 77589,
                            [3] = 150670,
                            ["Pre"] = 976.1900000000,
                        },
                        [24] = 
                        {
                            [1] = 30153,
                            [2] = 77589,
                            [3] = 77591,
                            ["Pre"] = 1157.8100000000,
                        },
                        [25] = 
                        {
                            [1] = 30157,
                            [2] = 77589,
                            [3] = 77591,
                            ["Pre"] = 1162.9300000000,
                        },
                        [26] = 
                        {
                            [1] = 30153,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1214.8800000000,
                        },
                        [27] = 
                        {
                            [1] = 30157,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1220,
                        },
                        [28] = 
                        {
                            [1] = 30162,
                            [2] = 30153,
                            [3] = 139019,
                            ["Pre"] = 1910.9200000000,
                        },
                        [29] = 
                        {
                            [1] = 30154,
                            [2] = 30153,
                            [3] = 139019,
                            ["Pre"] = 1912.6700000000,
                        },
                        [30] = 
                        {
                            [1] = 30148,
                            [2] = 30157,
                            [3] = 139019,
                            ["Pre"] = 1917.5700000000,
                        },
                        [31] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 139019,
                            ["Pre"] = 1917.7900000000,
                        },
                        [32] = 
                        {
                            [1] = 30166,
                            [2] = 30157,
                            [3] = 139019,
                            ["Pre"] = 1937.8200000000,
                        },
                        [33] = 
                        {
                            [1] = 30153,
                            [2] = 30156,
                            [3] = 139019,
                            ["Pre"] = 1939.2400000000,
                        },
                        [34] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 139019,
                            ["Pre"] = 1941.9300000000,
                        },
                        [35] = 
                        {
                            [1] = 30153,
                            [2] = 30149,
                            [3] = 139019,
                            ["Pre"] = 1943.9500000000,
                        },
                        [36] = 
                        {
                            [1] = 30157,
                            [2] = 30156,
                            [3] = 139019,
                            ["Pre"] = 1944.3600000000,
                        },
                        [37] = 
                        {
                            [1] = 30153,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 1955.6700000000,
                        },
                        [38] = 
                        {
                            [1] = 30153,
                            [2] = 30161,
                            [3] = 139019,
                            ["Pre"] = 1996.1300000000,
                        },
                        [39] = 
                        {
                            [1] = 30153,
                            [2] = 30163,
                            [3] = 139019,
                            ["Pre"] = 2108.0100000000,
                        },
                        [40] = 
                        {
                            [1] = 30153,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2169.5200000000,
                        },
                        [41] = 
                        {
                            [1] = 30157,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2174.6400000000,
                        },
                        [42] = 
                        {
                            [1] = 30157,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2250.7700000000,
                        },
                        [43] = 
                        {
                            [1] = 77590,
                            [2] = 77589,
                            [3] = 139019,
                            ["Pre"] = 2297.6400000000,
                        },
                        [44] = 
                        {
                            [1] = 30153,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2454.3200000000,
                        },
                        [45] = 
                        {
                            [1] = 77589,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2579.8100000000,
                        },
                        [46] = 
                        {
                            [1] = 30153,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2796.8200000000,
                        },
                        [47] = 
                        {
                            [1] = 30162,
                            [2] = 30153,
                            [3] = 150671,
                            ["Pre"] = 7546.0200000000,
                        },
                        [48] = 
                        {
                            [1] = 30154,
                            [2] = 30153,
                            [3] = 150671,
                            ["Pre"] = 7547.7700000000,
                        },
                        [49] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 150671,
                            ["Pre"] = 7550.3100000000,
                        },
                        [50] = 
                        {
                            [1] = 30148,
                            [2] = 30157,
                            [3] = 150671,
                            ["Pre"] = 7552.6700000000,
                        },
                        [51] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 150671,
                            ["Pre"] = 7552.8900000000,
                        },
                        [52] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 150671,
                            ["Pre"] = 7555.4300000000,
                        },
                        [53] = 
                        {
                            [1] = 30166,
                            [2] = 30157,
                            [3] = 150671,
                            ["Pre"] = 7572.9200000000,
                        },
                        [54] = 
                        {
                            [1] = 30153,
                            [2] = 77585,
                            [3] = 150671,
                            ["Pre"] = 7573.6200000000,
                        },
                        [55] = 
                        {
                            [1] = 30157,
                            [2] = 77585,
                            [3] = 150671,
                            ["Pre"] = 7578.7400000000,
                        },
                        [56] = 
                        {
                            [1] = 30153,
                            [2] = 30149,
                            [3] = 150671,
                            ["Pre"] = 7579.0500000000,
                        },
                        [57] = 
                        {
                            [1] = 30153,
                            [2] = 30151,
                            [3] = 150671,
                            ["Pre"] = 7590.7700000000,
                        },
                        [58] = 
                        {
                            [1] = 30153,
                            [2] = 77590,
                            [3] = 150671,
                            ["Pre"] = 7598.5800000000,
                        },
                        [59] = 
                        {
                            [1] = 30153,
                            [2] = 77583,
                            [3] = 150671,
                            ["Pre"] = 7679.0100000000,
                        },
                        [60] = 
                        {
                            [1] = 30157,
                            [2] = 77583,
                            [3] = 150671,
                            ["Pre"] = 7684.1300000000,
                        },
                        [61] = 
                        {
                            [1] = 30153,
                            [2] = 30163,
                            [3] = 150671,
                            ["Pre"] = 7743.1100000000,
                        },
                        [62] = 
                        {
                            [1] = 30162,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7880.1800000000,
                        },
                        [63] = 
                        {
                            [1] = 30148,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7881.7100000000,
                        },
                        [64] = 
                        {
                            [1] = 30154,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7881.9300000000,
                        },
                        [65] = 
                        {
                            [1] = 30157,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 7885.8700000000,
                        },
                        [66] = 
                        {
                            [1] = 30166,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7901.9600000000,
                        },
                        [67] = 
                        {
                            [1] = 30158,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7906.0700000000,
                        },
                        [68] = 
                        {
                            [1] = 30149,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7913.2100000000,
                        },
                        [69] = 
                        {
                            [1] = 30151,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7924.9300000000,
                        },
                        [70] = 
                        {
                            [1] = 77590,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7932.7400000000,
                        },
                        [71] = 
                        {
                            [1] = 30161,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 7965.3900000000,
                        },
                        [72] = 
                        {
                            [1] = 77583,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 8013.1700000000,
                        },
                        [73] = 
                        {
                            [1] = 30163,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 8077.2700000000,
                        },
                        [74] = 
                        {
                            [1] = 30153,
                            [2] = 150669,
                            [3] = 150671,
                            ["Pre"] = 8089.4200000000,
                        },
                        [75] = 
                        {
                            [1] = 30153,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8110.6800000000,
                        },
                        [76] = 
                        {
                            [1] = 30157,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8115.8000000000,
                        },
                        [77] = 
                        {
                            [1] = 30160,
                            [2] = 77589,
                            [3] = 150671,
                            ["Pre"] = 8138.7800000000,
                        },
                        [78] = 
                        {
                            [1] = 77589,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 8214.9100000000,
                        },
                        [79] = 
                        {
                            [1] = 77589,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 8263.2200000000,
                        },
                        [80] = 
                        {
                            [1] = 77589,
                            [2] = 150669,
                            [3] = 150671,
                            ["Pre"] = 8423.5800000000,
                        },
                        [81] = 
                        {
                            [1] = 30153,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 8431.9200000000,
                        },
                        [82] = 
                        {
                            [1] = 77589,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8444.8400000000,
                        },
                        [83] = 
                        {
                            [1] = 77589,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 8766.0800000000,
                        },
                        [84] = 
                        {
                            [1] = 30162,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9197.9500000000,
                        },
                        [85] = 
                        {
                            [1] = 30148,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9199.4800000000,
                        },
                        [86] = 
                        {
                            [1] = 30154,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9199.7000000000,
                        },
                        [87] = 
                        {
                            [1] = 30166,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9219.7300000000,
                        },
                        [88] = 
                        {
                            [1] = 30149,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9230.9800000000,
                        },
                        [89] = 
                        {
                            [1] = 30151,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9242.7000000000,
                        },
                        [90] = 
                        {
                            [1] = 30163,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9395.0400000000,
                        },
                        [91] = 
                        {
                            [1] = 150672,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9532.6800000000,
                        },
                        [92] = 
                        {
                            [1] = 150669,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 9741.3500000000,
                        },
                        [93] = 
                        {
                            [1] = 77589,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9847.8600000000,
                        },
                        [94] = 
                        {
                            [1] = 30152,
                            [2] = 139019,
                            [3] = 150671,
                            ["Pre"] = 10083.8500000000,
                        },
                    },
                    [1179648] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 30156,
                            ["Pre"] = 275.8900000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 30158,
                            [3] = 30156,
                            ["Pre"] = 300.0300000000,
                        },
                        [3] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 30160,
                            ["Pre"] = 532.7400000000,
                        },
                        [4] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 150672,
                            ["Pre"] = 608.8700000000,
                        },
                        [5] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 77589,
                            ["Pre"] = 621.5900000000,
                        },
                        [6] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 150669,
                            ["Pre"] = 817.5400000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 77581,
                            ["Pre"] = 869.0800000000,
                        },
                        [8] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 77581,
                            ["Pre"] = 869.3000000000,
                        },
                        [9] = 
                        {
                            [1] = 30155,
                            [2] = 30165,
                            [3] = 77581,
                            ["Pre"] = 877.0400000000,
                        },
                        [10] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 77581,
                            ["Pre"] = 880.1500000000,
                        },
                        [11] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 77581,
                            ["Pre"] = 880.8400000000,
                        },
                        [12] = 
                        {
                            [1] = 30148,
                            [2] = 30156,
                            [3] = 77581,
                            ["Pre"] = 883.9900000000,
                        },
                        [13] = 
                        {
                            [1] = 30165,
                            [2] = 30158,
                            [3] = 77581,
                            ["Pre"] = 893.4400000000,
                        },
                        [14] = 
                        {
                            [1] = 77584,
                            [2] = 30156,
                            [3] = 77581,
                            ["Pre"] = 895.0600000000,
                        },
                        [15] = 
                        {
                            [1] = 30153,
                            [2] = 30156,
                            [3] = 77581,
                            ["Pre"] = 895.7500000000,
                        },
                        [16] = 
                        {
                            [1] = 30157,
                            [2] = 30156,
                            [3] = 77581,
                            ["Pre"] = 900.8700000000,
                        },
                        [17] = 
                        {
                            [1] = 30158,
                            [2] = 30156,
                            [3] = 77581,
                            ["Pre"] = 908.3500000000,
                        },
                        [18] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 139020,
                            ["Pre"] = 911.0800000000,
                        },
                        [19] = 
                        {
                            [1] = 30156,
                            [2] = 77590,
                            [3] = 77581,
                            ["Pre"] = 935.0200000000,
                        },
                        [20] = 
                        {
                            [1] = 30165,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1064.6400000000,
                        },
                        [21] = 
                        {
                            [1] = 30165,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1126.1500000000,
                        },
                        [22] = 
                        {
                            [1] = 30156,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1141.0600000000,
                        },
                        [23] = 
                        {
                            [1] = 30165,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1202.2800000000,
                        },
                        [24] = 
                        {
                            [1] = 30165,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1215,
                        },
                        [25] = 
                        {
                            [1] = 30156,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1217.1900000000,
                        },
                        [26] = 
                        {
                            [1] = 30156,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1229.9100000000,
                        },
                        [27] = 
                        {
                            [1] = 30156,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1265.5000000000,
                        },
                        [28] = 
                        {
                            [1] = 30165,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1410.9500000000,
                        },
                        [29] = 
                        {
                            [1] = 30165,
                            [2] = 77591,
                            [3] = 77581,
                            ["Pre"] = 1432.2100000000,
                        },
                        [30] = 
                        {
                            [1] = 30156,
                            [2] = 77591,
                            [3] = 77581,
                            ["Pre"] = 1447.1200000000,
                        },
                        [31] = 
                        {
                            [1] = 30165,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 1504.4900000000,
                        },
                        [32] = 
                        {
                            [1] = 30156,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 1519.4000000000,
                        },
                        [33] = 
                        {
                            [1] = 30156,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1768.3600000000,
                        },
                        [34] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 139019,
                            ["Pre"] = 1939.3600000000,
                        },
                        [35] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 30164,
                            ["Pre"] = 2241.8200000000,
                        },
                        [36] = 
                        {
                            [1] = 30165,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2835.2300000000,
                        },
                        [37] = 
                        {
                            [1] = 30156,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2850.1400000000,
                        },
                        [38] = 
                        {
                            [1] = 30165,
                            [2] = 30156,
                            [3] = 150731,
                            ["Pre"] = 3660.7000000000,
                        },
                        [39] = 
                        {
                            [1] = 30165,
                            [2] = 77581,
                            [3] = 150731,
                            ["Pre"] = 4254.1100000000,
                        },
                        [40] = 
                        {
                            [1] = 30156,
                            [2] = 77581,
                            [3] = 150731,
                            ["Pre"] = 4269.0200000000,
                        },
                        [41] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 150671,
                            ["Pre"] = 7547.8900000000,
                        },
                        [42] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 150671,
                            ["Pre"] = 7550.4300000000,
                        },
                        [43] = 
                        {
                            [1] = 30155,
                            [2] = 30165,
                            [3] = 150671,
                            ["Pre"] = 7555.6300000000,
                        },
                        [44] = 
                        {
                            [1] = 30148,
                            [2] = 30156,
                            [3] = 150671,
                            ["Pre"] = 7562.5800000000,
                        },
                        [45] = 
                        {
                            [1] = 30154,
                            [2] = 30156,
                            [3] = 150671,
                            ["Pre"] = 7562.8000000000,
                        },
                        [46] = 
                        {
                            [1] = 77584,
                            [2] = 30156,
                            [3] = 150671,
                            ["Pre"] = 7573.6500000000,
                        },
                        [47] = 
                        {
                            [1] = 77585,
                            [2] = 30156,
                            [3] = 150671,
                            ["Pre"] = 7588.6500000000,
                        },
                        [48] = 
                        {
                            [1] = 30156,
                            [2] = 77590,
                            [3] = 150671,
                            ["Pre"] = 7613.6100000000,
                        },
                        [49] = 
                        {
                            [1] = 30165,
                            [2] = 77583,
                            [3] = 150671,
                            ["Pre"] = 7679.1300000000,
                        },
                        [50] = 
                        {
                            [1] = 30165,
                            [2] = 30163,
                            [3] = 150671,
                            ["Pre"] = 7743.2300000000,
                        },
                        [51] = 
                        {
                            [1] = 30165,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 7880.8700000000,
                        },
                        [52] = 
                        {
                            [1] = 30156,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 7895.7800000000,
                        },
                        [53] = 
                        {
                            [1] = 30165,
                            [2] = 150669,
                            [3] = 150671,
                            ["Pre"] = 8089.5400000000,
                        },
                        [54] = 
                        {
                            [1] = 30156,
                            [2] = 150669,
                            [3] = 150671,
                            ["Pre"] = 8104.4500000000,
                        },
                        [55] = 
                        {
                            [1] = 30165,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8110.8000000000,
                        },
                        [56] = 
                        {
                            [1] = 30148,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8155.9900000000,
                        },
                        [57] = 
                        {
                            [1] = 30155,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8163.9500000000,
                        },
                        [58] = 
                        {
                            [1] = 77584,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8167.0600000000,
                        },
                        [59] = 
                        {
                            [1] = 30165,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8183.0800000000,
                        },
                        [60] = 
                        {
                            [1] = 30156,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8197.9900000000,
                        },
                        [61] = 
                        {
                            [1] = 30151,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8199.2100000000,
                        },
                        [62] = 
                        {
                            [1] = 77590,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8207.0200000000,
                        },
                        [63] = 
                        {
                            [1] = 30163,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8351.5500000000,
                        },
                        [64] = 
                        {
                            [1] = 30156,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 8446.9500000000,
                        },
                        [65] = 
                        {
                            [1] = 150672,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8489.1900000000,
                        },
                        [66] = 
                        {
                            [1] = 77591,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8719.1200000000,
                        },
                        [67] = 
                        {
                            [1] = 77581,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8791.4000000000,
                        },
                        [68] = 
                        {
                            [1] = 77581,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 9040.3600000000,
                        },
                    },
                    [1187072] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 77581,
                            ["Pre"] = 871.8400000000,
                        },
                        [2] = 
                        {
                            [1] = 77585,
                            [2] = 30156,
                            [3] = 77581,
                            ["Pre"] = 910.0600000000,
                        },
                        [3] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 962.3900000000,
                        },
                        [4] = 
                        {
                            [1] = 30156,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 977.3000000000,
                        },
                        [5] = 
                        {
                            [1] = 30165,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 1000.5400000000,
                        },
                        [6] = 
                        {
                            [1] = 30156,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 1015.4500000000,
                        },
                        [7] = 
                        {
                            [1] = 30165,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2532.7700000000,
                        },
                        [8] = 
                        {
                            [1] = 30156,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2547.6800000000,
                        },
                        [9] = 
                        {
                            [1] = 77587,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8158.7500000000,
                        },
                        [10] = 
                        {
                            [1] = 77585,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8182.0600000000,
                        },
                        [11] = 
                        {
                            [1] = 77583,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8287.4500000000,
                        },
                    },
                    [138240] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 77590,
                            ["Pre"] = 302.6700000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 77590,
                            ["Pre"] = 307.6700000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 30161,
                            ["Pre"] = 374.4700000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 672.3000000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 77590,
                            [3] = 30152,
                            ["Pre"] = 1175.1600000000,
                        },
                    },
                    [397824] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 30156,
                            ["Pre"] = 278.4300000000,
                        },
                        [2] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 77581,
                            ["Pre"] = 915.4900000000,
                        },
                        [3] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 927.2100000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 150671,
                            ["Pre"] = 7565.3400000000,
                        },
                        [5] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 150671,
                            ["Pre"] = 7594.0800000000,
                        },
                        [6] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 150671,
                            ["Pre"] = 7605.8000000000,
                        },
                    },
                    [132608] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 30149,
                            ["Pre"] = 283.1400000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 30151,
                            ["Pre"] = 294.8600000000,
                        },
                        [3] = 
                        {
                            [1] = 77584,
                            [2] = 30149,
                            [3] = 30151,
                            ["Pre"] = 322.7900000000,
                        },
                        [4] = 
                        {
                            [1] = 30153,
                            [2] = 30149,
                            [3] = 30151,
                            ["Pre"] = 323.4800000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 30149,
                            [3] = 30151,
                            ["Pre"] = 323.5200000000,
                        },
                        [6] = 
                        {
                            [1] = 30158,
                            [2] = 30149,
                            [3] = 30151,
                            ["Pre"] = 336.0800000000,
                        },
                        [7] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 77590,
                            ["Pre"] = 346.3200000000,
                        },
                        [8] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 30161,
                            ["Pre"] = 354.9400000000,
                        },
                        [9] = 
                        {
                            [1] = 30156,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 358.0400000000,
                        },
                        [10] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 366.6600000000,
                        },
                        [11] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 30161,
                            ["Pre"] = 378.9700000000,
                        },
                        [12] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 390.6900000000,
                        },
                        [13] = 
                        {
                            [1] = 30149,
                            [2] = 150789,
                            [3] = 30151,
                            ["Pre"] = 405.0300000000,
                        },
                        [14] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 77583,
                            ["Pre"] = 443.1800000000,
                        },
                        [15] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 150670,
                            ["Pre"] = 652.7700000000,
                        },
                        [16] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 664.4900000000,
                        },
                        [17] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 150670,
                            ["Pre"] = 676.8000000000,
                        },
                        [18] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 688.5200000000,
                        },
                        [19] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 77591,
                            ["Pre"] = 874.8500000000,
                        },
                        [20] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 139020,
                            ["Pre"] = 947.1300000000,
                        },
                        [21] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 30152,
                            ["Pre"] = 1155.6300000000,
                        },
                        [22] = 
                        {
                            [1] = 30149,
                            [2] = 30156,
                            [3] = 30152,
                            ["Pre"] = 1179.6600000000,
                        },
                        [23] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 1975.4100000000,
                        },
                        [24] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 150671,
                            ["Pre"] = 7610.5100000000,
                        },
                    },
                    [1056000] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 77585,
                            ["Pre"] = 277.7100000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 77585,
                            [3] = 77583,
                            ["Pre"] = 406.4100000000,
                        },
                    },
                    [131072] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 30157,
                            ["Pre"] = 265.9800000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 30157,
                            ["Pre"] = 268.5200000000,
                        },
                        [3] = 
                        {
                            [1] = 30159,
                            [2] = 30165,
                            [3] = 30157,
                            ["Pre"] = 277.5600000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 30149,
                            ["Pre"] = 280.6000000000,
                        },
                        [5] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 30158,
                            ["Pre"] = 290.1200000000,
                        },
                        [6] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 30151,
                            ["Pre"] = 290.5700000000,
                        },
                        [7] = 
                        {
                            [1] = 30159,
                            [2] = 30165,
                            [3] = 30149,
                            ["Pre"] = 292.1800000000,
                        },
                        [8] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 77590,
                            ["Pre"] = 298.3800000000,
                        },
                        [9] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 30151,
                            ["Pre"] = 299.8600000000,
                        },
                        [10] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 77590,
                            ["Pre"] = 300.1300000000,
                        },
                        [11] = 
                        {
                            [1] = 30159,
                            [2] = 30165,
                            [3] = 30151,
                            ["Pre"] = 303.9000000000,
                        },
                        [12] = 
                        {
                            [1] = 30165,
                            [2] = 30158,
                            [3] = 30149,
                            ["Pre"] = 304.7400000000,
                        },
                        [13] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 77590,
                            ["Pre"] = 305.1300000000,
                        },
                        [14] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 30151,
                            ["Pre"] = 308.1700000000,
                        },
                        [15] = 
                        {
                            [1] = 30159,
                            [2] = 30157,
                            [3] = 30151,
                            ["Pre"] = 308.9000000000,
                        },
                        [16] = 
                        {
                            [1] = 30159,
                            [2] = 30165,
                            [3] = 77590,
                            ["Pre"] = 311.7100000000,
                        },
                        [17] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 30156,
                            ["Pre"] = 312.1700000000,
                        },
                        [18] = 
                        {
                            [1] = 30165,
                            [2] = 30158,
                            [3] = 30151,
                            ["Pre"] = 316.4600000000,
                        },
                        [19] = 
                        {
                            [1] = 30159,
                            [2] = 30157,
                            [3] = 77590,
                            ["Pre"] = 316.7100000000,
                        },
                        [20] = 
                        {
                            [1] = 30154,
                            [2] = 30149,
                            [3] = 77590,
                            ["Pre"] = 319.7500000000,
                        },
                        [21] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 30151,
                            ["Pre"] = 321.4600000000,
                        },
                        [22] = 
                        {
                            [1] = 30157,
                            [2] = 30156,
                            [3] = 30151,
                            ["Pre"] = 323.8900000000,
                        },
                        [23] = 
                        {
                            [1] = 30165,
                            [2] = 30158,
                            [3] = 77590,
                            ["Pre"] = 324.2700000000,
                        },
                        [24] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 77590,
                            ["Pre"] = 329.2700000000,
                        },
                        [25] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 329.7200000000,
                        },
                        [26] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 30161,
                            ["Pre"] = 331.0300000000,
                        },
                        [27] = 
                        {
                            [1] = 30153,
                            [2] = 30149,
                            [3] = 77590,
                            ["Pre"] = 331.2900000000,
                        },
                        [28] = 
                        {
                            [1] = 30159,
                            [2] = 30149,
                            [3] = 77590,
                            ["Pre"] = 331.3300000000,
                        },
                        [29] = 
                        {
                            [1] = 30157,
                            [2] = 30156,
                            [3] = 77590,
                            ["Pre"] = 331.7000000000,
                        },
                        [30] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 30161,
                            ["Pre"] = 332.7800000000,
                        },
                        [31] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 30161,
                            ["Pre"] = 335.3200000000,
                        },
                        [32] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 30161,
                            ["Pre"] = 340.3200000000,
                        },
                        [33] = 
                        {
                            [1] = 30153,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 343.0100000000,
                        },
                        [34] = 
                        {
                            [1] = 30159,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 343.0500000000,
                        },
                        [35] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 30161,
                            ["Pre"] = 343.6300000000,
                        },
                        [36] = 
                        {
                            [1] = 30158,
                            [2] = 30149,
                            [3] = 77590,
                            ["Pre"] = 343.8900000000,
                        },
                        [37] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 30161,
                            ["Pre"] = 344.3200000000,
                        },
                        [38] = 
                        {
                            [1] = 30159,
                            [2] = 30165,
                            [3] = 30161,
                            ["Pre"] = 344.3600000000,
                        },
                        [39] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 30161,
                            ["Pre"] = 348.6300000000,
                        },
                        [40] = 
                        {
                            [1] = 30158,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 355.6100000000,
                        },
                        [41] = 
                        {
                            [1] = 30162,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 362.3700000000,
                        },
                        [42] = 
                        {
                            [1] = 77584,
                            [2] = 30149,
                            [3] = 30161,
                            ["Pre"] = 363.2500000000,
                        },
                        [43] = 
                        {
                            [1] = 30153,
                            [2] = 30149,
                            [3] = 30161,
                            ["Pre"] = 363.9400000000,
                        },
                        [44] = 
                        {
                            [1] = 30157,
                            [2] = 30156,
                            [3] = 30161,
                            ["Pre"] = 364.3500000000,
                        },
                        [45] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 30161,
                            ["Pre"] = 370.1800000000,
                        },
                        [46] = 
                        {
                            [1] = 77584,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 374.9700000000,
                        },
                        [47] = 
                        {
                            [1] = 30153,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 375.6600000000,
                        },
                        [48] = 
                        {
                            [1] = 30153,
                            [2] = 77590,
                            [3] = 30161,
                            ["Pre"] = 383.4700000000,
                        },
                        [49] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 30151,
                            ["Pre"] = 390.4100000000,
                        },
                        [50] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 77583,
                            ["Pre"] = 397.2200000000,
                        },
                        [51] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 77590,
                            ["Pre"] = 398.2200000000,
                        },
                        [52] = 
                        {
                            [1] = 30156,
                            [2] = 77590,
                            [3] = 30161,
                            ["Pre"] = 398.5000000000,
                        },
                        [53] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 77583,
                            ["Pre"] = 411.8400000000,
                        },
                        [54] = 
                        {
                            [1] = 30149,
                            [2] = 150789,
                            [3] = 77590,
                            ["Pre"] = 412.8400000000,
                        },
                        [55] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            [3] = 77583,
                            ["Pre"] = 423.5600000000,
                        },
                        [56] = 
                        {
                            [1] = 150789,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 424.5600000000,
                        },
                        [57] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 30161,
                            ["Pre"] = 425.8700000000,
                        },
                        [58] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            [3] = 77583,
                            ["Pre"] = 428.5600000000,
                        },
                        [59] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 30161,
                            ["Pre"] = 430.8700000000,
                        },
                        [60] = 
                        {
                            [1] = 30149,
                            [2] = 150789,
                            [3] = 30161,
                            ["Pre"] = 445.4900000000,
                        },
                        [61] = 
                        {
                            [1] = 150789,
                            [2] = 30151,
                            [3] = 30161,
                            ["Pre"] = 457.2100000000,
                        },
                        [62] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            [3] = 77583,
                            ["Pre"] = 464.0200000000,
                        },
                        [63] = 
                        {
                            [1] = 150789,
                            [2] = 77590,
                            [3] = 30161,
                            ["Pre"] = 465.0200000000,
                        },
                        [64] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 77583,
                            ["Pre"] = 469.0200000000,
                        },
                        [65] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            [3] = 77583,
                            ["Pre"] = 483.6400000000,
                        },
                        [66] = 
                        {
                            [1] = 30151,
                            [2] = 30161,
                            [3] = 77583,
                            ["Pre"] = 495.3600000000,
                        },
                        [67] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 77589,
                            ["Pre"] = 626.3000000000,
                        },
                        [68] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 150670,
                            ["Pre"] = 628.8600000000,
                        },
                        [69] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 150670,
                            ["Pre"] = 630.6100000000,
                        },
                        [70] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 150670,
                            ["Pre"] = 633.1500000000,
                        },
                        [71] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 150670,
                            ["Pre"] = 635.6100000000,
                        },
                        [72] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 150670,
                            ["Pre"] = 638.1500000000,
                        },
                        [73] = 
                        {
                            [1] = 30159,
                            [2] = 30165,
                            [3] = 150670,
                            ["Pre"] = 642.1900000000,
                        },
                        [74] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 77589,
                            ["Pre"] = 645.8300000000,
                        },
                        [75] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 150670,
                            ["Pre"] = 646.4600000000,
                        },
                        [76] = 
                        {
                            [1] = 30159,
                            [2] = 30157,
                            [3] = 150670,
                            ["Pre"] = 647.1900000000,
                        },
                        [77] = 
                        {
                            [1] = 30154,
                            [2] = 30149,
                            [3] = 150670,
                            ["Pre"] = 650.2300000000,
                        },
                        [78] = 
                        {
                            [1] = 30162,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 660.2000000000,
                        },
                        [79] = 
                        {
                            [1] = 77584,
                            [2] = 30149,
                            [3] = 150670,
                            ["Pre"] = 661.0800000000,
                        },
                        [80] = 
                        {
                            [1] = 30153,
                            [2] = 30149,
                            [3] = 150670,
                            ["Pre"] = 661.7700000000,
                        },
                        [81] = 
                        {
                            [1] = 30159,
                            [2] = 30149,
                            [3] = 150670,
                            ["Pre"] = 661.8100000000,
                        },
                        [82] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 661.9500000000,
                        },
                        [83] = 
                        {
                            [1] = 30157,
                            [2] = 30156,
                            [3] = 150670,
                            ["Pre"] = 662.1800000000,
                        },
                        [84] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 77589,
                            ["Pre"] = 665.4500000000,
                        },
                        [85] = 
                        {
                            [1] = 77584,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 672.8000000000,
                        },
                        [86] = 
                        {
                            [1] = 30153,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 673.4900000000,
                        },
                        [87] = 
                        {
                            [1] = 30159,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 673.5300000000,
                        },
                        [88] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            [3] = 77589,
                            ["Pre"] = 678.4800000000,
                        },
                        [89] = 
                        {
                            [1] = 30158,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 686.0900000000,
                        },
                        [90] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            [3] = 77589,
                            ["Pre"] = 698.1000000000,
                        },
                        [91] = 
                        {
                            [1] = 30151,
                            [2] = 30161,
                            [3] = 77589,
                            ["Pre"] = 709.8200000000,
                        },
                        [92] = 
                        {
                            [1] = 77590,
                            [2] = 30161,
                            [3] = 77589,
                            ["Pre"] = 717.6300000000,
                        },
                        [93] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 150670,
                            ["Pre"] = 728.7000000000,
                        },
                        [94] = 
                        {
                            [1] = 30149,
                            [2] = 150789,
                            [3] = 150670,
                            ["Pre"] = 743.3200000000,
                        },
                        [95] = 
                        {
                            [1] = 150789,
                            [2] = 30151,
                            [3] = 150670,
                            ["Pre"] = 755.0400000000,
                        },
                        [96] = 
                        {
                            [1] = 150789,
                            [2] = 77590,
                            [3] = 150670,
                            ["Pre"] = 762.8500000000,
                        },
                        [97] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 150669,
                            ["Pre"] = 822.2500000000,
                        },
                        [98] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 77591,
                            ["Pre"] = 828.8900000000,
                        },
                        [99] = 
                        {
                            [1] = 30165,
                            [2] = 77590,
                            [3] = 150669,
                            ["Pre"] = 841.7800000000,
                        },
                        [100] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 77591,
                            ["Pre"] = 843.5100000000,
                        },
                        [101] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            [3] = 77591,
                            ["Pre"] = 855.2300000000,
                        },
                        [102] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            [3] = 77591,
                            ["Pre"] = 860.2300000000,
                        },
                        [103] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 150669,
                            ["Pre"] = 861.4000000000,
                        },
                        [104] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 874.4300000000,
                        },
                        [105] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            [3] = 77591,
                            ["Pre"] = 895.6900000000,
                        },
                        [106] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 77591,
                            ["Pre"] = 900.6900000000,
                        },
                        [107] = 
                        {
                            [1] = 30165,
                            [2] = 30157,
                            [3] = 139020,
                            ["Pre"] = 901.1700000000,
                        },
                        [108] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            [3] = 77591,
                            ["Pre"] = 915.3100000000,
                        },
                        [109] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 139020,
                            ["Pre"] = 915.7900000000,
                        },
                        [110] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 917.3000000000,
                        },
                        [111] = 
                        {
                            [1] = 30157,
                            [2] = 77590,
                            [3] = 77581,
                            ["Pre"] = 925.1100000000,
                        },
                        [112] = 
                        {
                            [1] = 30151,
                            [2] = 30161,
                            [3] = 77591,
                            ["Pre"] = 927.0300000000,
                        },
                        [113] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            [3] = 139020,
                            ["Pre"] = 927.5100000000,
                        },
                        [114] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            [3] = 139020,
                            ["Pre"] = 932.5100000000,
                        },
                        [115] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 951.4500000000,
                        },
                        [116] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            [3] = 139020,
                            ["Pre"] = 967.9700000000,
                        },
                        [117] = 
                        {
                            [1] = 30157,
                            [2] = 30161,
                            [3] = 139020,
                            ["Pre"] = 972.9700000000,
                        },
                        [118] = 
                        {
                            [1] = 30165,
                            [2] = 77589,
                            [3] = 150670,
                            ["Pre"] = 976.3100000000,
                        },
                        [119] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            [3] = 139020,
                            ["Pre"] = 987.5900000000,
                        },
                        [120] = 
                        {
                            [1] = 30149,
                            [2] = 77589,
                            [3] = 150670,
                            ["Pre"] = 995.9300000000,
                        },
                        [121] = 
                        {
                            [1] = 30151,
                            [2] = 30161,
                            [3] = 139020,
                            ["Pre"] = 999.3100000000,
                        },
                        [122] = 
                        {
                            [1] = 30151,
                            [2] = 77589,
                            [3] = 150670,
                            ["Pre"] = 1007.6500000000,
                        },
                        [123] = 
                        {
                            [1] = 77590,
                            [2] = 77589,
                            [3] = 150670,
                            ["Pre"] = 1015.4600000000,
                        },
                        [124] = 
                        {
                            [1] = 30161,
                            [2] = 77589,
                            [3] = 150670,
                            ["Pre"] = 1048.1100000000,
                        },
                        [125] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 30152,
                            ["Pre"] = 1131.7200000000,
                        },
                        [126] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 30152,
                            ["Pre"] = 1136.0100000000,
                        },
                        [127] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 30152,
                            ["Pre"] = 1141.0100000000,
                        },
                        [128] = 
                        {
                            [1] = 30159,
                            [2] = 30165,
                            [3] = 30152,
                            ["Pre"] = 1145.0500000000,
                        },
                        [129] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 30152,
                            ["Pre"] = 1149.3200000000,
                        },
                        [130] = 
                        {
                            [1] = 30159,
                            [2] = 30157,
                            [3] = 30152,
                            ["Pre"] = 1150.0500000000,
                        },
                        [131] = 
                        {
                            [1] = 77584,
                            [2] = 30149,
                            [3] = 30152,
                            ["Pre"] = 1163.9400000000,
                        },
                        [132] = 
                        {
                            [1] = 30153,
                            [2] = 30149,
                            [3] = 30152,
                            ["Pre"] = 1164.6300000000,
                        },
                        [133] = 
                        {
                            [1] = 30159,
                            [2] = 30149,
                            [3] = 30152,
                            ["Pre"] = 1164.6700000000,
                        },
                        [134] = 
                        {
                            [1] = 30157,
                            [2] = 30156,
                            [3] = 30152,
                            ["Pre"] = 1165.0400000000,
                        },
                        [135] = 
                        {
                            [1] = 30162,
                            [2] = 77590,
                            [3] = 30152,
                            ["Pre"] = 1170.8700000000,
                        },
                        [136] = 
                        {
                            [1] = 30153,
                            [2] = 77590,
                            [3] = 30152,
                            ["Pre"] = 1184.1600000000,
                        },
                        [137] = 
                        {
                            [1] = 30159,
                            [2] = 77590,
                            [3] = 30152,
                            ["Pre"] = 1184.2000000000,
                        },
                        [138] = 
                        {
                            [1] = 30156,
                            [2] = 77590,
                            [3] = 30152,
                            ["Pre"] = 1199.1900000000,
                        },
                        [139] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 30152,
                            ["Pre"] = 1231.5600000000,
                        },
                        [140] = 
                        {
                            [1] = 30149,
                            [2] = 150789,
                            [3] = 30152,
                            ["Pre"] = 1246.1800000000,
                        },
                        [141] = 
                        {
                            [1] = 30157,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1255.5900000000,
                        },
                        [142] = 
                        {
                            [1] = 150789,
                            [2] = 77590,
                            [3] = 30152,
                            ["Pre"] = 1265.7100000000,
                        },
                        [143] = 
                        {
                            [1] = 30165,
                            [2] = 150670,
                            [3] = 139020,
                            ["Pre"] = 1265.8000000000,
                        },
                        [144] = 
                        {
                            [1] = 30157,
                            [2] = 150670,
                            [3] = 139020,
                            ["Pre"] = 1270.8000000000,
                        },
                        [145] = 
                        {
                            [1] = 30151,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1281.9300000000,
                        },
                        [146] = 
                        {
                            [1] = 30149,
                            [2] = 150670,
                            [3] = 139020,
                            ["Pre"] = 1285.4200000000,
                        },
                        [147] = 
                        {
                            [1] = 30151,
                            [2] = 150670,
                            [3] = 139020,
                            ["Pre"] = 1297.1400000000,
                        },
                        [148] = 
                        {
                            [1] = 30162,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1501.3500000000,
                        },
                        [149] = 
                        {
                            [1] = 30154,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1503.1000000000,
                        },
                        [150] = 
                        {
                            [1] = 77587,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1505.6400000000,
                        },
                        [151] = 
                        {
                            [1] = 77584,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1513.9500000000,
                        },
                        [152] = 
                        {
                            [1] = 30153,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1514.6400000000,
                        },
                        [153] = 
                        {
                            [1] = 30159,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1514.6800000000,
                        },
                        [154] = 
                        {
                            [1] = 30156,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1529.6700000000,
                        },
                        [155] = 
                        {
                            [1] = 150789,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1596.1900000000,
                        },
                        [156] = 
                        {
                            [1] = 30165,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 1696.3800000000,
                        },
                        [157] = 
                        {
                            [1] = 30157,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 1701.3800000000,
                        },
                        [158] = 
                        {
                            [1] = 30149,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 1716,
                        },
                        [159] = 
                        {
                            [1] = 30157,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1758.4500000000,
                        },
                        [160] = 
                        {
                            [1] = 30165,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1768.6600000000,
                        },
                        [161] = 
                        {
                            [1] = 30157,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1773.6600000000,
                        },
                        [162] = 
                        {
                            [1] = 30149,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1788.2800000000,
                        },
                        [163] = 
                        {
                            [1] = 77590,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1792.6000000000,
                        },
                        [164] = 
                        {
                            [1] = 77589,
                            [2] = 150670,
                            [3] = 30152,
                            ["Pre"] = 1848.8000000000,
                        },
                        [165] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 139019,
                            ["Pre"] = 1944.0700000000,
                        },
                        [166] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 1955.7900000000,
                        },
                        [167] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            [3] = 139019,
                            ["Pre"] = 1996.2500000000,
                        },
                        [168] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            [3] = 139019,
                            ["Pre"] = 2015.8700000000,
                        },
                        [169] = 
                        {
                            [1] = 30151,
                            [2] = 30161,
                            [3] = 139019,
                            ["Pre"] = 2027.5900000000,
                        },
                        [170] = 
                        {
                            [1] = 150670,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 2123.0800000000,
                        },
                        [171] = 
                        {
                            [1] = 150670,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 2138.2900000000,
                        },
                        [172] = 
                        {
                            [1] = 30165,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2796.9400000000,
                        },
                        [173] = 
                        {
                            [1] = 30149,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2816.5600000000,
                        },
                        [174] = 
                        {
                            [1] = 30165,
                            [2] = 30149,
                            [3] = 150731,
                            ["Pre"] = 3665.4100000000,
                        },
                        [175] = 
                        {
                            [1] = 30165,
                            [2] = 30151,
                            [3] = 150731,
                            ["Pre"] = 3677.1300000000,
                        },
                        [176] = 
                        {
                            [1] = 30157,
                            [2] = 30151,
                            [3] = 150731,
                            ["Pre"] = 3682.1300000000,
                        },
                        [177] = 
                        {
                            [1] = 30149,
                            [2] = 30151,
                            [3] = 150731,
                            ["Pre"] = 3696.7500000000,
                        },
                        [178] = 
                        {
                            [1] = 30165,
                            [2] = 30161,
                            [3] = 150731,
                            ["Pre"] = 3717.5900000000,
                        },
                        [179] = 
                        {
                            [1] = 30149,
                            [2] = 30161,
                            [3] = 150731,
                            ["Pre"] = 3737.2100000000,
                        },
                        [180] = 
                        {
                            [1] = 30151,
                            [2] = 30161,
                            [3] = 150731,
                            ["Pre"] = 3748.9300000000,
                        },
                        [181] = 
                        {
                            [1] = 30165,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4015.4200000000,
                        },
                        [182] = 
                        {
                            [1] = 30149,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4035.0400000000,
                        },
                        [183] = 
                        {
                            [1] = 30151,
                            [2] = 150670,
                            [3] = 150731,
                            ["Pre"] = 4046.7600000000,
                        },
                        [184] = 
                        {
                            [1] = 30165,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4518.2800000000,
                        },
                        [185] = 
                        {
                            [1] = 30149,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4537.9000000000,
                        },
                        [186] = 
                        {
                            [1] = 150670,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4887.9100000000,
                        },
                        [187] = 
                        {
                            [1] = 30149,
                            [2] = 77590,
                            [3] = 150671,
                            ["Pre"] = 7618.3200000000,
                        },
                        [188] = 
                        {
                            [1] = 77590,
                            [2] = 30151,
                            [3] = 150671,
                            ["Pre"] = 7630.0400000000,
                        },
                        [189] = 
                        {
                            [1] = 30151,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7662.6900000000,
                        },
                        [190] = 
                        {
                            [1] = 30151,
                            [2] = 150670,
                            [3] = 150671,
                            ["Pre"] = 7960.5200000000,
                        },
                        [191] = 
                        {
                            [1] = 30149,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 8451.6600000000,
                        },
                        [192] = 
                        {
                            [1] = 30151,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 8463.3800000000,
                        },
                        [193] = 
                        {
                            [1] = 77590,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 8471.1900000000,
                        },
                        [194] = 
                        {
                            [1] = 150670,
                            [2] = 30152,
                            [3] = 150671,
                            ["Pre"] = 8801.6700000000,
                        },
                    },
                    [1312256] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 30151,
                            ["Pre"] = 303.2300000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 30151,
                            ["Pre"] = 308.4300000000,
                        },
                        [3] = 
                        {
                            [1] = 30166,
                            [2] = 30156,
                            [3] = 30151,
                            ["Pre"] = 327.2600000000,
                        },
                        [4] = 
                        {
                            [1] = 30166,
                            [2] = 30149,
                            [3] = 30151,
                            ["Pre"] = 331.9700000000,
                        },
                    },
                    [983040] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 30153,
                            ["Pre"] = 269.2300000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30153,
                            [3] = 30158,
                            ["Pre"] = 271.5900000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 30153,
                            ["Pre"] = 271.7700000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 30153,
                            [3] = 30158,
                            ["Pre"] = 273.3400000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 30158,
                            ["Pre"] = 275.8800000000,
                        },
                        [6] = 
                        {
                            [1] = 30155,
                            [2] = 30153,
                            [3] = 30158,
                            ["Pre"] = 281.0800000000,
                        },
                        [7] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 30158,
                            ["Pre"] = 281.8300000000,
                        },
                        [8] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 30158,
                            ["Pre"] = 284.3700000000,
                        },
                        [9] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 30158,
                            ["Pre"] = 292.6800000000,
                        },
                        [10] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 30156,
                            ["Pre"] = 295.8000000000,
                        },
                        [11] = 
                        {
                            [1] = 30166,
                            [2] = 30157,
                            [3] = 30158,
                            ["Pre"] = 298.4900000000,
                        },
                        [12] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 30156,
                            ["Pre"] = 299.9100000000,
                        },
                        [13] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 30149,
                            ["Pre"] = 300.5100000000,
                        },
                        [14] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 30149,
                            ["Pre"] = 304.6200000000,
                        },
                        [15] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 30156,
                            ["Pre"] = 308.4000000000,
                        },
                        [16] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 30151,
                            ["Pre"] = 312.2300000000,
                        },
                        [17] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 30149,
                            ["Pre"] = 313.1100000000,
                        },
                        [18] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 30151,
                            ["Pre"] = 316.3400000000,
                        },
                        [19] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 77590,
                            ["Pre"] = 320.0400000000,
                        },
                        [20] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 77590,
                            ["Pre"] = 324.1500000000,
                        },
                        [21] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 77590,
                            ["Pre"] = 332.6400000000,
                        },
                        [22] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 30161,
                            ["Pre"] = 352.6900000000,
                        },
                        [23] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 150789,
                            ["Pre"] = 374.9200000000,
                        },
                        [24] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 77583,
                            ["Pre"] = 400.4700000000,
                        },
                        [25] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 30163,
                            ["Pre"] = 468.6800000000,
                        },
                        [26] = 
                        {
                            [1] = 30162,
                            [2] = 30153,
                            [3] = 150672,
                            ["Pre"] = 580.4300000000,
                        },
                        [27] = 
                        {
                            [1] = 30154,
                            [2] = 30153,
                            [3] = 150672,
                            ["Pre"] = 582.1800000000,
                        },
                        [28] = 
                        {
                            [1] = 30162,
                            [2] = 30158,
                            [3] = 150672,
                            ["Pre"] = 593.0300000000,
                        },
                        [29] = 
                        {
                            [1] = 30154,
                            [2] = 30158,
                            [3] = 150672,
                            ["Pre"] = 594.7800000000,
                        },
                        [30] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 150672,
                            ["Pre"] = 605.6300000000,
                        },
                        [31] = 
                        {
                            [1] = 30159,
                            [2] = 30158,
                            [3] = 150672,
                            ["Pre"] = 606.3600000000,
                        },
                        [32] = 
                        {
                            [1] = 30166,
                            [2] = 30157,
                            [3] = 150672,
                            ["Pre"] = 607.3300000000,
                        },
                        [33] = 
                        {
                            [1] = 30153,
                            [2] = 30156,
                            [3] = 150672,
                            ["Pre"] = 608.7500000000,
                        },
                        [34] = 
                        {
                            [1] = 30157,
                            [2] = 30158,
                            [3] = 150672,
                            ["Pre"] = 611.4400000000,
                        },
                        [35] = 
                        {
                            [1] = 30153,
                            [2] = 30149,
                            [3] = 150672,
                            ["Pre"] = 613.4600000000,
                        },
                        [36] = 
                        {
                            [1] = 30158,
                            [2] = 30156,
                            [3] = 150672,
                            ["Pre"] = 621.3500000000,
                        },
                        [37] = 
                        {
                            [1] = 30166,
                            [2] = 30149,
                            [3] = 150672,
                            ["Pre"] = 621.9500000000,
                        },
                        [38] = 
                        {
                            [1] = 30153,
                            [2] = 30151,
                            [3] = 150672,
                            ["Pre"] = 625.1800000000,
                        },
                        [39] = 
                        {
                            [1] = 30158,
                            [2] = 30149,
                            [3] = 150672,
                            ["Pre"] = 626.0600000000,
                        },
                        [40] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 77589,
                            ["Pre"] = 627.5300000000,
                        },
                        [41] = 
                        {
                            [1] = 30158,
                            [2] = 30151,
                            [3] = 150672,
                            ["Pre"] = 637.7800000000,
                        },
                        [42] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 150670,
                            ["Pre"] = 650.5200000000,
                        },
                        [43] = 
                        {
                            [1] = 30153,
                            [2] = 30161,
                            [3] = 150672,
                            ["Pre"] = 665.6400000000,
                        },
                        [44] = 
                        {
                            [1] = 30166,
                            [2] = 30161,
                            [3] = 150672,
                            ["Pre"] = 674.1300000000,
                        },
                        [45] = 
                        {
                            [1] = 30158,
                            [2] = 150789,
                            [3] = 150672,
                            ["Pre"] = 687.8700000000,
                        },
                        [46] = 
                        {
                            [1] = 30153,
                            [2] = 77583,
                            [3] = 150672,
                            ["Pre"] = 713.4200000000,
                        },
                        [47] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 150669,
                            ["Pre"] = 810.8800000000,
                        },
                        [48] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 150669,
                            ["Pre"] = 814.9900000000,
                        },
                        [49] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 150669,
                            ["Pre"] = 823.4800000000,
                        },
                        [50] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 77591,
                            ["Pre"] = 832.1400000000,
                        },
                        [51] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 77591,
                            ["Pre"] = 836.2500000000,
                        },
                        [52] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 77591,
                            ["Pre"] = 844.7400000000,
                        },
                        [53] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 77581,
                            ["Pre"] = 889.2100000000,
                        },
                        [54] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 77581,
                            ["Pre"] = 893.3200000000,
                        },
                        [55] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 77581,
                            ["Pre"] = 901.8100000000,
                        },
                        [56] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 139020,
                            ["Pre"] = 904.4200000000,
                        },
                        [57] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 139020,
                            ["Pre"] = 908.5300000000,
                        },
                        [58] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 139020,
                            ["Pre"] = 917.0200000000,
                        },
                        [59] = 
                        {
                            [1] = 30158,
                            [2] = 77589,
                            [3] = 150672,
                            ["Pre"] = 940.4800000000,
                        },
                        [60] = 
                        {
                            [1] = 30153,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1145.0900000000,
                        },
                        [61] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 30152,
                            ["Pre"] = 1153.3800000000,
                        },
                        [62] = 
                        {
                            [1] = 30158,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1157.6900000000,
                        },
                        [63] = 
                        {
                            [1] = 30153,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1202.1600000000,
                        },
                        [64] = 
                        {
                            [1] = 30158,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1214.7600000000,
                        },
                        [65] = 
                        {
                            [1] = 30153,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1217.3700000000,
                        },
                        [66] = 
                        {
                            [1] = 30158,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1229.9700000000,
                        },
                        [67] = 
                        {
                            [1] = 30153,
                            [2] = 150672,
                            [3] = 30152,
                            ["Pre"] = 1466.3300000000,
                        },
                        [68] = 
                        {
                            [1] = 30166,
                            [2] = 150672,
                            [3] = 30152,
                            ["Pre"] = 1474.8200000000,
                        },
                        [69] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 139019,
                            ["Pre"] = 1945.3000000000,
                        },
                        [70] = 
                        {
                            [1] = 30158,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2258.2500000000,
                        },
                        [71] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 150731,
                            ["Pre"] = 3654.0400000000,
                        },
                        [72] = 
                        {
                            [1] = 30153,
                            [2] = 30158,
                            [3] = 150731,
                            ["Pre"] = 3658.1500000000,
                        },
                        [73] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 150731,
                            ["Pre"] = 3666.6400000000,
                        },
                        [74] = 
                        {
                            [1] = 30153,
                            [2] = 150672,
                            [3] = 150731,
                            ["Pre"] = 3966.9900000000,
                        },
                        [75] = 
                        {
                            [1] = 30158,
                            [2] = 150672,
                            [3] = 150731,
                            ["Pre"] = 3979.5900000000,
                        },
                    },
                    [1448448] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 77584,
                            [3] = 150789,
                            ["Pre"] = 344.1400000000,
                        },
                        [2] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 688.1100000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 965.7200000000,
                        },
                        [4] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 977.4800000000,
                        },
                        [5] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 977.6000000000,
                        },
                    },
                    [917760] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 30163,
                            ["Pre"] = 440.7400000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 30163,
                            ["Pre"] = 443.2800000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 30153,
                            [3] = 30163,
                            ["Pre"] = 452.2800000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 30163,
                            ["Pre"] = 464.8800000000,
                        },
                        [5] = 
                        {
                            [1] = 30155,
                            [2] = 150789,
                            [3] = 30163,
                            ["Pre"] = 533.8300000000,
                        },
                        [6] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 786.4400000000,
                        },
                        [7] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 982.3900000000,
                        },
                        [8] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1060.7200000000,
                        },
                        [9] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            [3] = 139019,
                            ["Pre"] = 2104.2100000000,
                        },
                        [10] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 30164,
                            ["Pre"] = 2237.9000000000,
                        },
                        [11] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            [3] = 150731,
                            ["Pre"] = 3825.5500000000,
                        },
                        [12] = 
                        {
                            [1] = 30155,
                            [2] = 30163,
                            [3] = 150671,
                            ["Pre"] = 7739.3100000000,
                        },
                    },
                    [399872] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 77589,
                            ["Pre"] = 593.6400000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 77589,
                            ["Pre"] = 612.4700000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 77589,
                            ["Pre"] = 617.1800000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 139020,
                            ["Pre"] = 901.9600000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 139020,
                            ["Pre"] = 906.6700000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            [3] = 139020,
                            ["Pre"] = 918.3900000000,
                        },
                    },
                    [400640] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 30156,
                            ["Pre"] = 292.6200000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 30149,
                            ["Pre"] = 297.3300000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 30151,
                            ["Pre"] = 309.0500000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 77583,
                            ["Pre"] = 379.1800000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 77583,
                            ["Pre"] = 402.7200000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            [3] = 77583,
                            ["Pre"] = 414.4400000000,
                        },
                        [7] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 77581,
                            ["Pre"] = 867.9200000000,
                        },
                        [8] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 903.1800000000,
                        },
                        [9] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 139019,
                            ["Pre"] = 1911.4100000000,
                        },
                        [10] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 139019,
                            ["Pre"] = 1930.2400000000,
                        },
                        [11] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 139019,
                            ["Pre"] = 1934.9500000000,
                        },
                        [12] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 1946.6700000000,
                        },
                    },
                    [400384] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 77590,
                            ["Pre"] = 298.7500000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 77590,
                            ["Pre"] = 317.5800000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 150672,
                            ["Pre"] = 599.7500000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 150672,
                            ["Pre"] = 604.4600000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            [3] = 150672,
                            ["Pre"] = 616.1800000000,
                        },
                    },
                    [8785408] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 30156,
                            ["Pre"] = 274.5100000000,
                        },
                        [2] = 
                        {
                            [1] = 30155,
                            [2] = 30156,
                            [3] = 30151,
                            ["Pre"] = 314.9700000000,
                        },
                    },
                    [65536] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 30155,
                            ["Pre"] = 243.4300000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 30166,
                            ["Pre"] = 260.0100000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 77585,
                            ["Pre"] = 261.5400000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 30166,
                            ["Pre"] = 265.4300000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 30158,
                            ["Pre"] = 269.3200000000,
                        },
                        [6] = 
                        {
                            [1] = 30162,
                            [2] = 30155,
                            [3] = 77585,
                            ["Pre"] = 269.5000000000,
                        },
                        [7] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 77585,
                            ["Pre"] = 271.2500000000,
                        },
                        [8] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 77585,
                            ["Pre"] = 274.8700000000,
                        },
                        [9] = 
                        {
                            [1] = 30155,
                            [2] = 30153,
                            [3] = 77585,
                            ["Pre"] = 282.7900000000,
                        },
                        [10] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 77585,
                            ["Pre"] = 283.5400000000,
                        },
                        [11] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 30156,
                            ["Pre"] = 284.0400000000,
                        },
                        [12] = 
                        {
                            [1] = 30148,
                            [2] = 30158,
                            [3] = 77585,
                            ["Pre"] = 287.4300000000,
                        },
                        [13] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 30156,
                            ["Pre"] = 289.8600000000,
                        },
                        [14] = 
                        {
                            [1] = 30166,
                            [2] = 30153,
                            [3] = 77585,
                            ["Pre"] = 295.0800000000,
                        },
                        [15] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 77585,
                            ["Pre"] = 295.3900000000,
                        },
                        [16] = 
                        {
                            [1] = 30166,
                            [2] = 30158,
                            [3] = 77585,
                            ["Pre"] = 307.6800000000,
                        },
                        [17] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 30156,
                            ["Pre"] = 310.1100000000,
                        },
                        [18] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 150789,
                            ["Pre"] = 358.5200000000,
                        },
                        [19] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 77583,
                            ["Pre"] = 376.4200000000,
                        },
                        [20] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 77583,
                            ["Pre"] = 388.7100000000,
                        },
                        [21] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 77583,
                            ["Pre"] = 396.6700000000,
                        },
                        [22] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 30163,
                            ["Pre"] = 435.3200000000,
                        },
                        [23] = 
                        {
                            [1] = 30162,
                            [2] = 30155,
                            [3] = 30163,
                            ["Pre"] = 438.9900000000,
                        },
                        [24] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 30163,
                            ["Pre"] = 444.3600000000,
                        },
                        [25] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 30163,
                            ["Pre"] = 453.0300000000,
                        },
                        [26] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 30163,
                            ["Pre"] = 455.5700000000,
                        },
                        [27] = 
                        {
                            [1] = 30148,
                            [2] = 30158,
                            [3] = 30163,
                            ["Pre"] = 456.9200000000,
                        },
                        [28] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 30163,
                            ["Pre"] = 458.8500000000,
                        },
                        [29] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 30163,
                            ["Pre"] = 463.8800000000,
                        },
                        [30] = 
                        {
                            [1] = 30153,
                            [2] = 77585,
                            [3] = 30163,
                            ["Pre"] = 470.3900000000,
                        },
                        [31] = 
                        {
                            [1] = 30159,
                            [2] = 77585,
                            [3] = 30163,
                            ["Pre"] = 470.4300000000,
                        },
                        [32] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 30163,
                            ["Pre"] = 482.9900000000,
                        },
                        [33] = 
                        {
                            [1] = 30162,
                            [2] = 30155,
                            [3] = 30160,
                            ["Pre"] = 500.5000000000,
                        },
                        [34] = 
                        {
                            [1] = 30155,
                            [2] = 30153,
                            [3] = 30160,
                            ["Pre"] = 513.7900000000,
                        },
                        [35] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 30160,
                            ["Pre"] = 517.0800000000,
                        },
                        [36] = 
                        {
                            [1] = 30148,
                            [2] = 30158,
                            [3] = 30160,
                            ["Pre"] = 518.4300000000,
                        },
                        [37] = 
                        {
                            [1] = 30162,
                            [2] = 77585,
                            [3] = 30160,
                            ["Pre"] = 518.6100000000,
                        },
                        [38] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 30160,
                            ["Pre"] = 525.3900000000,
                        },
                        [39] = 
                        {
                            [1] = 30153,
                            [2] = 77585,
                            [3] = 30160,
                            ["Pre"] = 531.9000000000,
                        },
                        [40] = 
                        {
                            [1] = 30159,
                            [2] = 77585,
                            [3] = 30160,
                            ["Pre"] = 531.9400000000,
                        },
                        [41] = 
                        {
                            [1] = 30166,
                            [2] = 30156,
                            [3] = 30160,
                            ["Pre"] = 541.1100000000,
                        },
                        [42] = 
                        {
                            [1] = 30166,
                            [2] = 150789,
                            [3] = 30163,
                            ["Pre"] = 546.1200000000,
                        },
                        [43] = 
                        {
                            [1] = 77585,
                            [2] = 30156,
                            [3] = 30160,
                            ["Pre"] = 546.9300000000,
                        },
                        [44] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 150672,
                            ["Pre"] = 568.6700000000,
                        },
                        [45] = 
                        {
                            [1] = 30162,
                            [2] = 30155,
                            [3] = 150672,
                            ["Pre"] = 576.6300000000,
                        },
                        [46] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 150672,
                            ["Pre"] = 578.3800000000,
                        },
                        [47] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 150672,
                            ["Pre"] = 582,
                        },
                        [48] = 
                        {
                            [1] = 30162,
                            [2] = 77585,
                            [3] = 150672,
                            ["Pre"] = 594.7400000000,
                        },
                        [49] = 
                        {
                            [1] = 30155,
                            [2] = 150789,
                            [3] = 30160,
                            ["Pre"] = 595.3400000000,
                        },
                        [50] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 150672,
                            ["Pre"] = 596.4900000000,
                        },
                        [51] = 
                        {
                            [1] = 30148,
                            [2] = 30156,
                            [3] = 150672,
                            ["Pre"] = 596.9900000000,
                        },
                        [52] = 
                        {
                            [1] = 77584,
                            [2] = 77585,
                            [3] = 150672,
                            ["Pre"] = 607.3400000000,
                        },
                        [53] = 
                        {
                            [1] = 30166,
                            [2] = 150789,
                            [3] = 30160,
                            ["Pre"] = 607.6300000000,
                        },
                        [54] = 
                        {
                            [1] = 30153,
                            [2] = 77585,
                            [3] = 150672,
                            ["Pre"] = 608.0300000000,
                        },
                        [55] = 
                        {
                            [1] = 30159,
                            [2] = 77585,
                            [3] = 150672,
                            ["Pre"] = 608.0700000000,
                        },
                        [56] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 77589,
                            ["Pre"] = 611.1300000000,
                        },
                        [57] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 150672,
                            ["Pre"] = 620.6300000000,
                        },
                        [58] = 
                        {
                            [1] = 77585,
                            [2] = 30156,
                            [3] = 150672,
                            ["Pre"] = 623.0600000000,
                        },
                        [59] = 
                        {
                            [1] = 30155,
                            [2] = 77583,
                            [3] = 30160,
                            ["Pre"] = 633.4900000000,
                        },
                        [60] = 
                        {
                            [1] = 30166,
                            [2] = 77583,
                            [3] = 30160,
                            ["Pre"] = 645.7800000000,
                        },
                        [61] = 
                        {
                            [1] = 30155,
                            [2] = 150789,
                            [3] = 150672,
                            ["Pre"] = 671.4700000000,
                        },
                        [62] = 
                        {
                            [1] = 77587,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 692.3900000000,
                        },
                        [63] = 
                        {
                            [1] = 77584,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 700.7000000000,
                        },
                        [64] = 
                        {
                            [1] = 30153,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 701.3900000000,
                        },
                        [65] = 
                        {
                            [1] = 30159,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 701.4300000000,
                        },
                        [66] = 
                        {
                            [1] = 30148,
                            [2] = 77583,
                            [3] = 150672,
                            ["Pre"] = 701.6600000000,
                        },
                        [67] = 
                        {
                            [1] = 30155,
                            [2] = 77583,
                            [3] = 150672,
                            ["Pre"] = 709.6200000000,
                        },
                        [68] = 
                        {
                            [1] = 30154,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 765.9800000000,
                        },
                        [69] = 
                        {
                            [1] = 77584,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 776.8300000000,
                        },
                        [70] = 
                        {
                            [1] = 30159,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 777.5600000000,
                        },
                        [71] = 
                        {
                            [1] = 150789,
                            [2] = 30163,
                            [3] = 30160,
                            ["Pre"] = 782.9400000000,
                        },
                        [72] = 
                        {
                            [1] = 30166,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 798.7300000000,
                        },
                        [73] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 150669,
                            ["Pre"] = 807.0800000000,
                        },
                        [74] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 77591,
                            ["Pre"] = 808.0900000000,
                        },
                        [75] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 150669,
                            ["Pre"] = 812.9000000000,
                        },
                        [76] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 77591,
                            ["Pre"] = 820.3800000000,
                        },
                        [77] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 150669,
                            ["Pre"] = 825.1900000000,
                        },
                        [78] = 
                        {
                            [1] = 30162,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 825.7400000000,
                        },
                        [79] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 77591,
                            ["Pre"] = 826.2000000000,
                        },
                        [80] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 77591,
                            ["Pre"] = 828.3400000000,
                        },
                        [81] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 77591,
                            ["Pre"] = 834.1600000000,
                        },
                        [82] = 
                        {
                            [1] = 77584,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 838.3400000000,
                        },
                        [83] = 
                        {
                            [1] = 30159,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 839.0700000000,
                        },
                        [84] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 77591,
                            ["Pre"] = 846.4500000000,
                        },
                        [85] = 
                        {
                            [1] = 30155,
                            [2] = 30160,
                            [3] = 77589,
                            ["Pre"] = 847.9500000000,
                        },
                        [86] = 
                        {
                            [1] = 30156,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 854.0600000000,
                        },
                        [87] = 
                        {
                            [1] = 150789,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 859.0700000000,
                        },
                        [88] = 
                        {
                            [1] = 30166,
                            [2] = 30160,
                            [3] = 77589,
                            ["Pre"] = 860.2400000000,
                        },
                        [89] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 77581,
                            ["Pre"] = 865.1600000000,
                        },
                        [90] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 77581,
                            ["Pre"] = 877.4500000000,
                        },
                        [91] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 77581,
                            ["Pre"] = 885.4100000000,
                        },
                        [92] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 139020,
                            ["Pre"] = 892.6600000000,
                        },
                        [93] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 139020,
                            ["Pre"] = 898.4800000000,
                        },
                        [94] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 139020,
                            ["Pre"] = 918.7300000000,
                        },
                        [95] = 
                        {
                            [1] = 150789,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 920.5800000000,
                        },
                        [96] = 
                        {
                            [1] = 30155,
                            [2] = 77589,
                            [3] = 150672,
                            ["Pre"] = 924.0800000000,
                        },
                        [97] = 
                        {
                            [1] = 77585,
                            [2] = 77589,
                            [3] = 150672,
                            ["Pre"] = 942.1900000000,
                        },
                        [98] = 
                        {
                            [1] = 77583,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 958.7300000000,
                        },
                        [99] = 
                        {
                            [1] = 30163,
                            [2] = 30160,
                            [3] = 77589,
                            ["Pre"] = 1035.5500000000,
                        },
                        [100] = 
                        {
                            [1] = 30155,
                            [2] = 30160,
                            [3] = 150669,
                            ["Pre"] = 1043.9000000000,
                        },
                        [101] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1052.7600000000,
                        },
                        [102] = 
                        {
                            [1] = 30166,
                            [2] = 30160,
                            [3] = 150669,
                            ["Pre"] = 1056.1900000000,
                        },
                        [103] = 
                        {
                            [1] = 77585,
                            [2] = 30160,
                            [3] = 150669,
                            ["Pre"] = 1062.0100000000,
                        },
                        [104] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1067.9700000000,
                        },
                        [105] = 
                        {
                            [1] = 30166,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1073.0100000000,
                        },
                        [106] = 
                        {
                            [1] = 30166,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1088.2200000000,
                        },
                        [107] = 
                        {
                            [1] = 77585,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1094.0400000000,
                        },
                        [108] = 
                        {
                            [1] = 30163,
                            [2] = 77589,
                            [3] = 150672,
                            ["Pre"] = 1111.6800000000,
                        },
                        [109] = 
                        {
                            [1] = 30155,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1122.2300000000,
                        },
                        [110] = 
                        {
                            [1] = 30148,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1133.3300000000,
                        },
                        [111] = 
                        {
                            [1] = 30166,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1134.5200000000,
                        },
                        [112] = 
                        {
                            [1] = 30155,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1141.2900000000,
                        },
                        [113] = 
                        {
                            [1] = 77585,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1159.4000000000,
                        },
                        [114] = 
                        {
                            [1] = 30160,
                            [2] = 77589,
                            [3] = 150672,
                            ["Pre"] = 1173.1900000000,
                        },
                        [115] = 
                        {
                            [1] = 30148,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1190.4000000000,
                        },
                        [116] = 
                        {
                            [1] = 30155,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1198.3600000000,
                        },
                        [117] = 
                        {
                            [1] = 30148,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1205.6100000000,
                        },
                        [118] = 
                        {
                            [1] = 77585,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1231.6800000000,
                        },
                        [119] = 
                        {
                            [1] = 30163,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1309.8300000000,
                        },
                        [120] = 
                        {
                            [1] = 30163,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1385.9600000000,
                        },
                        [121] = 
                        {
                            [1] = 30163,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1401.1700000000,
                        },
                        [122] = 
                        {
                            [1] = 30160,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1447.4700000000,
                        },
                        [123] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 139019,
                            ["Pre"] = 1908.6500000000,
                        },
                        [124] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 139019,
                            ["Pre"] = 1920.9400000000,
                        },
                        [125] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 139019,
                            ["Pre"] = 1928.9000000000,
                        },
                        [126] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            [3] = 139019,
                            ["Pre"] = 2096.2500000000,
                        },
                        [127] = 
                        {
                            [1] = 30166,
                            [2] = 30163,
                            [3] = 139019,
                            ["Pre"] = 2116.5000000000,
                        },
                        [128] = 
                        {
                            [1] = 30155,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2165.7200000000,
                        },
                        [129] = 
                        {
                            [1] = 30166,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2178.0100000000,
                        },
                        [130] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 30164,
                            ["Pre"] = 2205.9100000000,
                        },
                        [131] = 
                        {
                            [1] = 30162,
                            [2] = 30155,
                            [3] = 30164,
                            ["Pre"] = 2209.5800000000,
                        },
                        [132] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 30164,
                            ["Pre"] = 2211.3300000000,
                        },
                        [133] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 30164,
                            ["Pre"] = 2213.8700000000,
                        },
                        [134] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 30164,
                            ["Pre"] = 2223.6200000000,
                        },
                        [135] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 30164,
                            ["Pre"] = 2226.1600000000,
                        },
                        [136] = 
                        {
                            [1] = 30148,
                            [2] = 30158,
                            [3] = 30164,
                            ["Pre"] = 2227.5100000000,
                        },
                        [137] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 30164,
                            ["Pre"] = 2229.4400000000,
                        },
                        [138] = 
                        {
                            [1] = 30148,
                            [2] = 30156,
                            [3] = 30164,
                            ["Pre"] = 2229.9400000000,
                        },
                        [139] = 
                        {
                            [1] = 30148,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2233.8900000000,
                        },
                        [140] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 30164,
                            ["Pre"] = 2234.4700000000,
                        },
                        [141] = 
                        {
                            [1] = 30155,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2241.8500000000,
                        },
                        [142] = 
                        {
                            [1] = 30166,
                            [2] = 30156,
                            [3] = 30164,
                            ["Pre"] = 2250.1900000000,
                        },
                        [143] = 
                        {
                            [1] = 77585,
                            [2] = 30156,
                            [3] = 30164,
                            ["Pre"] = 2256.0100000000,
                        },
                        [144] = 
                        {
                            [1] = 30155,
                            [2] = 150789,
                            [3] = 30164,
                            ["Pre"] = 2304.4200000000,
                        },
                        [145] = 
                        {
                            [1] = 30166,
                            [2] = 150789,
                            [3] = 30164,
                            ["Pre"] = 2316.7100000000,
                        },
                        [146] = 
                        {
                            [1] = 30148,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2334.6100000000,
                        },
                        [147] = 
                        {
                            [1] = 30155,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2342.5700000000,
                        },
                        [148] = 
                        {
                            [1] = 30163,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2353.3200000000,
                        },
                        [149] = 
                        {
                            [1] = 30166,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2354.8600000000,
                        },
                        [150] = 
                        {
                            [1] = 77587,
                            [2] = 30163,
                            [3] = 30164,
                            ["Pre"] = 2401.4700000000,
                        },
                        [151] = 
                        {
                            [1] = 30163,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2429.4500000000,
                        },
                        [152] = 
                        {
                            [1] = 30160,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2490.9600000000,
                        },
                        [153] = 
                        {
                            [1] = 30154,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2536.5700000000,
                        },
                        [154] = 
                        {
                            [1] = 77584,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2547.4200000000,
                        },
                        [155] = 
                        {
                            [1] = 30148,
                            [2] = 77589,
                            [3] = 30164,
                            ["Pre"] = 2549.0700000000,
                        },
                        [156] = 
                        {
                            [1] = 30155,
                            [2] = 77589,
                            [3] = 30164,
                            ["Pre"] = 2557.0300000000,
                        },
                        [157] = 
                        {
                            [1] = 30156,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2563.1400000000,
                        },
                        [158] = 
                        {
                            [1] = 30166,
                            [2] = 77589,
                            [3] = 30164,
                            ["Pre"] = 2569.3200000000,
                        },
                        [159] = 
                        {
                            [1] = 150789,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2629.6600000000,
                        },
                        [160] = 
                        {
                            [1] = 77583,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2667.8100000000,
                        },
                        [161] = 
                        {
                            [1] = 30155,
                            [2] = 150669,
                            [3] = 30164,
                            ["Pre"] = 2752.9800000000,
                        },
                        [162] = 
                        {
                            [1] = 30148,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2766.2800000000,
                        },
                        [163] = 
                        {
                            [1] = 30155,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2774.2400000000,
                        },
                        [164] = 
                        {
                            [1] = 30166,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2786.5300000000,
                        },
                        [165] = 
                        {
                            [1] = 77585,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2792.3500000000,
                        },
                        [166] = 
                        {
                            [1] = 30160,
                            [2] = 77589,
                            [3] = 30164,
                            ["Pre"] = 2806.1400000000,
                        },
                        [167] = 
                        {
                            [1] = 30148,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2823.3500000000,
                        },
                        [168] = 
                        {
                            [1] = 30155,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2831.3100000000,
                        },
                        [169] = 
                        {
                            [1] = 30148,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2838.5600000000,
                        },
                        [170] = 
                        {
                            [1] = 30166,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2843.6000000000,
                        },
                        [171] = 
                        {
                            [1] = 30166,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2858.8100000000,
                        },
                        [172] = 
                        {
                            [1] = 77585,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2864.6300000000,
                        },
                        [173] = 
                        {
                            [1] = 77589,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2882.2700000000,
                        },
                        [174] = 
                        {
                            [1] = 150672,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 3099.4800000000,
                        },
                        [175] = 
                        {
                            [1] = 150672,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 3156.5500000000,
                        },
                        [176] = 
                        {
                            [1] = 150672,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 3171.7600000000,
                        },
                        [177] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 150731,
                            ["Pre"] = 3629.9900000000,
                        },
                        [178] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 150731,
                            ["Pre"] = 3642.2800000000,
                        },
                        [179] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 150731,
                            ["Pre"] = 3650.2400000000,
                        },
                        [180] = 
                        {
                            [1] = 30148,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3866.8400000000,
                        },
                        [181] = 
                        {
                            [1] = 30155,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3874.8000000000,
                        },
                        [182] = 
                        {
                            [1] = 30155,
                            [2] = 30160,
                            [3] = 150731,
                            ["Pre"] = 3887.0600000000,
                        },
                        [183] = 
                        {
                            [1] = 30166,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3887.0900000000,
                        },
                        [184] = 
                        {
                            [1] = 30166,
                            [2] = 30160,
                            [3] = 150731,
                            ["Pre"] = 3899.3500000000,
                        },
                        [185] = 
                        {
                            [1] = 30148,
                            [2] = 150672,
                            [3] = 150731,
                            ["Pre"] = 3955.2300000000,
                        },
                        [186] = 
                        {
                            [1] = 30155,
                            [2] = 150672,
                            [3] = 150731,
                            ["Pre"] = 3963.1900000000,
                        },
                        [187] = 
                        {
                            [1] = 77585,
                            [2] = 150672,
                            [3] = 150731,
                            ["Pre"] = 3981.3000000000,
                        },
                        [188] = 
                        {
                            [1] = 150672,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 4200.0400000000,
                        },
                        [189] = 
                        {
                            [1] = 30160,
                            [2] = 150672,
                            [3] = 150731,
                            ["Pre"] = 4212.3000000000,
                        },
                        [190] = 
                        {
                            [1] = 30155,
                            [2] = 30164,
                            [3] = 150731,
                            ["Pre"] = 5596.1400000000,
                        },
                        [191] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 150671,
                            ["Pre"] = 7543.7500000000,
                        },
                        [192] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 150671,
                            ["Pre"] = 7556.0400000000,
                        },
                        [193] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 150671,
                            ["Pre"] = 7561.8600000000,
                        },
                        [194] = 
                        {
                            [1] = 30155,
                            [2] = 30166,
                            [3] = 150671,
                            ["Pre"] = 7564,
                        },
                        [195] = 
                        {
                            [1] = 30155,
                            [2] = 77585,
                            [3] = 150671,
                            ["Pre"] = 7569.8200000000,
                        },
                        [196] = 
                        {
                            [1] = 30166,
                            [2] = 77585,
                            [3] = 150671,
                            ["Pre"] = 7582.1100000000,
                        },
                        [197] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            [3] = 150671,
                            ["Pre"] = 7731.3500000000,
                        },
                        [198] = 
                        {
                            [1] = 30166,
                            [2] = 30163,
                            [3] = 150671,
                            ["Pre"] = 7751.6000000000,
                        },
                        [199] = 
                        {
                            [1] = 77585,
                            [2] = 30163,
                            [3] = 150671,
                            ["Pre"] = 7757.4200000000,
                        },
                        [200] = 
                        {
                            [1] = 30148,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 7868.9900000000,
                        },
                        [201] = 
                        {
                            [1] = 30155,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 7876.9500000000,
                        },
                        [202] = 
                        {
                            [1] = 77585,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 7895.0600000000,
                        },
                        [203] = 
                        {
                            [1] = 30163,
                            [2] = 150672,
                            [3] = 150671,
                            ["Pre"] = 8064.5500000000,
                        },
                        [204] = 
                        {
                            [1] = 30148,
                            [2] = 30164,
                            [3] = 150671,
                            ["Pre"] = 9501.9400000000,
                        },
                    },
                    [8781824] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 30149,
                            ["Pre"] = 279.2200000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 30151,
                            ["Pre"] = 290.9400000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30149,
                            [3] = 30156,
                            ["Pre"] = 298.0500000000,
                        },
                        [4] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 30156,
                            ["Pre"] = 303.2500000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30156,
                            [3] = 30151,
                            ["Pre"] = 309.7700000000,
                        },
                        [6] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 30151,
                            ["Pre"] = 319.6800000000,
                        },
                    },
                    [1579520] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 77584,
                            [3] = 139020,
                            ["Pre"] = 886.2400000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 139020,
                            ["Pre"] = 886.9700000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 973.6800000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 977.5200000000,
                        },
                    },
                    [1245184] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 30153,
                            ["Pre"] = 260.5600000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 30153,
                            ["Pre"] = 260.7800000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 30153,
                            ["Pre"] = 263.3200000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 30153,
                            ["Pre"] = 268.5200000000,
                        },
                        [5] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 30153,
                            ["Pre"] = 271.6300000000,
                        },
                        [6] = 
                        {
                            [1] = 30159,
                            [2] = 30165,
                            [3] = 30153,
                            ["Pre"] = 272.4400000000,
                        },
                        [7] = 
                        {
                            [1] = 30159,
                            [2] = 30157,
                            [3] = 30153,
                            ["Pre"] = 277.4400000000,
                        },
                        [8] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 77585,
                            ["Pre"] = 286.6300000000,
                        },
                        [9] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 30156,
                            ["Pre"] = 287.3500000000,
                        },
                        [10] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 30149,
                            ["Pre"] = 292.0600000000,
                        },
                        [11] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 77590,
                            ["Pre"] = 311.5900000000,
                        },
                        [12] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 30161,
                            ["Pre"] = 344.2400000000,
                        },
                        [13] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 150789,
                            ["Pre"] = 353.8700000000,
                        },
                        [14] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 77583,
                            ["Pre"] = 392.0200000000,
                        },
                        [15] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 30163,
                            ["Pre"] = 456.1200000000,
                        },
                        [16] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 30160,
                            ["Pre"] = 517.6300000000,
                        },
                        [17] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 77589,
                            ["Pre"] = 606.4800000000,
                        },
                        [18] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 150670,
                            ["Pre"] = 642.0700000000,
                        },
                        [19] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 150669,
                            ["Pre"] = 802.4300000000,
                        },
                        [20] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 77591,
                            ["Pre"] = 823.6900000000,
                        },
                        [21] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 77581,
                            ["Pre"] = 880.7600000000,
                        },
                        [22] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 139020,
                            ["Pre"] = 895.9700000000,
                        },
                        [23] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 30152,
                            ["Pre"] = 1144.9300000000,
                        },
                        [24] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 139019,
                            ["Pre"] = 1924.2500000000,
                        },
                        [25] = 
                        {
                            [1] = 30154,
                            [2] = 30153,
                            [3] = 30164,
                            ["Pre"] = 2215.1300000000,
                        },
                        [26] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 30164,
                            ["Pre"] = 2217.6700000000,
                        },
                        [27] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 30164,
                            ["Pre"] = 2217.7100000000,
                        },
                        [28] = 
                        {
                            [1] = 30159,
                            [2] = 30165,
                            [3] = 30164,
                            ["Pre"] = 2226.8300000000,
                        },
                        [29] = 
                        {
                            [1] = 30153,
                            [2] = 30156,
                            [3] = 30164,
                            ["Pre"] = 2241.7000000000,
                        },
                        [30] = 
                        {
                            [1] = 30159,
                            [2] = 30156,
                            [3] = 30164,
                            ["Pre"] = 2241.7400000000,
                        },
                        [31] = 
                        {
                            [1] = 30153,
                            [2] = 30149,
                            [3] = 30164,
                            ["Pre"] = 2246.4100000000,
                        },
                        [32] = 
                        {
                            [1] = 30159,
                            [2] = 30149,
                            [3] = 30164,
                            ["Pre"] = 2246.4500000000,
                        },
                        [33] = 
                        {
                            [1] = 30153,
                            [2] = 77590,
                            [3] = 30164,
                            ["Pre"] = 2265.9400000000,
                        },
                        [34] = 
                        {
                            [1] = 30159,
                            [2] = 77590,
                            [3] = 30164,
                            ["Pre"] = 2265.9800000000,
                        },
                        [35] = 
                        {
                            [1] = 30159,
                            [2] = 150789,
                            [3] = 30164,
                            ["Pre"] = 2308.2600000000,
                        },
                        [36] = 
                        {
                            [1] = 30153,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2346.3700000000,
                        },
                        [37] = 
                        {
                            [1] = 30159,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2346.4100000000,
                        },
                        [38] = 
                        {
                            [1] = 30159,
                            [2] = 77589,
                            [3] = 30164,
                            ["Pre"] = 2560.8700000000,
                        },
                        [39] = 
                        {
                            [1] = 30153,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2778.0400000000,
                        },
                        [40] = 
                        {
                            [1] = 30159,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2778.0800000000,
                        },
                        [41] = 
                        {
                            [1] = 30153,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2835.1100000000,
                        },
                        [42] = 
                        {
                            [1] = 30153,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2850.3200000000,
                        },
                        [43] = 
                        {
                            [1] = 30153,
                            [2] = 30152,
                            [3] = 30164,
                            ["Pre"] = 3099.2800000000,
                        },
                        [44] = 
                        {
                            [1] = 30159,
                            [2] = 30152,
                            [3] = 30164,
                            ["Pre"] = 3099.3200000000,
                        },
                        [45] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 150731,
                            ["Pre"] = 3645.5900000000,
                        },
                        [46] = 
                        {
                            [1] = 30159,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3878.6400000000,
                        },
                        [47] = 
                        {
                            [1] = 30159,
                            [2] = 30153,
                            [3] = 150671,
                            ["Pre"] = 7559.3500000000,
                        },
                    },
                    [1572864] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30155,
                            [3] = 77584,
                            ["Pre"] = 254.5000000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 77584,
                            ["Pre"] = 256.2500000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 77584,
                            ["Pre"] = 259.8700000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 77584,
                            ["Pre"] = 260.0900000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 77584,
                            ["Pre"] = 262.6300000000,
                        },
                        [6] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 30165,
                            ["Pre"] = 268.6400000000,
                        },
                        [7] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 30165,
                            ["Pre"] = 271.7500000000,
                        },
                        [8] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 30158,
                            ["Pre"] = 280.3900000000,
                        },
                        [9] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 30158,
                            ["Pre"] = 281.1200000000,
                        },
                        [10] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 30158,
                            ["Pre"] = 284.2300000000,
                        },
                        [11] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 30156,
                            ["Pre"] = 286.6600000000,
                        },
                        [12] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 30149,
                            ["Pre"] = 291.3700000000,
                        },
                        [13] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 30151,
                            ["Pre"] = 303.0900000000,
                        },
                        [14] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 77590,
                            ["Pre"] = 307.7900000000,
                        },
                        [15] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 30161,
                            ["Pre"] = 339.7100000000,
                        },
                        [16] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 30161,
                            ["Pre"] = 343.5500000000,
                        },
                        [17] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 150789,
                            ["Pre"] = 350.0700000000,
                        },
                        [18] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 150789,
                            ["Pre"] = 353.1800000000,
                        },
                        [19] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 77583,
                            ["Pre"] = 387.4900000000,
                        },
                        [20] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 77583,
                            ["Pre"] = 388.2200000000,
                        },
                        [21] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 77583,
                            ["Pre"] = 391.3300000000,
                        },
                        [22] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 30163,
                            ["Pre"] = 455.4300000000,
                        },
                        [23] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 30160,
                            ["Pre"] = 516.9400000000,
                        },
                        [24] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 150672,
                            ["Pre"] = 593.0700000000,
                        },
                        [25] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 150670,
                            ["Pre"] = 637.5400000000,
                        },
                        [26] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 150670,
                            ["Pre"] = 638.2700000000,
                        },
                        [27] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 150670,
                            ["Pre"] = 641.3800000000,
                        },
                        [28] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 150669,
                            ["Pre"] = 797.9000000000,
                        },
                        [29] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 150669,
                            ["Pre"] = 801.7400000000,
                        },
                        [30] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 77591,
                            ["Pre"] = 819.8900000000,
                        },
                        [31] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 77581,
                            ["Pre"] = 876.2300000000,
                        },
                        [32] = 
                        {
                            [1] = 30162,
                            [2] = 30155,
                            [3] = 139020,
                            ["Pre"] = 878.8400000000,
                        },
                        [33] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 77581,
                            ["Pre"] = 880.0700000000,
                        },
                        [34] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 139020,
                            ["Pre"] = 884.2100000000,
                        },
                        [35] = 
                        {
                            [1] = 30155,
                            [2] = 30165,
                            [3] = 139020,
                            ["Pre"] = 892.2500000000,
                        },
                        [36] = 
                        {
                            [1] = 30159,
                            [2] = 30165,
                            [3] = 139020,
                            ["Pre"] = 896.0900000000,
                        },
                        [37] = 
                        {
                            [1] = 30155,
                            [2] = 30158,
                            [3] = 139020,
                            ["Pre"] = 904.7300000000,
                        },
                        [38] = 
                        {
                            [1] = 30159,
                            [2] = 30158,
                            [3] = 139020,
                            ["Pre"] = 908.5700000000,
                        },
                        [39] = 
                        {
                            [1] = 30159,
                            [2] = 77585,
                            [3] = 139020,
                            ["Pre"] = 910.2800000000,
                        },
                        [40] = 
                        {
                            [1] = 30159,
                            [2] = 30156,
                            [3] = 139020,
                            ["Pre"] = 911,
                        },
                        [41] = 
                        {
                            [1] = 30159,
                            [2] = 30149,
                            [3] = 139020,
                            ["Pre"] = 915.7100000000,
                        },
                        [42] = 
                        {
                            [1] = 30159,
                            [2] = 30151,
                            [3] = 139020,
                            ["Pre"] = 927.4300000000,
                        },
                        [43] = 
                        {
                            [1] = 30155,
                            [2] = 30161,
                            [3] = 139020,
                            ["Pre"] = 964.0500000000,
                        },
                        [44] = 
                        {
                            [1] = 30155,
                            [2] = 77583,
                            [3] = 139020,
                            ["Pre"] = 1011.8300000000,
                        },
                        [45] = 
                        {
                            [1] = 77584,
                            [2] = 77583,
                            [3] = 139020,
                            ["Pre"] = 1014.9400000000,
                        },
                        [46] = 
                        {
                            [1] = 30159,
                            [2] = 77583,
                            [3] = 139020,
                            ["Pre"] = 1015.6700000000,
                        },
                        [47] = 
                        {
                            [1] = 30159,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1079.7700000000,
                        },
                        [48] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 30152,
                            ["Pre"] = 1140.4000000000,
                        },
                        [49] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 30152,
                            ["Pre"] = 1141.1300000000,
                        },
                        [50] = 
                        {
                            [1] = 30159,
                            [2] = 77584,
                            [3] = 30152,
                            ["Pre"] = 1144.2400000000,
                        },
                        [51] = 
                        {
                            [1] = 30159,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1217.4100000000,
                        },
                        [52] = 
                        {
                            [1] = 30155,
                            [2] = 150670,
                            [3] = 139020,
                            ["Pre"] = 1261.8800000000,
                        },
                        [53] = 
                        {
                            [1] = 30159,
                            [2] = 150670,
                            [3] = 139020,
                            ["Pre"] = 1265.7200000000,
                        },
                        [54] = 
                        {
                            [1] = 30155,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1422.2400000000,
                        },
                        [55] = 
                        {
                            [1] = 30155,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 1500.5700000000,
                        },
                        [56] = 
                        {
                            [1] = 77584,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 1503.6800000000,
                        },
                        [57] = 
                        {
                            [1] = 30155,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1764.7400000000,
                        },
                        [58] = 
                        {
                            [1] = 30159,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1768.5800000000,
                        },
                        [59] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 150731,
                            ["Pre"] = 3641.7900000000,
                        },
                    },
                    [399360] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30155,
                            [3] = 77584,
                            ["Pre"] = 258.7900000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 30155,
                            ["Pre"] = 259.5200000000,
                        },
                        [3] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 30149,
                            ["Pre"] = 287.5300000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 30149,
                            ["Pre"] = 288.2600000000,
                        },
                        [5] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 30151,
                            ["Pre"] = 299.2500000000,
                        },
                        [6] = 
                        {
                            [1] = 30159,
                            [2] = 30155,
                            [3] = 30151,
                            ["Pre"] = 299.9800000000,
                        },
                        [7] = 
                        {
                            [1] = 30155,
                            [2] = 30149,
                            [3] = 139020,
                            ["Pre"] = 911.8700000000,
                        },
                        [8] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 139020,
                            ["Pre"] = 923.5900000000,
                        },
                    },
                    [267520] = 
                    {
                        [1] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 30151,
                            ["Pre"] = 292.2400000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 77589,
                            ["Pre"] = 594.9400000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 150669,
                            ["Pre"] = 781.8500000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 150669,
                            ["Pre"] = 787.0500000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 150669,
                            ["Pre"] = 799.3400000000,
                        },
                        [6] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 150669,
                            ["Pre"] = 805.1600000000,
                        },
                        [7] = 
                        {
                            [1] = 30154,
                            [2] = 30156,
                            [3] = 150669,
                            ["Pre"] = 805.8800000000,
                        },
                        [8] = 
                        {
                            [1] = 30154,
                            [2] = 30149,
                            [3] = 150669,
                            ["Pre"] = 810.5900000000,
                        },
                        [9] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 150669,
                            ["Pre"] = 830.1200000000,
                        },
                        [10] = 
                        {
                            [1] = 30159,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 833.8900000000,
                        },
                        [11] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 900.6400000000,
                        },
                        [12] = 
                        {
                            [1] = 30154,
                            [2] = 77583,
                            [3] = 150669,
                            ["Pre"] = 910.5500000000,
                        },
                        [13] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 30152,
                            ["Pre"] = 1133.3900000000,
                        },
                        [14] = 
                        {
                            [1] = 30159,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1136.5900000000,
                        },
                        [15] = 
                        {
                            [1] = 30154,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1203.3400000000,
                        },
                        [16] = 
                        {
                            [1] = 30151,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1442.2900000000,
                        },
                        [17] = 
                        {
                            [1] = 30159,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1675.0400000000,
                        },
                        [18] = 
                        {
                            [1] = 30154,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1741.7900000000,
                        },
                        [19] = 
                        {
                            [1] = 77589,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1744.9900000000,
                        },
                        [20] = 
                        {
                            [1] = 77581,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 2283.4400000000,
                        },
                        [21] = 
                        {
                            [1] = 30154,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2442.7800000000,
                        },
                    },
                    [465408] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 139020,
                            ["Pre"] = 875.3900000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 965.9400000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1132.2400000000,
                        },
                        [4] = 
                        {
                            [1] = 150789,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1222.7900000000,
                        },
                        [5] = 
                        {
                            [1] = 30160,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1475.4000000000,
                        },
                    },
                    [1383680] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 77581,
                            ["Pre"] = 860.1800000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 77581,
                            ["Pre"] = 871.7600000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 77581,
                            ["Pre"] = 883.4900000000,
                        },
                        [4] = 
                        {
                            [1] = 30159,
                            [2] = 77585,
                            [3] = 77581,
                            ["Pre"] = 895.0700000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 943.6400000000,
                        },
                        [6] = 
                        {
                            [1] = 77585,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 966.9500000000,
                        },
                        [7] = 
                        {
                            [1] = 30154,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 988.8800000000,
                        },
                        [8] = 
                        {
                            [1] = 30159,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 1000.4600000000,
                        },
                        [9] = 
                        {
                            [1] = 30161,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 1072.3400000000,
                        },
                        [10] = 
                        {
                            [1] = 77587,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1401.8300000000,
                        },
                        [11] = 
                        {
                            [1] = 77585,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1425.1400000000,
                        },
                        [12] = 
                        {
                            [1] = 77583,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1530.5300000000,
                        },
                        [13] = 
                        {
                            [1] = 30154,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2521.1100000000,
                        },
                        [14] = 
                        {
                            [1] = 30159,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2532.6900000000,
                        },
                        [15] = 
                        {
                            [1] = 30161,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2604.5700000000,
                        },
                        [16] = 
                        {
                            [1] = 77581,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 3062.7600000000,
                        },
                    },
                    [458752] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 77591,
                            ["Pre"] = 798.8200000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 77591,
                            ["Pre"] = 803.1100000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 77591,
                            ["Pre"] = 808.3100000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 30153,
                            [3] = 77591,
                            ["Pre"] = 812.1100000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 77591,
                            ["Pre"] = 812.2300000000,
                        },
                        [6] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 77591,
                            ["Pre"] = 817.2300000000,
                        },
                        [7] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 77591,
                            ["Pre"] = 820.6000000000,
                        },
                        [8] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 77591,
                            ["Pre"] = 826.4200000000,
                        },
                        [9] = 
                        {
                            [1] = 30154,
                            [2] = 30149,
                            [3] = 77591,
                            ["Pre"] = 831.8500000000,
                        },
                        [10] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 139020,
                            ["Pre"] = 871.1000000000,
                        },
                        [11] = 
                        {
                            [1] = 30154,
                            [2] = 30153,
                            [3] = 139020,
                            ["Pre"] = 884.3900000000,
                        },
                        [12] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 139020,
                            ["Pre"] = 884.5100000000,
                        },
                        [13] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 139020,
                            ["Pre"] = 889.5100000000,
                        },
                        [14] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 139020,
                            ["Pre"] = 892.8800000000,
                        },
                        [15] = 
                        {
                            [1] = 30154,
                            [2] = 150789,
                            [3] = 77591,
                            ["Pre"] = 893.6600000000,
                        },
                        [16] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 139020,
                            ["Pre"] = 898.7000000000,
                        },
                        [17] = 
                        {
                            [1] = 30154,
                            [2] = 30156,
                            [3] = 139020,
                            ["Pre"] = 899.4200000000,
                        },
                        [18] = 
                        {
                            [1] = 30154,
                            [2] = 30149,
                            [3] = 139020,
                            ["Pre"] = 904.1300000000,
                        },
                        [19] = 
                        {
                            [1] = 30162,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1055.6700000000,
                        },
                        [20] = 
                        {
                            [1] = 77587,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1059.9600000000,
                        },
                        [21] = 
                        {
                            [1] = 30154,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1068.1900000000,
                        },
                        [22] = 
                        {
                            [1] = 30153,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1068.9600000000,
                        },
                        [23] = 
                        {
                            [1] = 30159,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1069,
                        },
                        [24] = 
                        {
                            [1] = 30165,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1069.0800000000,
                        },
                        [25] = 
                        {
                            [1] = 30157,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1074.0800000000,
                        },
                        [26] = 
                        {
                            [1] = 30149,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1088.7000000000,
                        },
                        [27] = 
                        {
                            [1] = 30151,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1100.4200000000,
                        },
                        [28] = 
                        {
                            [1] = 30162,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1127.9500000000,
                        },
                        [29] = 
                        {
                            [1] = 30154,
                            [2] = 150672,
                            [3] = 77591,
                            ["Pre"] = 1133.5500000000,
                        },
                        [30] = 
                        {
                            [1] = 30153,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1141.2400000000,
                        },
                        [31] = 
                        {
                            [1] = 30165,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1141.3600000000,
                        },
                        [32] = 
                        {
                            [1] = 30157,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1146.3600000000,
                        },
                        [33] = 
                        {
                            [1] = 150789,
                            [2] = 30160,
                            [3] = 77591,
                            ["Pre"] = 1150.5100000000,
                        },
                        [34] = 
                        {
                            [1] = 30156,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1156.2700000000,
                        },
                        [35] = 
                        {
                            [1] = 30149,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1160.9800000000,
                        },
                        [36] = 
                        {
                            [1] = 30151,
                            [2] = 30160,
                            [3] = 139020,
                            ["Pre"] = 1172.7000000000,
                        },
                        [37] = 
                        {
                            [1] = 30154,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1205.8300000000,
                        },
                        [38] = 
                        {
                            [1] = 30154,
                            [2] = 150670,
                            [3] = 139020,
                            ["Pre"] = 1254.1400000000,
                        },
                        [39] = 
                        {
                            [1] = 30160,
                            [2] = 77589,
                            [3] = 77591,
                            ["Pre"] = 1403.1200000000,
                        },
                        [40] = 
                        {
                            [1] = 77587,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1438.3000000000,
                        },
                        [41] = 
                        {
                            [1] = 77585,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1461.6100000000,
                        },
                        [42] = 
                        {
                            [1] = 150789,
                            [2] = 77591,
                            [3] = 139020,
                            ["Pre"] = 1528.8500000000,
                        },
                        [43] = 
                        {
                            [1] = 30160,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1599.0700000000,
                        },
                        [44] = 
                        {
                            [1] = 30160,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1671.3500000000,
                        },
                        [45] = 
                        {
                            [1] = 30160,
                            [2] = 77591,
                            [3] = 77581,
                            ["Pre"] = 1677.4000000000,
                        },
                        [46] = 
                        {
                            [1] = 30160,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 1749.6800000000,
                        },
                        [47] = 
                        {
                            [1] = 77591,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 2055.7400000000,
                        },
                        [48] = 
                        {
                            [1] = 30154,
                            [2] = 139020,
                            [3] = 139019,
                            ["Pre"] = 2536.3200000000,
                        },
                        [49] = 
                        {
                            [1] = 30154,
                            [2] = 77591,
                            [3] = 30164,
                            ["Pre"] = 2766.5000000000,
                        },
                        [50] = 
                        {
                            [1] = 30160,
                            [2] = 139020,
                            [3] = 139019,
                            ["Pre"] = 2793.1700000000,
                        },
                        [51] = 
                        {
                            [1] = 30154,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2838.7800000000,
                        },
                        [52] = 
                        {
                            [1] = 77591,
                            [2] = 139020,
                            [3] = 139019,
                            ["Pre"] = 3099.2300000000,
                        },
                        [53] = 
                        {
                            [1] = 30154,
                            [2] = 77591,
                            [3] = 150671,
                            ["Pre"] = 8099.1400000000,
                        },
                        [54] = 
                        {
                            [1] = 30154,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8171.4200000000,
                        },
                    },
                    [788224] = 
                    {
                        [1] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 30160,
                            ["Pre"] = 492.7600000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 30160,
                            ["Pre"] = 497.0500000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 77584,
                            [3] = 30160,
                            ["Pre"] = 505.3600000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 30153,
                            [3] = 30160,
                            ["Pre"] = 506.0500000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 30160,
                            ["Pre"] = 506.1700000000,
                        },
                        [6] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 30160,
                            ["Pre"] = 511.1700000000,
                        },
                        [7] = 
                        {
                            [1] = 30154,
                            [2] = 30156,
                            [3] = 30160,
                            ["Pre"] = 521.0800000000,
                        },
                        [8] = 
                        {
                            [1] = 30154,
                            [2] = 30149,
                            [3] = 30160,
                            ["Pre"] = 525.7900000000,
                        },
                        [9] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 30160,
                            ["Pre"] = 537.5100000000,
                        },
                        [10] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 30160,
                            ["Pre"] = 545.3200000000,
                        },
                        [11] = 
                        {
                            [1] = 30154,
                            [2] = 150789,
                            [3] = 30160,
                            ["Pre"] = 587.6000000000,
                        },
                        [12] = 
                        {
                            [1] = 30154,
                            [2] = 30160,
                            [3] = 77589,
                            ["Pre"] = 840.2100000000,
                        },
                        [13] = 
                        {
                            [1] = 30154,
                            [2] = 30160,
                            [3] = 150670,
                            ["Pre"] = 875.8000000000,
                        },
                        [14] = 
                        {
                            [1] = 30154,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2157.9800000000,
                        },
                        [15] = 
                        {
                            [1] = 30154,
                            [2] = 30160,
                            [3] = 150731,
                            ["Pre"] = 3879.3200000000,
                        },
                        [16] = 
                        {
                            [1] = 30154,
                            [2] = 30160,
                            [3] = 150671,
                            ["Pre"] = 7793.0800000000,
                        },
                    },
                    [1376256] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 30159,
                            ["Pre"] = 251.7800000000,
                        },
                        [2] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 30157,
                            ["Pre"] = 265.9000000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 30158,
                            ["Pre"] = 273.3800000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 77585,
                            ["Pre"] = 275.0900000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 30156,
                            ["Pre"] = 275.8100000000,
                        },
                        [6] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 30149,
                            ["Pre"] = 280.5200000000,
                        },
                        [7] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 77590,
                            ["Pre"] = 300.0500000000,
                        },
                        [8] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 30161,
                            ["Pre"] = 319.3700000000,
                        },
                        [9] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 30161,
                            ["Pre"] = 323.6600000000,
                        },
                        [10] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 30161,
                            ["Pre"] = 328.8600000000,
                        },
                        [11] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 30161,
                            ["Pre"] = 335.2400000000,
                        },
                        [12] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 30161,
                            ["Pre"] = 341.1500000000,
                        },
                        [13] = 
                        {
                            [1] = 30154,
                            [2] = 30158,
                            [3] = 30161,
                            ["Pre"] = 345.2600000000,
                        },
                        [14] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 30161,
                            ["Pre"] = 346.9700000000,
                        },
                        [15] = 
                        {
                            [1] = 30154,
                            [2] = 30156,
                            [3] = 30161,
                            ["Pre"] = 347.6900000000,
                        },
                        [16] = 
                        {
                            [1] = 30159,
                            [2] = 77585,
                            [3] = 30161,
                            ["Pre"] = 358.5500000000,
                        },
                        [17] = 
                        {
                            [1] = 30159,
                            [2] = 30156,
                            [3] = 30161,
                            ["Pre"] = 359.2700000000,
                        },
                        [18] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 77583,
                            ["Pre"] = 380.4800000000,
                        },
                        [19] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 30163,
                            ["Pre"] = 444.5800000000,
                        },
                        [20] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 77583,
                            ["Pre"] = 452.3600000000,
                        },
                        [21] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 77583,
                            ["Pre"] = 463.9400000000,
                        },
                        [22] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 30163,
                            ["Pre"] = 516.4600000000,
                        },
                        [23] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 30163,
                            ["Pre"] = 528.0400000000,
                        },
                        [24] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 150672,
                            ["Pre"] = 582.2200000000,
                        },
                        [25] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 150670,
                            ["Pre"] = 630.5300000000,
                        },
                        [26] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 150672,
                            ["Pre"] = 654.1000000000,
                        },
                        [27] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 150672,
                            ["Pre"] = 665.6800000000,
                        },
                        [28] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 77589,
                            ["Pre"] = 666.8200000000,
                        },
                        [29] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 77589,
                            ["Pre"] = 678.4000000000,
                        },
                        [30] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 150669,
                            ["Pre"] = 793.4300000000,
                        },
                        [31] = 
                        {
                            [1] = 30154,
                            [2] = 30158,
                            [3] = 150669,
                            ["Pre"] = 803.4500000000,
                        },
                        [32] = 
                        {
                            [1] = 30159,
                            [2] = 30158,
                            [3] = 150669,
                            ["Pre"] = 815.0300000000,
                        },
                        [33] = 
                        {
                            [1] = 30159,
                            [2] = 77585,
                            [3] = 150669,
                            ["Pre"] = 816.7400000000,
                        },
                        [34] = 
                        {
                            [1] = 30159,
                            [2] = 30156,
                            [3] = 150669,
                            ["Pre"] = 817.4600000000,
                        },
                        [35] = 
                        {
                            [1] = 30159,
                            [2] = 30149,
                            [3] = 150669,
                            ["Pre"] = 822.1700000000,
                        },
                        [36] = 
                        {
                            [1] = 30159,
                            [2] = 77590,
                            [3] = 150669,
                            ["Pre"] = 841.7000000000,
                        },
                        [37] = 
                        {
                            [1] = 77587,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 865.3100000000,
                        },
                        [38] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 77581,
                            ["Pre"] = 865.3800000000,
                        },
                        [39] = 
                        {
                            [1] = 30155,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 870.5100000000,
                        },
                        [40] = 
                        {
                            [1] = 30154,
                            [2] = 30157,
                            [3] = 77581,
                            ["Pre"] = 874.3000000000,
                        },
                        [41] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 77581,
                            ["Pre"] = 877.6700000000,
                        },
                        [42] = 
                        {
                            [1] = 30154,
                            [2] = 30158,
                            [3] = 77581,
                            ["Pre"] = 881.7800000000,
                        },
                        [43] = 
                        {
                            [1] = 30166,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 882.8000000000,
                        },
                        [44] = 
                        {
                            [1] = 30159,
                            [2] = 30157,
                            [3] = 77581,
                            ["Pre"] = 885.8800000000,
                        },
                        [45] = 
                        {
                            [1] = 77585,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 888.6200000000,
                        },
                        [46] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 77581,
                            ["Pre"] = 889.2500000000,
                        },
                        [47] = 
                        {
                            [1] = 30156,
                            [2] = 30161,
                            [3] = 150669,
                            ["Pre"] = 889.3400000000,
                        },
                        [48] = 
                        {
                            [1] = 30159,
                            [2] = 30158,
                            [3] = 77581,
                            ["Pre"] = 893.3600000000,
                        },
                        [49] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 77591,
                            ["Pre"] = 895.6100000000,
                        },
                        [50] = 
                        {
                            [1] = 30159,
                            [2] = 30156,
                            [3] = 77581,
                            ["Pre"] = 895.7900000000,
                        },
                        [51] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 77581,
                            ["Pre"] = 908.4500000000,
                        },
                        [52] = 
                        {
                            [1] = 30159,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 912.2200000000,
                        },
                        [53] = 
                        {
                            [1] = 30159,
                            [2] = 77590,
                            [3] = 77581,
                            ["Pre"] = 920.0300000000,
                        },
                        [54] = 
                        {
                            [1] = 30159,
                            [2] = 77583,
                            [3] = 150669,
                            ["Pre"] = 922.1300000000,
                        },
                        [55] = 
                        {
                            [1] = 30155,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 948.8400000000,
                        },
                        [56] = 
                        {
                            [1] = 30166,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 961.1300000000,
                        },
                        [57] = 
                        {
                            [1] = 30161,
                            [2] = 77583,
                            [3] = 150669,
                            ["Pre"] = 994.0100000000,
                        },
                        [58] = 
                        {
                            [1] = 30159,
                            [2] = 30160,
                            [3] = 150669,
                            ["Pre"] = 1047.7400000000,
                        },
                        [59] = 
                        {
                            [1] = 30154,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1052.9800000000,
                        },
                        [60] = 
                        {
                            [1] = 30159,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1064.5600000000,
                        },
                        [61] = 
                        {
                            [1] = 30161,
                            [2] = 30160,
                            [3] = 150669,
                            ["Pre"] = 1119.6200000000,
                        },
                        [62] = 
                        {
                            [1] = 30159,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1126.0700000000,
                        },
                        [63] = 
                        {
                            [1] = 30161,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1136.4400000000,
                        },
                        [64] = 
                        {
                            [1] = 30154,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1190.6200000000,
                        },
                        [65] = 
                        {
                            [1] = 30159,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1202.2000000000,
                        },
                        [66] = 
                        {
                            [1] = 30161,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1208.4700000000,
                        },
                        [67] = 
                        {
                            [1] = 30159,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1214.9200000000,
                        },
                        [68] = 
                        {
                            [1] = 30154,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1238.9300000000,
                        },
                        [69] = 
                        {
                            [1] = 30159,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1250.5100000000,
                        },
                        [70] = 
                        {
                            [1] = 30161,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1274.0800000000,
                        },
                        [71] = 
                        {
                            [1] = 30161,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1286.8000000000,
                        },
                        [72] = 
                        {
                            [1] = 30159,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1353.8000000000,
                        },
                        [73] = 
                        {
                            [1] = 30155,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1407.0300000000,
                        },
                        [74] = 
                        {
                            [1] = 30166,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1419.3200000000,
                        },
                        [75] = 
                        {
                            [1] = 30158,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1423.4300000000,
                        },
                        [76] = 
                        {
                            [1] = 30161,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1425.6800000000,
                        },
                        [77] = 
                        {
                            [1] = 30159,
                            [2] = 77591,
                            [3] = 77581,
                            ["Pre"] = 1432.1300000000,
                        },
                        [78] = 
                        {
                            [1] = 77590,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1450.1000000000,
                        },
                        [79] = 
                        {
                            [1] = 30161,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1497.9600000000,
                        },
                        [80] = 
                        {
                            [1] = 30161,
                            [2] = 77591,
                            [3] = 77581,
                            ["Pre"] = 1504.0100000000,
                        },
                        [81] = 
                        {
                            [1] = 30161,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 1576.2900000000,
                        },
                        [82] = 
                        {
                            [1] = 30160,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1656.1400000000,
                        },
                        [83] = 
                        {
                            [1] = 30159,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1753.3700000000,
                        },
                        [84] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 139019,
                            ["Pre"] = 1912.7100000000,
                        },
                        [85] = 
                        {
                            [1] = 77591,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1962.2000000000,
                        },
                        [86] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 139019,
                            ["Pre"] = 1984.5900000000,
                        },
                        [87] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 139019,
                            ["Pre"] = 1996.1700000000,
                        },
                        [88] = 
                        {
                            [1] = 77581,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 2034.4800000000,
                        },
                        [89] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 30164,
                            ["Pre"] = 2287.0500000000,
                        },
                        [90] = 
                        {
                            [1] = 30159,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2454.3600000000,
                        },
                        [91] = 
                        {
                            [1] = 30161,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2526.2400000000,
                        },
                        [92] = 
                        {
                            [1] = 30154,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2823.5700000000,
                        },
                        [93] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 150731,
                            ["Pre"] = 3634.0500000000,
                        },
                        [94] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 150731,
                            ["Pre"] = 3705.9300000000,
                        },
                        [95] = 
                        {
                            [1] = 30159,
                            [2] = 30161,
                            [3] = 150731,
                            ["Pre"] = 3717.5100000000,
                        },
                        [96] = 
                        {
                            [1] = 30154,
                            [2] = 77581,
                            [3] = 150731,
                            ["Pre"] = 4242.4500000000,
                        },
                        [97] = 
                        {
                            [1] = 30159,
                            [2] = 77581,
                            [3] = 150731,
                            ["Pre"] = 4254.0300000000,
                        },
                        [98] = 
                        {
                            [1] = 30161,
                            [2] = 77581,
                            [3] = 150731,
                            ["Pre"] = 4325.9100000000,
                        },
                        [99] = 
                        {
                            [1] = 30154,
                            [2] = 30159,
                            [3] = 150671,
                            ["Pre"] = 7547.8100000000,
                        },
                        [100] = 
                        {
                            [1] = 30154,
                            [2] = 30161,
                            [3] = 150671,
                            ["Pre"] = 7619.6900000000,
                        },
                        [101] = 
                        {
                            [1] = 30154,
                            [2] = 150669,
                            [3] = 150671,
                            ["Pre"] = 8077.8800000000,
                        },
                        [102] = 
                        {
                            [1] = 30159,
                            [2] = 150669,
                            [3] = 150671,
                            ["Pre"] = 8089.4600000000,
                        },
                        [103] = 
                        {
                            [1] = 30161,
                            [2] = 150669,
                            [3] = 150671,
                            ["Pre"] = 8161.3400000000,
                        },
                        [104] = 
                        {
                            [1] = 30159,
                            [2] = 77581,
                            [3] = 150671,
                            ["Pre"] = 8167.7900000000,
                        },
                    },
                    [662784] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30162,
                            [3] = 77581,
                            ["Pre"] = 858.4300000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 77585,
                            [3] = 77581,
                            ["Pre"] = 881.7400000000,
                        },
                        [3] = 
                        {
                            [1] = 77585,
                            [2] = 30149,
                            [3] = 77581,
                            ["Pre"] = 914.7700000000,
                        },
                        [4] = 
                        {
                            [1] = 30162,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 948.9800000000,
                        },
                        [5] = 
                        {
                            [1] = 30149,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 982.0100000000,
                        },
                        [6] = 
                        {
                            [1] = 30162,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2519.3600000000,
                        },
                        [7] = 
                        {
                            [1] = 30149,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2552.3900000000,
                        },
                    },
                    [1711360] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30162,
                            [3] = 150789,
                            ["Pre"] = 331.5400000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 150789,
                            ["Pre"] = 333.2900000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 150789,
                            ["Pre"] = 344.8700000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 150789,
                            ["Pre"] = 349.9500000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 150789,
                            ["Pre"] = 353.3200000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 150789,
                            ["Pre"] = 357.4300000000,
                        },
                        [7] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 30161,
                            ["Pre"] = 416.7500000000,
                        },
                        [8] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 30163,
                            ["Pre"] = 528.6300000000,
                        },
                        [9] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 30160,
                            ["Pre"] = 590.1400000000,
                        },
                        [10] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 77589,
                            ["Pre"] = 611.7500000000,
                        },
                        [11] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 150669,
                            ["Pre"] = 874.9400000000,
                        },
                        [12] = 
                        {
                            [1] = 77587,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1205.8800000000,
                        },
                        [13] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 30152,
                            ["Pre"] = 1217.4400000000,
                        },
                        [14] = 
                        {
                            [1] = 150789,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1296.4300000000,
                        },
                        [15] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 30164,
                            ["Pre"] = 2299.2200000000,
                        },
                    },
                    [854528] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 30149,
                            ["Pre"] = 266.9700000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 30149,
                            ["Pre"] = 267.1900000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30162,
                            [3] = 30149,
                            ["Pre"] = 269.7300000000,
                        },
                        [4] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 30149,
                            ["Pre"] = 278.0400000000,
                        },
                        [5] = 
                        {
                            [1] = 30162,
                            [2] = 30153,
                            [3] = 30149,
                            ["Pre"] = 278.7300000000,
                        },
                        [6] = 
                        {
                            [1] = 30162,
                            [2] = 30158,
                            [3] = 30149,
                            ["Pre"] = 291.3300000000,
                        },
                        [7] = 
                        {
                            [1] = 30162,
                            [2] = 77585,
                            [3] = 30149,
                            ["Pre"] = 293.0400000000,
                        },
                        [8] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 150789,
                            ["Pre"] = 360.2800000000,
                        },
                        [9] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 30160,
                            ["Pre"] = 524.0400000000,
                        },
                        [10] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 150672,
                            ["Pre"] = 600.1700000000,
                        },
                        [11] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 77589,
                            ["Pre"] = 612.8900000000,
                        },
                        [12] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 150669,
                            ["Pre"] = 808.8400000000,
                        },
                        [13] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 139020,
                            ["Pre"] = 902.3800000000,
                        },
                        [14] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 139019,
                            ["Pre"] = 1930.6600000000,
                        },
                        [15] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 30164,
                            ["Pre"] = 2233.1200000000,
                        },
                        [16] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 150731,
                            ["Pre"] = 3652,
                        },
                        [17] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 150671,
                            ["Pre"] = 7565.7600000000,
                        },
                    },
                    [851968] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30162,
                            [3] = 30157,
                            ["Pre"] = 255.1100000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30157,
                            [3] = 30149,
                            ["Pre"] = 285.3800000000,
                        },
                        [3] = 
                        {
                            [1] = 30166,
                            [2] = 30157,
                            [3] = 30149,
                            ["Pre"] = 305.6300000000,
                        },
                        [4] = 
                        {
                            [1] = 30157,
                            [2] = 77585,
                            [3] = 30149,
                            ["Pre"] = 311.4500000000,
                        },
                        [5] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 77583,
                            ["Pre"] = 398.4300000000,
                        },
                        [6] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 30160,
                            ["Pre"] = 542.4500000000,
                        },
                        [7] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 150672,
                            ["Pre"] = 618.5800000000,
                        },
                        [8] = 
                        {
                            [1] = 30162,
                            [2] = 30149,
                            [3] = 77591,
                            ["Pre"] = 830.1000000000,
                        },
                        [9] = 
                        {
                            [1] = 30157,
                            [2] = 30149,
                            [3] = 30164,
                            ["Pre"] = 2251.5300000000,
                        },
                    },
                    [1441792] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 77584,
                            ["Pre"] = 246.5400000000,
                        },
                        [2] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 30153,
                            ["Pre"] = 247.2300000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 30165,
                            ["Pre"] = 247.3500000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 77584,
                            ["Pre"] = 250.8300000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 30153,
                            ["Pre"] = 251.5200000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 30165,
                            ["Pre"] = 251.6400000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 30165,
                            ["Pre"] = 256.8400000000,
                        },
                        [8] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 30153,
                            ["Pre"] = 258.3000000000,
                        },
                        [9] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 30165,
                            ["Pre"] = 258.4200000000,
                        },
                        [10] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 30153,
                            ["Pre"] = 259.1100000000,
                        },
                        [11] = 
                        {
                            [1] = 77587,
                            [2] = 77584,
                            [3] = 30153,
                            ["Pre"] = 262.5900000000,
                        },
                        [12] = 
                        {
                            [1] = 77587,
                            [2] = 77584,
                            [3] = 30165,
                            ["Pre"] = 262.7100000000,
                        },
                        [13] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 30153,
                            ["Pre"] = 263.4000000000,
                        },
                        [14] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 30157,
                            ["Pre"] = 264.9500000000,
                        },
                        [15] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 30157,
                            ["Pre"] = 265.7600000000,
                        },
                        [16] = 
                        {
                            [1] = 30155,
                            [2] = 77584,
                            [3] = 30153,
                            ["Pre"] = 267.7900000000,
                        },
                        [17] = 
                        {
                            [1] = 30155,
                            [2] = 30165,
                            [3] = 30153,
                            ["Pre"] = 268.6000000000,
                        },
                        [18] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 30165,
                            ["Pre"] = 269.1300000000,
                        },
                        [19] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 30158,
                            ["Pre"] = 272.4300000000,
                        },
                        [20] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 30158,
                            ["Pre"] = 273.2400000000,
                        },
                        [21] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 30156,
                            ["Pre"] = 274.8600000000,
                        },
                        [22] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 30156,
                            ["Pre"] = 275.5500000000,
                        },
                        [23] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 30153,
                            ["Pre"] = 276.7100000000,
                        },
                        [24] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 30149,
                            ["Pre"] = 279.5700000000,
                        },
                        [25] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 30165,
                            ["Pre"] = 280.2000000000,
                        },
                        [26] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 30149,
                            ["Pre"] = 280.2600000000,
                        },
                        [27] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 30149,
                            ["Pre"] = 280.3800000000,
                        },
                        [28] = 
                        {
                            [1] = 30166,
                            [2] = 30165,
                            [3] = 30153,
                            ["Pre"] = 280.8900000000,
                        },
                        [29] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 30158,
                            ["Pre"] = 284.3100000000,
                        },
                        [30] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 30158,
                            ["Pre"] = 285,
                        },
                        [31] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 30156,
                            ["Pre"] = 286.6200000000,
                        },
                        [32] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 77585,
                            ["Pre"] = 286.7100000000,
                        },
                        [33] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 30149,
                            ["Pre"] = 291.3300000000,
                        },
                        [34] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 77590,
                            ["Pre"] = 299.7900000000,
                        },
                        [35] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 77590,
                            ["Pre"] = 299.9100000000,
                        },
                        [36] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 30151,
                            ["Pre"] = 303.0500000000,
                        },
                        [37] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 150789,
                            ["Pre"] = 328.7800000000,
                        },
                        [38] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 150789,
                            ["Pre"] = 339.8500000000,
                        },
                        [39] = 
                        {
                            [1] = 30162,
                            [2] = 30153,
                            [3] = 150789,
                            ["Pre"] = 340.5400000000,
                        },
                        [40] = 
                        {
                            [1] = 30162,
                            [2] = 30165,
                            [3] = 150789,
                            ["Pre"] = 340.6600000000,
                        },
                        [41] = 
                        {
                            [1] = 30148,
                            [2] = 30157,
                            [3] = 150789,
                            ["Pre"] = 347.1900000000,
                        },
                        [42] = 
                        {
                            [1] = 30155,
                            [2] = 30153,
                            [3] = 150789,
                            ["Pre"] = 350.0300000000,
                        },
                        [43] = 
                        {
                            [1] = 30155,
                            [2] = 30165,
                            [3] = 150789,
                            ["Pre"] = 350.1500000000,
                        },
                        [44] = 
                        {
                            [1] = 30148,
                            [2] = 30158,
                            [3] = 150789,
                            ["Pre"] = 354.6700000000,
                        },
                        [45] = 
                        {
                            [1] = 30148,
                            [2] = 30156,
                            [3] = 150789,
                            ["Pre"] = 357.1000000000,
                        },
                        [46] = 
                        {
                            [1] = 77584,
                            [2] = 30157,
                            [3] = 150789,
                            ["Pre"] = 358.2600000000,
                        },
                        [47] = 
                        {
                            [1] = 77584,
                            [2] = 30166,
                            [3] = 150789,
                            ["Pre"] = 361.6300000000,
                        },
                        [48] = 
                        {
                            [1] = 30148,
                            [2] = 30149,
                            [3] = 150789,
                            ["Pre"] = 361.8100000000,
                        },
                        [49] = 
                        {
                            [1] = 30166,
                            [2] = 30165,
                            [3] = 150789,
                            ["Pre"] = 362.4400000000,
                        },
                        [50] = 
                        {
                            [1] = 77584,
                            [2] = 30158,
                            [3] = 150789,
                            ["Pre"] = 365.7400000000,
                        },
                        [51] = 
                        {
                            [1] = 30165,
                            [2] = 30158,
                            [3] = 150789,
                            ["Pre"] = 366.5500000000,
                        },
                        [52] = 
                        {
                            [1] = 77584,
                            [2] = 30156,
                            [3] = 150789,
                            ["Pre"] = 368.1700000000,
                        },
                        [53] = 
                        {
                            [1] = 30153,
                            [2] = 30156,
                            [3] = 150789,
                            ["Pre"] = 368.8600000000,
                        },
                        [54] = 
                        {
                            [1] = 77584,
                            [2] = 30149,
                            [3] = 150789,
                            ["Pre"] = 372.8800000000,
                        },
                        [55] = 
                        {
                            [1] = 30153,
                            [2] = 30149,
                            [3] = 150789,
                            ["Pre"] = 373.5700000000,
                        },
                        [56] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 77583,
                            ["Pre"] = 379.5300000000,
                        },
                        [57] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 77583,
                            ["Pre"] = 380.2200000000,
                        },
                        [58] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 77583,
                            ["Pre"] = 380.3400000000,
                        },
                        [59] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 77590,
                            ["Pre"] = 381.3400000000,
                        },
                        [60] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 30151,
                            ["Pre"] = 384.6000000000,
                        },
                        [61] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 30151,
                            ["Pre"] = 385.2900000000,
                        },
                        [62] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 77583,
                            ["Pre"] = 391.2900000000,
                        },
                        [63] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 77583,
                            ["Pre"] = 391.4100000000,
                        },
                        [64] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 77583,
                            ["Pre"] = 392.1000000000,
                        },
                        [65] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 77590,
                            ["Pre"] = 392.4100000000,
                        },
                        [66] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 77590,
                            ["Pre"] = 393.1000000000,
                        },
                        [67] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 30163,
                            ["Pre"] = 444.4400000000,
                        },
                        [68] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 30163,
                            ["Pre"] = 455.3900000000,
                        },
                        [69] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 30163,
                            ["Pre"] = 455.5100000000,
                        },
                        [70] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 30163,
                            ["Pre"] = 456.2000000000,
                        },
                        [71] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 472.8400000000,
                        },
                        [72] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 30160,
                            ["Pre"] = 516.9000000000,
                        },
                        [73] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 30160,
                            ["Pre"] = 517.0200000000,
                        },
                        [74] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 30160,
                            ["Pre"] = 517.7100000000,
                        },
                        [75] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 30163,
                            ["Pre"] = 536.9400000000,
                        },
                        [76] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 30163,
                            ["Pre"] = 537.6300000000,
                        },
                        [77] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 30163,
                            ["Pre"] = 537.7500000000,
                        },
                        [78] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 150672,
                            ["Pre"] = 582.0800000000,
                        },
                        [79] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 150672,
                            ["Pre"] = 593.1500000000,
                        },
                        [80] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 150672,
                            ["Pre"] = 593.8400000000,
                        },
                        [81] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 30160,
                            ["Pre"] = 598.4500000000,
                        },
                        [82] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 30160,
                            ["Pre"] = 599.1400000000,
                        },
                        [83] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 30160,
                            ["Pre"] = 599.2600000000,
                        },
                        [84] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 150670,
                            ["Pre"] = 629.5800000000,
                        },
                        [85] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 150670,
                            ["Pre"] = 630.2700000000,
                        },
                        [86] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 150670,
                            ["Pre"] = 630.3900000000,
                        },
                        [87] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 150670,
                            ["Pre"] = 641.3400000000,
                        },
                        [88] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 150672,
                            ["Pre"] = 674.5800000000,
                        },
                        [89] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 150672,
                            ["Pre"] = 675.3900000000,
                        },
                        [90] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 150670,
                            ["Pre"] = 711.8200000000,
                        },
                        [91] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 150670,
                            ["Pre"] = 722.8900000000,
                        },
                        [92] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 150670,
                            ["Pre"] = 723.5800000000,
                        },
                        [93] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 77591,
                            ["Pre"] = 811.8900000000,
                        },
                        [94] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 77591,
                            ["Pre"] = 812.0100000000,
                        },
                        [95] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 77591,
                            ["Pre"] = 823.7700000000,
                        },
                        [96] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 139020,
                            ["Pre"] = 884.1700000000,
                        },
                        [97] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 139020,
                            ["Pre"] = 884.2900000000,
                        },
                        [98] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 77591,
                            ["Pre"] = 893.4400000000,
                        },
                        [99] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 139020,
                            ["Pre"] = 896.0500000000,
                        },
                        [100] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 77591,
                            ["Pre"] = 904.5100000000,
                        },
                        [101] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 77591,
                            ["Pre"] = 905.2000000000,
                        },
                        [102] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 77591,
                            ["Pre"] = 905.3200000000,
                        },
                        [103] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 30152,
                            ["Pre"] = 1144.2000000000,
                        },
                        [104] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 30152,
                            ["Pre"] = 1225.7500000000,
                        },
                        [105] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 30152,
                            ["Pre"] = 1226.4400000000,
                        },
                        [106] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 139019,
                            ["Pre"] = 1912.5700000000,
                        },
                        [107] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 30164,
                            ["Pre"] = 2215.0300000000,
                        },
                        [108] = 
                        {
                            [1] = 77584,
                            [2] = 30165,
                            [3] = 30164,
                            ["Pre"] = 2226.1000000000,
                        },
                        [109] = 
                        {
                            [1] = 77584,
                            [2] = 150789,
                            [3] = 30164,
                            ["Pre"] = 2307.5300000000,
                        },
                        [110] = 
                        {
                            [1] = 30165,
                            [2] = 150789,
                            [3] = 30164,
                            ["Pre"] = 2308.3400000000,
                        },
                        [111] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 150731,
                            ["Pre"] = 3633.7900000000,
                        },
                        [112] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 150731,
                            ["Pre"] = 3633.9100000000,
                        },
                        [113] = 
                        {
                            [1] = 30165,
                            [2] = 30153,
                            [3] = 150731,
                            ["Pre"] = 3645.6700000000,
                        },
                        [114] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 150671,
                            ["Pre"] = 7546.8600000000,
                        },
                        [115] = 
                        {
                            [1] = 77584,
                            [2] = 30153,
                            [3] = 150671,
                            ["Pre"] = 7558.6200000000,
                        },
                    },
                    [1114112] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 30159,
                            ["Pre"] = 247.2700000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30162,
                            [3] = 30159,
                            ["Pre"] = 250.0300000000,
                        },
                        [3] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 30166,
                            ["Pre"] = 255.9400000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 30162,
                            [3] = 30166,
                            ["Pre"] = 258.4800000000,
                        },
                        [5] = 
                        {
                            [1] = 30162,
                            [2] = 77584,
                            [3] = 30166,
                            ["Pre"] = 266.7900000000,
                        },
                        [6] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 30158,
                            ["Pre"] = 271.6300000000,
                        },
                        [7] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 30166,
                            ["Pre"] = 271.8100000000,
                        },
                        [8] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 77585,
                            ["Pre"] = 273.3400000000,
                        },
                        [9] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 30157,
                            ["Pre"] = 285.9300000000,
                        },
                        [10] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 30151,
                            ["Pre"] = 290.4900000000,
                        },
                        [11] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 77590,
                            ["Pre"] = 298.3000000000,
                        },
                        [12] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 30149,
                            ["Pre"] = 300.5500000000,
                        },
                        [13] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 77590,
                            ["Pre"] = 306.7500000000,
                        },
                        [14] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 30151,
                            ["Pre"] = 312.2700000000,
                        },
                        [15] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 77590,
                            ["Pre"] = 320.0800000000,
                        },
                        [16] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 30161,
                            ["Pre"] = 339.4000000000,
                        },
                        [17] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 150789,
                            ["Pre"] = 340.5800000000,
                        },
                        [18] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 150789,
                            ["Pre"] = 349.0300000000,
                        },
                        [19] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 150789,
                            ["Pre"] = 362.3600000000,
                        },
                        [20] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 77583,
                            ["Pre"] = 378.7300000000,
                        },
                        [21] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 77583,
                            ["Pre"] = 387.1800000000,
                        },
                        [22] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 77583,
                            ["Pre"] = 400.5100000000,
                        },
                        [23] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 30160,
                            ["Pre"] = 504.3400000000,
                        },
                        [24] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 150672,
                            ["Pre"] = 580.4700000000,
                        },
                        [25] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 77589,
                            ["Pre"] = 593.1900000000,
                        },
                        [26] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 77589,
                            ["Pre"] = 601.6400000000,
                        },
                        [27] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 77589,
                            ["Pre"] = 614.9700000000,
                        },
                        [28] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 150670,
                            ["Pre"] = 628.7800000000,
                        },
                        [29] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 150670,
                            ["Pre"] = 637.2300000000,
                        },
                        [30] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 150670,
                            ["Pre"] = 650.5600000000,
                        },
                        [31] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 77591,
                            ["Pre"] = 810.4000000000,
                        },
                        [32] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 77591,
                            ["Pre"] = 818.8500000000,
                        },
                        [33] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 77591,
                            ["Pre"] = 832.1800000000,
                        },
                        [34] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 139020,
                            ["Pre"] = 891.1300000000,
                        },
                        [35] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 30152,
                            ["Pre"] = 1131.6400000000,
                        },
                        [36] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 30152,
                            ["Pre"] = 1140.0900000000,
                        },
                        [37] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 30152,
                            ["Pre"] = 1153.4200000000,
                        },
                        [38] = 
                        {
                            [1] = 30162,
                            [2] = 30159,
                            [3] = 139019,
                            ["Pre"] = 1910.9600000000,
                        },
                        [39] = 
                        {
                            [1] = 30162,
                            [2] = 30166,
                            [3] = 139019,
                            ["Pre"] = 1919.4100000000,
                        },
                        [40] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 139019,
                            ["Pre"] = 1932.7400000000,
                        },
                        [41] = 
                        {
                            [1] = 30159,
                            [2] = 30166,
                            [3] = 150731,
                            ["Pre"] = 3654.0800000000,
                        },
                    },
                    [262144] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 30151,
                            ["Pre"] = 278.6900000000,
                        },
                        [2] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 30151,
                            ["Pre"] = 278.9100000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 77584,
                            [3] = 30151,
                            ["Pre"] = 291.5100000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 30151,
                            ["Pre"] = 292.0200000000,
                        },
                        [5] = 
                        {
                            [1] = 30154,
                            [2] = 30153,
                            [3] = 30151,
                            ["Pre"] = 292.2000000000,
                        },
                        [6] = 
                        {
                            [1] = 30148,
                            [2] = 30157,
                            [3] = 30151,
                            ["Pre"] = 297.1000000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 30151,
                            ["Pre"] = 306.2900000000,
                        },
                        [8] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 30151,
                            ["Pre"] = 306.5100000000,
                        },
                        [9] = 
                        {
                            [1] = 30148,
                            [2] = 77590,
                            [3] = 30151,
                            ["Pre"] = 331.2500000000,
                        },
                        [10] = 
                        {
                            [1] = 30154,
                            [2] = 150789,
                            [3] = 30151,
                            ["Pre"] = 373.7500000000,
                        },
                        [11] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            [3] = 77583,
                            ["Pre"] = 411.6800000000,
                        },
                        [12] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 77583,
                            ["Pre"] = 411.9000000000,
                        },
                        [13] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            [3] = 30163,
                            ["Pre"] = 475.7800000000,
                        },
                        [14] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 30163,
                            ["Pre"] = 476,
                        },
                        [15] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 77589,
                            ["Pre"] = 581.3900000000,
                        },
                        [16] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 77589,
                            ["Pre"] = 581.6100000000,
                        },
                        [17] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 77589,
                            ["Pre"] = 591.1000000000,
                        },
                        [18] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 77589,
                            ["Pre"] = 594.7200000000,
                        },
                        [19] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 77589,
                            ["Pre"] = 595.0200000000,
                        },
                        [20] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 77589,
                            ["Pre"] = 603.3900000000,
                        },
                        [21] = 
                        {
                            [1] = 30148,
                            [2] = 30156,
                            [3] = 77589,
                            ["Pre"] = 609.7100000000,
                        },
                        [22] = 
                        {
                            [1] = 30154,
                            [2] = 30156,
                            [3] = 77589,
                            ["Pre"] = 609.9300000000,
                        },
                        [23] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            [3] = 150672,
                            ["Pre"] = 613.4200000000,
                        },
                        [24] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 150672,
                            ["Pre"] = 613.6400000000,
                        },
                        [25] = 
                        {
                            [1] = 30148,
                            [2] = 30149,
                            [3] = 77589,
                            ["Pre"] = 614.4200000000,
                        },
                        [26] = 
                        {
                            [1] = 30154,
                            [2] = 30149,
                            [3] = 77589,
                            ["Pre"] = 614.6400000000,
                        },
                        [27] = 
                        {
                            [1] = 30162,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 624.6100000000,
                        },
                        [28] = 
                        {
                            [1] = 30148,
                            [2] = 77590,
                            [3] = 77589,
                            ["Pre"] = 633.9500000000,
                        },
                        [29] = 
                        {
                            [1] = 30154,
                            [2] = 77590,
                            [3] = 77589,
                            ["Pre"] = 634.1700000000,
                        },
                        [30] = 
                        {
                            [1] = 30159,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 637.9400000000,
                        },
                        [31] = 
                        {
                            [1] = 30148,
                            [2] = 77583,
                            [3] = 77589,
                            ["Pre"] = 714.3800000000,
                        },
                        [32] = 
                        {
                            [1] = 30154,
                            [2] = 77583,
                            [3] = 77589,
                            ["Pre"] = 714.6000000000,
                        },
                        [33] = 
                        {
                            [1] = 30151,
                            [2] = 77583,
                            [3] = 77589,
                            ["Pre"] = 757.6000000000,
                        },
                        [34] = 
                        {
                            [1] = 30154,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 778.7000000000,
                        },
                        [35] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 150669,
                            ["Pre"] = 781.6300000000,
                        },
                        [36] = 
                        {
                            [1] = 30148,
                            [2] = 77584,
                            [3] = 150669,
                            ["Pre"] = 789.9400000000,
                        },
                        [37] = 
                        {
                            [1] = 30154,
                            [2] = 77584,
                            [3] = 150669,
                            ["Pre"] = 790.1600000000,
                        },
                        [38] = 
                        {
                            [1] = 30148,
                            [2] = 30153,
                            [3] = 150669,
                            ["Pre"] = 790.6300000000,
                        },
                        [39] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 150669,
                            ["Pre"] = 790.6700000000,
                        },
                        [40] = 
                        {
                            [1] = 30148,
                            [2] = 30165,
                            [3] = 150669,
                            ["Pre"] = 790.7500000000,
                        },
                        [41] = 
                        {
                            [1] = 30154,
                            [2] = 30153,
                            [3] = 150669,
                            ["Pre"] = 790.8500000000,
                        },
                        [42] = 
                        {
                            [1] = 30154,
                            [2] = 30165,
                            [3] = 150669,
                            ["Pre"] = 790.9700000000,
                        },
                        [43] = 
                        {
                            [1] = 30148,
                            [2] = 30156,
                            [3] = 150669,
                            ["Pre"] = 805.6600000000,
                        },
                        [44] = 
                        {
                            [1] = 30148,
                            [2] = 30149,
                            [3] = 150669,
                            ["Pre"] = 810.3700000000,
                        },
                        [45] = 
                        {
                            [1] = 30162,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 820.5600000000,
                        },
                        [46] = 
                        {
                            [1] = 30151,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 821.7000000000,
                        },
                        [47] = 
                        {
                            [1] = 77587,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 824.8500000000,
                        },
                        [48] = 
                        {
                            [1] = 30148,
                            [2] = 77590,
                            [3] = 150669,
                            ["Pre"] = 829.9000000000,
                        },
                        [49] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 830.0500000000,
                        },
                        [50] = 
                        {
                            [1] = 77584,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 833.1600000000,
                        },
                        [51] = 
                        {
                            [1] = 30153,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 833.8500000000,
                        },
                        [52] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            [3] = 77591,
                            ["Pre"] = 843.3500000000,
                        },
                        [53] = 
                        {
                            [1] = 77585,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 848.1600000000,
                        },
                        [54] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 848.8800000000,
                        },
                        [55] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 150669,
                            ["Pre"] = 872.1800000000,
                        },
                        [56] = 
                        {
                            [1] = 30154,
                            [2] = 150789,
                            [3] = 150669,
                            ["Pre"] = 872.4000000000,
                        },
                        [57] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 900.4200000000,
                        },
                        [58] = 
                        {
                            [1] = 30148,
                            [2] = 77583,
                            [3] = 150669,
                            ["Pre"] = 910.3300000000,
                        },
                        [59] = 
                        {
                            [1] = 150789,
                            [2] = 30151,
                            [3] = 150669,
                            ["Pre"] = 915.4000000000,
                        },
                        [60] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            [3] = 139020,
                            ["Pre"] = 915.6300000000,
                        },
                        [61] = 
                        {
                            [1] = 30154,
                            [2] = 77589,
                            [3] = 150672,
                            ["Pre"] = 916.3400000000,
                        },
                        [62] = 
                        {
                            [1] = 30151,
                            [2] = 77583,
                            [3] = 150669,
                            ["Pre"] = 953.5500000000,
                        },
                        [63] = 
                        {
                            [1] = 30151,
                            [2] = 77589,
                            [3] = 150672,
                            ["Pre"] = 959.3400000000,
                        },
                        [64] = 
                        {
                            [1] = 30151,
                            [2] = 30163,
                            [3] = 150669,
                            ["Pre"] = 1017.6500000000,
                        },
                        [65] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 30152,
                            ["Pre"] = 1119.8400000000,
                        },
                        [66] = 
                        {
                            [1] = 30162,
                            [2] = 30154,
                            [3] = 30152,
                            ["Pre"] = 1120.0600000000,
                        },
                        [67] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 30152,
                            ["Pre"] = 1124.1300000000,
                        },
                        [68] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 30152,
                            ["Pre"] = 1124.3500000000,
                        },
                        [69] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 30152,
                            ["Pre"] = 1129.3300000000,
                        },
                        [70] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 30152,
                            ["Pre"] = 1129.5500000000,
                        },
                        [71] = 
                        {
                            [1] = 30154,
                            [2] = 77584,
                            [3] = 30152,
                            ["Pre"] = 1132.6600000000,
                        },
                        [72] = 
                        {
                            [1] = 30155,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1132.7500000000,
                        },
                        [73] = 
                        {
                            [1] = 30148,
                            [2] = 30159,
                            [3] = 30152,
                            ["Pre"] = 1133.1700000000,
                        },
                        [74] = 
                        {
                            [1] = 30154,
                            [2] = 30153,
                            [3] = 30152,
                            ["Pre"] = 1133.3500000000,
                        },
                        [75] = 
                        {
                            [1] = 30165,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1136.6700000000,
                        },
                        [76] = 
                        {
                            [1] = 30148,
                            [2] = 30157,
                            [3] = 30152,
                            ["Pre"] = 1138.2500000000,
                        },
                        [77] = 
                        {
                            [1] = 30148,
                            [2] = 30166,
                            [3] = 30152,
                            ["Pre"] = 1141.6200000000,
                        },
                        [78] = 
                        {
                            [1] = 30154,
                            [2] = 30166,
                            [3] = 30152,
                            ["Pre"] = 1141.8400000000,
                        },
                        [79] = 
                        {
                            [1] = 30166,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1145.0400000000,
                        },
                        [80] = 
                        {
                            [1] = 30148,
                            [2] = 77589,
                            [3] = 77591,
                            ["Pre"] = 1146.0500000000,
                        },
                        [81] = 
                        {
                            [1] = 30148,
                            [2] = 77585,
                            [3] = 30152,
                            ["Pre"] = 1147.4400000000,
                        },
                        [82] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 30152,
                            ["Pre"] = 1147.6600000000,
                        },
                        [83] = 
                        {
                            [1] = 30148,
                            [2] = 30156,
                            [3] = 30152,
                            ["Pre"] = 1148.1600000000,
                        },
                        [84] = 
                        {
                            [1] = 30154,
                            [2] = 30156,
                            [3] = 30152,
                            ["Pre"] = 1148.3800000000,
                        },
                        [85] = 
                        {
                            [1] = 30156,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1151.5800000000,
                        },
                        [86] = 
                        {
                            [1] = 30148,
                            [2] = 30149,
                            [3] = 30152,
                            ["Pre"] = 1152.8700000000,
                        },
                        [87] = 
                        {
                            [1] = 30149,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1156.2900000000,
                        },
                        [88] = 
                        {
                            [1] = 30148,
                            [2] = 77590,
                            [3] = 30152,
                            ["Pre"] = 1172.4000000000,
                        },
                        [89] = 
                        {
                            [1] = 77590,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1175.8200000000,
                        },
                        [90] = 
                        {
                            [1] = 30151,
                            [2] = 77589,
                            [3] = 77591,
                            ["Pre"] = 1189.2700000000,
                        },
                        [91] = 
                        {
                            [1] = 77585,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1190.6600000000,
                        },
                        [92] = 
                        {
                            [1] = 30148,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1203.1200000000,
                        },
                        [93] = 
                        {
                            [1] = 30154,
                            [2] = 150789,
                            [3] = 30152,
                            ["Pre"] = 1214.9000000000,
                        },
                        [94] = 
                        {
                            [1] = 30151,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1246.3400000000,
                        },
                        [95] = 
                        {
                            [1] = 30154,
                            [2] = 77583,
                            [3] = 30152,
                            ["Pre"] = 1253.0500000000,
                        },
                        [96] = 
                        {
                            [1] = 77583,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1256.2500000000,
                        },
                        [97] = 
                        {
                            [1] = 30148,
                            [2] = 30163,
                            [3] = 30152,
                            ["Pre"] = 1316.9300000000,
                        },
                        [98] = 
                        {
                            [1] = 30154,
                            [2] = 30163,
                            [3] = 30152,
                            ["Pre"] = 1317.1500000000,
                        },
                        [99] = 
                        {
                            [1] = 30148,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1342,
                        },
                        [100] = 
                        {
                            [1] = 30151,
                            [2] = 30163,
                            [3] = 30152,
                            ["Pre"] = 1360.1500000000,
                        },
                        [101] = 
                        {
                            [1] = 30151,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1385.2200000000,
                        },
                        [102] = 
                        {
                            [1] = 30148,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1399.0700000000,
                        },
                        [103] = 
                        {
                            [1] = 30148,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1414.2800000000,
                        },
                        [104] = 
                        {
                            [1] = 30148,
                            [2] = 150672,
                            [3] = 30152,
                            ["Pre"] = 1454.5700000000,
                        },
                        [105] = 
                        {
                            [1] = 30154,
                            [2] = 150672,
                            [3] = 30152,
                            ["Pre"] = 1454.7900000000,
                        },
                        [106] = 
                        {
                            [1] = 30151,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1457.5000000000,
                        },
                        [107] = 
                        {
                            [1] = 30162,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1465.7600000000,
                        },
                        [108] = 
                        {
                            [1] = 30155,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1475.2500000000,
                        },
                        [109] = 
                        {
                            [1] = 30159,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1479.0900000000,
                        },
                        [110] = 
                        {
                            [1] = 30166,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1487.5400000000,
                        },
                        [111] = 
                        {
                            [1] = 30156,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1494.0800000000,
                        },
                        [112] = 
                        {
                            [1] = 30151,
                            [2] = 150672,
                            [3] = 30152,
                            ["Pre"] = 1497.7900000000,
                        },
                        [113] = 
                        {
                            [1] = 30163,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1662.8500000000,
                        },
                        [114] = 
                        {
                            [1] = 77587,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1666,
                        },
                        [115] = 
                        {
                            [1] = 30155,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1671.2000000000,
                        },
                        [116] = 
                        {
                            [1] = 77584,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1674.3100000000,
                        },
                        [117] = 
                        {
                            [1] = 30153,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1675,
                        },
                        [118] = 
                        {
                            [1] = 30166,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1683.4900000000,
                        },
                        [119] = 
                        {
                            [1] = 30148,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 1684.5000000000,
                        },
                        [120] = 
                        {
                            [1] = 30154,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 1684.7200000000,
                        },
                        [121] = 
                        {
                            [1] = 77589,
                            [2] = 77591,
                            [3] = 150669,
                            ["Pre"] = 1687.9200000000,
                        },
                        [122] = 
                        {
                            [1] = 77585,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1689.3100000000,
                        },
                        [123] = 
                        {
                            [1] = 30156,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1690.0300000000,
                        },
                        [124] = 
                        {
                            [1] = 30148,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1741.5700000000,
                        },
                        [125] = 
                        {
                            [1] = 150789,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 1756.5500000000,
                        },
                        [126] = 
                        {
                            [1] = 30148,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1756.7800000000,
                        },
                        [127] = 
                        {
                            [1] = 30154,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1757,
                        },
                        [128] = 
                        {
                            [1] = 77589,
                            [2] = 150672,
                            [3] = 30152,
                            ["Pre"] = 1800.4900000000,
                        },
                        [129] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 1943.9100000000,
                        },
                        [130] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 1944.1300000000,
                        },
                        [131] = 
                        {
                            [1] = 77589,
                            [2] = 77591,
                            [3] = 30152,
                            ["Pre"] = 2030.4200000000,
                        },
                        [132] = 
                        {
                            [1] = 77589,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 2087.4900000000,
                        },
                        [133] = 
                        {
                            [1] = 77591,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 2226.3700000000,
                        },
                        [134] = 
                        {
                            [1] = 139020,
                            [2] = 150669,
                            [3] = 30152,
                            ["Pre"] = 2298.6500000000,
                        },
                        [135] = 
                        {
                            [1] = 30148,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2442.5600000000,
                        },
                        [136] = 
                        {
                            [1] = 30151,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2485.7800000000,
                        },
                        [137] = 
                        {
                            [1] = 30148,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2785.0600000000,
                        },
                        [138] = 
                        {
                            [1] = 30154,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2785.2800000000,
                        },
                        [139] = 
                        {
                            [1] = 150669,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 3326.9300000000,
                        },
                        [140] = 
                        {
                            [1] = 30148,
                            [2] = 30151,
                            [3] = 150731,
                            ["Pre"] = 3665.2500000000,
                        },
                        [141] = 
                        {
                            [1] = 30154,
                            [2] = 30151,
                            [3] = 150731,
                            ["Pre"] = 3665.4700000000,
                        },
                        [142] = 
                        {
                            [1] = 30151,
                            [2] = 150669,
                            [3] = 150731,
                            ["Pre"] = 4207.1200000000,
                        },
                        [143] = 
                        {
                            [1] = 30148,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4506.4000000000,
                        },
                        [144] = 
                        {
                            [1] = 30154,
                            [2] = 30152,
                            [3] = 150731,
                            ["Pre"] = 4506.6200000000,
                        },
                    },
                    [1703936] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30162,
                            [3] = 77589,
                            ["Pre"] = 584.1500000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 77584,
                            [3] = 77589,
                            ["Pre"] = 596.7500000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 77589,
                            ["Pre"] = 597.4800000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 77589,
                            ["Pre"] = 597.5600000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 77589,
                            ["Pre"] = 605.9300000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 77589,
                            ["Pre"] = 610.0400000000,
                        },
                        [7] = 
                        {
                            [1] = 77587,
                            [2] = 30161,
                            [3] = 77589,
                            ["Pre"] = 669.3600000000,
                        },
                        [8] = 
                        {
                            [1] = 30162,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 674.7000000000,
                        },
                        [9] = 
                        {
                            [1] = 30155,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 684.1900000000,
                        },
                        [10] = 
                        {
                            [1] = 30159,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 688.0300000000,
                        },
                        [11] = 
                        {
                            [1] = 30166,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 696.4800000000,
                        },
                        [12] = 
                        {
                            [1] = 30158,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 700.5900000000,
                        },
                        [13] = 
                        {
                            [1] = 30156,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 703.0200000000,
                        },
                        [14] = 
                        {
                            [1] = 30149,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 707.7300000000,
                        },
                        [15] = 
                        {
                            [1] = 150789,
                            [2] = 30161,
                            [3] = 77589,
                            ["Pre"] = 759.9100000000,
                        },
                        [16] = 
                        {
                            [1] = 77587,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 781.2400000000,
                        },
                        [17] = 
                        {
                            [1] = 77587,
                            [2] = 30160,
                            [3] = 77589,
                            ["Pre"] = 842.7500000000,
                        },
                        [18] = 
                        {
                            [1] = 150789,
                            [2] = 30163,
                            [3] = 77589,
                            ["Pre"] = 871.7900000000,
                        },
                        [19] = 
                        {
                            [1] = 77587,
                            [2] = 30162,
                            [3] = 139020,
                            ["Pre"] = 873.6400000000,
                        },
                        [20] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 139020,
                            ["Pre"] = 875.1700000000,
                        },
                        [21] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 139020,
                            ["Pre"] = 886.9300000000,
                        },
                        [22] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 139020,
                            ["Pre"] = 887.0500000000,
                        },
                        [23] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 139020,
                            ["Pre"] = 892.0500000000,
                        },
                        [24] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 139020,
                            ["Pre"] = 895.4200000000,
                        },
                        [25] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 139020,
                            ["Pre"] = 899.5300000000,
                        },
                        [26] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 139020,
                            ["Pre"] = 901.2400000000,
                        },
                        [27] = 
                        {
                            [1] = 77587,
                            [2] = 77589,
                            [3] = 150672,
                            ["Pre"] = 918.8800000000,
                        },
                        [28] = 
                        {
                            [1] = 150789,
                            [2] = 30160,
                            [3] = 77589,
                            ["Pre"] = 933.3000000000,
                        },
                        [29] = 
                        {
                            [1] = 77587,
                            [2] = 30161,
                            [3] = 139020,
                            ["Pre"] = 958.8500000000,
                        },
                        [30] = 
                        {
                            [1] = 30162,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 964.1900000000,
                        },
                        [31] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 982.6000000000,
                        },
                        [32] = 
                        {
                            [1] = 30166,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 985.9700000000,
                        },
                        [33] = 
                        {
                            [1] = 30158,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 990.0800000000,
                        },
                        [34] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 991.7900000000,
                        },
                        [35] = 
                        {
                            [1] = 30156,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 992.5100000000,
                        },
                        [36] = 
                        {
                            [1] = 30149,
                            [2] = 150789,
                            [3] = 139020,
                            ["Pre"] = 997.2200000000,
                        },
                        [37] = 
                        {
                            [1] = 150789,
                            [2] = 30151,
                            [3] = 139020,
                            ["Pre"] = 1008.9400000000,
                        },
                        [38] = 
                        {
                            [1] = 150789,
                            [2] = 77589,
                            [3] = 150672,
                            ["Pre"] = 1009.4300000000,
                        },
                        [39] = 
                        {
                            [1] = 150789,
                            [2] = 30161,
                            [3] = 139020,
                            ["Pre"] = 1049.4000000000,
                        },
                        [40] = 
                        {
                            [1] = 77587,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1070.7300000000,
                        },
                        [41] = 
                        {
                            [1] = 150789,
                            [2] = 30163,
                            [3] = 139020,
                            ["Pre"] = 1161.2800000000,
                        },
                        [42] = 
                        {
                            [1] = 30162,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1216.8000000000,
                        },
                        [43] = 
                        {
                            [1] = 30155,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1226.2900000000,
                        },
                        [44] = 
                        {
                            [1] = 30153,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1230.0900000000,
                        },
                        [45] = 
                        {
                            [1] = 30159,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1230.1300000000,
                        },
                        [46] = 
                        {
                            [1] = 30165,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1230.2100000000,
                        },
                        [47] = 
                        {
                            [1] = 30157,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1235.2100000000,
                        },
                        [48] = 
                        {
                            [1] = 30166,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1238.5800000000,
                        },
                        [49] = 
                        {
                            [1] = 30158,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1242.6900000000,
                        },
                        [50] = 
                        {
                            [1] = 30156,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1245.1200000000,
                        },
                        [51] = 
                        {
                            [1] = 30149,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1249.8300000000,
                        },
                        [52] = 
                        {
                            [1] = 150789,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1298.9200000000,
                        },
                        [53] = 
                        {
                            [1] = 30161,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1302.0100000000,
                        },
                        [54] = 
                        {
                            [1] = 30163,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1413.8900000000,
                        },
                        [55] = 
                        {
                            [1] = 77587,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1417.0400000000,
                        },
                        [56] = 
                        {
                            [1] = 77587,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 1495.3700000000,
                        },
                        [57] = 
                        {
                            [1] = 150789,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1507.5900000000,
                        },
                        [58] = 
                        {
                            [1] = 77589,
                            [2] = 150672,
                            [3] = 139020,
                            ["Pre"] = 1551.5300000000,
                        },
                        [59] = 
                        {
                            [1] = 150789,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 1585.9200000000,
                        },
                        [60] = 
                        {
                            [1] = 77587,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1759.5400000000,
                        },
                        [61] = 
                        {
                            [1] = 77589,
                            [2] = 77581,
                            [3] = 139020,
                            ["Pre"] = 1838.5300000000,
                        },
                        [62] = 
                        {
                            [1] = 150789,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 1850.0900000000,
                        },
                        [63] = 
                        {
                            [1] = 77587,
                            [2] = 77589,
                            [3] = 30164,
                            ["Pre"] = 2551.8300000000,
                        },
                        [64] = 
                        {
                            [1] = 150789,
                            [2] = 77589,
                            [3] = 30164,
                            ["Pre"] = 2642.3800000000,
                        },
                        [65] = 
                        {
                            [1] = 77587,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2841.3200000000,
                        },
                        [66] = 
                        {
                            [1] = 150789,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 2931.8700000000,
                        },
                        [67] = 
                        {
                            [1] = 77589,
                            [2] = 139020,
                            [3] = 30164,
                            ["Pre"] = 3184.4800000000,
                        },
                        [68] = 
                        {
                            [1] = 77587,
                            [2] = 77589,
                            [3] = 150731,
                            ["Pre"] = 3970.7100000000,
                        },
                        [69] = 
                        {
                            [1] = 77587,
                            [2] = 139020,
                            [3] = 150731,
                            ["Pre"] = 4260.2000000000,
                        },
                        [70] = 
                        {
                            [1] = 77587,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8173.9600000000,
                        },
                        [71] = 
                        {
                            [1] = 77589,
                            [2] = 139020,
                            [3] = 150671,
                            ["Pre"] = 8517.1200000000,
                        },
                    },
                    [72704] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 150672,
                            ["Pre"] = 572.9600000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30163,
                            [3] = 150672,
                            ["Pre"] = 768.5200000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30160,
                            [3] = 150672,
                            ["Pre"] = 830.0300000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 150672,
                            [3] = 30164,
                            ["Pre"] = 2539.1100000000,
                        },
                    },
                    [268800] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 77589,
                            ["Pre"] = 585.6800000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 77589,
                            ["Pre"] = 585.9000000000,
                        },
                        [3] = 
                        {
                            [1] = 30154,
                            [2] = 150789,
                            [3] = 77589,
                            ["Pre"] = 676.4500000000,
                        },
                        [4] = 
                        {
                            [1] = 150789,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 719.4500000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1127.5500000000,
                        },
                        [6] = 
                        {
                            [1] = 150789,
                            [2] = 77589,
                            [3] = 150669,
                            ["Pre"] = 1218.1000000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1218.3300000000,
                        },
                        [8] = 
                        {
                            [1] = 30151,
                            [2] = 77589,
                            [3] = 139020,
                            ["Pre"] = 1261.5500000000,
                        },
                        [9] = 
                        {
                            [1] = 77587,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1470.0500000000,
                        },
                        [10] = 
                        {
                            [1] = 150789,
                            [2] = 77589,
                            [3] = 30152,
                            ["Pre"] = 1560.6000000000,
                        },
                        [11] = 
                        {
                            [1] = 77589,
                            [2] = 139020,
                            [3] = 150669,
                            ["Pre"] = 1760.2000000000,
                        },
                        [12] = 
                        {
                            [1] = 77589,
                            [2] = 139020,
                            [3] = 30152,
                            ["Pre"] = 2102.7000000000,
                        },
                    },
                    [1900544] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30162,
                            [3] = 77585,
                            ["Pre"] = 264.3000000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 77585,
                            ["Pre"] = 266.0500000000,
                        },
                        [3] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 77585,
                            ["Pre"] = 277.5900000000,
                        },
                        [4] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 77585,
                            ["Pre"] = 277.6300000000,
                        },
                        [5] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 77585,
                            ["Pre"] = 282.7100000000,
                        },
                        [6] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 77585,
                            ["Pre"] = 290.1900000000,
                        },
                        [7] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 30161,
                            ["Pre"] = 349.5100000000,
                        },
                        [8] = 
                        {
                            [1] = 30162,
                            [2] = 77585,
                            [3] = 150789,
                            ["Pre"] = 354.8500000000,
                        },
                        [9] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 150789,
                            ["Pre"] = 356.6000000000,
                        },
                        [10] = 
                        {
                            [1] = 30159,
                            [2] = 77585,
                            [3] = 150789,
                            ["Pre"] = 368.1800000000,
                        },
                        [11] = 
                        {
                            [1] = 77587,
                            [2] = 30162,
                            [3] = 77583,
                            ["Pre"] = 369.6900000000,
                        },
                        [12] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 77583,
                            ["Pre"] = 371.2200000000,
                        },
                        [13] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 77583,
                            ["Pre"] = 371.4400000000,
                        },
                        [14] = 
                        {
                            [1] = 30157,
                            [2] = 77585,
                            [3] = 150789,
                            ["Pre"] = 373.2600000000,
                        },
                        [15] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 150789,
                            ["Pre"] = 380.7400000000,
                        },
                        [16] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 77583,
                            ["Pre"] = 382.9800000000,
                        },
                        [17] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 77583,
                            ["Pre"] = 383.0200000000,
                        },
                        [18] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 77583,
                            ["Pre"] = 383.1000000000,
                        },
                        [19] = 
                        {
                            [1] = 77585,
                            [2] = 30156,
                            [3] = 150789,
                            ["Pre"] = 383.1700000000,
                        },
                        [20] = 
                        {
                            [1] = 77585,
                            [2] = 30149,
                            [3] = 150789,
                            ["Pre"] = 387.8800000000,
                        },
                        [21] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 77583,
                            ["Pre"] = 388.1000000000,
                        },
                        [22] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 77583,
                            ["Pre"] = 391.4700000000,
                        },
                        [23] = 
                        {
                            [1] = 30162,
                            [2] = 77585,
                            [3] = 77583,
                            ["Pre"] = 393,
                        },
                        [24] = 
                        {
                            [1] = 30154,
                            [2] = 77585,
                            [3] = 77583,
                            ["Pre"] = 394.7500000000,
                        },
                        [25] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 30151,
                            ["Pre"] = 399.6000000000,
                        },
                        [26] = 
                        {
                            [1] = 30153,
                            [2] = 77585,
                            [3] = 77583,
                            ["Pre"] = 406.2900000000,
                        },
                        [27] = 
                        {
                            [1] = 30159,
                            [2] = 77585,
                            [3] = 77583,
                            ["Pre"] = 406.3300000000,
                        },
                        [28] = 
                        {
                            [1] = 30157,
                            [2] = 77585,
                            [3] = 77583,
                            ["Pre"] = 411.4100000000,
                        },
                        [29] = 
                        {
                            [1] = 77585,
                            [2] = 30149,
                            [3] = 77583,
                            ["Pre"] = 426.0300000000,
                        },
                        [30] = 
                        {
                            [1] = 77585,
                            [2] = 30151,
                            [3] = 77583,
                            ["Pre"] = 437.7500000000,
                        },
                        [31] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 30161,
                            ["Pre"] = 440.0600000000,
                        },
                        [32] = 
                        {
                            [1] = 77587,
                            [2] = 30161,
                            [3] = 77583,
                            ["Pre"] = 454.9000000000,
                        },
                        [33] = 
                        {
                            [1] = 30162,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 460.2400000000,
                        },
                        [34] = 
                        {
                            [1] = 30154,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 461.9900000000,
                        },
                        [35] = 
                        {
                            [1] = 30155,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 469.7300000000,
                        },
                        [36] = 
                        {
                            [1] = 30159,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 473.5700000000,
                        },
                        [37] = 
                        {
                            [1] = 77585,
                            [2] = 30161,
                            [3] = 77583,
                            ["Pre"] = 478.2100000000,
                        },
                        [38] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 478.6500000000,
                        },
                        [39] = 
                        {
                            [1] = 30166,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 482.0200000000,
                        },
                        [40] = 
                        {
                            [1] = 30149,
                            [2] = 150789,
                            [3] = 77583,
                            ["Pre"] = 493.2700000000,
                        },
                        [41] = 
                        {
                            [1] = 150789,
                            [2] = 30151,
                            [3] = 77583,
                            ["Pre"] = 504.9900000000,
                        },
                        [42] = 
                        {
                            [1] = 150789,
                            [2] = 30161,
                            [3] = 77583,
                            ["Pre"] = 545.4500000000,
                        },
                        [43] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            [3] = 30160,
                            ["Pre"] = 628.2900000000,
                        },
                        [44] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 150670,
                            ["Pre"] = 647.3400000000,
                        },
                        [45] = 
                        {
                            [1] = 77587,
                            [2] = 150789,
                            [3] = 150670,
                            ["Pre"] = 714.5800000000,
                        },
                        [46] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            [3] = 77589,
                            ["Pre"] = 717.1400000000,
                        },
                        [47] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            [3] = 30160,
                            ["Pre"] = 718.8400000000,
                        },
                        [48] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 150670,
                            ["Pre"] = 737.8900000000,
                        },
                        [49] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 752.7300000000,
                        },
                        [50] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            [3] = 150672,
                            ["Pre"] = 794.9700000000,
                        },
                        [51] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            [3] = 77589,
                            ["Pre"] = 807.6900000000,
                        },
                        [52] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 150669,
                            ["Pre"] = 807.7000000000,
                        },
                        [53] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            [3] = 150670,
                            ["Pre"] = 843.2800000000,
                        },
                        [54] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 77581,
                            ["Pre"] = 859.9600000000,
                        },
                        [55] = 
                        {
                            [1] = 77587,
                            [2] = 30153,
                            [3] = 77581,
                            ["Pre"] = 871.7200000000,
                        },
                        [56] = 
                        {
                            [1] = 77587,
                            [2] = 30157,
                            [3] = 77581,
                            ["Pre"] = 876.8400000000,
                        },
                        [57] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 77581,
                            ["Pre"] = 880.2100000000,
                        },
                        [58] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 77581,
                            ["Pre"] = 884.3200000000,
                        },
                        [59] = 
                        {
                            [1] = 30153,
                            [2] = 77585,
                            [3] = 77581,
                            ["Pre"] = 895.0300000000,
                        },
                        [60] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 150669,
                            ["Pre"] = 898.2500000000,
                        },
                        [61] = 
                        {
                            [1] = 30157,
                            [2] = 77585,
                            [3] = 77581,
                            ["Pre"] = 900.1500000000,
                        },
                        [62] = 
                        {
                            [1] = 30158,
                            [2] = 77585,
                            [3] = 77581,
                            ["Pre"] = 907.6300000000,
                        },
                        [63] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            [3] = 150669,
                            ["Pre"] = 913.0900000000,
                        },
                        [64] = 
                        {
                            [1] = 77585,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 926.4900000000,
                        },
                        [65] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            [3] = 150669,
                            ["Pre"] = 936.4000000000,
                        },
                        [66] = 
                        {
                            [1] = 30148,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 950.5100000000,
                        },
                        [67] = 
                        {
                            [1] = 30154,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 950.7300000000,
                        },
                        [68] = 
                        {
                            [1] = 30155,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 958.4700000000,
                        },
                        [69] = 
                        {
                            [1] = 30153,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 962.2700000000,
                        },
                        [70] = 
                        {
                            [1] = 30159,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 962.3100000000,
                        },
                        [71] = 
                        {
                            [1] = 30157,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 967.3900000000,
                        },
                        [72] = 
                        {
                            [1] = 30166,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 970.7600000000,
                        },
                        [73] = 
                        {
                            [1] = 30158,
                            [2] = 150789,
                            [3] = 77581,
                            ["Pre"] = 974.8700000000,
                        },
                        [74] = 
                        {
                            [1] = 30162,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 987.1300000000,
                        },
                        [75] = 
                        {
                            [1] = 30148,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 988.6600000000,
                        },
                        [76] = 
                        {
                            [1] = 150789,
                            [2] = 30151,
                            [3] = 77581,
                            ["Pre"] = 993.7300000000,
                        },
                        [77] = 
                        {
                            [1] = 30155,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 996.6200000000,
                        },
                        [78] = 
                        {
                            [1] = 30153,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 1000.4200000000,
                        },
                        [79] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            [3] = 150669,
                            ["Pre"] = 1003.6400000000,
                        },
                        [80] = 
                        {
                            [1] = 30157,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 1005.5400000000,
                        },
                        [81] = 
                        {
                            [1] = 30166,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 1008.9100000000,
                        },
                        [82] = 
                        {
                            [1] = 30149,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 1020.1600000000,
                        },
                        [83] = 
                        {
                            [1] = 30151,
                            [2] = 77583,
                            [3] = 77581,
                            ["Pre"] = 1031.8800000000,
                        },
                        [84] = 
                        {
                            [1] = 150789,
                            [2] = 30161,
                            [3] = 77581,
                            ["Pre"] = 1034.1900000000,
                        },
                        [85] = 
                        {
                            [1] = 77587,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1055.5200000000,
                        },
                        [86] = 
                        {
                            [1] = 77587,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1117.0300000000,
                        },
                        [87] = 
                        {
                            [1] = 150789,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1146.0700000000,
                        },
                        [88] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 30152,
                            ["Pre"] = 1150.2000000000,
                        },
                        [89] = 
                        {
                            [1] = 77583,
                            [2] = 30163,
                            [3] = 77581,
                            ["Pre"] = 1184.2200000000,
                        },
                        [90] = 
                        {
                            [1] = 150789,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1207.5800000000,
                        },
                        [91] = 
                        {
                            [1] = 77585,
                            [2] = 150789,
                            [3] = 30152,
                            ["Pre"] = 1240.7500000000,
                        },
                        [92] = 
                        {
                            [1] = 77587,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1241.4700000000,
                        },
                        [93] = 
                        {
                            [1] = 77583,
                            [2] = 30160,
                            [3] = 77581,
                            ["Pre"] = 1245.7300000000,
                        },
                        [94] = 
                        {
                            [1] = 77585,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1264.7800000000,
                        },
                        [95] = 
                        {
                            [1] = 150789,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1283.7100000000,
                        },
                        [96] = 
                        {
                            [1] = 77583,
                            [2] = 150672,
                            [3] = 77581,
                            ["Pre"] = 1321.8600000000,
                        },
                        [97] = 
                        {
                            [1] = 150789,
                            [2] = 150670,
                            [3] = 77581,
                            ["Pre"] = 1332.0200000000,
                        },
                        [98] = 
                        {
                            [1] = 77583,
                            [2] = 77589,
                            [3] = 77581,
                            ["Pre"] = 1334.5800000000,
                        },
                        [99] = 
                        {
                            [1] = 150789,
                            [2] = 77581,
                            [3] = 150669,
                            ["Pre"] = 1492.3800000000,
                        },
                        [100] = 
                        {
                            [1] = 77587,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1744.3300000000,
                        },
                        [101] = 
                        {
                            [1] = 77585,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1767.6400000000,
                        },
                        [102] = 
                        {
                            [1] = 150789,
                            [2] = 77581,
                            [3] = 30152,
                            ["Pre"] = 1834.8800000000,
                        },
                        [103] = 
                        {
                            [1] = 77587,
                            [2] = 30162,
                            [3] = 139019,
                            ["Pre"] = 1901.9200000000,
                        },
                        [104] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 139019,
                            ["Pre"] = 1903.4500000000,
                        },
                        [105] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 139019,
                            ["Pre"] = 1903.6700000000,
                        },
                        [106] = 
                        {
                            [1] = 77587,
                            [2] = 30159,
                            [3] = 139019,
                            ["Pre"] = 1915.2500000000,
                        },
                        [107] = 
                        {
                            [1] = 77587,
                            [2] = 30165,
                            [3] = 139019,
                            ["Pre"] = 1915.3300000000,
                        },
                        [108] = 
                        {
                            [1] = 77587,
                            [2] = 30166,
                            [3] = 139019,
                            ["Pre"] = 1923.7000000000,
                        },
                        [109] = 
                        {
                            [1] = 77587,
                            [2] = 30158,
                            [3] = 139019,
                            ["Pre"] = 1927.8100000000,
                        },
                        [110] = 
                        {
                            [1] = 77587,
                            [2] = 30161,
                            [3] = 139019,
                            ["Pre"] = 1987.1300000000,
                        },
                        [111] = 
                        {
                            [1] = 30162,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 1992.4700000000,
                        },
                        [112] = 
                        {
                            [1] = 30154,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 1994.2200000000,
                        },
                        [113] = 
                        {
                            [1] = 30155,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 2001.9600000000,
                        },
                        [114] = 
                        {
                            [1] = 30159,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 2005.8000000000,
                        },
                        [115] = 
                        {
                            [1] = 30166,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 2014.2500000000,
                        },
                        [116] = 
                        {
                            [1] = 30158,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 2018.3600000000,
                        },
                        [117] = 
                        {
                            [1] = 30156,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 2020.7900000000,
                        },
                        [118] = 
                        {
                            [1] = 30149,
                            [2] = 150789,
                            [3] = 139019,
                            ["Pre"] = 2025.5000000000,
                        },
                        [119] = 
                        {
                            [1] = 150789,
                            [2] = 30151,
                            [3] = 139019,
                            ["Pre"] = 2037.2200000000,
                        },
                        [120] = 
                        {
                            [1] = 150789,
                            [2] = 30161,
                            [3] = 139019,
                            ["Pre"] = 2077.6800000000,
                        },
                        [121] = 
                        {
                            [1] = 77587,
                            [2] = 30163,
                            [3] = 139019,
                            ["Pre"] = 2099.0100000000,
                        },
                        [122] = 
                        {
                            [1] = 77587,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2160.5200000000,
                        },
                        [123] = 
                        {
                            [1] = 150789,
                            [2] = 30163,
                            [3] = 139019,
                            ["Pre"] = 2189.5600000000,
                        },
                        [124] = 
                        {
                            [1] = 77587,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2236.6500000000,
                        },
                        [125] = 
                        {
                            [1] = 150789,
                            [2] = 30160,
                            [3] = 139019,
                            ["Pre"] = 2251.0700000000,
                        },
                        [126] = 
                        {
                            [1] = 77587,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2284.9600000000,
                        },
                        [127] = 
                        {
                            [1] = 150789,
                            [2] = 150672,
                            [3] = 139019,
                            ["Pre"] = 2327.2000000000,
                        },
                        [128] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2337.3700000000,
                        },
                        [129] = 
                        {
                            [1] = 150789,
                            [2] = 150670,
                            [3] = 139019,
                            ["Pre"] = 2375.5100000000,
                        },
                        [130] = 
                        {
                            [1] = 150789,
                            [2] = 77583,
                            [3] = 30164,
                            ["Pre"] = 2427.9200000000,
                        },
                        [131] = 
                        {
                            [1] = 77587,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2445.3200000000,
                        },
                        [132] = 
                        {
                            [1] = 30148,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2520.8900000000,
                        },
                        [133] = 
                        {
                            [1] = 30155,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2528.8500000000,
                        },
                        [134] = 
                        {
                            [1] = 150789,
                            [2] = 150669,
                            [3] = 139019,
                            ["Pre"] = 2535.8700000000,
                        },
                        [135] = 
                        {
                            [1] = 30166,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2541.1400000000,
                        },
                        [136] = 
                        {
                            [1] = 30158,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2545.2500000000,
                        },
                        [137] = 
                        {
                            [1] = 30151,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2564.1100000000,
                        },
                        [138] = 
                        {
                            [1] = 30163,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2716.4500000000,
                        },
                        [139] = 
                        {
                            [1] = 30160,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2777.9600000000,
                        },
                        [140] = 
                        {
                            [1] = 77587,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2787.8200000000,
                        },
                        [141] = 
                        {
                            [1] = 77587,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2826.1100000000,
                        },
                        [142] = 
                        {
                            [1] = 150672,
                            [2] = 77581,
                            [3] = 139019,
                            ["Pre"] = 2854.0900000000,
                        },
                        [143] = 
                        {
                            [1] = 150789,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 2878.3700000000,
                        },
                        [144] = 
                        {
                            [1] = 150789,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2916.6600000000,
                        },
                        [145] = 
                        {
                            [1] = 77583,
                            [2] = 77581,
                            [3] = 30164,
                            ["Pre"] = 2954.8100000000,
                        },
                        [146] = 
                        {
                            [1] = 77581,
                            [2] = 30152,
                            [3] = 139019,
                            ["Pre"] = 3405.2600000000,
                        },
                        [147] = 
                        {
                            [1] = 77587,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3869.6000000000,
                        },
                        [148] = 
                        {
                            [1] = 150789,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 3960.1500000000,
                        },
                        [149] = 
                        {
                            [1] = 77581,
                            [2] = 30164,
                            [3] = 139019,
                            ["Pre"] = 4487.0400000000,
                        },
                        [150] = 
                        {
                            [1] = 77587,
                            [2] = 77585,
                            [3] = 150671,
                            ["Pre"] = 7564.6200000000,
                        },
                        [151] = 
                        {
                            [1] = 77587,
                            [2] = 77583,
                            [3] = 150671,
                            ["Pre"] = 7670.0100000000,
                        },
                        [152] = 
                        {
                            [1] = 77585,
                            [2] = 77583,
                            [3] = 150671,
                            ["Pre"] = 7693.3200000000,
                        },
                    },
                    [263680] = 
                    {
                        [1] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 30151,
                            ["Pre"] = 282.9800000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30154,
                            [3] = 30151,
                            ["Pre"] = 283.2000000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30155,
                            [3] = 30151,
                            ["Pre"] = 288.1800000000,
                        },
                        [4] = 
                        {
                            [1] = 30154,
                            [2] = 30155,
                            [3] = 30151,
                            ["Pre"] = 288.4000000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 30156,
                            [3] = 30151,
                            ["Pre"] = 307.0100000000,
                        },
                        [6] = 
                        {
                            [1] = 30154,
                            [2] = 30156,
                            [3] = 30151,
                            ["Pre"] = 307.2300000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 30149,
                            [3] = 30151,
                            ["Pre"] = 311.7200000000,
                        },
                        [8] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 634.1000000000,
                        },
                        [9] = 
                        {
                            [1] = 30156,
                            [2] = 30151,
                            [3] = 77589,
                            ["Pre"] = 652.9300000000,
                        },
                        [10] = 
                        {
                            [1] = 30155,
                            [2] = 30151,
                            [3] = 30152,
                            ["Pre"] = 1172.5500000000,
                        },
                    },
                    [265216] = 
                    {
                        [1] = 
                        {
                            [1] = 30148,
                            [2] = 30162,
                            [3] = 30154,
                            ["Pre"] = 235.6900000000,
                        },
                        [2] = 
                        {
                            [1] = 77587,
                            [2] = 30148,
                            [3] = 30154,
                            ["Pre"] = 239.9800000000,
                        },
                        [3] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 77584,
                            ["Pre"] = 248.2900000000,
                        },
                        [4] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 30153,
                            ["Pre"] = 248.9800000000,
                        },
                        [5] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 30159,
                            ["Pre"] = 249.0200000000,
                        },
                        [6] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 30165,
                            ["Pre"] = 249.1000000000,
                        },
                        [7] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 30157,
                            ["Pre"] = 254.1000000000,
                        },
                        [8] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 30156,
                            ["Pre"] = 264.0100000000,
                        },
                        [9] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 30149,
                            ["Pre"] = 268.7200000000,
                        },
                        [10] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 77590,
                            ["Pre"] = 288.2500000000,
                        },
                        [11] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 150789,
                            ["Pre"] = 330.5300000000,
                        },
                        [12] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 77583,
                            ["Pre"] = 368.6800000000,
                        },
                        [13] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 77581,
                            ["Pre"] = 857.4200000000,
                        },
                        [14] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 139019,
                            ["Pre"] = 1900.9100000000,
                        },
                        [15] = 
                        {
                            [1] = 30148,
                            [2] = 30154,
                            [3] = 150731,
                            ["Pre"] = 3622.2500000000,
                        },
                    },
                }
--Nothing here ~